<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicewtadd.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$external = ($_GET["external"]) ? $_GET["external"] : $_POST["external"] ;
	if (isset($external))	$HTTP_POST_VARS = $_POST = $_GET ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$filter=urlencode(stripslashes($filter));

	$invoice = CreateObject('ck-ap.invoice') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','invoicewtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Add New Invoice [with Tax]'));
	$t->set_var('readonly','');
	$t->set_var('disabled','');
	$message = lang("UC - Unit Cost, BTUP - Before Tax Unit Price.") ;
	$message.= "  ".lang("To recalculate Due Date, clear the Due Date field and click [Refresh Page].");
	$message.= "<br>".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$message.= "<br>".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "  ".lang("Posted (Tax Exempted) invoice will appear in the Invoice [no Tax] list.");
	$message.= "<br><b>".lang("Manual tax input is allowed.");
	$message.= "  ".lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	if (isset($external))
		$message.= "<br><b>".lang("Since invoice data is feed from external source, be sure to check the accuracy of all data.")."</b>" ;
	$t->set_var('message',$message);

/*------------- Write Invoice to Screen Display ----------------------------*/

	$invoice->invoice_header_write($t, $_POST, 'wt') ;
	$invoice->invoice_transform($_POST,$newrow,$delete) ;
	$invoice->invoice_detail_write($t,$_POST,$posted,False);
	$t->parse('out','report',True);

/*-------------- Post Invoice ----------------------------------------------*/

	if (isset($post)) {
		$err = $invoice->invoice_validate($_POST) ;
		$t->set_var('message',$err);
		if ($err=='') { $posted = $invoice->invoice_post($_POST, $t, $id, 'new', 'invoicewtadd', "APWT") ; }
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr= "filter=$filter";
	$return = ($filter=="") ? "invoicewtfilter.php" : "invoicewtlist.php" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-ap/$return',$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-ap/invoicewtadd.php',$getstr)) ;
		$t->set_var('lang_post',lang('Post Invoice [with Tax]'));
		$t->set_var('lang_newrow',lang('Add New Row & Refresh Page'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-ap/$return",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
