<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ipmatchclear.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$ipmatch = CreateObject('ck-ap.ipmatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','ipmatchscreen.tpl') ;
	$t->set_block('report','billedlist','billedlist_section');
	$t->set_block('report','unbilledlist','unbilledlist_section');
	$t->set_var('lang_title',lang("Clear Invoice/PO Matching Detail"));
	$t->set_var('message1','') ;
	$t->set_var('message2','') ;
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to clear ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-ap/ipmatchclear.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$ip[id] = $id ;
		$ipmatch->ipmatch_post($ip, $t,'clear','ipmatchclear');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		exit;
		}

/*------------- Write Invoice/PO Matching Detail to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM ap WHERE id='$id'");
$phpgw->db->next_record();
$vendor = $phpgw->db->f('vendor') ;
$ip = $phpgw->db->Record ;
$ipmatch->ipmatch_header_write($t, $ip) ;

$sql ="SELECT ponumber,id,duedate,amount,b_amount FROM po, ipmatch ";
$sql.="WHERE invoiceid='$id' and id=poid";
$phpgw->db->query($sql);
$i=1;
while ($phpgw->db->next_record()) {
	$ip['bponumber'.$i]	=	$phpgw->db->f('ponumber') ;
	$ip['bpoid'.$i]		=	$phpgw->db->f('id') ;
	$ip['bduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$ip['bpoamount'.$i]	=	$phpgw->db->f('amount') ;
	$ip['bb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
	$ip['bnewbamount'.$i]	=	"" ;
	$i++ ;
	}

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "ip1".$user.time() ;
$temp2 = "ip2".$user.time() ;
$sql = "CREATE TABLE $temp1 AS " ;
$sql.="SELECT ponumber,id,duedate,amount,0.0 as b_amount,0.0 as billedamount FROM po WHERE vendor='$vendor' ";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT ponumber,id,duedate,0.0 as amount,b_amount,0.0 as billedamount FROM po, ipmatch ";
$sql.= "WHERE id=poid and invoiceid='$id'";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT ponumber,id,duedate,0.0 as amount,0.0 as b_amount,sum(b_amount) as billedamount " ;
$sql.= "FROM po a, ipmatch b ";
$sql.= "WHERE vendor='$vendor' and a.id=b.poid GROUP BY duedate,id,ponumber";
$phpgw->db->query($sql);
$sql = "CREATE TABLE $temp2 AS " ;
$sql.= "SELECT ponumber,id,duedate,sum(amount) as amount,sum(b_amount) as b_amount,sum(billedamount) as billedamt " ;
$sql.= "FROM $temp1 GROUP BY duedate,id,ponumber ";
$phpgw->db->query($sql);
$sql = "SELECT * FROM $temp2 WHERE amount > billedamt ORDER BY ponumber" ;
$phpgw->db->query($sql) ;

$i=1;
$fullybilled = False ;
while ($phpgw->db->next_record()) {
	$poamount		=	$phpgw->db->f('amount') ;
	$billedamt		=	$phpgw->db->f('billedamt') ;
	$ip['ubponumber'.$i]	=	$phpgw->db->f('ponumber') ;
	$ip['ubpoid'.$i]	=	$phpgw->db->f('id') ;
	$ip['ubduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$ip['ubpoamount'.$i]	=	$poamount ;
	$ip['ubb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
	$ip['ubb_othamt'.$i]	=	$billedamt-$phpgw->db->f('b_amount') ;
	$ip['ubbilledamt'.$i]	=	$billedamt ;
	$ip['ubosamount'.$i]	=	$poamount - $billedamt ;
	$i++ ;
	}
$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

$ipmatch->ipmatch_detail_write($t,$ip,True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_match',lang("Auto-allocate Invoice's Remaining Amount by :"));
	$t->set_var('action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr));
	$t->set_var('lang_match_equal',lang('Done'));
	$t->set_var('lang_match_fifo',lang('Done'));
	$t->set_var('lang_clear',lang('Done'));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
