<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ipmatchedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$move = ($_GET["move"]) ? $_GET["move"] : $_POST["move"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$clear = ($_GET["clear"]) ? $_GET["clear"] : $_POST["clear"] ;
	$match_equal = ($_GET["match_equal"]) ? $_GET["match_equal"] : $_POST["match_equal"] ;
	$match_fifo = ($_GET["match_fifo"]) ? $_GET["match_fifo"] : $_POST["match_fifo"] ;
	$filter=urlencode(stripslashes($filter));

	$ipmatch = CreateObject('ck-ap.ipmatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','ipmatchscreen.tpl') ;
	$t->set_block('report','billedlist','billedlist_section');
	$t->set_block('report','unbilledlist','unbilledlist_section');
	$t->set_var('lang_title',lang('Edit Invoice/PO Matching Detail'));
	$message1 = lang("If either auto-allocation button is clicked, the [Amount Billed via this invoice to be updated to] field will be ignored and blanked out.") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;

/*------------- Write Invoice/PO Matching to Screen Display ----------------------------*/

if (!isset($post) and !isset($move) and !isset($update) and !isset($clear) and !isset($match_equal) and !isset($match_fifo)) {
	$phpgw->db->query("SELECT * FROM ap WHERE id='$id'");
	$phpgw->db->next_record();
	$ip = $phpgw->db->Record ;
	}
    else $ip = $_POST ;
$vendor = $ip[vendor] ;
$ipmatch->ipmatch_header_write($t, $ip) ;

if (!isset($post) and !isset($move) and !isset($update) and !isset($clear) and !isset($match_equal) and !isset($match_fifo)) {
	$sql ="SELECT ponumber,id,duedate,amount,b_amount FROM po, ipmatch ";
	$sql.="WHERE invoiceid='$id' and id=poid";
	$phpgw->db->query($sql);
	$i=1;
	while ($phpgw->db->next_record()) {
		$ip['bponumber'.$i]	=	$phpgw->db->f('ponumber') ;
		$ip['bpoid'.$i]		=	$phpgw->db->f('id') ;
		$ip['bduedate'.$i]	=	$phpgw->db->f('duedate') ;
		$ip['bpoamount'.$i]	=	$phpgw->db->f('amount') ;
		$ip['bb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
		$ip['bnewbamount'.$i]	=	"" ;
		$i++ ;
		}

	$user = trim($phpgw_info["user"]["userid"]);
	$temp1 = "ip1".$user.time() ;
	$temp2 = "ip2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT ponumber,id,duedate,amount,0.0 as b_amount,0.0 as billedamount FROM po WHERE vendor='$vendor' ";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT ponumber,id,duedate,0.0 as amount,b_amount,0.0 as billedamount FROM po, ipmatch ";
	$sql.= "WHERE id=poid and invoiceid='$id'";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT ponumber,id,duedate,0.0 as amount,0.0 as b_amount,sum(b_amount) as billedamount " ;
	$sql.= "FROM po a, ipmatch b ";
	$sql.= "WHERE vendor='$vendor' and a.id=b.poid GROUP BY duedate,id,ponumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT ponumber,id,duedate,sum(amount) as amount,sum(b_amount) as b_amount,sum(billedamount) as billedamt " ;
	$sql.= "FROM $temp1 GROUP BY duedate,id,ponumber ";
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > billedamt ORDER BY duedate,ponumber" ;
	$phpgw->db->query($sql) ;

	$i=1;
	$fullybilled = False ;
	while ($phpgw->db->next_record()) {
		$poamount			=	$phpgw->db->f('amount') ;
		$billedamt			=	$phpgw->db->f('billedamt') ;
		if ($poamount>$billedamt ) {
			$ip['ubponumber'.$i]	=	$phpgw->db->f('ponumber') ;
			$ip['ubpoid'.$i]	=	$phpgw->db->f('id') ;
			$ip['ubduedate'.$i]	=	$phpgw->db->f('duedate') ;
			$ip['ubpoamount'.$i]	=	$poamount ;
			$ip['ubb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
			$ip['ubb_othamt'.$i]	=	$billedamt-$phpgw->db->f('b_amount') ;
			$ip['ubbilledamt'.$i]	=	$billedamt ;
			$ip['ubosamount'.$i]	=	$poamount - $billedamt ;
			$i++ ;
			}
		}

	$sql = "DROP TABLE $temp1, $temp2" ;
	$phpgw->db->query($sql);
	}
    else $ip = $_POST ;

if (isset($clear))		{$msg = $ipmatch->match_clear($ip) ; $t->set_var('message1',$msg) ;}
if (isset($match_equal))	{$msg = $ipmatch->match_equal($ip) ; $t->set_var('message1',$msg) ;}
if (isset($match_fifo))		{$msg = $ipmatch->match_fifo($ip); $t->set_var('message1',$msg) ;}

$ipmatch->ipmatch_detail_write($t,$ip,$posted);

$t->parse('out','report',True);

/*-------------- Post Invoice/PO Matching ----------------------------------------------*/

if (isset($post)) {
	$err = $ipmatch->ipmatch_validate($ip) ;
	$t->set_var('message2',$err);
	if ($err=='') { $posted = $ipmatch->ipmatch_post($ip, $t, 'edit', 'ipmatchedit') ; }
	}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_match',lang("Auto-allocate Invoice's Remaining Amount by :"));
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr));
		$t->set_var('lang_match_equal',lang('Done'));
		$t->set_var('lang_match_fifo',lang('Done'));
		$t->set_var('lang_clear',lang('Done'));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-ap/ipmatchedit.php',$getstr)) ;
		$t->set_var('lang_match_equal',lang('Matching Oldest Equal Amount'));
		$t->set_var('lang_match_fifo',lang('FIFO Scheme'));
		$t->set_var('lang_clear',lang('Clear Allocation'));
		$t->set_var('lang_post',lang('Post IP/Invoice Matching'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link('/ck-ap/ipmatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
