<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: paymentcheque.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-ap',
					'noheader'	=> True,
					'nonavbar'	=> True,
			'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','cheque.tpl') ;
	$rows = "<br><br><br><br><br><br><br><br><br><br><br>" ;
	$title=$rows.lang('Cheque Image (Use browser print function to output the cheque shown above)');
	$t->set_var('lang_title',$title);
	$notes=lang('[This is a sample output subject to tailoring per individual printer & cheque format]');
	$t->set_var('lang_notes',$notes);
	$t->set_var('charset',lang('charset'));


	$unit =	 array (	9 => 'Hundred', 8 => '*', 7 => 'Million',
				6 => 'Hundred', 5 => '*', 4 => 'Thousand',
				3 => 'Hundred', 2 => '*', 1 => '' ) ;
	$digitword = array (	9 => 'Nine', 8 => 'Eight', 7 => 'Seven', 6 => 'Six',  5 => 'Five',
				4 => 'Four', 3 => 'Three', 2 => 'Two',   1 => 'One',  0 => '' ) ;
	$tens =	 array (	9 => 'Ninety', 8 => 'Eighty', 7 => 'Seventy', 6 =>'Sixty', 5 =>'Fifty',
				4 => 'Forty', 3 => 'Thirty', 2 => 'Twenty', 1 => 'Ten', 0 =>'' ) ;
	$tenplus = array (	9 => 'Nineteen', 8 => 'Eighteen', 7 => 'Seventeen',
				6 => 'Sixteen', 5 =>'Fifteen', 4 => 'Forteen',
				3 => 'Thirteen', 2 => 'Twelve', 1 => 'Eleven', 0 =>'' ) ;

/*------------- Write Payment to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM payment WHERE id='$id'");
$phpgw->db->next_record();
$transdate = $phpgw->db->f('transdate') ;
$transdate = date("d-m-Y",strtotime($transdate)) ;
$payee = $phpgw->db->f('payee') ;
$amount = $phpgw->db->f('amount') ;
$pamount = '<br>$'.sprintf("%01.2f",$amount) ;
$payee = "$payee**********" ;
$payee = "<br>$payee" ;
$lang_acpayee = lang('A/C Payee Only') ;
$remark = "<b><u>$lang_acpayee</u></b>" ;
$cents  = round(($amount - floor($amount))* 100) % 100 ;

$divider = 100000000 ;
For ($i=9;$divider>=1;$i--)	{
	$digit[$i]=floor($amount/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	if ($unit[$i]=="Hundred" and $digit[$i]==0) $unit[$i] = "" ;
	if ($unit[$i]=="Million" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;
	if ($unit[$i]=="Thousand" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;

	$amount = $amount % $divider ;
	$divider = $divider / 10 ;
	}
$longhand = "" ;
For ($i=9;$i>=1;$i--)	{$longhand .= "$word[$i] $unit[$i] " ; }
$longhand = str_replace("*","",$longhand);

$divider = 10 ;
For ($i=2;$divider>=1;$i--)	{
	$digit[$i]=floor($cents/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	$cents = $cents % $divider ;
	$divider = $divider / 10 ;
	}
$centhand = "" ;
For ($i=2;$i>=1;$i--)	{$centhand .= "$word[$i] $unit[$i] " ; }
$centhand = str_replace("*","",$centhand) ;
$longhand = trim($centhand)=="" ? $longhand : $longhand." And Cents ".$centhand ;
$longhand = "$longhand Only**********" ;
$longhand = "<br>$longhand" ;

$t->set_var('lang_payee',lang('Payee'));
$t->set_var('lang_id',lang('Audit Id:'));
$t->set_var('lang_chequedate',lang('Cheque Date'));
$t->set_var('lang_longhand',lang('In words'));
$t->set_var('lang_amount',lang('Payment Amount'));
$t->set_var('lang_remark',lang('Remark'));
$t->set_var('transdate',$transdate) ;
$t->set_var('payee',$payee) ;
$t->set_var('longhand',$longhand) ;
$t->set_var('amount',$pamount) ;
$t->set_var('remark',$remark) ;
$t->set_var('id',$phpgw->db->f('id')) ;
$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link('/ck-ap/paymentlist.php',"filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ap/paymentlist.php',"filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
