<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pofilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$vendor = ($_GET["vendor"]) ? $_GET["vendor"] : $_POST["vendor"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Vendor and then the relevant Purchase Order to convert :'));
	$t->set_var('lang_search_message','');

/* ------------- Display Report Generation Parameters ----------------------- */

$t->set_var('lang_criteria',lang('Action Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
;
$filter = array (cond1		=>	lang('Which Vendor') ,
		condvar1	=>	'vendor' ,
		selectlist1	=>	'',
		conddefault1	=>	'' ,
		condnote1	=>	lang('Select the target vendor') ,

		cond2		=>	lang('Which Purchase Order') ,
		condvar2	=>	'id' ,
		selectlist2	=>	'' ,
		conddefault2	=>	'' ,
		condnote2	=>	lang('Select the target Purchase Order') ) ;

$t->set_var('condition',$filter[cond1]) ;
$t->set_var('var',$filter[condvar1]) ;
$t->set_var('note',$filter[condnote1]);
if (!$vendor)	$t->set_var('selectlist',vendor_selectlist('','')) ;
	else	$t->set_var('selectlist',vendor_selectlist("WHERE id=$vendor",'')) ;
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

if ($vendor) {
	$t->set_var('condition',$filter[cond2]) ;
	$t->set_var('var',$filter[condvar2]) ;
	$t->set_var('note',$filter[condnote2]);
	$selectlist = po_selectlist("WHERE vendor=$vendor",'') ;
	if ($selectlist=="")	$err = $err='<b>Error: No relevant PO found</b>';
	$t->set_var('selectlist',$selectlist) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('select_section','select', True);
	}

$t->set_var('detail_section',"");

if ($err)	$t->set_var('lang_search_message',$err) ;

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$vendor) {
		$t->set_var('search_action',$phpgw->link('/ck-ap/pofilter.php')) ;
		$t->set_var('lang_search',lang('Next Step - Choose Purchase Order to convert'));
		}
	    else {
		$t->set_var('search_action',$phpgw->link('/ck-ap/poconvert.php')) ;
		$t->set_var('lang_search',lang('Start Purchase Order Conversion'));
		}
	if ($err) {
		$t->set_var('search_action',$phpgw->link('/ck-ap/pofilter.php')) ;
		$t->set_var('lang_search',lang('Press adjacent [Done] button to restart'));
		}
	$t->set_var('add_action',$phpgw->link('/ck-ap/pofilter.php')) ;
	$t->set_var('lang_add',lang('Done'));
	$t->pparse('out','report',True);

?>
