<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=> 'ck-ap', 'enable_nextmatchs_class'=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$vendor = ($_GET["vendor"]) ? $_GET["vendor"] : $_POST["vendor"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Report to Generate and to set Report Parameters :'));
	$t->set_var('lang_search_message',lang('Generation of A/P report requires lengthy processing time.<br>You should initiate report generation only during off-peak hours.'));

/* ------------- Display Report Generation Parameters ----------------------- */

$t->set_var('lang_criteria',lang('Reporting Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$replist = array (	1	=>	"<OPTION value='1'>1 -- ".lang('Accounts Payable Aging Report')."</OPTION>",
			2	=>	"<OPTION value='2'>2 -- ".lang('Vendor Invoice Aging Report')."</OPTION>",
			3	=>	"<OPTION value='3'>3 -- ".lang('Reserved')."</OPTION>",
			4	=>	"<OPTION value='4'>4 -- ".lang('Reserved')."</OPTION>",
			5	=>	"<OPTION value='5'>5 -- ".lang('Accounts Payable Audit Control Report')."</OPTION>" ) ;
$filter = array (	cond1		=>	lang('Which Report') ,
			condvar1	=>	'repnum' ,
			conddefault1	=>	'' ,
			condnote1	=>	lang('If wrong report chosen, click [Report] to restart'),
			cond2		=>	lang('Which Vendor') ,
			condvar2	=>	'vendor' ,
			selectlist2	=>	vendor_selectlist('',$vendor),
			conddefault2	=>	'' ,
			condnote2	=>	lang('Select the target vendor') ,

			cond3		=>	lang('Report Status as of') ,
			condvar3	=>	'rdate' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Format: YYYY-MM-DD') ) ;

if ($err) {
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $repnum ;
	$filter["conddefault2"] = $vendor ;
	$filter["conddefault3"] = $rdate ;
	}
$t->set_var('condition',$filter[cond1]) ;
$t->set_var('var',$filter[condvar1]) ;
$t->set_var('note',$filter[condnote1]);
if (!$repnum) 		For ($i=1;isset($replist[$i]);$i++)	{$selectlist .= $replist[$i] ;}
    else 		$selectlist = $replist[$repnum];
$t->set_var('selectlist',$selectlist);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);
if ($repnum==2) {
	$t->set_var('condition',$filter[cond2]) ;
	$t->set_var('var',$filter[condvar2]) ;
	$default = $filter[conddefault2] ;
	$t->set_var('selectlist',str_replace("'$default'","'$default' selected",$filter[selectlist2]));
	$t->set_var('note',$filter[condnote2]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('select_section','select', True);
	}

If (!$repnum) 	{$t->set_var('detail_section',"");}
	else
	For ($i=3;isset($filter['cond'.$i]);$i++)	{
		$print = False ;
		Switch ($repnum) :
			case "1" :
				$print = $i==3 ? True : False ;		break;
			case "2" :
				$print = $i==3 ? True : False ;		break;
			case "3" :
				$print = $i==3 ? True : False ;		break;
			case "4" :
				$print = $i==3 ? True : False ;		break;
			case "5" :
				$print = $i==3 ? True : False ;		break;
		endswitch;
		if ($print)	{
			$t->set_var('condition',$filter['cond'.$i]);
			$t->set_var('var',$filter['condvar'.$i]);
			$t->set_var('default',$filter['conddefault'.$i]);
			$t->set_var('note',$filter['condnote'.$i]);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$repnum) {
		$t->set_var('search_action',$phpgw->link('/ck-ap/reportfilter.php')) ;
		$t->set_var('lang_search',lang('Input Report Generation Parameters'));
		}
	    else {
		$t->set_var('search_action',$phpgw->link('/ck-ap/reportfilter_validate.php')) ;
		$t->set_var('lang_search',lang('Start Report Generation'));
		}
	$t->set_var('add_action',$phpgw->link('/ck-ap/reportfilter.php')) ;
	$t->set_var('lang_add',lang('Done'));
	$t->pparse('out','report',True);

?>
