<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array(	'currentapp'		=> 'ck-ap',
					'noheader'		=> True,
					'nonavbar'		=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$vendor = ($_GET["vendor"]) ? $_GET["vendor"] : $_POST["vendor"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/* --------------------- Validation Check Start ----------------------------	*/
	
	if ($err)		$err="Error flagged before validation." ;

	$error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)		$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($rdate) {
		$date=input2date($rdate) ;
		if ($date=="")	$err=lang("Invalid Report Status Date");
			else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;

	if ($err)	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
		switch ($repnum) {
			case 1:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.$phpgw->link("/ck-ap/apaging.php","$param_list"));
				$phpgw->common->phpgw_exit();
			case 2:
				$param_list = "repdate=$rdate&vendor=$vendor" ;
				Header('Location: '.$phpgw->link("/ck-ap/invoiceaging.php","$param_list"));
				$phpgw->common->phpgw_exit();
			case 3:
				$phpgw->common->phpgw_exit();
			case 4:
				$phpgw->common->phpgw_exit();
			case 5:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.$phpgw->link("/ck-ap/controlreport.php","$param_list"));
				$phpgw->common->phpgw_exit();
			default:
				echo "Should not be here.  Weird Report Number" ;
			}
		}
	else
		{
		$err = urlencode($err) ;
		$return = $phpgw->link("/ck-ap/reportfilter.php","repnum=$repnum&vendor=$vendor&rdate=$rdate&err=$err") ;
		Header('Location: '.$return);
		$phpgw->common->phpgw_exit();
		}

?>
