<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"]["currentapp"] = 'ck-ar';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Accounts Receivable Audit Control Report'));
	$t->set_var('lang_detail', lang('Detail'));
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_customer', lang('Customer'));
	$t->set_var('lang_tax', lang('Tax Type'));
	$t->set_var('lang_invoice', lang('Receivable'));
	$t->set_var('lang_invoiceitem', lang('Invoice Item'));
	$t->set_var('lang_receipt', lang('Receipt'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_status_note', " ".lang('(note the effect of postdated journals)'));
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_netamount', lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', lang('Total Tax'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ar WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_amount = $phpgw->db->f('amount') ;
$invoice_netamount = $phpgw->db->f('netamount') ;


$sql =	"SELECT sum(qty*sellprice-discount-tax1-tax2) as invoice_item_amount from invoice a,ar b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount = $phpgw->db->f('invoice_item_amount') ;
$sql =	"SELECT sum(qty*sellprice-discount) as invoice_item_amount from invoice a,ar b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount += $phpgw->db->f('invoice_item_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from invoice a,ar b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT sum(amount) as amount from receipt WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_amount = $phpgw->db->f('amount') ;

$sql =	"SELECT count(id) as count from ar WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count from invoice a,ar b WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count from receipt WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id from ar WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id from invoice a,ar b WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id from receipt WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_id = $phpgw->db->f('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('receipt_amount',sprintf("%01.2f",$receipt_amount)) ;
$t->set_var('invoice_count',$invoice_count) ;
$t->set_var('invoice_item_count',$invoice_item_count) ;
$t->set_var('receipt_count',$receipt_count) ;
$t->set_var('invoice_id',$invoice_id) ;
$t->set_var('invoice_item_id',$invoice_item_id) ;
$t->set_var('receipt_id',$receipt_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ar " ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_amount = $phpgw->db->f('amount') ;
$invoice_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum(qty*sellprice-discount-tax1-tax2) as invoice_item_amount from invoice a,ar b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount = $phpgw->db->f('invoice_item_amount') ;
$sql =	"SELECT sum(qty*sellprice-discount) as invoice_item_amount from invoice a,ar b " .
	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount += $phpgw->db->f('invoice_item_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from invoice a,ar b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT sum(amount) as amount FROM receipt" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_amount = $phpgw->db->f('amount') ;

$sql =	"SELECT count(id) as count FROM customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ar" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count FROM invoice a,ar b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM receipt" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id FROM customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_id = $phpgw->db->f('id') ;

$sql =	"SELECT count(id) as count FROM tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id FROM ar" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id FROM invoice a,ar b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM receipt" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$receipt_id = $phpgw->db->f('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('sys_invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('sys_invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('sys_invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('sys_receipt_amount',sprintf("%01.2f",$receipt_amount)) ;
$t->set_var('sys_customer_count',$customer_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_invoice_count',$invoice_count) ;
$t->set_var('sys_invoice_item_count',$invoice_item_count) ;
$t->set_var('sys_receipt_count',$receipt_count) ;
$t->set_var('sys_customer_id',$customer_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_invoice_id',$invoice_id) ;
$t->set_var('sys_invoice_item_id',$invoice_item_id) ;
$t->set_var('sys_receipt_id',$receipt_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-ar/reportfilter.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	$phpgw->common->phpgw_footer();
?>
