<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invacctran.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ar', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$fromnt = ($_GET["fromnt"]) ? $_GET["fromnt"] : $_POST["fromnt"] ;
	$repl_nonbs = ($_GET["repl_nonbs"]) ? $_GET["repl_nonbs"] : $_POST["repl_nonbs"] ;
	$repl_all = ($_GET["repl_all"]) ? $_GET["repl_all"] : $_POST["repl_all"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$invat = CreateObject('ck-ar.invacctran') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file('report','invacctranscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View & Edit Invoice Accounting Entries'));
	$msg1 = lang("This screen is for adjusting the accounting entries' attribute codes") ;
	$msg2 = lang("and for splitting the entries across different attributes.") ;
	$msg3 = lang("Therefore, the original A/R and tax entries are not modifiable") ;
	$msg4 = lang("and the total Dr/Cr amount should not be changed.") ;
	$msg5 = lang("B/S - Balance Sheet.") ;
	$t->set_var('message',"$msg1 $msg2  $msg3 $msg4   $msg5") ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	$firstime = substr_count($_SERVER['HTTP_REFERER'],'list.php') > 0 ;
	if ($firstime) {
//	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$phpgw->db->query("SELECT * FROM gl WHERE id='$id'");
		$phpgw->db->next_record();
		$iat = $phpgw->db->Record ;
		$phpgw->db->query("SELECT sum(amount) as total FROM acc_trans WHERE trans_id='$id' and amount>0");
		$phpgw->db->next_record();
		$iat[total] = $phpgw->db->f('total') ;
		}
	    else $iat = $_POST ;
	$invat->invacctran_header_write($t, $iat) ;

	if ($firstime) {
//	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$sql = "SELECT chart_id,amount,attrib1,attrib2,attrib3 from acc_trans a, chart b " ;
		$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$iat['accno'.$i]	=	$phpgw->db->f('chart_id') ;
			$iat['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
			$iat['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
			$iat['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
			$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
			$dr			=	sprintf("%01.2f",-$cr) ;
			if ($cr>0)	$dr='';		else $cr='';
			$iat['dr'.$i]		= 	$dr ;
			$iat['cr'.$i]		= 	$cr ;
			$i++ ;
			}
		}
	    else $iat = $_POST ;

	if (isset($reload)) {
		unset($iat) ;
		$iat[id] = $id ;
		$phpgw->db->query("SELECT ar_accno_id,taxincluded,amount FROM ar WHERE id='$id'") ;
		$phpgw->db->next_record();
		$aracc = $phpgw->db->f('ar_accno_id') ;
		$taxstatus = $phpgw->db->f('taxincluded') ;
		$aramt = $phpgw->db->f('amount') ;
		$phpgw->db->query("SELECT * FROM invoice WHERE trans_id='$id'") ;
		$i = 1 ;
		while ($phpgw->db->next_record()) {
			$qty		= $phpgw->db->f('qty') ;
			$sellprice	= $phpgw->db->f('sellprice') ;
			$cost   	= $phpgw->db->f('cost') ;
			$discount 	= $phpgw->db->f('discount') ;
			$tax1		= $phpgw->db->f('tax1') ;
			$tax2		= $phpgw->db->f('tax2') ;
			$incaid		= $phpgw->db->f('income_accno_id') ;
			$invaid		= $phpgw->db->f('inventory_accno_id') ;
			$expaid		= $phpgw->db->f('expense_accno_id') ;
			$t1aid		= $phpgw->db->f('tax1_accno_id') ;
			$t2aid		= $phpgw->db->f('tax2_accno_id') ;
			switch ($taxstatus) :
				case "f" :	$netamount = number_format($qty*$sellprice-$discount,2,".",'') ;	break ;
				case "t" :	$netamount = number_format($qty*$sellprice,2,".",'') - $tax1 - $tax2 ;	break ;
				case "e" :	$netamount = number_format($qty*$sellprice-$discount,2,".",'') ;	break ;
				endswitch ;
			$iat['accno'.$i]	=	$incaid;
			$iat['dr'.$i]		= 	"" ;
			$iat['cr'.$i]		= 	sprintf("%01.2f",$netamount) ;
			$i++ ;
			if ($invaid<>0 and $invaid<>"") {
				$cogs = number_format($qty*$cost,2,".",'') ;
				$iat['accno'.$i]	=	$expaid;
				$iat['dr'.$i]		= 	sprintf("%01.2f",$cogs) ;
				$iat['cr'.$i]		= 	"" ;
				$i++ ;
				$iat['accno'.$i]	=	$invaid;
				$iat['dr'.$i]		= 	"" ;
				$iat['cr'.$i]		= 	sprintf("%01.2f",$cogs) ;
				$i++ ;
				}
			if ($tax1<>0 and $tax1<>"") {
				$iat['accno'.$i]	=	$t1aid;
				$iat['dr'.$i]		= 	"" ;
				$iat['cr'.$i]		= 	sprintf("%01.2f",$tax1) ;
				$i++ ;
				}
			if ($tax2<>0 and $tax2<>"") {
				$iat['accno'.$i]	=	$t2aid;
				$iat['dr'.$i]		= 	"" ;
				$iat['cr'.$i]		= 	sprintf("%01.2f",$tax2) ;
				$i++ ;
				}
			}
		$iat['accno'.$i]	=	$aracc;
		$iat['dr'.$i]		= 	sprintf("%01.2f",$aramt) ;
		$iat['cr'.$i]		= 	"" ;
		$i++ ;
		}

	if (isset($repl_all)) {
		For ($i=1;isset($iat['accno'.$i]);$i++) {
			$iat['attrib1'.$i]	=	$iat['attrib1_cap'] ;
			$iat['attrib2'.$i]	=	$iat['attrib2_cap'] ;
			$iat['attrib3'.$i]	=	$iat['attrib3_cap'] ;
			}
		}

	if (isset($repl_nonbs)) {
		For ($i=1;isset($iat['accno'.$i]);$i++) {
			$accid = $iat['accno'.$i] ;
			$phpgw->db->query("SELECT category FROM chart WHERE id='$accid'") ;
			$phpgw->db->next_record();
			$cat = $phpgw->db->f('category') ;
			if ($cat=="I" or $cat=="E") {
				$iat['attrib1'.$i]	=	$iat['attrib1_cap'] ;
				$iat['attrib2'.$i]	=	$iat['attrib2_cap'] ;
				$iat['attrib3'.$i]	=	$iat['attrib3_cap'] ;
				}
			}
		}

	$invat->invacctran_detail_write($t, $iat, $posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $invat->invacctran_validate($iat) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$invat->invacctran_post($iat,$t,$fromnt,'edit','invacctran');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$return = ($fromnt=="yes") ? "invoicentlist.php" : "invoicewtlist.php" ;
	$t->set_var('lang_replicate',lang('Replicate Attribute Values from Caption :'));
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-ar/$return",$getstr));
		$t->set_var('lang_nonbs',lang('Done'));
		$t->set_var('lang_all',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-ar/invacctran.php","fromnt=$fromnt&".$getstr)) ;
		$t->set_var('lang_nonbs',lang('non B/S accounts only'));
		$t->set_var('lang_all',lang('All'));
		$t->set_var('lang_update',lang('Post Invoice Accounting Entries'));
		$t->set_var('lang_newrow',lang('Add New Row'));
		$t->set_var('lang_reload',lang('Reload Default'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-ar/$return",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
