<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicentlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ar', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'invoicentlist.tpl',	'invoices'=>'invoicentlist.tpl'));
	$t->set_block('invoices','invoice_row','invoice_section');
	$db_type = $phpgw_info["server"]["db_type"] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Invoices [no Tax]'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Invoices'));
$t->set_var('add_action',$phpgw->link('/ck-ar/invoicentadd.php',"filter=$filter"));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_edit_addtax',lang('Edit (Add Tax)'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_rpthist',lang('Receipt History'));
$t->set_var('lang_oinvoice',lang('Invoice / Reminder'));
$t->set_var('lang_acctran',lang('Accouting Entries'));
$t->set_var('lang_bulk',lang('Bulk Despatch'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-ar/invoicentlist.php',lang('Invoice Date')));
$t->set_var('sort_duedate',$nm->show_sort_order($sort,'duedate',$order,'/ck-ar/invoicentlist.php',lang('Due Date')));
$t->set_var('sort_customer',$nm->show_sort_order($sort,'customer',$order,'/ck-ar/invoicentlist.php',lang('Customer')));
$t->set_var('sort_invnumber',$nm->show_sort_order($sort,'invnumber',$order,'/ck-ar/invoicentlist.php',lang('Invoice#')));
$t->set_var('sort_ordnumber',$nm->show_sort_order($sort,'ordnumber',$order,'/ck-ar/invoicentlist.php',lang('Order#')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-ar/invoicentlist.php',lang('Amount')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-ar/invoicentlist.php',lang('Audit Id')));

$last10 = substr($where,strlen($where)-10,10) ;
$fields = "transdate,duedate,invnumber,ordnumber,name,amount,a.id" ;
if ($last10==' AND OPEN '){
	$where = substr($where,0,strlen($where)-10) ;
	$sql1 = "SELECT $fields FROM ar a,customer b $where AND a.customer=b.id " ;
	$sql2 = "SELECT $fields FROM ar a,customer b,r_match c " ;
	$sql2.= "$where AND customer=b.id AND a.id=c.invoiceid ";
	$sql2.=	"GROUP BY $fields HAVING sum(s_amount)>=amount " ;
	if ($db_type=="mysql")	{
		$user = trim($phpgw_info["user"]["userid"]) ;
		$temp1 = "arntl1".$user.time() ;
		$temp2 = "arntl2".$user.time() ;
		$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
		$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
		$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
		$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
		}
		else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
	}
   else	$sql = "SELECT $fields FROM ar a, customer b $where AND a.customer=b.id ORDER BY $order $sort";

$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'duedate'	=> "",
				'customer'	=> "",
				'invnumber'	=> "",
				'ordnumber'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'view'		=> "",
				'rpthist'	=> "",
				'oinvoice'	=> "",
				'acctran'	=> "",
				'edit'		=> "",
				'edit_addtax'	=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('invoice_section','invoice_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$ordnumber = $phpgw->db->f('ordnumber')=="" ? "." : $phpgw->db->f('ordnumber') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'duedate'	=> $phpgw->db->f('duedate'),
            	    		'customer'	=> $phpgw->db->f('name'),
            	    		'invnumber'	=> $phpgw->db->f('invnumber'),
            	    		'ordnumber'	=> $ordnumber,
            	    		'amount'	=> $phpgw->db->f('amount'),
				'id'		=> $phpgw->db->f('id'),
				'view'		=> $phpgw->link('/ck-ar/invoicentview.php',$getstr),
				'rpthist'	=> $phpgw->link('/ck-ar/invrpthist.php',$getstr),
				'oinvoice'	=> $phpgw->link('/ck-ar/invoicentoff.php',$getstr),
				'acctran'	=> $phpgw->link('/ck-ar/invacctran.php',"fromnt=yes&".$getstr),
				'edit'		=> $phpgw->link('/ck-ar/invoicentedit.php',$getstr),
				'edit_addtax'	=>$phpgw->link('/ck-ar/invoicewtedit.php',"fromnt=yes&".$getstr),
				'copy'		=> $phpgw->link('/ck-ar/invoicentcopy.php',$getstr),
				'delete'	=> $phpgw->link('/ck-ar/invoicentdelete.php',$getstr) ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('invoice_section','invoice_row',true);
	}
$t->set_var('bulk_action',$phpgw->link('/ck-ar/invoicentbulk.php',"order=$order&sort=$sort&".$getstr));
$disabled = ($id=="") ? "disabled" : "" ;
$t->set_var('disabled',$disabled) ;
if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','invoices','report');

?>
