<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicewtview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ar', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$invoice = CreateObject('ck-ar.invoice') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file('report','invoicewtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','cogs_row','cogs_section');
	$t->set_var('lang_title',lang('View Invoice [With Tax]'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$message = lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a vendor.") ;
	$message.= "<br>".lang("To recalculate Due Date, clear the Due Date field and click [Refresh Page].");
	$message.= "<br>".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$message.= "<br>".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "  ".lang("Posted (Tax Exempted) invoice will appear in the Invoice [no Tax] list.");
	$message.= "<br><b>".lang("Manual tax input is allowed.");
	$message.= "  ".lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',$message);

/*------------- Write Invoice to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ar WHERE id='$id'");
	$phpgw->db->next_record();
	$iv = $phpgw->db->Record ;
	$iv[taxstatus] = $phpgw->db->f('taxincluded') ;
	$iv[customer] = $phpgw->db->f('customer') ;
	$iv[ar_accno_id] = $phpgw->db->f('ar_accno_id') ;
	$invoice->invoice_header_write($t, $iv,'wt') ;

	$phpgw->db->query("SELECT * FROM invoice WHERE trans_id='$id' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$iv['itemid'.$i]		=	$phpgw->db->f('itemid') ;
		$iv['itemtype'.$i]		=	$phpgw->db->f('itemtype') ;
		$iv['description'.$i]		=	$phpgw->db->f('description') ;
		$iv['qty'.$i]			=	$phpgw->db->f('qty') ;
		$iv['unit'.$i]			=	$phpgw->db->f('unit') ;
		$iv['sellprice'.$i]		=	$phpgw->db->f('sellprice') ;
		$iv['cost'.$i]			=	$phpgw->db->f('cost') ;
		$iv['discount'.$i]		=	$phpgw->db->f('discount') ;
		$iv['income_accno_id'.$i]	=	$phpgw->db->f('income_accno_id') ;
		$iv['inventory_accno_id'.$i]	=	$phpgw->db->f('inventory_accno_id') ;
		$iv['expense_accno_id'.$i]	=	$phpgw->db->f('expense_accno_id') ;
		$iv['tax1'.$i]			=	$phpgw->db->f('tax1') ;
		$iv['tax2'.$i]			=	$phpgw->db->f('tax2') ;
		$iv['tax1_accno_id'.$i]		=	$phpgw->db->f('tax1_accno_id') ;
		$iv['tax2_accno_id'.$i]		=	$phpgw->db->f('tax2_accno_id') ;
		$i++ ;
		}
	$invoice->invoice_detail_write($t,$iv,True,True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('action',$phpgw->link('/ck-ar/invoicewtlist.php',$getstr)) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ar/invoicewtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
?>
