<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: receiptbulk.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-ar',
					'noheader'	=> True,
					'nonavbar'	=> True,
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file(array(	'report'	=> 'receiptoff.tpl',
				'items'		=> 'receiptoff.tpl'));
	$t->set_block('items','item_row','item_section');
	$t->set_var('charset',lang('charset'));
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

/*------------- Write Receipt Header to Screen Display ----------------------------*/

	$t->set_var('lang_receipt',lang('OFFICIAL RECEIPT'));
	$t->set_var('lang_rptnumber',lang('Receipt Number'));
	$t->set_var('lang_rdate',lang('Receipt Date'));
	$t->set_var('lang_customer',lang('Customer:'));

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$footer = $phpgw->db->f('inv_remark') ;

	$phpgw->db->query("SELECT * FROM receipt WHERE id='$id'");
	$phpgw->db->next_record();
	$t->set_var('rptnumber',$phpgw->db->f('rptnumber')) ;
	$customer = $phpgw->db->f('customer') ;
	$amount = $phpgw->db->f('amount') ;
	$cheque = $phpgw->db->f('cheque') ;
	$t->set_var('rdate',$phpgw->db->f('transdate')) ;
	$t->set_var('amount',$phpgw->db->f('amount')) ;

	$phpgw->db->query("SELECT * FROM customer WHERE id='$customer'");
	$phpgw->db->next_record();
	$t->set_var('name',$phpgw->db->f('name')) ;
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$phpgw->db->f('addr1')) ;
	$t->set_var('addr2',$phpgw->db->f('addr2')) ;
	$t->set_var('addr3',$phpgw->db->f('addr3')) ;
	$t->set_var('addr4',$phpgw->db->f('addr4')) ;
	$comment1 = lang("Thank you for your payment!") ;
	$comment1 = "<font size=+1>$comment1</font>" ;
	$t->set_var('comment1',$comment1) ;
	$t->set_var('comment2',"") ;
	$comment3 = lang("The validity of this receipt is subject to the clearance") ;
	$comment4 = lang("of all included cheques, remittance and pending funds.") ;
	$comment3 = "<font size=-1>$comment3</font>" ;
	$comment4 = "<font size=-1>$comment4</font>" ;
	$t->set_var('comment3',$comment3) ;
	$t->set_var('comment4',$comment4) ;

/*-----Translating $amount into $longhand------------------------------------------------*/


	$unit =		 array (9 => 'Hundred', 8 => '*', 7 => 'Million',
				6 => 'Hundred', 5 => '*', 4 => 'Thousand',
				3 => 'Hundred', 2 => '*', 1 => '' ) ;
	$digitword = array (	9 => 'Nine', 8 => 'Eight', 7 => 'Seven', 6 => 'Six',  5 => 'Five',
				4 => 'Four', 3 => 'Three', 2 => 'Two',   1 => 'One',  0 => '' ) ;
	$tens =		 array (9 => 'Ninety', 8 => 'Eighty', 7 => 'Seventy', 6 =>'Sixty', 5 =>'Fifty',
				4 => 'Forty', 3 => 'Thirty', 2 => 'Twenty', 1 => 'Ten', 0 =>'' ) ;
	$tenplus =	 array (9 => 'Nineteen', 8 => 'Eighteen', 7 => 'Seventeen',
				6 => 'Sixteen', 5 =>'Fifteen', 4 => 'Forteen',
				3 => 'Thirteen', 2 => 'Twelve', 1 => 'Eleven', 0 =>'' ) ;

$pamount = '$'.sprintf("%01.2f",$amount) ;
$cents  = round(($amount - floor($amount))* 100) % 100 ;

$divider = 100000000 ;
For ($i=9;$divider>=1;$i--)	{
	$digit[$i]=floor($amount/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	if ($unit[$i]=="Hundred" and $digit[$i]==0) $unit[$i] = "" ;
	if ($unit[$i]=="Million" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;
	if ($unit[$i]=="Thousand" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;

	$amount = $amount % $divider ;
	$divider = $divider / 10 ;
	}
$longhand = "" ;
For ($i=9;$i>=1;$i--)	{$longhand .= "$word[$i] $unit[$i] " ; }
$longhand = str_replace("*","",$longhand);

$divider = 10 ;
For ($i=2;$divider>=1;$i--)	{
	$digit[$i]=floor($cents/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	$cents = $cents % $divider ;
	$divider = $divider / 10 ;
	}
$centhand = "" ;
For ($i=2;$i>=1;$i--)	{$centhand .= "$word[$i] $unit[$i] " ; }
$centhand = str_replace("*","",$centhand) ;
$longhand = trim($centhand)=="" ? $longhand : $longhand." And Cents ".$centhand ;

/*---------------Write Receipt Wording--------------------------------------------------------------*/

	$sql = "SELECT invnumber from r_match a, ar b WHERE a.receiptid=$id and a.invoiceid=b.id " ;
	$phpgw->db->query($sql);
	$invlist = "" ;
	while ($phpgw->db->next_record()) {
		$invlist .= $phpgw->db->f('invnumber').", " ;
		}
	$memo1 = lang("The following proceeds have been received,");
	$memo2 = lang("From:")." <b>$name</b>" ;
	$memo3 = lang("Amount:")." <b>$currency $longhand</b>" ;
	if ($cheque<>"")	$memo4 = lang("Format:  cheque - numbered")." $cheque" ;
		else		$memo4 = lang("Format:  in cash") ;
	$memo = "$memo1<br>$memo2<br>$memo3<br>$memo4" ;
	if ($invlist<>"") 	$memo.= "<br>".lang("in payment of the invoices:")." $invlist" ;
	
//	$memo = "Received from <b>$name</b> the sum of <b>$currency $longhand</b> (".$pamount.") " ;
//	if ($invlist<>"") 	$memo.= "in payment of the invoices - $invlist" ;
//	if ($cheque<>"")	$memo.= "by cheque (numbered $cheque)." ;
//		else		$memo.= "by cash." ;
//	$memo = "<br>".$memo."<br><br>" ;
//	$t->set_var('memo',$memo) ;

//	$memo = "Received from <b>$name</b> the sum of <b>$currency $longhand</b> (".$pamount.") " ;
//	if ($invlist<>"") 	$memo.= "in payment of the invoices - $invlist" ;
//	if ($cheque<>"")	$memo.= "by cheque (numbered $cheque)." ;
//		else		$memo.= "by cash." ;
	$memo = "<br>".$memo."<br><br>" ;
	$t->set_var('memo',$memo) ;

/*--------------------Write bottom Section------------------------------------------*/

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title = lang('If the sample displayed is OK, press [Email ...] button to start bulk despatch');
	$t->set_var('lang_title',$title);
	$note1=lang('<br>For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_note1',$note1);
	$note2=lang('<b>Warning:  Make sure that the receipt had been properly allocated to the appropriate invoices, before generating, mailing or emailing the official receipt.</b>');
	$t->set_var('lang_note2',$note2);

	$t->set_var('email_action',$phpgw->link('/ck-ar/receiptbulkemail.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('lang_email',lang('Email Receipt'));

	$t->set_var('fax_action',$phpgw->link('/ck-ar/bulkinvntfax.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('lang_fax',lang('Bulk Fax Despatch'));

	$t->set_var('done_action',$phpgw->link('/ck-ar/receiptlist.php',"order=$order&sort=$sort&filter=$filter"));
	$t->set_var('lang_done',lang('Done'));

	$t->pparse('out','items',report);


?>
