<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: receiptfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=> 'ck-ar', 'enable_nextmatchs_class' => True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$customer = ($_GET["customer"]) ? $_GET["customer"] : $_POST["customer"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$rptnumber = ($_GET["rptnumber"]) ? $_GET["rptnumber"] : $_POST["rptnumber"] ;
	$remark = ($_GET["remark"]) ? $_GET["remark"] : $_POST["remark"] ;
	$opentran = ($_GET["opentran"]) ? $_GET["opentran"] : $_POST["opentran"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted receipts :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Searching Criteria --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$warning = lang("Make sure you have completed all receipt allocation before checking on unallocated receipts") ;
$filter = array (	cond1		=>	lang('Customer') ,
			condvar1	=>	'customer' ,
			selectlist1	=>	"<OPTION value='ALL'></OPTION>".customer_selectlist('',''),
			conddefault1	=>	'ALL' ,
			condnote1	=>	lang('Select the appropriate customer') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Receipt Date (from)') ,
			condvar2	=>	'from' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Must be a valid date [format: YYYY-MM-DD]'),
			checkbox3	=>	'no',
			cond3		=>	lang('Receipt Date (to)') ,
			condvar3	=>	'to' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date [format: YYYY-MM-DD]'),
			checkbox4	=>	'no',
			cond4		=>	lang('Receipt Number') ,
			condvar4	=>	'rptnumber' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for target key word/number in the receipt number field') ,
			checkbox5	=>	'no',
			cond5		=>	lang('Remark') ,
			condvar5	=>	'remark' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for target key word/number in the remark field')  ,
			checkbox6	=>	'yes',
			cond6		=>	lang('Unallocated Receipt Only') ,
			condvar6	=>	'opentran' ,
			conddefault6	=>	'' ,
			condnote6	=>	lang('Click box if only non fully allocated receipts are to be retrieved')."<br><b>$warning</b>" ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $customer ;
	$filter["conddefault2"] = $from ;
	$filter["conddefault3"]	= $to ;
	$filter["conddefault4"] = $rptnumber ;
	$filter["conddefault5"] = $remark ;
	$filter["conddefault6"] = $opentran ;
	}
$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	if ($filter['checkbox'.$i]=='yes') {
		$t->set_var('checkbox',"type='checkbox'");
		$t->set_var('default',"yes");
		if ($filter['conddefault'.$i]=='yes')	$t->set_var('checked',"checked");
			else				$t->set_var('checked',"");
		}
	   else	{
		$t->set_var('checkbox',"");
		$t->set_var('checked',"");
		}
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

$t->set_var('search_action',$phpgw->link('/ck-ar/receiptfilter_validate.php')) ;
$t->set_var('lang_search',lang('Start Search'));
$t->set_var('add_action',$phpgw->link('/ck-ar/receiptadd.php')) ;
$t->set_var('lang_add',lang('Add New Receipt'));

if (isset($phpgw_info["user"]["preferences"]["common"]["currency"])) {
	$currency = $phpgw_info["user"]["preferences"]["common"]["currency"];
	$t->set_var("error","");
	}
    else $t->set_var('error',lang('Please select your currency in preferences !'));

$t->pparse('out','report',True);

?>
