<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: import2wksht.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-bank', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$where = stripslashes($filter) ;
	$filter=urlencode(stripslashes($filter));
	$db_type = $phpgw_info["server"]["db_type"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',lang("Import Ledger Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "br1".$user.time() ;
$temp2 = "br2".$user.time() ;
$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,amount " ;
$sql.=	"FROM acc_trans a, gl b $where and trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,paynumber as refnumber,cheque,a.amount " ;
$sql.=	"FROM $temp1 a, payment b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,rptnumber,b.cheque,a.amount " ;
$sql.=	"FROM $temp1 a, receipt b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (chart_id,trans_id,transdate,source,description,amount) " ;
$sql.=	"SELECT * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE $temp2 SET amount=-amount");
$dashpos = "position('-' in description)+1" ;
$blkpos = "position(' ' in description)-1" ;
$sql = "UPDATE $temp2 SET cheque=substring(description,$dashpos,$blkpos-$dashpos) ";
$sql.= "WHERE source='PYPY'" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT distinct chart_id FROM $temp2");
$phpgw->db->next_record() ;
$chart_id = $phpgw->db->f('chart_id') ;

$app  = $phpgw_info[flags][currentapp] ;
$script = 'import2wksht' ;
$user = trim($phpgw_info["user"]["userid"]);
$date = date("Ymd") ;
$time = date("H:i:s") ;
$op = 'import' ;
$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
$phpgw->db->query($sql);
$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) " ;
$sql.= "VALUES ('$chart_id','$app','$script','$user','$date','$time','$op')" ;
$phpgw->db->query($sql);

$sql =	"INSERT INTO bkr_trans (chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) " ;
$sql.=	"SELECT * FROM $temp2" ;
$phpgw->db->query($sql);

$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
$phpgw->db->query($sql);

if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang('Ledger Items Imported'));
	$t->set_var('lang_yes',lang('done'));
	$t->set_var('lang_no',lang('done'));
	$t->set_var('yes_action',$phpgw->link('/ck-bank/importfilter.php')) ;
	$t->set_var('no_action',$phpgw->link('/ck-bank/importfilter.php')) ;
	$t->pparse('out','question',True);

?>
