<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array(	'currentapp'		=> 'ck-bank',
					'noheader'		=> True,
					'nonavbar'		=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$bankbal = ($_GET["bankbal"]) ? $_GET["bankbal"] : $_POST["bankbal"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)			$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if (!$from)			$err=lang("Reconiliation Period From Date missing") ;
	if (!$to)			$err=lang("Reconiliation Period To Date missing") ;
	if ($repnum==1 and !is_numeric($bankbal))
					$err=lang("Bank Balance must be non-blank and numeric") ;
	if ($from) {
		$date=input2date($from) ;
		if ($date=="")		$err=lang("Invalid Reconciliation Period From Date");
			else	$from = $date ;
		}
	if ($to) {
		$date=input2date($to) ;
		if ($date=="")		$err=lang("Invalid Reconciliation Period To Date");
			else	$to = $date ;
		}
	if ($repnum<>1 and $repnum<>5)	$err=lang("Invalid Report chosen") ;
	if ($err)	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
		switch ($repnum) {
			case 1:
				$getstr = "chart_id=$chart_id&from=$from&to=$to&bankbal=$bankbal" ;
				Header('Location: '.$phpgw->link("/ck-bank/brstatement.php",$getstr));
				exit();
			case 2:
				$phpgw->common->phpgw_exit();
			case 3:
				$phpgw->common->phpgw_exit();
			case 4:
				$phpgw->common->phpgw_exit();
			case 5:
				$getstr = "chart_id=$chart_id&from=$from&to=$to" ;
				Header('Location: '.$phpgw->link("/ck-bank/controlreport.php",$getstr));
				exit();
			default:
				echo "Should not be here.  Weird Report Number" ;
			}
		}
	else
		{
		$err = urlencode($err) ;
		$getstr = "repnum=$repnum&chart_id=$chart_id&" ;
		$getstr.= "from=$from&to=$to&bankbal=$bankbal&err=$err" ;
		$return = $phpgw->link("/ck-bank/reportfilter.php",$getstr) ;
		Header('Location: '.$return);
		}

?>
