<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: statementlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-bank', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'statementlist.tpl',  'statements'=>'statementlist.tpl'));
	$t->set_block('statements','statement_row','statement_section');
	$db_type = $phpgw_info["server"]["db_type"] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of statement Items'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_bankac',lang('Bank Account'));
$pos = strpos($where,'chart_id=') ;
$posspace = strpos($where,' ',$pos) ;
$chart_id = substr($where,$pos+9,$posspace-$pos-9) ;
$phpgw->db->query("SELECT accno,description FROM chart WHERE id=$chart_id");
$phpgw->db->next_record() ;
$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
$t->set_var('bankac',$bankac);
$t->set_var('lang_add',lang('Add New Statement Item'));
$t->set_var('add_action',$phpgw->link('/ck-bank/statementadd.php',"filter=$filter"));

$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-bank/statementlist.php',lang('statement Date')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,'/ck-bank/statementlist.php',lang('Source')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-bank/statementlist.php',lang('Description')));
$t->set_var('sort_refnumber',$nm->show_sort_order($sort,'refnumber',$order,'/ck-bank/statementlist.php',lang('Ref Number')));
$t->set_var('sort_cheque',$nm->show_sort_order($sort,'cheque',$order,'/ck-bank/statementlist.php',lang('Cheque')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-bank/statementlist.php',lang('Amount (Dr being +ve)')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-bank/statementlist.php',lang('Audit Id')));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT *,trans_id as id FROM bkr_trans $where ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'refnumber'	=> "",
				'cheque'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('statement_section','statement_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(
		'transdate'	=> $phpgw->db->f('transdate'),
		'source'	=> $phpgw->db->f('source'),
		'description'	=> $phpgw->db->f('description'),
		'refnumber'	=> $phpgw->db->f('refnumber'),
		'cheque'	=> $phpgw->db->f('cheque'),
		'amount'	=> $phpgw->db->f('amount'),
		'id'		=> $id,
		'view'		=> $phpgw->link('/ck-bank/statementview.php',$getstr),
		'edit'		=> $phpgw->link('/ck-bank/statementedit.php',$getstr),
		'copy'		=> $phpgw->link('/ck-bank/statementcopy.php',$getstr),
		'delete'	=> $phpgw->link('/ck-bank/statementdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('statement_section','statement_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','statements','report');
?>
