<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attendlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'attendlist.tpl', 'attend'=>'attendlist.tpl'));
	$t->set_block('attend','attend_row','attend_section');
	$msg1 = lang('Attendance Records are auto-created via staff signing in/out.') ;
	$msg2 = lang('Normally, HR staff should not create/amend attendance records.') ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Attendance List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Add New Attendance Record'));
	$t->set_var('add_action',$phpgw->link('/ck-hr/attendadd.php',"filter=$filter"));
	$t->set_var('message',"$msg1  $msg2");

$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-hr/attendlist.php',lang('Employee Name/#')));
$t->set_var('sort_dept',$nm->show_sort_order($sort,'dept',$order,'/ck-hr/attendlist.php',lang('Department')));
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-hr/attendlist.php',lang('Date')));
$t->set_var('sort_time',$nm->show_sort_order($sort,'time',$order,'/ck-hr/attendlist.php',lang('Time')));
$t->set_var('sort_type',$nm->show_sort_order($sort,'type',$order,'/ck-hr/attendlist.php',lang('Type')));
$t->set_var('sort_reason',$nm->show_sort_order($sort,'reason',$order,'/ck-hr/attendlist.php',lang('Reason')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-hr/attendlist.php',lang('Audit Id')));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name,transdate,time" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT b.name,d.description as dept,transdate,time,a.type,c.description as reason, a.id as id " ;
$sql.=  "from attendance a, employee b, hrcode c, department d " ;
$sql.=  "$where and empid=b.id and b.dept=d.id and a.type=c.type and a.reason=c.name " ;
$sql.=	"order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'dept'		=> "",
				'transdate'		=> "",
				'time'		=> "",
				'type'		=> "",
				'reason'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'		=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('attend_section','attend_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'dept'		=> $phpgw->db->f('dept'),
				'transdate'	=> $phpgw->db->f('transdate'),
				'time'		=> $phpgw->db->f('time'),
				'type'		=> $phpgw->db->f('type'),
				'reason'	=> $phpgw->db->f('reason'),
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-hr/attendview.php',$getstr),
				'edit'		=> $phpgw->link('/ck-hr/attendedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-hr/attendcopy.php',$getstr),
				'delete'	=> $phpgw->link('/ck-hr/attenddelete.php',$getstr)));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('attend_section','attend_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','attend','report');

?>
