<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: employeefilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$name = ($_GET["name"]) ? $_GET["name"] : $_POST["name"] ;
	$prefix = ($_GET["prefix"]) ? $_GET["prefix"] : $_POST["prefix"] ;
	$family = ($_GET["family"]) ? $_GET["family"] : $_POST["family"] ;
	$given = ($_GET["given"]) ? $_GET["given"] : $_POST["given"] ;
	$suffix = ($_GET["suffix"]) ? $_GET["suffix"] : $_POST["suffix"] ;
	$nationalid = ($_GET["nationalid"]) ? $_GET["nationalid"] : $_POST["nationalid"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among existing Employees :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Searching Criteria'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));
	$nullopt = "<OPTION value=''></OPTION>" ;
	$lang_prefix = lang('prefix') ;
	$lang_suffix = lang('suffix') ;
	$t->set_var('prefix_sl',hrcodename_selectlist("WHERE type='$lang_prefix'",$e[prefix],"name","short"));

	$filter = array (
				ftr1		=>	lang('Prefix') ,
				ftrtype1	=>	'select' ,
				ftrsl1		=>	$nullopt.hrcodename_selectlist("WHERE type='$lang_prefix'",'',"name","short") ,
				ftrvar1		=>	'prefix' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	lang('Search for target Employee Name Prefix'),

				ftr2		=>	lang('Suffix') ,
				ftrtype2	=>	'select' ,
				ftrsl2		=>	$nullopt.hrcodename_selectlist("WHERE type='$lang_suffix'",'',"name","short") ,
				ftrvar2		=>	'suffix' ,
				ftrdefault2	=>	'' ,
				ftrnote2	=>	lang('Search for target Employee Name Suffix'),

				ftr3		=>	lang('Employee Name/#') ,
				ftrtype3	=>	'input' ,
				ftrvar3		=>	'name' ,
				ftrdefault3	=>	'' ,
				ftrnote3	=>	lang('Search for target key word in the Employee Name/# field'),

				ftr4		=>	lang('Family Name') ,
				ftrtype4	=>	'input' ,
				ftrvar4		=>	'family' ,
				ftrdefault4	=>	'' ,
				ftrnote4	=>	lang('Search for target key word in Employee Family Name field'),

				ftr5		=>	lang('Given Name') ,
				ftrtype5	=>	'input' ,
				ftrvar5		=>	'given' ,
				ftrdefault5	=>	'' ,
				ftrnote5	=>	lang('Search for target key word in the Employee Given Name field') ,

				ftr6		=>	lang('National ID') ,
				ftrtype6	=>	'input' ,
				ftrvar6		=>	'nationalid' ,
				ftrdefault6	=>	'' ,
				ftrnote6	=>	lang('Search for target key word in the Employee National ID field'),
															 ) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $prefix ;
		$filter["ftrdefault2"] = $suffix ;
		$filter["ftrdefault3"] = $name ;
		$filter["ftrdefault4"] = $family ;
		$filter["ftrdefault5"] = $given ;
		$filter["ftrdefault6"] = $nationalid ;
		}

	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-hr/employeefilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-hr/employeeadd.php')) ;
	$t->set_var('lang_add',lang('Add New Employee'));
	$t->pparse('out','report',True);

?>
