<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: employeelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'employeelist.tpl', 'employee'=>'employeelist.tpl'));
	$t->set_block('employee','employee_row','employee_section');
	$message = lang("EC - Emergency Contact; PR - Performance Review") ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Employee List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Add New Employee'));
	$t->set_var('add_action',$phpgw->link('/ck-hr/employeeadd.php',"filter=$filter"));
	$t->set_var('message',$message);

$t->set_var('lang_auxiinfo',lang('Edit Auxillary Employee Information'));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-hr/employeelist.php',lang('Employee Name/#')));
$t->set_var('sort_family',$nm->show_sort_order($sort,'family',$order,'/ck-hr/employeelist.php',lang('Family Name')));
$t->set_var('sort_given',$nm->show_sort_order($sort,'given',$order,'/ck-hr/employeelist.php',lang('Given Name')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-hr/employeelist.php',lang('Audit Id')));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_photo',lang('Photo'));
$t->set_var('lang_address',lang('Address'));
$t->set_var('lang_phone',lang('Phone'));
$t->set_var('lang_email',lang('Email'));
$t->set_var('lang_ec',lang('EC'));
$t->set_var('lang_dates',lang('Dates'));
$t->set_var('lang_leave',lang('Leave'));
$t->set_var('lang_pr',lang('PR'));
$t->set_var('lang_role',lang('Role'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from employee $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'			=> lang("No Matching Item Found"),
				'family'		=> "",
				'given'			=> "",
				'id'			=> "",
				'view'			=> "",
				'edit'			=> "",
				'copy'			=> "",
				'photo'			=> "",
				'address'		=> "",
				'phone'			=> "",
				'email'			=> "",
				'ec'			=> "",
				'dates'			=> "",
				'leave'			=> "",
				'pr'			=> "",
				'role'			=> "",
				'delete'		=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('employee_section','employee_row',True);
	}
while ($phpgw->db->next_record()) {
	$name		= $phpgw->db->f('name') ;
	$prefix		= $phpgw->db->f('prefix') ;
	$family		= $phpgw->db->f('family') ;
	$given		= $phpgw->db->f('given') ;
	$suffix		= $phpgw->db->f('suffix') ;
	$nationalid	= $phpgw->db->f('nationalid') ;
	$id		= $phpgw->db->f('id') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $name,
				'family'	=> $family,
				'given'		=> $given,
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-hr/employeeview.php',$getstr),
				'edit'		=> $phpgw->link('/ck-hr/employeeedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-hr/employeecopy.php',$getstr),
				'photo'		=> $phpgw->link('/ck-hr/photoedit.php',$getstr),
				'address'	=> $phpgw->link('/ck-hr/addressedit.php',$getstr),
				'phone'		=> $phpgw->link('/ck-hr/phoneedit.php',$getstr),
				'email'		=> $phpgw->link('/ck-hr/emailedit.php',$getstr),
				'ec'		=> $phpgw->link('/ck-hr/ecedit.php',$getstr),
				'dates'		=> $phpgw->link('/ck-hr/datesedit.php',$getstr),
				'leave'		=> $phpgw->link('/ck-hr/leaveedit.php',$getstr),
				'pr'		=> $phpgw->link('/ck-hr/predit.php',$getstr),
				'role'		=> $phpgw->link('/ck-hr/roleedit.php',$getstr),
				'delete'	=> $phpgw->link('/ck-hr/employeedelete.php',$getstr)));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('employee_section','employee_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','employee','report');

?>
