<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attend.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class attend {

//---- attend Detail Validation Checks

    function attend_validate($a) {
	global $phpgw ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$err=""; $error = lang("Error") ;
	$time = $a[time] ;
	$hr = substr($time,0,2) ;
	$t2 = substr($time,2,1) ;
	$mn = substr($time,3,2) ;
	$t5 = substr($time,5,1) ;
	$sc = substr($time,6,2) ;
	if (input2date($a[transdate])=="")		$err=lang("Invalid Date") ;
	if ($hr<0 or $hr>23)				$err=lang("Invalid Time") ;
	if ($mn<0 or $mn>59)				$err=lang("Invalid Time") ;
	if ($sc<0 or $sc>59)				$err=lang("Invalid Time") ;
	if ($t2<>":" or $t5<>":")			$err=lang("Invalid Time Format") ;
	if ($a[type]=="$lang_si" and $a[signin]=='')	$err=lang("Sign in Reason Missing") ;
	if ($a[type]=="$lang_so" and $a[signout]=='')	$err=lang("Sign out Reason Missing") ;
	if ($a[signin]<>'' and $a[signout]<>'')	$err=lang("Both Sign In & Out Reasons are active") ;
	if ($err)					$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post attend Detail to Database

    function attend_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $a[id] ;
	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$reason = ($a[type]=="$lang_si") ? $a[signin] : $a[signout] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO attendance (id,empid,type,reason,transdate,time) ";
			$sql.="VALUES ('$id','$a[empid]','$a[type]','$reason','$a[transdate]','$a[time]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE attendance SET empid='$a[empid]',type='$a[type]'," ;
			$sql.="reason='$reason',transdate='$a[transdate]',time='$a[time]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM attendance WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Attendance Record") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Attendance Detail

    function attend_write(&$t, $a) {
	global $phpgw ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>" ;
	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_time',lang('Time'));
	$t->set_var('lang_type',lang('Type'));
	$t->set_var('lang_signin',lang('Sign In Reason'));
	$t->set_var('lang_signout',lang('Sign Out Reason'));

	$t->set_var('empid_selectlist',employee_selectlist('',$a[empid]));
	$t->set_var('id',$a[id]);
	$t->set_var('transdate',$a[transdate]);
	$t->set_var('time',$a[time]);
	$t->set_var('type_selectlist',str_replace("'$a[type]'","'$a[type]' selected",$type_sl));

	$signin_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_si'",'','long') ;
	$signin_sl = str_replace("'$a[signin]'","'$a[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
	$signout_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_so'",'','long') ;
	$signout_sl = str_replace("'$a[signout]'","'$a[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

    }

?>
