<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.dept.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class dept {

//---- Department Detail Validation Checks

    function dept_validate($d) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	if ($d[name]=="")		$err=lang('Department name Missing');
	if ($d[description]=="")	$err=lang('Department description Missing');
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Department Detail to Database

    function dept_post($d, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $d[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO department (id,name,description,head) VALUES('$id','$d[name]','$d[description]','$d[head]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE department SET name='$d[name]',description='$d[description]',head='$d[head]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from department where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Department") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Department Detail

    function dept_write(&$t, &$d) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Department Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_head',lang('Head of Department'));
	$t->set_var('lang_headcount',lang('Head Count'));
	$id = ($d[id]=="") ? 0 : $d[id] ;
	$t->set_var('id',$id);
	$t->set_var('name',$d[name]);
	$t->set_var('description',$d[description]);
	$t->set_var('head_sl',employee_selectlist('',$d[head]));
	$phpgw->db->query("SELECT count(name) as headcount from employee where dept = '$id'");
	$phpgw->db->next_record();
	$t->set_var('headcount',$phpgw->db->f('headcount'));
	$t->parse('out','report',True);
	}

    }

?>
