<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.employee.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	class employee {  

//---- Employee Detail Validation Checks

    function employee_validate($e,$oldname) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	if ($e[name]=="")				$err=lang('Employee Name/# Missing');
	   else {
		$phpgw->db->query("SELECT * from employee WHERE name='$e[name]'");
		if ($e[name]<>$oldname and $phpgw->db->num_rows()>0)
							$err=lang("Employee Name/# already exists");
		}
	if ($e[family]=="")				$err=lang('Family name missing');
	if ($e[given]=="")				$err=lang('Given name missing');
	if ($e[nationalid]=="")				$err=lang('National ID missing');
	if ($e[title]=="")				$err=lang('Corporate title missing');
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Employee Detail to Database

    function employee_post($e, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $e[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO employee (id,name,prefix,family,given,suffix,nationalid,";
			$sql.="title,supervisor,dept,grade,username) VALUES " ;
			$sql.="('$id','$e[name]','$e[prefix]','$e[family]','$e[given]','$e[suffix]','$e[nationalid]',";
			$sql.="'$e[title]','$e[supervisor]','$e[dept]','$e[grade]','$e[username]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE employee SET name='$e[name]',prefix='$e[prefix]',family='$e[family]',";
			$sql.="given='$e[given]',suffix='$e[suffix]',nationalid='$e[nationalid]',title='$e[title]',";
			$sql.="supervisor='$e[supervisor]',dept='$e[dept]',grade='$e[grade]',username='$e[username]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from employee where id = '$id'");
			$phpgw->db->query("DELETE from dates where empid = '$id'");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$reminder = lang("Remember to update the auxillary employee information.") ;
	$tran = lang('Employee') ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.  $reminder</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Employee Detail

    function employee_write(&$t, $e) {
	global $phpgw,$phpgw_info ;

	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->set_var('lang_name',lang("Employee Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_personal',lang("Personal Information :"));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_family',lang("Family Name"));
	$t->set_var('lang_given',lang("Given Name"));
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_nationalid',lang("National ID"));
	$t->set_var('lang_username',lang("Host System User Name"));
	$t->set_var('lang_corporate',lang("Corporate Information :"));
	$t->set_var('lang_ctitle',lang("Corporate Title"));
	$t->set_var('lang_dept',lang("Department"));
	$t->set_var('lang_grade',lang("Staff Grade"));
	$t->set_var('lang_supervisor',lang("Supervisor"));
	$t->set_var('lang_subtitle',lang("Auxillary Information [click righthand links to view (readonly) details]:"));
	$t->set_var('lang_address',lang("Address"));
	$t->set_var('lang_phone',lang("Phone"));
	$t->set_var('lang_email',lang("Email"));
	$t->set_var('lang_ec',lang("Emergency Contact"));
	$t->set_var('lang_dates',lang("Important Dates"));
	$t->set_var('lang_leave',lang("Leave Record"));
	$t->set_var('lang_perform',lang("Performance Review"));
	$t->set_var('lang_role',lang("Role"));

	$blankopt = "<OPTION value=''></OPTION>" ;
	$t->set_var('name',$e[name]);
	$t->set_var('id',$e[id]);
	$lang_prefix = lang('prefix') ;
	$t->set_var('prefix_sl',hrcodename_selectlist("WHERE type='$lang_prefix'",$e[prefix],"short"));
	$t->set_var('family',$e[family]);
	$t->set_var('given',$e[given]);
	$lang_suffix = lang('suffix') ;
	$t->set_var('suffix_sl',$blankopt.hrcodename_selectlist("WHERE type='$lang_suffix'",$e[suffix],"short"));
	$t->set_var('nationalid',$e[nationalid]);
	$t->set_var('username',$e[username]);
	$t->set_var('title',$e[title]);
	$t->set_var('dept_sl',dept_selectlist('',$e[dept]));
	$lang_grade = lang('grade') ;
	$t->set_var('grade_sl',hrcodename_selectlist("WHERE type='$lang_grade'",$e[grade],"long"));
	$t->set_var('supervisor_sl',employee_selectlist('',$e[supervisor]));
	$getstr = "id=$e[id]" ;
	$t->set_var('address',$phpgw->link('/ck-hr/addressview.php',$getstr));
	$t->set_var('phone',$phpgw->link('/ck-hr/phoneview.php',$getstr));
	$t->set_var('email',$phpgw->link('/ck-hr/emailview.php',$getstr));
	$t->set_var('ec',$phpgw->link('/ck-hr/ecview.php',$getstr));
	$t->set_var('dates',$phpgw->link('/ck-hr/datesview.php',$getstr));
	$t->set_var('leave',$phpgw->link('/ck-hr/leaveview.php',$getstr));
	$t->set_var('perform',$phpgw->link('/ck-hr/prview.php',$getstr));
	$t->set_var('role',$phpgw->link('/ck-hr/roleview.php',$getstr));

	$img = $phpgw_info["server"]["files_dir"]."/images/$e[id].png" ;
	$t->set_var('image',$phpgw->link("/ck-hr/employeeview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}

    }

?>



