<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: gddn.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-inv',
					'noheader'	=> True,
					'nonavbar'	=> True,
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$t->set_file(array('report'		=> 'gddn.tpl',
	                   'items'		=> 'gddn.tpl'));
	$t->set_block('items','item_row','item_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Delivery Note (DN) Image (Use browser print function to output the DN shown above)');
	$t->set_var('lang_title',$title);
	$remark=lang('Please sign and return the duplicate of this Delivery Note to acknowledge receipt of the items listed above.<br><br><br><br><br><br><br>____________________________________________<br>Authorised Signature') ;
	$notes=lang('(This is a sample subject to tailoring per individual printer and DN format)');
	$t->set_var('charset',lang('charset'));
	$t->set_var('lang_notes',$notes);
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;

	$phpgw->db->query("SELECT * FROM il WHERE id='$id'");
	$phpgw->db->next_record();
	$customer = $phpgw->db->f('to_from') ;
	$transdate = $phpgw->db->f('transdate') ;
	$dnnumber = $phpgw->db->f('id') ;
	$transdate = date("d-m-Y",strtotime($transdate)) ;
	$duedate = date("d-m-Y",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM customer WHERE id='$customer'");
	$phpgw->db->next_record();
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$addr1 = $phpgw->db->f('addr1') ;
	$addr2 = $phpgw->db->f('addr2') ;
	$addr3 = $phpgw->db->f('addr3') ;
	$addr4 = $phpgw->db->f('addr4') ;
	$terms = $phpgw->db->f('terms') ;
	$shiptoname = $phpgw->db->f('shiptoname') ;
	$shiptoaddr1 = $phpgw->db->f('shiptoaddr1') ;
	$shiptoaddr2 = $phpgw->db->f('shiptoaddr2') ;
	$shiptoaddr3 = $phpgw->db->f('shiptoaddr3') ;
	$shiptoaddr4 = $phpgw->db->f('shiptoaddr4') ;

	$t->set_var('lang_dn',lang('DELIVERY NOTE'));
	$t->set_var('lang_transdate',lang('Delivery Note Date'));
	$t->set_var('lang_dnnumber',lang('DN Number'));
	$t->set_var('lang_billto',lang('Bill To:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('dnnumber',$dnnumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shiptoname',$shiptoname) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$phpgw->db->query("SELECT c.itemid,c.description,a.qty FROM inv_trans a,so b,oitem c WHERE a.trans_id='$id' and a.order_id=b.id and b.id=c.trans_id and a.parts_id=c.itemid");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = -$phpgw->db->f('qty') ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty )) ;
		$t->parse('item_section','item_row',true);
		}
	$t->set_var('lang_thank',lang("Thank you for your valued business!")) ;
	$t->set_var('lang_remark',$remark) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('email_action',$phpgw->link('/ck-inv/gdlist.php',"filter=$filter")) ;
	$t->set_var('lang_email',lang('DONE'));
	$t->set_var('done_action',$phpgw->link('/ck-inv/gdlist.php',"filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','items',report);
?>
