<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: iaadd.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-inv',    'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$ia = CreateObject('ck-inv.ia') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$t->set_file('report','iascreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Add Inventory Adjustment (IA)'));
	$message = lang("<b>Be sure to inform Accounts Dept to put through related journal entries</b>");
	$t->set_var('message',$message) ;

/*------------- Write Inventory Adjustment to Screen Display ----------------------------*/

	$ia->ia_header_write($t, $_POST) ;

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$iaa = array(	'part1'		=> "",
				'qty1'		=> "",
				'acc1'		=> ""  ) ;
		}
	    else $iaa = $_POST ;
	$ia->ia_detail_write($t, $iaa, $posted, $delete, $newrow);

	$t->parse('out','report',True);

/*-------------- Post Inventory Adjustment----------------------------------------------*/

	if (isset($post)) {
		$err = $ia->ia_validate($iaa) ;
		$t->set_var('message',$err);
		if ($err=='') {$posted =$ia->ia_post($iaa,$t,$id,'new','iaadd');}
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter";
	$return = ($filter=="") ? "iafilter.php" : "ialist.php" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-inv/$return",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-inv/iaadd.php',$getstr)) ;
		$t->set_var('lang_post',lang('Post Inventory Adjustment'));
		$t->set_var('lang_newrow',lang('Add new row'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link("/ck-inv/$return",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
