<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: admindevelop.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'		=> 'ck-ledadmin',
				  'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actn = ($_GET["actn"]) ? $_GET["actn"] : $_POST["actn"] ;
	$chart = ($_GET["chart"]) ? $_GET["chart"] : $_POST["chart"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Admin Action to Perform :'));
	$t->set_var('lang_search_message','');
	if (!$pass2)	unset($actn) ;

/* ------------- Read and Write Journal Detail --------------------------- */

	$t->set_var('lang_criteria',lang('Action to Perform'));
	$t->set_var('lang_value',lang('Parameter Value'));
	$t->set_var('lang_note',lang('Start Related Action'));

	$chartlist1 = lang('1 -- Default Chart of Account') ;
	$chartlist2 = lang('2 -- PRC Chart of Account') ;
	$chartlist3 = lang('3 -- Canadian Chart of Account') ;
	$chartlist =	"<OPTION value='1'>$chartlist1</OPTION>" .
			"<OPTION value='2'>$chartlist2</OPTION>" .
			"<OPTION value='3'>$chartlist3</OPTION>" ;
	$lang_delete = lang('Delete') ;  $link_delete = $phpgw->link('/ck-ledadmin/admindelete.php') ;
	$lang_setup = lang('Setup') ;  $link_setup = $phpgw->link('/ck-ledadmin/adminsetup.php') ;
	$lang_build = lang('Build') ;  $link_build = $phpgw->link('/ck-ledadmin/adminbuild.php',"chart=1") ;
	$lang_create = lang('Create') ;  $link_create = $phpgw->link('/ck-ledadmin/admincreate.php') ;
	
	$filter = array (
				ftr1		=>	lang('Delete all Data and Data Tables') ,
				ftrtype1	=>	'input' ,
				ftrvar1		=>	'name' ,
				ftrdefault1	=>	lang('[No Input Required]') ,
				ftrnote1	=>	"<a href='$link_delete' target='_blank'>$lang_delete</a>",

				ftr2		=>	lang('Setup Data Tables') ,
				ftrtype2	=>	'input' ,
				ftrvar2		=>	'description' ,
				ftrdefault2	=>	lang('[No Input Required]') ,
				ftrnote2	=>	"<a href='$link_setup' target='_blank'>$lang_setup</a>",
	
				ftr3		=>	lang('Build Chart of Accounts and other Master Data') ,
				ftrtype3	=>	'input' ,
				ftrvar3		=>	'chart' ,
				ftrdefault3	=>	lang('[No Input Required]') ,
				ftrnote3	=>	"<a href='$link_build' target='_blank'>$lang_build</a>",

				ftr4		=>	lang('Create Test Data') ,
				ftrtype4	=>	'input' ,
				ftrvar4		=>	'name' ,
				ftrdefault4	=>	lang('[No Input Required]') ,
				ftrnote4	=>	"<a href='$link_create' target='_blank'>$lang_create</a>",
				 ) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $name ;
		$filter["ftrdefault2"] = $description ;
		}

	$noselect = True ;

	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$noselect = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}
	if ($noselect)		$t->set_var('select_section','');

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

$t->set_var('search_action',$phpgw->link('/ck-ledadmin/index.php')) ;
$t->set_var('lang_search',lang('Done'));
$t->set_var('add_action',$phpgw->link('/ck-ledadmin/index.php')) ;
$t->set_var('lang_add',lang('Done'));

$t->pparse('out','report',True);
?>
