<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminsetup.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"]["currentapp"] = 'ck-ledadmin';
	include('../header.inc.php');

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$t->set_file('report','confirm.tpl');
	$db_type = $phpgw_info["server"]["db_type"] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;
	$int = "int default 0" ;

/*---------------------------------------------------------------------------------*/

	if ($db_type == "mysql")	$id_field = $sid_field = "id int unsigned PRIMARY KEY auto_increment" ;
	if ($db_type == "pgsql")	{
		$comment = lang("sequence created") ;
		$sql =	"CREATE SEQUENCE id start 10000 increment 1 maxvalue 2147483647 minvalue 1 cache 1" ;
		$phpgw->db->query($sql);
		$sql =	"SELECT nextval ('id')" ;
		$phpgw->db->query($sql);
			echo "<b>[id]</b> $comment<br>";
		$sql =	"CREATE SEQUENCE sid start 20000 increment 1 maxvalue 2147483647 minvalue 1 cache 1" ;
		$phpgw->db->query($sql);
		$sql =	"SELECT nextval ('sid')" ;
		$phpgw->db->query($sql);
			echo "<b>[sid]</b> $comment<br>";
		$id_field = "id int DEFAULT nextval('id')" ;
		$sid_field = "id int DEFAULT nextval('sid')" ;
		}

/*---------------------------------------------------------------------------------*/

	$transdate = "transdate date DEFAULT 'now'" ;
	$desc = "description text" ;
	$name = "name text" ;
	$count = 0 ;
	$comment = lang("table(s) created") ;
	$sql =	"CREATE TABLE makemodel ($id_field,parts_id $int,$name)" ;
	$phpgw->db->query($sql);
		echo "<b>[makemodel]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE gl ($id_field,source text,$desc,$transdate)" ;
	$phpgw->db->query($sql);
		echo "<b>[gl]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE il ($id_field,source text,$desc,to_from $int,$transdate)" ;
	$phpgw->db->query($sql);
		echo "<b>[il]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE chart ($id_field,accno $int UNIQUE,$desc," ;
	$sql.=			"charttype char(1) DEFAULT 'A',gifi $int,category char(1),link text)" ;
	$phpgw->db->query($sql);
		echo "<b>[chart]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE fund ($id_field,$name,$desc)" ;
	$phpgw->db->query($sql);
		echo "<b>[fund]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE project ($id_field,$name,$desc)" ;
	$phpgw->db->query($sql);
		echo "<b>[project]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE activity ($id_field,$name,$desc,rate $float,factor $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[activity]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE achievement ($id_field,$name,$desc,min $float,max $float,rate $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[achievement]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE department ($id_field,$name,$desc,head $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[department]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE remark ($id_field,$name,detail text)" ;
	$phpgw->db->query($sql);
		echo "<b>[remark]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE defaults (inventory_accno_id $int,income_accno_id $int,expense_accno_id $int," ;
	$sql.=	"company varchar(35),addr1 varchar(35),addr2 varchar(35),addr3 varchar(35),";
	$sql.=	"addr4 varchar(35),contact varchar(35),phone varchar(30),fax varchar(20),";
	$sql.=	"aptax1cap text,aptax2cap text,aptax1pref char(1),aptax2pref char(1)," ;
	$sql.=	"artax1cap text,artax2cap text,artax1pref char(1),artax2pref char(1)," ;
	$sql.=	"postax1cap text,postax2cap text,postax1pref char(1),postax2pref char(1)," ;
	$sql.=	"attrib1cap text,attrib2cap text,attrib3cap text,";
	$sql.=	"attrib1tbl text,attrib2tbl text,attrib3tbl text," ;
	$sql.=	"attrib1sdesc text,attrib2sdesc text,attrib3sdesc text," ;
	$sql.=	"attrib1ldesc text,attrib2ldesc text,attrib3ldesc text," ;
	$sql.=	"attrib1tblmn text,attrib2tblmn text,attrib3tblmn text," ;
	$sql.=	"attrib1cnval text,attrib2cnval text,attrib3cnval text," ;
	$sql.=	"email text,inv_rmkid $int,rmd_rmkid $int,po_rmkid $int,quo_rmkid $int," ;
	$sql.=	"sm_rmkid $int,invnumber text,ponumber text,yearend date,nativecurr varchar(3),";
	$sql.=	"weightunit varchar(5),businessnumber text,version varchar(8)," ;
	$sql.=	"photoyn text,addressyn text,phoneyn text,emailyn text,ecyn text," ;
	$sql.=	"mndfactor $int,smdfactor $int,wkdfactor $float," ;
	$sql.=	"mnhfactor $int,smhfactor $int,wkhfactor $int,dyhfactor $int )";
	$phpgw->db->query($sql);
		echo "<b>[defaults]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE resourcelock (resource text,used_by text)";
	$phpgw->db->query($sql);
		echo "<b>[resourcelock]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE acc_trans($id_field,trans_id $int,chart_id $int," ;
	$sql.=			"attrib1 $int, attrib2 $int, attrib3 $int,amount $float,$transdate)";
	$phpgw->db->query($sql);
		echo "<b>[acc_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE bkr_trans(trans_id $int,chart_id $int,source text,$desc," ;
	$sql.=			"cheque text,refnumber text,status char(1),amount $float,$transdate)";
	$phpgw->db->query($sql);
		echo "<b>[bkr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE inv_trans(trans_id $int,order_id $int,parts_id $int,qty float4,$transdate)";
	$phpgw->db->query($sql);
		echo "<b>[inv_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE invoice ($id_field,trans_id $int,inventory_accno_id $int," ;
	$sql.=			"income_accno_id $int,expense_accno_id $int,itemid $int,itemtype char(1)," ;
	$sql.=			"$desc,qty float4,sellprice $float,cost $float,discount float4," ;
	$sql.=			"tax1 $float,tax2 $float,tax1_accno_id $int,tax2_accno_id $int,unit varchar(5))";
	$phpgw->db->query($sql);
		echo "<b>[invoice]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE oitem ($id_field,trans_id $int,itemid $int," ;
	$sql.=			"itemtype char(1),$desc,qty float4,sellprice $float," ;
	$sql.=			"cost $float,discount float4,tax1 float,tax2 float,unit varchar(5))";
	$phpgw->db->query($sql);
		echo "<b>[oitem]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE vendor ($id_field,$name,addr1 varchar(35)," ;
	$sql.=			"addr2 varchar(35),addr3 varchar(35),addr4 varchar(35)," ;
	$sql.=			"contact varchar(35),phone varchar(20),fax varchar(20),email text," ;
	$sql.=			"notes text,terms int2 DEFAULT 0,taxincluded char) " ;
	$phpgw->db->query($sql);
		echo "<b>[vendor]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE customer ($id_field,$name,addr1 varchar(35)," ;
	$sql.=			"addr2 varchar(35),addr3 varchar(35),addr4 varchar(35)," ;
	$sql.=			"contact varchar(35),phone varchar(20),fax varchar(20),email text," ;
	$sql.=			"notes text,discount float4,taxincluded char,creditlimit $float," ;
	$sql.=			"terms int2 DEFAULT 0,shiptoname varchar(35),shiptoaddr1 varchar(35)," ;
	$sql.=			"shiptoaddr2 varchar(35),shiptoaddr3 varchar(35),shiptoaddr4 varchar(35)," ;
	$sql.=			"shiptocontact varchar(35),shiptophone varchar(20),shiptofax varchar(20)," ;
	$sql.=			"shiptoemail text) " ;
	$phpgw->db->query($sql);
		echo "<b>[customer]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE parts ($id_field,partnumber text,$desc," ;
	$sql.=			"unit varchar(5),listprice $float,sellprice $float,cost $float," ;
	$sql.=			"notes text,bin text,priceupdate date DEFAULT 'now',weight float4," ;
	$sql.=			"costupdate date DEFAULT 'now',rop float4," ;
	$sql.=			"inventory_accno_id $int,income_accno_id $int,expense_accno_id $int )" ;
	$phpgw->db->query($sql);
		echo "<b>[parts]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE assembly ($id_field,assembly_id $int,item_id $int,qty $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[assembly]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE alternate ($id_field,alternate_id $int,item_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[alternate]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE service ($id_field,servicenumber text,$desc," ;
	$sql.=			"unit varchar(5),listprice $float,sellprice $float,cost $float,notes text," ;
	$sql.=			"priceupdate date DEFAULT 'now',costupdate date DEFAULT 'now'," ;
	$sql.=			"income_accno_id $int,expense_accno_id $int )" ;
	$phpgw->db->query($sql);
		echo "<b>[service]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ar ($id_field,invnumber text,ar_accno_id $int," ;
	$sql.=			"$transdate,customer $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,duedate date,notes text,ordnumber text," ;
	$sql.=			"shippingpoint text,terms int2 DEFAULT 0)" ;
	$phpgw->db->query($sql);
		echo "<b>[ar]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ap ($id_field,invnumber text,ap_accno_id $int," ;
	$sql.=			"$transdate,vendor $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,duedate date,ordnumber text )" ;
	$phpgw->db->query($sql);
		echo "<b>[ap]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE po ($id_field,ponumber text,$transdate,vendor $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,duedate date,shipfrom text,notes text )" ;
	$phpgw->db->query($sql);
		echo "<b>[po]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE so ($id_field,sonumber text,$transdate,customer $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,duedate date,shipfrom text,notes text )" ;
	$phpgw->db->query($sql);
		echo "<b>[so]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE quote ($id_field,quotenumber text,so_id $int," ;
	$sql.=			"$transdate,customer $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,duedate date,shipfrom text,notes text )" ;
	$phpgw->db->query($sql);
		echo "<b>[quote]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE tax ($id_field,chart_id $int,rate float,taxnumber text,taxgroup text,notes text )" ;
	$phpgw->db->query($sql);
		echo "<b>[tax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE customertax (customer_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[customertax]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE vendortax (vendor_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[vendortax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE itemtax (item_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[itemtax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE payment ($id_field,paynumber text,cheque text," ;
	$sql.=			"$transdate,vendor $int,amount $float,payee text," ;
	$sql.=			"remark text,dr_accno_id $int,cr_accno_id $int )" ;
	$phpgw->db->query($sql);
		echo "<b>[payment]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE receipt ($id_field,rptnumber text,cheque text," ;
	$sql.=			"$transdate,customer $int,amount $float," ;
	$sql.=			"remark text,dr_accno_id $int,cr_accno_id $int )" ;
	$phpgw->db->query($sql);
		echo "<b>[receipt]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE p_match (paymentid $int,invoiceid $int,s_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[p_match]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE r_match (receiptid $int,invoiceid $int,s_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[r_match]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ipmatch (poid $int,invoiceid $int,b_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[ipmatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ismatch (soid $int,invoiceid $int,b_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[ismatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE sqmatch (quoteid $int,soid $int,a_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[sqmatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE qcash ($id_field,$name,value $float,minsale $float,maxsale $float," ;
	$sql.=			"minqty $int,maxqty $int,minvalue $float,maxvalue $float," ;
	$sql.=			"posacc_id $int,start date,endd date,splan_id $int,notes text)" ;
	$phpgw->db->query($sql);
		echo "<b>[qcash]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE addon ($id_field,$name,factor $float,basis char(1)," ;
	$sql.=			"mincount $int,maxcount $int,minsale $float,maxsale $float," ;
	$sql.=			"incacc_id $int,expacc_id $int,start date,endd date,splan_id $int,notes text)" ;
	$phpgw->db->query($sql);
		echo "<b>[addon]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE sprice ($id_field,$name,itemid $int,price $float," ;
	$sql.=			"start date,endd date,splan_id $int,notes text)" ;
	$phpgw->db->query($sql);
		echo "<b>[sprice]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE cashbox($id_field,$name,cashier text,shift char(1)," ;
	$sql.=			"location text,maxcash $float,notes text)";
	$phpgw->db->query($sql);
		echo "<b>[cashbox]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE pos ($id_field,posnumber text,cboxid $int,cashier text," ;
	$sql.=			"$transdate,shift char(1),customer $int," ;
	$sql.=			"taxincluded char,amount $float,netamount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[pos]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE positem ($id_field,trans_id $int," ;
	$sql.=			"invacc_id $int,incacc_id $int,expacc_id $int,posacc_id $int," ;
	$sql.=			"itemid $int,itemtype char(1),qty float4,price $float,cost $float," ;
	$sql.=			"value float4,factor $float,discount float4,unit varchar(5),";
	$sql.=			"tax1 $float,tax2 $float,tax1acc_id $int,tax2acc_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[positem]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE cbtran ($id_field,cbtnumber text,cboxid $int,manager text,cashier text," ;
	$sql.=			"trantype char(1),$transdate,shift char(1),amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[cbtran]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE log ($sid_field,trans_id $int,app text,script text,userid text,date $int,time text,op text)" ;
	$phpgw->db->query($sql);
		echo "<b>[log]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE employee ($sid_field,$name,prefix text,family text,given text,suffix text," ;
	$sql.=	"nationalid text,username text,title text,supervisor $int,dept $int,grade text)" ;
	$phpgw->db->query($sql);
		echo "<b>[employee]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE hrcode ($id_field,type text,$name,$desc,allowdelete char)" ;
	$phpgw->db->query($sql);
		echo "<b>[hrcode]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE address (empid $int,line1 text,line2 text,line3 text,line4 text," ;
	$sql.=	"addresscode text,region text,country text,zip text)" ;
	$phpgw->db->query($sql);
		echo "<b>[address]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE phone (empid $int,prefix text,phone $int,suffix text,phonecode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[phone]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE email (empid $int,prefix text,suffix text,emailcode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[email]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ec (empid $int,prefix text,family text,given text,suffix text," ;
	$sql.=	"contact text,relation text,eccode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[ec]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE dates (empid $int,empdate date,datecode text,notify $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[dates]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE leave (empid $int,leavefrom date,leaveto date,leavecode text,duration $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[leave]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE pr (empid $int,prfrom date,prto date,prcode text,comment text,reviewer $int,pddate date)" ;
	$phpgw->db->query($sql);
		echo "<b>[pr]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE role (empid $int,rolecode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[role]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE attendance ($id_field,empid $int,type text,reason text,$transdate,time text)" ;
	$phpgw->db->query($sql);
		echo "<b>[attendance]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE timesheet ($id_field,empid $int,year $int,week $int," ;
	$sql.=	"hour_ttl $float,day_ttl $float,approved_by text)" ;
	$phpgw->db->query($sql);
		echo "<b>[timesheet]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ts_trans ($id_field,trans_id $int,$transdate,project $int,activity text," ;
	$sql.=	"hour $float,day $float,achieve $int,achival $float,achiunit $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[ts_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE leaveapp ($id_field,empid $int,leavefrom date,leaveto date," ;
	$sql.=	"leavecode text,duration $float,approved_by text)" ;
	$phpgw->db->query($sql);
		echo "<b>[leaveapp]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE payroll ($id_field,empid $int,salary $int,period char(2),chart_id $int," ;
	$sql.=	"bankacname text,bankac text)" ;
	$phpgw->db->query($sql);
		echo "<b>[payroll]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE pyrcode ($id_field,$name,$desc,basis text,minqty $float,maxqty $float," ;
	$sql.=	"minamt $float,maxamt $float,unitamt $float,unit text,rate $float,chart_id $int," ;
	$sql.=	"single char,allowssc char,allowdelete char)" ;
	$phpgw->db->query($sql);
		echo "<b>[pyrcode]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE pyrc_trans ($id_field,pyroid $int,pyrcodeid $int,qty $float," ;
	$sql.=	"unit text,unitamt $float,rate $float,amount $float,comment text,chart_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[pyrc_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE pynr_trans ($id_field,empid $int,pyrcodeid $int,qty $float,unit text," ;
	$sql.=	"unitamt $float,rate $float,amount $float,comment text,chart_id $int,approved_by text)" ;
	$phpgw->db->query($sql);
		echo "<b>[pynr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE rdtn_trans ($id_field,pyroid $int,rdtnid $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[rdtn_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE cntr_trans ($id_field,pyroid $int,cntrid $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[cntr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE reductn ($id_field,$name,$desc,locality text,chart_id $int," ;
	$sql.=	"floor $int,min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[reductn]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE rdtnrate ($id_field,rdtnid $int,step $int,rate $float,subtract $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[rdtnrate]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE rdtnexem ($id_field,rdtnid $int,pyrcodeid $int," ;
	$sql.=	"min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[rdtnexem]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE contri ($id_field,$name,$desc,locality text,ac_exp $int,ac_liab $int," ;
	$sql.=	"floor $int,min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[contri]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE cntrrate ($id_field,cntrid $int,step $int,rate $float,subtract $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[cntrrate]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE cntrexem ($id_field,cntrid $int,pyrcodeid $int," ;
	$sql.=	"min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[cntrexem]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE pyrohist (trans_id $int,empid $int,type char(4),codeid $int,basis text," ;
	$sql.=	"qty $float,unit text,unitamt $float,rate $float,amount $float,comment text," ;
	$sql.=	"approved_by text,chart_id $int,base $float,floor $int,subtract $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[pyrohist]</b> $comment<br>";				$count++ ;

		echo "<br>$count $comment" ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang('Blank Data Tables Created'));
	$t->set_var('lang_yes',lang('Done'));
	$t->set_var('lang_no',lang('Done'));
	$t->set_var('yes_action',$phpgw->link('/ck-ledadmin/adminfilter.php')) ;
	$t->set_var('no_action',$phpgw->link('/ck-ledadmin/adminfilter.php')) ;
	$t->pparse('out','report');
?>

