<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: defaults.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw, $phpgw_info;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledadmin', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','defaults.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Default Values'));
	$warning1 = lang("Important Note:  Modifying attribute after system has operated will invalidate all attribute-based historical info") ;
	$t->set_var('warning1',"<b>$warning1</b>") ;
	$warning2 = lang("If this entry is not blank, users may forget to investigate tax rate when they should") ;
	$t->set_var('warning2',"<b>$warning2</b>") ;
	$t->set_var('message','') ;
	$t->set_var('readonly','');
	$t->set_var('tr_color_a',$nm->alternate_row_color()) ;
	$t->set_var('tr_color_b',$nm->alternate_row_color()) ;
	$db_type = $phpgw_info["server"]["db_type"] ;

/*-------------- Update Defaults ----------------------------------------------*/

$d = $HTTP_POST_VARS ;
if (isset($post)) {
	$err=""; $error=lang("Error") ;
	if ($d[company]=="")				$err=lang("Company Name Missing");
	if ($d[contact]=="")				$err=lang("Company Contact Missing");
	if ($d[phone] and !is_numeric($d[phone]))	$err=lang("phone# must be numeric");
	if ($d[fax] and !is_numeric($d[fax]))		$err=lang("fax# must be numeric");
	if ($d[email] and strpos($d[email],'@')=='')	$err=lang("invalid email address");
	if (input2date($d[yearend])=="")		$err=lang("Invalid Year End Date");
	if (strlen($d[attrib1cap])>10)			$err=lang("Attribute1 caption descripton too long");
	if (substr_count($d[attrib1cap]," ")>0)		$err=lang("Attribute1 caption should not contain space");
	if (strlen($d[attrib2cap])>10)			$err=lang("Attribute2 caption description too long");
	if (substr_count($d[attrib2cap]," ")>0)		$err=lang("Attribute2 caption should not contain space");
	if (strlen($d[attrib3cap])>10)			$err=lang("Attribute3 caption description too long");
	if (substr_count($d[attrib3cap]," ")>0)		$err=lang("Attribute3 caption should not contain space");
	if ($d[mndfactor]=="")				$err=lang("Daily Salary Imputation (monthly) divisor Missing");
	if ($d[smdfactor]=="")				$err=lang("Daily Salary Imputation (semi-monthly) divisor Missing");
	if ($d[wkdfactor]=="")				$err=lang("Daily Salary Imputation (weekly) divisor Missing");
	if ($d[mnhfactor]=="")				$err=lang("Hourly Salary Imputation (monthly) divisor Missing");
	if ($d[smhfactor]=="")				$err=lang("Hourly Salary Imputation (semi-monthly) divisor Missing");
	if ($d[wkhfactor]=="")				$err=lang("Hourly Salary Imputation (weekly) divisor Missing");
	if ($d[dyhfactor]=="")				$err=lang("Hourly Salary Imputation (daily) divisor Missing");
	if (!is_numeric($d[mndfactor]) or strpos($d[mndfactor],".")<>"")
							$err=lang("Daily Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($d[smdfactor]) or strpos($d[smdfactor],".")<>"")
							$err=lang("Daily Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($d[wkdfactor]))			$err=lang("Daily Salary Imputation (weekly) divisor must be numeric");
	if (!is_numeric($d[mnhfactor]) or strpos($d[mnhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($d[smhfactor]) or strpos($d[smhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($d[wkhfactor]) or strpos($d[wkhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (weekly) divisor must be integer");
	if (!is_numeric($d[dyhfactor]) or strpos($d[dyhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (daily) divisor must be integer");

	$table = array(0,$d[attrib1tbl], $d[attrib2tbl], $d[attrib3tbl]) ;
	$sdesc = array(0,$d[attrib1sdesc],$d[attrib2sdesc],$d[attrib3sdesc]) ;
	$ldesc = array(0,$d[attrib1ldesc],$d[attrib2ldesc],$d[attrib3ldesc]) ;
	for ($i=1; $i<4; $i++ ) {
		$tblid = $tblsdesc = $tblldesc = False ;
		$tbl = $table[$i] ;
		$sd  = $sdesc[$i] ;
		$ld  = $ldesc[$i] ;
		$sql = "select a.attname, format_type(a.atttypid,a.atttypmod) from pg_class c,pg_attribute a " ;
		$sql.= "where c.relname='$tbl' and a.attnum>0 and a.attrelid=c.oid" ;
		if ($db_type=="mysql")		$sql = "describe $tbl" ;
		$phpgw->db->query($sql);
		While ($phpgw->db->next_record()) {
			$fldname = $phpgw->db->Record[0] ;
			$fldtype = $phpgw->db->Record[1] ;
			if ($fldname=="id" and substr($fldtype,0,3)=='int')	$tblid = True ;
			if ($fldname==$sd) 					$tblsdesc = True ;
			if ($fldname==$ld)					$tblldesc = True ;
			}
		$attablei = "[".lang("Attrib table")." $i]" ;
		if (!$tblid)	$err=$attablei.lang("must have id field [type int(eger)]");
		if (!$tblsdesc)	$err=$attablei.lang("does not have field ").$sd ;
		if (!$tblldesc)	$err=$attablei.lang("does not have field ").$ld ;
		}
	$t->set_var('message',"<b>$error: $err</b>") ;

	if ($err=='') {
		$app  = $phpgw_info[flags][currentapp] ;
		$user = trim($phpgw_info["user"]["userid"]);
		$date = date("Ymd") ;
		$time = date("H:i:s") ;
		$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
		$phpgw->db->query($sql);
		$sql = "INSERT INTO log (app,script,userid,date,time,op) " ;
		$sql.= "VALUES ('$app','defaults','$user','$date','$time','edit')" ;
		$phpgw->db->query($sql);

		$sql ="UPDATE defaults SET company='$d[company]',addr1='$d[addr1]',addr2='$d[addr2]'," ;
		$sql.="addr3='$d[addr3]',addr4='$d[addr4]',contact='$d[contact]',phone='$d[phone]',";
		$sql.="fax='$d[fax]',email='$d[email]',nativecurr='$d[nativecurr]',";
		$sql.="weightunit='$d[weightunit]',yearend='$d[yearend]',version='$d[version]',";
		$sql.="aptax1cap='$d[aptax1cap]',aptax2cap='$d[aptax2cap]'," ;
		$sql.="aptax1pref='$d[aptax1pref]',aptax2pref='$d[aptax2pref]'," ;
		$sql.="artax1cap='$d[artax1cap]',artax2cap='$d[artax2cap]'," ;
		$sql.="artax1pref='$d[artax1pref]',artax2pref='$d[artax2pref]'," ;
		$sql.="postax1cap='$d[postax1cap]',postax2cap='$d[postax2cap]'," ;
		$sql.="postax1pref='$d[postax1pref]',postax2pref='$d[postax2pref]'," ;
		$sql.="attrib1cap='$d[attrib1cap]',attrib2cap='$d[attrib2cap]',attrib3cap='$d[attrib3cap]',";
		$sql.="attrib1tbl='$d[attrib1tbl]',attrib2tbl='$d[attrib2tbl]',attrib3tbl='$d[attrib3tbl]',";
		$sql.="attrib1sdesc='$d[attrib1sdesc]',attrib2sdesc='$d[attrib2sdesc]',attrib3sdesc='$d[attrib3sdesc]',";
		$sql.="attrib1ldesc='$d[attrib1ldesc]',attrib2ldesc='$d[attrib2ldesc]',attrib3ldesc='$d[attrib3ldesc]',";
		$sql.="attrib1tblmn='$d[attrib1tblmn]',attrib2tblmn='$d[attrib2tblmn]',attrib3tblmn='$d[attrib3tblmn]',";
		$sql.="attrib1cnval='$d[attrib1cnval]',attrib2cnval='$d[attrib2cnval]',attrib3cnval='$d[attrib3cnval]',";
		$sql.="inventory_accno_id='$d[inventory_accno_id]',income_accno_id='$d[income_accno_id]',";
		$sql.="expense_accno_id='$d[expense_accno_id]',inv_rmkid='$d[inv_rmkid]',";
		$sql.="rmd_rmkid='$d[rmd_rmkid]',po_rmkid='$d[po_rmkid]',quo_rmkid='$d[quo_rmkid]',";
		$sql.="sm_rmkid='$d[sm_rmkid]',photoyn='$d[photoyn]',addressyn='$d[addressyn]',phoneyn='$d[phoneyn]',";
		$sql.="emailyn='$d[emailyn]',ecyn='$d[ecyn]',mndfactor='$d[mndfactor]',smdfactor='$d[smdfactor]'," ;
		$sql.="wkdfactor='$d[wkdfactor]',mnhfactor='$d[mnhfactor]',smhfactor='$d[smhfactor]'," ;
		$sql.="wkhfactor='$d[wkhfactor]',dyhfactor='$d[dyhfactor]'" ;
		$phpgw->db->query($sql);

		$sql = "UPDATE log SET trans_id=id WHERE script='defaults' ";
		$sql.= "and userid='$user' and date='$date' and time='$time'" ;
		$phpgw->db->query($sql);

		$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
		$phpgw->db->query($sql);

		$t->set_var('disabled',"disabled") ;
		$t->set_var('readonly',"readonly");
		$t->set_var("message","<b>".lang("Default Values updated")."</b>") ;
		$posted = True ;
		}
	}

/*------------- Write Defaults Detail to Screen Display ----------------------------*/

if (!isset($post)) {
	$phpgw->db->query("SELECT * from defaults");
	$phpgw->db->next_record();
	$d = $phpgw->db->Record ;
	}
$yes=lang('Yes'); $no=lang('No'); 
$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
$irate = lang('apply item tax rate') ;
$crate = lang('apply customer rate') ;
$vrate = lang('apply vendor rate') ;
$srate = lang('apply my std rate') ;
$zrate = lang('tax rate = zero') ;
$mrate = lang('manual tax input') ;
$aptax_pref_slist = "<OPTION value=''></OPTION>" ;
$aptax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
$aptax_pref_slist.= "<OPTION value='v'>$vrate</OPTION>" ;
$aptax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
$aptax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
$aptax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;
$artax_pref_slist = "<OPTION value=''></OPTION>" ;
$artax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
$artax_pref_slist.= "<OPTION value='c'>$crate</OPTION>" ;
$artax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
$artax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
$artax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;
//$artax_pref_slist = str_replace("'v'","'c'",$aptax_pref_slist) ;
//$artax_pref_slist = str_replace("vendor","customer",$artax_pref_slist) ;
$postax_pref_slist = "<OPTION value='i'>$irate</OPTION>" ;
$postax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_company',lang('Company Name'));
$t->set_var('lang_address',lang('Address'));
$t->set_var('lang_contact',lang('Contact'));
$t->set_var('lang_phone',lang('Phone'));
$t->set_var('lang_fax',lang('Fax'));
$t->set_var('lang_email',lang('E-Mail'));
$t->set_var('lang_nativecurr',lang('Ledger Currency'));
$t->set_var('lang_weightunit',lang('Unit Weight'));

$t->set_var('lang_attribdef',lang('Attribute'));
$t->set_var('lang_attribcap',lang('Caption<br>Description'));
$t->set_var('lang_attribtbl',lang('Table Name'));
$t->set_var('lang_attribsdesc',lang('Short Desc Field Name'));
$t->set_var('lang_attribldesc',lang('Long Desc Field Name'));
$t->set_var('lang_attribtblmn',lang('Allow Table<br>Maintenance in<br>Ledger module'));
$t->set_var('lang_attribcnval',lang('Keep Value Constant<br>within a single journal'));
$t->set_var('lang_attrib1',lang('Attribute1'));
$t->set_var('lang_attrib2',lang('Attribute2'));
$t->set_var('lang_attrib3',lang('Attribute3'));

$t->set_var('lang_aptax',lang('AP/PO Tax'));
$t->set_var('lang_aptax1',lang('Primary'));
$t->set_var('lang_aptax2',lang('Secondary'));
$t->set_var('lang_aptaxcap',lang('Caption Description'));
$langits = lang('Initial Setting of Tax Rate Drop Down Select List') ;
$note = lang('(my std rate = my standard rate as a customer)') ;
$t->set_var('lang_aptaxpref',"$langits:  $note");
$t->set_var('lang_artax',lang('AR/SO/Quotation Tax'));
$t->set_var('lang_artax1',lang('Primary'));
$t->set_var('lang_artax2',lang('Secondary'));
$t->set_var('lang_artaxcap',lang('Caption Description'));
$note = lang('(my std rate = my standard rate as a vendor)') ;
$t->set_var('lang_artaxpref',"$langits:  $note");
$t->set_var('lang_postax',lang('POS Tax'));
$t->set_var('lang_postax1',lang('Primary'));
$t->set_var('lang_postax2',lang('Secondary'));
$t->set_var('lang_postaxcap',lang('Caption Description'));
$langtx = lang('What Type of Tax Rate to apply to Cash Sale') ;
$note = lang('(my std rate = my standard rate as a vendor)') ;
$t->set_var('lang_postaxpref',"$langtx:  $note");

$t->set_var('lang_yearend',lang('Year End Date'));
$t->set_var('lang_version',lang('Software Version'));
$t->set_var('lang_inc',lang('Income A/C'));
$t->set_var('lang_exp',lang('Expense A/C'));
$t->set_var('lang_inv',lang('Inventory A/C'));
$t->set_var('lang_remark',lang('Remarks'));
$t->set_var('lang_invoice',lang('Invoice'));
$t->set_var('lang_reminder',lang('Reminder'));
$t->set_var('lang_po',lang('PO'));
$t->set_var('lang_quo',lang('Quotation'));
$t->set_var('lang_sm',lang('Sales Memo'));

$t->set_var('lang_hr',lang('Human Resources'));
$t->set_var('lang_photo',lang('Photo'));
$t->set_var('lang_ec',lang('Emergency Contact'));
$t->set_var('lang_update',lang('Staff allowed to update their personal info regarding this data ?'));

$t->set_var('lang_pyr',lang('Payroll'));
$t->set_var('lang_mn',lang('Monthly'));
$t->set_var('lang_smn',lang('Semi-monthly'));
$t->set_var('lang_wk',lang('Weekly'));
$t->set_var('lang_dy',lang('Daily'));
$t->set_var('lang_salary',lang('Salary divided by'));
$t->set_var('lang_daypay',lang('Imputed Daily Salary calculated by:'));
$t->set_var('lang_hourpay',lang('Imputed Hourly Salary calculated by:'));

$t->set_var('company',$d[company]);
$t->set_var('addr1',$d[addr1]);
$t->set_var('addr2',$d[addr2]);
$t->set_var('addr3',$d[addr3]);
$t->set_var('addr4',$d[addr4]);
$t->set_var('contact',$d[contact]);
$t->set_var('phone',$d[phone]);
$t->set_var('fax',$d[fax]);
$t->set_var('email',$d[email]);
$t->set_var('nativecurr',$d[nativecurr]);
$t->set_var('weightunit',$d[weightunit]);
$t->set_var('yearend',$d[yearend]);
$t->set_var('version',$d[version]);
$t->set_var('attrib1cap',$d[attrib1cap]);
$t->set_var('attrib2cap',$d[attrib2cap]);
$t->set_var('attrib3cap',$d[attrib3cap]);
$t->set_var('attrib1tbl_selectlist',table_selectlist("",$d[attrib1tbl]));
$t->set_var('attrib2tbl_selectlist',table_selectlist("",$d[attrib2tbl]));
$t->set_var('attrib3tbl_selectlist',table_selectlist("",$d[attrib3tbl]));
$t->set_var('attrib1sdesc',$d[attrib1sdesc]);
$t->set_var('attrib2sdesc',$d[attrib2sdesc]);
$t->set_var('attrib3sdesc',$d[attrib3sdesc]);
$t->set_var('attrib1ldesc',$d[attrib1ldesc]);
$t->set_var('attrib2ldesc',$d[attrib2ldesc]);
$t->set_var('attrib3ldesc',$d[attrib3ldesc]);
$tblmn_sl = str_replace("'$d[attrib1tblmn]'","'$d[attrib1tblmn]'"." selected",$yesno_sl) ;
$t->set_var('attrib1tblmn_selectlist',$tblmn_sl);
$tblmn_sl = str_replace("'$d[attrib2tblmn]'","'$d[attrib2tblmn]'"." selected",$yesno_sl) ;
$t->set_var('attrib2tblmn_selectlist',$tblmn_sl);
$tblmn_sl = str_replace("'$d[attrib3tblmn]'","'$d[attrib3tblmn]'"." selected",$yesno_sl) ;
$t->set_var('attrib3tblmn_selectlist',$tblmn_sl);
$cnval_sl = str_replace("'$d[attrib1cnval]'","'$d[attrib1cnval]'"." selected",$yesno_sl) ;
$t->set_var('attrib1cnval_selectlist',$cnval_sl);
$cnval_sl = str_replace("'$d[attrib2cnval]'","'$d[attrib2cnval]'"." selected",$yesno_sl) ;
$t->set_var('attrib2cnval_selectlist',$cnval_sl);
$cnval_sl = str_replace("'$d[attrib3cnval]'","'$d[attrib3cnval]'"." selected",$yesno_sl) ;
$t->set_var('attrib3cnval_selectlist',$cnval_sl);

$t->set_var('aptax1cap',$d[aptax1cap]);
$t->set_var('aptax2cap',$d[aptax2cap]);
$tax1_sl = str_replace("'$d[aptax1pref]'","'$d[aptax1pref]'"." selected",$aptax_pref_slist) ;
$t->set_var('aptax1pref_selectlist',$tax1_sl);
$tax2_sl = str_replace("'$d[aptax2pref]'","'$d[aptax2pref]'"." selected",$aptax_pref_slist) ;
$t->set_var('aptax2pref_selectlist',$tax2_sl);
$t->set_var('artax1cap',$d[artax1cap]);
$t->set_var('artax2cap',$d[artax2cap]);
$tax1_sl = str_replace("'$d[artax1pref]'","'$d[artax1pref]'"." selected",$artax_pref_slist) ;
$t->set_var('artax1pref_selectlist',$tax1_sl);
$tax2_sl = str_replace("'$d[artax2pref]'","'$d[artax2pref]'"." selected",$artax_pref_slist) ;
$t->set_var('artax2pref_selectlist',$tax2_sl);
$t->set_var('postax1cap',$d[postax1cap]);
$t->set_var('postax2cap',$d[postax2cap]);
$tax1_sl = str_replace("'$d[postax1pref]'","'$d[postax1pref]'"." selected",$postax_pref_slist) ;
$t->set_var('postax1pref_selectlist',$tax1_sl);
$tax2_sl = str_replace("'$d[postax2pref]'","'$d[postax2pref]'"." selected",$postax_pref_slist) ;
$t->set_var('postax2pref_selectlist',$tax2_sl);

$t->set_var('inc_selectlist',account_selectlist("WHERE link like '%AR_amount%'",$d[income_accno_id]));
$t->set_var('exp_selectlist',account_selectlist("WHERE link like '%AP_amount%'",$d[expense_accno_id]));
$t->set_var('inv_selectlist',account_selectlist("WHERE link like '%IC:%' or link like '%IC'",$d[inventory_accno_id]));
$t->set_var('invrmk_selectlist',remark_selectlist("",$d[inv_rmkid]));
$t->set_var('rmdrmk_selectlist',remark_selectlist("",$d[rmd_rmkid]));
$t->set_var('pormk_selectlist',remark_selectlist("",$d[po_rmkid]));
$t->set_var('quormk_selectlist',remark_selectlist("",$d[quo_rmkid]));
$t->set_var('smrmk_selectlist',remark_selectlist("",$d[sm_rmkid]));

$photoyn_sl = str_replace("'$d[photoyn]'","'$d[photoyn]'"." selected",$yesno_sl) ;
$t->set_var('photoyn_selectlist',$photoyn_sl);
$addressyn_sl = str_replace("'$d[addressyn]'","'$d[addressyn]'"." selected",$yesno_sl) ;
$t->set_var('addressyn_selectlist',$addressyn_sl);
$phoneyn_sl = str_replace("'$d[phoneyn]'","'$d[phoneyn]'"." selected",$yesno_sl) ;
$t->set_var('phoneyn_selectlist',$phoneyn_sl);
$emailyn_sl = str_replace("'$d[emailyn]'","'$d[emailyn]'"." selected",$yesno_sl) ;
$t->set_var('emailyn_selectlist',$emailyn_sl);
$ecyn_sl = str_replace("'$d[ecyn]'","'$d[ecyn]'"." selected",$yesno_sl) ;
$t->set_var('ecyn_selectlist',$ecyn_sl);

$t->set_var('mndfactor',$d[mndfactor]);
$t->set_var('smdfactor',$d[smdfactor]);
$t->set_var('wkdfactor',$d[wkdfactor]);
$t->set_var('mnhfactor',$d[mnhfactor]);
$t->set_var('smhfactor',$d[smhfactor]);
$t->set_var('wkhfactor',$d[wkhfactor]);
$t->set_var('dyhfactor',$d[dyhfactor]);

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$filter=urlencode(stripslashes($filter));
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-ledadmin/index.php'));
		$t->set_var('lang_post',lang('Done'));
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-ledadmin/defaults.php')) ;
		$t->set_var('lang_post',lang('Update Default Values'));
		}
	$t->set_var('done_action',$phpgw->link('/ck-ledadmin/index.php'));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
