<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.remark.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class remark {

//---- remark Detail Validation Checks

    function remark_validate($rmk) {
	global $phpgw ;
	$err=""; $error=lang("Error") ;
	if ($rmk[name]=="")			$err=lang("Remark Name Missing");
	if ($rmk[detail]=="")			$err=lang("Remark detail Missing");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Remark Detail to Database

    function remark_post($rmk, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $rmk[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO remark(id,name,detail) ";
			$sql.="VALUES ('$id','$rmk[name]','$rmk[detail]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE remark SET name='$rmk[name]',detail='$rmk[detail]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM remark WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Remark") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Remark Detail

    function remark_write(&$t, &$rmk) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_detail',lang('Detail (Format - html source)'));
	$t->set_var('id',$rmk[id]);
	$t->set_var('name',$rmk[name]);
	$t->set_var('detail',$rmk[detail]);
	$t->parse('out','report',True);
	}

    }

?>
