<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: index.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

    $phpgw_info["flags"]["currentapp"] = 'ck-ledadmin';
    include('../header.inc.php');

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','index.tpl') ;
	$t->set_block('report','detail','detail_row');
	$t->set_block('report','ack','ack_row');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

$welcometo = lang("Welcome to LedgerAdmin") ;
$motto = lang("CK: Common Knowledge - to be shared and developed by all") ;
$t->set_var('lang_caption',$welcometo);
$t->set_var('lang_motto',$motto);
$welcome1 = lang("LedgerAdmin is developed based on an Open Source accounting software.") ;
$welcome2 = lang("Special thank is due to the developers of this Open Source solution.") ;
$welcome3 = lang("However, any error in LedgerAdmin is the author's own.") ;
$t->set_var('lang_welcome',"$welcome1  $welcome2  $welcome3");
$t->set_var('lang_user_admin',lang('User/Administrator'));
$t->set_var('lang_auditor',lang('Auditor'));
$t->set_var('lang_developer',lang('Developer'));
$user1a = lang("Irrespective of any assertion from any person or source, there are BUGS/ERRORS associated with LedgerAdmin.") ;
$user1b = lang("You are using LedgerAdmin or any derivative of LedgerAdmin at your own risk.") ;
$user1	= "<b>$user1a  $user1b</b>" ;
$user2	= "<b>".lang("Do not expect any help nor assistance on LedgerAdmin from anyone.")."</b>" ;
$user3a = lang("You should report to relevant government authority once you have concrete evidence that major fictitious entries are being put through the system");
$user3b = lang("or the system itself is being used for illegal purpose, e.g. money laundering") ;
$user3  = "<b>$user3a, $user3b</b>" ;
$user4a = lang("LedgerAdmin is intended to run on top of Linux, Postgres/MySQL, Apache, PHP and PHPGroupWare.") ;
$user4b = lang("For similar platforms, it may work, but no guarantees.") ;
$user4	= "<b>$user4a  $user4b</b>" ;
$user5a = lang("LedgerAdmin is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.") ;
$user5b = lang("See the GNU General Public License for more detail.") ;
$user5	= "$user5a  $user5b" ;
$user6a = lang("LedgerAdmin is designed with simplicity in mind and no attempt is made to speed up execution.") ;
$user6b = lang("Client display is best viewed at 1024x768 or above.");
$user6	= "$user6a  $user6b" ;
$user7a = lang("Since LedgerAdmin communicates via http, it is exposed to hacking attempts from inside/outside of the installation site.") ;
$user7b = lang("It is recommended that the LedgerAdmin server be disconnected physically from the network whenever possible,") ;
$user7c = lang("or putting the server and client on the same machine, so network connection is not necessary.") ;
$user7  = "$user7a  $user7b $user7c" ;
$user8a	= lang("The best way to study LedgerAdmin is to follow the steps:") ;
$user8b = lang("Admin/Setup -> 1 - Setup Data Tables") ;
$user8c = lang("Admin/Setup -> 2 - Build Chart -> Default Chart") ;
$user8d = lang("Admin/Setup -> 3 - Create Test Data") ;
$user8e = lang("Play around with the various features.  If stuck,") ;
$user8f = lang("Admin/Setup -> 4 - Delete all Data") ;
$user8g = lang("and repeat the process") ;
$user8  = "$user8a<br>$user8b<br>$user8c<br>$user8d<br>$user8e<br>$user8f<br>$user8g" ;
$user9a = lang("If you are reporting an error and/or bug, please try to recreate the symptoms using the standard test data,") ;
$user9b = lang("so other people can readily recreate the error to help in debugging.") ;
$user9 = "$user9a $user9b" ;
$auditor1a = lang("LedgerAdmin is intended for use by System Administrators only and should not be made available to non-sysadmin users.") ;
$auditor1b = lang("If it is somehow made available to ordinary users, then it is a pointer towards adverse audit opinion on system deployment.") ;
$auditor1  = "<b>$auditor1a  $auditor1b</b>" ;
$auditor2  = $user2 ;
$auditor3  = $user3 ;
$auditor4a = lang("Access control is implemented using phpGW's User/Group access feature.") ;
$auditor4b = lang("However, a user with direct access to the underlying database WILL CIRCUMVENT ALL SUCH CONTROLS.") ;
$auditor4c = lang("In a PC environment, the existence of such a user must be assumed.") ;
$auditor4  = "$auditor4a  $auditor4b  $auditor4c" ;
$auditor5a = lang("Because LedgerAdmin is written in PHP, you should check in detail the entire content of php.ini,") ;
$auditor5b = lang("to ensure that all operating parameters and startup environment are safe and secure.") ;
$auditor5  = "$auditor5a  $auditor5b" ;
$auditor6  = lang("There are other areas of audit concern regarding the OS, middleware, development language, co-existing applications, etc, etc, etc.") ;
$auditor7a = lang("It is perfectly OK to house CK-Ledger and its modules in the default database.") ;
$auditor7b = lang("However, If necessary, CK-Ledger modules may be housed in a distinct database (virtual domain) away from the other phpgw modules.") ;
$auditor7  = "$auditor7a  $auditor7b" ;
$developer1a = lang("LedgerAdmin is GPL software.") ;
$developer1b = lang("If you display this -- Welcome to LedgerAdmin -- page exactly as it is,") ;
$developer1c = lang("or display this same page's translation (into a different language), without loss of meaning,") ;
$developer1d = lang("then you may redistribute and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.") ;
$developer1  = "<b>$developer1a  $developer1b  $developer1c $developer1d</b>" ;
$developer2  = $user2 ;
$developer3  = $user3 ;
$developer4a = lang("LedgerAdmin is intended to be used by SMEs that cannot afford a full-blown ERP.") ;
$developer4b = lang("Therefore, I don't intent to implement any advanced feature beyond a basic vanila accounting system.") ;
$developer4  = "$developer4a  $developer4b" ;
$developer5a = lang("To follow the logic of LedgerAdmin, you must have basic accounting knowledge.") ;
$developer5b = lang("Just ask how you would create the beginning account balances and/or reverse an accrual entry in a manual ledger environment.") ;
$developer5c = lang("If you are not sure how these are done, pick up an introductory accounting text and work your way through.") ;
$developer5  = "$developer5a  $developer5b  $developer5c" ;
$developer8a = lang("Currently, LedgerAdmin employs 2 methods to build up the database:") ;
$developer8b = lang("Admin/Setup - Drop table/Create table/Insert into table") ;
$developer8c = lang("Backup/Restore - Build/Restore via data command file") ;
$developer8d = lang("When more experience is gained via actual use, one of the method will be phased out.") ;
$developer8  = "$developer8a<br>$developer8b<br>$developer8c<br>$developer8d" ;
$developer9 = lang("Warning:  This module does not work properly with RedHat7.3/KDE3/konqueror.  Other browsers work fine.") ;

For ($i=1;$i<=9;$i++) {
	$user='user'.$i;
	$auditor='auditor'.$i;
	$developer='developer'.$i;
	$t->set_var('user',$$user);
	$t->set_var('auditor',$$auditor);
	$t->set_var('developer',$$developer);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_row','detail',True);
	}

$t->set_var('lang_ack',lang('ACKNOWLEDGEMENT'));
$t->set_var('lang_date',lang('Date'));
$t->set_var('lang_detail',lang('Detail'));
$t->set_var('lang_contributor',lang('Contributor'));

$dates = array(
		lang("Pre-2002-02-12"),
		lang("2002-02-12")
		) ;
$details = array(
		lang("Predecessor of CK-Ledger is an Open Source accounting software"),
		lang("CK-Ledger v.0.0.5; LedgerAdmin being a sub-module")
		) ;
$contributors = array (
		lang("Developers of this Open Source accounting software") ,
		lang("Wu Chiu Kay aka CK Wu aka CK")
		) ;

foreach ($dates as $key => $date ) {
	$t->set_var('date',$date);
	$t->set_var('detail',$details[$key]);
	$t->set_var('contributor',$contributors[$key]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('ack_row','ack',True);
	}

$t->pparse('out','report', true);
$phpgw->common->phpgw_footer();

?>
