<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: loglist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledadmin', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report' => 'loglist.tpl', 'log' => 'loglist.tpl'));
	$t->set_block('log','log_row','log_section');

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of log entries'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('done'));
$t->set_var('add_action',$phpgw->link('/ck-ledadmin/logfilter.php'));

$t->set_var('sort_date',$phpgw->nextmatchs->show_sort_order($sort,'date',$order,'/ck-ledadmin/loglist.php',lang('Date (yyyymmdd)')));
$t->set_var('sort_time',$phpgw->nextmatchs->show_sort_order($sort,'time',$order,'/ck-ledadmin/loglist.php',lang('Time')));
$t->set_var('sort_trans_id',$phpgw->nextmatchs->show_sort_order($sort,'trans_id',$order,'/ck-ledadmin/loglist.php',lang('Transaction ID')));
$t->set_var('sort_app',$phpgw->nextmatchs->show_sort_order($sort,'app',$order,'/ck-ledadmin/loglist.php',lang('Application')));
$t->set_var('sort_op',$phpgw->nextmatchs->show_sort_order($sort,'op',$order,'/ck-ledadmin/loglist.php',lang('Operation')));
$t->set_var('sort_script',$phpgw->nextmatchs->show_sort_order($sort,'script',$order,'/ck-ledadmin/loglist.php',lang('Script')));
$t->set_var('sort_userid',$phpgw->nextmatchs->show_sort_order($sort,'userid',$order,'/ck-ledadmin/loglist.php',lang('User')));
$t->set_var('sort_id',$phpgw->nextmatchs->show_sort_order($sort,'id',$order,'/ck-ledadmin/loglist.php',lang('Log Table Id')));

if (!$order) {$order = "date" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from log $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'date'		=> lang("No Matching Item Found"),
				'time'		=> "",
				'trans_id'	=> "",
				'app'		=> "",
				'op'		=> "",
				'script'	=> "",
				'userid'	=> "",
				'id'		=> ""	 ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('log_section','log_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$op = $phpgw->db->f('op') ;
	switch ($op) :
		case "new" :	$lang_op = lang("new");		break;
		case "edit" :	$lang_op = lang("edit");	break;
		case "delete" :	$lang_op = lang("delete");	break;
		case "start" :	$lang_op = lang("start");	break;
		case "clear" :	$lang_op = lang("clear");	break;
		default:	$lang_op = lang("Error: please inform sysadmin");	break;
		endswitch ;
	$t->set_var(array(	'date'		=> $phpgw->db->f('date'),
				'time'		=> $phpgw->db->f('time'),
				'trans_id'	=> $phpgw->db->f('trans_id'),
				'app'		=> $phpgw->db->f('app'),
				'op'		=> $lang_op,
				'script'	=> $phpgw->db->f('script'),
				'userid'	=> $phpgw->db->f('userid'),
				'id'		=> $phpgw->db->f('id')			)) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('log_section','log_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','log','report');
	$phpgw->common->phpgw_footer();
?>
