<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: remarklist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledadmin', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'remarklist.tpl',	'remark'=>'remarklist.tpl'));
	$t->set_block('remark','remark_row','remark_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Standard Remark'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Remark'));
$t->set_var('add_action',$phpgw->link('/ck-ledadmin/remarkadd.php',"filter=$filter"));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-ledadmin/remarklist.php',lang('Name'),$filter));
$t->set_var('sort_detail',$nm->show_sort_order($sort,'detail',$order,'/ck-ledadmin/remarklist.php',lang('Detail'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-ledadmin/remarklist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from remark $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'detail'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('remark_section','remark_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'detail'	=> $phpgw->db->f('detail'),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-ledadmin/remarkview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-ledadmin/remarkedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-ledadmin/remarkcopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-ledadmin/remarkdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('remark_section','remark_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','remark','report');
?>
