<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: accountfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$description = ($_GET["description"]) ? $_GET["description"] : $_POST["description"] ;
	$category = ($_GET["category"]) ? $_GET["category"] : $_POST["category"] ;
	$type = ($_GET["type"]) ? $_GET["type"] : $_POST["type"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','filter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among existing Accounts :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Searching Criteria --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$filter = array (	cond1		=>	lang('Account# from') ,
			condvalue1	=>	'from' ,
			conddefault1	=>	'' ,
			condnote1	=>	lang('Account search starts from this number (format:9999)'),
			cond2		=>	lang('Account# to') ,
			condvalue2	=>	'to' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Account search ends at this number (format:9999)') ,
			cond3		=>	lang('Description') ,
			condvalue3	=>	'description' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Search for target key word in the account description field') ,
			cond4		=>	lang('Category') ,
			condvalue4	=>	'category' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for specific category of account (format: A=asset, L=liability, Q=Equity, I=income, E=expense)') ,
			cond5		=>	lang('Type') ,
			condvalue5	=>	'type' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for specific type of account (format: A=posting a/c, H=heading a/c)') ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $from ;
	$filter["conddefault2"] = $to ;
	$filter["conddefault3"]	= $description ;
	$filter["conddefault4"] = $category ;
	$filter["conddefault5"] = $type ;
	}

For ($i=1;isset($filter['cond'.$i]);$i++)	{

	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('value',$filter['condvalue'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

$t->set_var('search_action',$phpgw->link('/ck-ledger/accountfilter_validate.php')) ;
$t->set_var('lang_search',lang('Start Search'));
$t->set_var('add_action',$phpgw->link('/ck-ledger/accountadd.php')) ;
$t->set_var('lang_add',lang('Add New Account'));

$t->pparse('out','report',True);

?>
