<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: accountfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array(	'currentapp'		=> 'ck-ledger',
					'noheader'		=> True,
					'nonavbar'		=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$description = ($_GET["description"]) ? $_GET["description"] : $_POST["description"] ;
	$category = ($_GET["category"]) ? $_GET["category"] : $_POST["category"] ;
	$type = ($_GET["type"]) ? $_GET["type"] : $_POST["type"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)			$err=lang("Error:  Error flagged before validation") ;
	if ($from<>"" and $from<=0)	$err=lang("Error: Invalid starting account number");
	if ($to<>"" and $to>9999)	$err=lang("Error: Invalid ending account number");
	if ($category<>"" and $category<>"A" and $category<>"L" and $category<>"Q" and $category<>"I" and $category<>"E")
					$err=lang("Error: Invalid account category");
	if ($type<>"" and $type<>"A" and $type<>"H")	$err=lang("Error: Invalid account type");

	if ($err)			$err="<b>$err</b>" ;
/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
		$where = " WHERE 1=1 " ;
		if ($from)		$where .= " AND accno >= '$from' ";
		if ($to)		$where .= " AND accno <= '$to' " ;
		if ($description)	$where .= " AND lower(description) like lower('%$description%') " ;
		if ($category)		$where .= " AND category = '$category' " ;
		if ($type)		$where .= " AND charttype = '$type' " ;

		$where = urlencode($where) ;

		Header('Location: '.$phpgw->link("/ck-ledger/accountlist.php","filter=$where"));
		$phpgw->common->phpgw_exit();
		}
	else
		{
		$err = urlencode($err) ;
		$getstr = "from=$from&to=$to&description=$description&category=$category&type=$type&err=$err" ;
		$return = $phpgw->link("/ck-ledger/accountfilter.php",$getstr) ;
		Header('Location: '.$return);
		$phpgw->common->phpgw_exit();
		}

?>
