<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.account.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class account {

//---- Account Detail Validation Checks

    function account_validate($a,$oldaccno) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	if ($a[accno]=="")			$err=lang("Account Number Missing");
		elseif (!is_numeric($a[accno]))	$err=lang("Account# must be numberic");
	    	else {
			$phpgw->db->query("SELECT * from chart WHERE accno=$a[accno]");
			if ($phpgw->db->num_rows()<>0 and $a[accno]<>$oldaccno)
						$err=lang("Account# already exists");
		}
	if ($a[charttype]=='H') {
		foreach ($a as $key=>$value)
			if (ord($key)>=ord("A") and ord($key)<=ord("Z")) $err=lang("HEADING account cannot have any flag on") ;
		}
	if (strlen($a[description])>20)		$err=lang("Description too long") ;
	if ($err)				$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Account Detail to Database

    function account_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$link = "" ;
	$link.= ($a[AR])	?	":AR" : "" ;
	$link.= ($a[AP])	?	":AP" : "" ;
	$link.= ($a[IC])	?	":IC" : "" ;
	$link.= ($a[AR_amount])	?	":AR_amount" : "" ;
	$link.= ($a[AR_tax])	?	":AR_tax" : "" ;
	$link.= ($a[AR_paid])	?	":AR_paid" : "" ;
	$link.= ($a[AP_amount])	?	":AP_amount" : "" ;
	$link.= ($a[AP_tax])	?	":AP_tax" : "" ;
	$link.= ($a[AP_paid])	?	":AP_paid" : "" ;
	$link.= ($a[IC_sale])	?	":IC_sale" : "" ;
	$link.= ($a[IC_cogs])	?	":IC_cogs" : "" ;
	$link.= ($a[IC_income])	?	":IC_income" : "" ;
	$link.= ($a[IC_expense])?	":IC_expense" : "" ;
	$link.= ($a[IC_taxpart])?	":IC_taxpart" : "" ;
	$link.= ($a[IC_taxservice])?	":IC_taxservice" : "" ;
	$link.= ($a[CT_tax])	?	":CT_tax" : "" ;
	$link.= ($a[SV_income]) ?	":SV_income" : "" ;
	$link.= ($a[SV_expense])?	":SV_expense" : "" ;
	$link.= ($a[CS])	?	":CS" : "" ;
	$link.= ($a[CS_tax])	?	":CS_tax" : "" ;
	$link.= ($a[PY])?		":PY" : "" ;
	$link.= ($a[PY_expense])?	":PY_expense" : "" ;
	$link.= ($a[PY_paid])?		":PY_paid" : "" ;

	$id = $a[id] ;
	$app = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql ="INSERT INTO chart (id,accno,description,charttype,gifi,category,link) VALUES " ;
			$sql.="('$id','$a[accno]','$a[description]','$a[charttype]','$a[gifi]','$a[category]','$link')" ;
			$phpgw->db->query($sql);
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE chart SET accno='$a[accno]',description='$a[description]'," ;
			$sql.="charttype='$a[charttype]',gifi='$a[gifi]',category='$a[category]',link='$link' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from chart where id = $id");
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Account") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Account Detail

    function account_write(&$t, $a) {
	global $phpgw,$phpgw_info ;

	$cat_selectlist = "<OPTION value='A'>".lang('Asset')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='L'>".lang('Liability')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='Q'>".lang('Equity')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='I'>".lang('Income')."</OPTION>" ;
	$cat_selectlist.= "<OPTION value='E'>".lang('Expense')."</OPTION>" ;
	$type_selectlist = "<OPTION value='H'>".lang('HEADING (NO POSTING)')."</OPTION>" ;
	$type_selectlist.= "<OPTION value='A'>".lang('Account - posting allowed')."</OPTION>" ;

	/* ------------------- Print Account Details -------------------------------- */

	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_id',lang('Audit Id'));
	$t->set_var('lang_category',lang('Category'));
	$t->set_var('lang_type',lang('Type'));
	$t->set_var('lang_extcode',lang('Account code for external interface')) ;

	$category = $a[category] ;
	$t->set_var('cat_selectlist',str_replace("'$category'","'$category'"." selected",$cat_selectlist)) ;
	$type = $a[charttype] ;
	$t->set_var('type_selectlist',str_replace("'$type'","'$type'"." selected",$type_selectlist)) ;
	$link = $a[link] ;

	$t->set_var('accno',$a[accno]);
	$t->set_var('description',$a[description]);
	$t->set_var('id',$a[id]);
	$t->set_var('gifi',$a[gifi]);

	/*----------------- Print Account Flag Details -------------------------------------- */

	$t->set_var('lang_subtitle',lang('Account Flag Settings (Notes:  These settings should only be modified by an accountant fully conversant with the underlying operations of this ledger)')) ;
	$t->set_var('lang_flag_message',lang('Flag message to be defined')) ;
	$t->set_var('lang_flag',lang('(On/Off) Flag'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_accnolist',lang('Ledger accounts with target flag set "on"')) ;

	$ar_checked = (substr_count(str_replace("AR_","",$link),"AR")>0 or $a[AR]) ? "checked" : "" ;
	$ap_checked = (substr_count(str_replace("AP_","",$link),"AP")>0 or $a[AP]) ? "checked" : "" ;
	$ic_checked = (substr_count(str_replace("IC_","",$link),"IC")>0 or $a[IC]) ? "checked" : "" ;
	$py_checked = (substr_count(str_replace("PY_","",$link),"PY")>0 or $a[PY]) ? "checked" : "" ;
	$ar_amount_checked = (substr_count($link,"AR_amount")>0 or $a[AR_amount]) ? "checked" : "" ;
	$ar_tax_checked = (substr_count($link,"AR_tax")>0 or $a[AR_tax]) ? "checked" : "" ;
	$ar_paid_checked = (substr_count($link,"AR_paid")>0 or $a[AR_paid]) ? "checked" : "" ;
	$ap_amount_checked = (substr_count($link,"AP_amount")>0 or $a[AP_amount]) ? "checked" : "" ;
	$ap_tax_checked = (substr_count($link,"AP_tax")>0 or $a[AP_tax]) ? "checked" : "" ;
	$ap_paid_checked = (substr_count($link,"AP_paid")>0 or $a[AP_paid]) ? "checked" : "" ;
	$ic_sale_checked = (substr_count($link,"IC_sale")>0 or $a[IC_sale]) ? "checked" : "" ;
	$ic_cogs_checked = (substr_count($link,"IC_cogs")>0 or $a[IC_cogs]) ? "checked" : "" ;
	$ic_income_checked = (substr_count($link,"IC_income")>0 or $a[IC_income]) ? "checked" : "" ;
	$ic_expense_checked = (substr_count($link,"IC_expense")>0 or $a[IC_expense]) ? "checked" : "" ;
	$ic_taxpart_checked = (substr_count($link,"IC_taxpart")>0 or $a[IC_taxpart]) ? "checked" : "" ;
	$ic_taxservice_checked = (substr_count($link,"IC_taxservice")>0 or $a[IC_taxservice]) ? "checked" : "" ;
	$ct_tax_checked = (substr_count($link,"CT_tax")>0 or $a[CT_tax]) ? "checked" : "" ;
	$sv_income_checked = (substr_count($link,"SV_income")>0 or $a[SV_income]) ? "checked" : "" ;
	$sv_expense_checked = (substr_count($link,"SV_expense")>0 or $a[SV_expense]) ? "checked" : "" ;
	$cs_checked = (substr_count(str_replace("CS_","",$link),"CS")>0 or $a[CS]) ? "checked" : "" ;
	$cs_tax_checked = (substr_count($link,"CS_tax")>0 or $a[CS_tax]) ? "checked" : "" ;
	$py_expense_checked = (substr_count($link,"PY_expense")>0 or $a[PY_expense]) ? "checked" : "" ;
	$py_paid_checked = (substr_count($link,"PY_paid")>0 or $a[PY_paid]) ? "checked" : "" ;

	$flag = array (	flag1	=>	'AR' ,
		flagchecked1	=>	"$ar_checked" ,
		flagmessage1	=>	lang('On = allow posting of [Dr/Cr - A/Cs Receivable] journal entry from AR'),
		flag2		=>	'AR_amount' ,
		flagchecked2	=>	"$ar_amount_checked" ,
		flagmessage2	=>	lang('On = allow posting of [Cr - Sales] journal entry from AR'),
		flag3		=>	'AR_tax' ,
		flagchecked3	=>	"$ar_tax_checked" ,
		flagmessage3	=>	lang('On = allow posting of [Cr - Tax Payable] journal entry from AR'),
		flag4		=>	'AR_paid' ,
		flagchecked4	=>	"$ar_paid_checked" ,
		flagmessage4	=>	lang('On = allow posting of [Dr - Bank/Cash(Receipt)] journal entry from AR') ,
		flag5		=>	'AP' ,
		flagchecked5	=>	"$ap_checked" ,
		flagmessage5	=>	lang('On = allow posting of [Dr/Cr - A/Cs Payable] journal entry from AP') ,
		flag6		=>	'AP_amount' ,
		flagchecked6	=>	"$ap_amount_checked" ,
		flagmessage6	=>	lang('On = allow posting of [Dr - Purchases/Expenses] journal entry from AP') ,
		flag7		=>	'AP_tax' ,
		flagchecked7	=>	"$ap_tax_checked" ,
		flagmessage7	=>	lang('On = allow posting of [Dr - Tax Recoverable] journal entry from AP') ,
		flag8		=>	'AP_paid' ,
		flagchecked8	=>	"$ap_paid_checked" ,
		flagmessage8	=>	lang('On = allow posting of [Cr - Bank/Cash(Payment)] journal entry from AP') ,
		flag9		=>	'IC' ,
		flagchecked9	=>	"$ic_checked" ,
		flagmessage9	=>	lang('On = allow posting of [Dr/Cr - Inventory] journal entry from AP/AR') ,
		flag10		=>	'IC_sale' ,
		flagchecked10	=>	"$ic_sale_checked" ,
		flagmessage10	=>	lang('On = listed at Inventory Details page as Sales Account') ,
		flag11		=>	'IC_cogs' ,
		flagchecked11	=>	"$ic_cogs_checked" ,
		flagmessage11	=>	lang('On = allow posting of [Dr - COGS] journal entry from AR') ,
		flag12		=>	'SV_income' ,
		flagchecked12	=>	"$sv_income_checked" ,
		flagmessage12	=>	lang('On = listed at Service Details page as Income Account') ,
		flag13		=>	'SV_expense' ,
		flagchecked13	=>	"$sv_expense_checked" ,
		flagmessage13	=>	lang('On = listed at Service Details page as Expense Account') ,
		flag14		=>	'CS' ,
		flagchecked14	=>	"$cs_checked" ,
		flagmessage14	=>	lang('On = allow posting of [Dr - (Quasi)Cash] journal entry from POS') ,
		flag15		=>	'CS_tax' ,
		flagchecked15	=>	"$cs_tax_checked" ,
		flagmessage15	=>	lang('On = allow posting of [Cr - Tax Payable] journal entry from POS') ,
		flag16		=>	'PY' ,
		flagchecked16	=>	"$py_checked" ,
		flagmessage16	=>	lang('On = allow posting of [Dr/Cr - Payroll Payable] journal entry from Payroll'),
		flag17		=>	'PY_expense' ,
		flagchecked17	=>	"$py_expense_checked" ,
		flagmessage17	=>	lang('On = listed at Allowance/Deduction (Code) page as Payroll Expense Account') ,
		flag18		=>	'PY_paid' ,
		flagchecked18	=>	"$py_paid_checked" ,
		flagmessage18	=>	lang('On = allow posting of [Cr - Salary Payment] journal entry from Payroll') ,
		 ) ;

	For ($i=1;isset($flag['flag'.$i]);$i++)	{
		$pattern = $flag['flag'.$i] ;
		$t->set_var('flag',$pattern);
		$t->set_var('checked',$flag['flagchecked'.$i]);
		$select_filter = "WHERE link like '%$pattern:%' or link like '%$pattern'" ;
		$t->set_var('option_block',account_selectlist($select_filter));
		$t->set_var('msg',$flag['flagmessage'.$i]);
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}
    }

?>


