<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attrib.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class attrib {

//---- Attribute Detail Validation Checks

    function attrib_validate($a, $sdfld, $ldfld) {
	global $phpgw ;
	$err="";
	$error = lang("Error") ;
	$missing = lang("Missing") ;
	if ($a["$sdfld"]=="")		$err="$sdfld $missing";
	if ($a["$ldfld"]=="")		$err="$ldfld $missing";
	if ($err)			$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Attribute Detail to Database

    function attrib_post($a, &$t, $op, $script, $table, $caption, $sdfld, $ldfld) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $a[id] ;
	$sdesc	= $a["$sdfld"] ;
	$ldesc	= $a["$ldfld"] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO $table (id,$sdfld,$ldfld) VALUES('$id','$sdesc','$ldesc')";
			$phpgw->db->query($sql);
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE $table SET $sdfld='$sdesc',$ldfld='$ldesc' WHERE id=$id";
			$phpgw->db->query($sql);
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from $table where id = $id");
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$t->set_var("message","<b>$caption [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$caption [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Attribute Detail

    function attrib_write(&$t, &$a, $sdfld, $ldfld) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_sdfld',$sdfld);
	$t->set_var('lang_ldfld',$ldfld);
	$t->set_var('id',$a[id]);
	$t->set_var('sdfld',$sdfld);
	$t->set_var('ldfld',$ldfld);
	$t->set_var('sdesc',$a[$sdfld]);
	$t->set_var('ldesc',$a[$ldfld]);
	$t->parse('out','report',True);
	}

    }

?>
