<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: journaledit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$repl_nonbs = ($_GET["repl_nonbs"]) ? $_GET["repl_nonbs"] : $_POST["repl_nonbs"] ;
	$repl_all = ($_GET["repl_all"]) ? $_GET["repl_all"] : $_POST["repl_all"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$jnl = CreateObject('ck-ledger.journal') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$t->set_file('report','journalscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Journal'));
	$t->set_var('message',lang("B/S - Balance Sheet.")) ;

/*------------- Write Journal to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$phpgw->db->query("SELECT * FROM gl WHERE id='$id'");
		$phpgw->db->next_record();
		$jl = $phpgw->db->Record ;
		}
	    else $jl = $_POST ;
	$jnl->journal_header_write($t, $jl) ;

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$sql = "SELECT chart_id,attrib1,attrib2,attrib3,amount from acc_trans a, chart b " ;
		$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$jl['accno'.$i]		=	$phpgw->db->f('chart_id') ;
			$jl['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
			$jl['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
			$jl['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
			$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
			$dr			=	sprintf("%01.2f",-$cr) ;
			if ($cr>0)	$dr='';		else $cr='';
			$jl['dr'.$i]		= $dr ;
			$jl['cr'.$i]		= $cr ;
			$i++ ;
			}
		}
	    else $jl = $_POST ;

	if (isset($repl_all)) {
		For ($i=1;isset($jl['accno'.$i]);$i++) {
			$jl['attrib1'.$i]	=	$jl['attrib1_cap'] ;
			$jl['attrib2'.$i]	=	$jl['attrib2_cap'] ;
			$jl['attrib3'.$i]	=	$jl['attrib3_cap'] ;
			}
		}

	if (isset($repl_nonbs)) {
		For ($i=1;isset($jl['accno'.$i]);$i++) {
			$accid = $jl['accno'.$i] ;
			$phpgw->db->query("SELECT category FROM chart WHERE id='$accid'") ;
			$phpgw->db->next_record();
			$cat = $phpgw->db->f('category') ;
			if ($cat=="I" or $cat=="E") {
				$jl['attrib1'.$i]	=	$jl['attrib1_cap'] ;
				$jl['attrib2'.$i]	=	$jl['attrib2_cap'] ;
				$jl['attrib3'.$i]	=	$jl['attrib3_cap'] ;
				}
			}
		}

	$jnl->journal_detail_write($t, $jl, $posted, $insert, $delete, $newrow);

	$t->parse('out','report',True);

/*-------------- Post Journal----------------------------------------------*/

	if (isset($post)) {
		$err = $jnl->journal_validate($jl) ;
		$t->set_var('message',$err);
		if ($err=='') { $posted=$jnl->journal_post($jl,$t,'edit','journaledit'); }
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_replicate',lang('Replicate Attribute Values from Caption :'));
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-ledger/journallist.php',$getstr));
		$t->set_var('lang_nonbs',lang('Done'));
		$t->set_var('lang_all',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-ledger/journaledit.php',$getstr)) ;
		$t->set_var('lang_nonbs',lang('non B/S accounts only'));
		$t->set_var('lang_all',lang('All'));
		$t->set_var('lang_update',lang('Post Journal'));
		$t->set_var('lang_newrow',lang('Add new row'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link('/ck-ledger/journallist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
