<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: journalfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$source = ($_GET["source"]) ? $_GET["source"] : $_POST["source"] ;
	$description = ($_GET["description"]) ? $_GET["description"] : $_POST["description"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted Journals :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$dateformat = lang('Format: YYYY-MM-DD') ;

	$filter = array (
				ftr1		=>	lang('Date from') ,
				ftrtype1	=>	'input' ,
				ftrsl1		=>	'' ,
				ftrvar1		=>	'from' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	$dateformat ,

				ftr2		=>	lang('Date to') ,
				ftrtype2	=>	'input' ,
				ftrsl2		=>	'' ,
				ftrvar2		=>	'to' ,
				ftrdefault2	=>	'' ,
				ftrnote2	=>	$dateformat ,
				
				ftr3		=>	lang('Source') ,
				ftrtype3	=>	'input' ,
				ftrsl3		=>	'' ,
				ftrvar3		=>	'source' ,
				ftrdefault3	=>	'' ,
				ftrnote3	=>	lang('Search for target key word in the journal source field') ,

				ftr4		=>	lang('Description') ,
				ftrtype4	=>	'input' ,
				ftrsl4		=>	'' ,
				ftrvar4		=>	'description' ,
				ftrdefault4	=>	'' ,
				ftrnote4	=>	lang('Search for target key word in the journal description field') ,
									) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["conddefault1"] = $from ;
		$filter["conddefault2"] = $to ;
		$filter["conddefault3"]	= $source ;
		$filter["conddefault4"] = $description ;
		}

	$t->set_var('detail_section','');
	$t->set_var('select_section','');
	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
//		if (substr_count($filterstr,$i)==0)	continue ;
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-ledger/journalfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-ledger/journaladd.php')) ;
	$t->set_var('lang_add',lang('Add New Journal'));

	$t->pparse('out','report',True);

?>
