<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: journallist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'journallist.tpl',  'journals'=>'journallist.tpl'));
	$t->set_block('journals','journal_row','journal_section');

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Journals'));
$t->set_var('lang_viewonly',lang('Non-GL journals are view-only'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Journals'));
$t->set_var('add_action',$phpgw->link('/ck-ledger/journaladd.php',"filter=$filter"));
$t->set_var('lang_edit_hd',lang('Edit'));
$t->set_var('lang_view_hd',lang('View'));
$t->set_var('lang_copy_hd',lang('Copy/Modify'));
$t->set_var('lang_reverse_hd',lang('Reverse/Modify'));
$t->set_var('lang_delete_hd',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$langid = lang(' Id') ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-ledger/journallist.php',lang('Journal Date')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,'/ck-ledger/journallist.php',lang('Source')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-ledger/journallist.php',lang('Description')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-ledger/journallist.php',lang('Audit Id')));

$sql =  "SELECT * from gl $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'lang_view'	=> lang('View'),
				'lang_edit'	=> lang('Edit'),
				'lang_copy'	=> lang('Copy/Modify'),
				'lang_reverse'	=> lang('Reverse/Modify'),
				'lang_delete'	=> lang('Delete'),
				'transdate'	=> lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'reverse'	=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('journal_section','journal_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$getstr  = "id=$id&filter=$filter" ;
	$t->set_var(array(
		'lang_view'		=> lang('View'),
		'lang_edit'		=> lang('Edit'),
		'lang_copy'		=> lang('Copy/Modify'),
		'lang_reverse'		=> lang('Reverse/Modify'),
		'lang_delete'		=> lang('Delete'),
		'transdate'		=> $phpgw->db->f('transdate'),
		'source'		=> $phpgw->db->f('source'),
		'description'		=> $phpgw->db->f('description'),
		'id'			=> $id,
		'view'			=> $phpgw->link('/ck-ledger/journalview.php',$getstr),
		'edit'			=> $phpgw->link('/ck-ledger/journaledit.php',$getstr),
		'copy'			=> $phpgw->link('/ck-ledger/journalcopy.php',$getstr),
		'reverse'		=> $phpgw->link('/ck-ledger/journalreverse.php',$getstr),
		'delete'		=> $phpgw->link('/ck-ledger/journaldelete.php',$getstr) ));
	if (substr($phpgw->db->f('source'),0,2)<>"GL") {
		$t->set_var(array(	'lang_edit'	=> "",
					'lang_copy'	=> "",
					'lang_reverse'	=> "",
					'lang_delete'	=> "",
					'edit'		=> "",
					'copy'		=> "",
					'reverse'	=> "",
					'delete'	=> "")) ;
		}
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('journal_section','journal_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','journals','report');
?>
