<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array(	'currentapp'		=> 'ck-ledger',
					'noheader'		=> True,
					'nonavbar'		=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$account = ($_GET["account"]) ? $_GET["account"] : $_POST["account"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;
	$rdate_curr = ($_GET["rdate_curr"]) ? $_GET["rdate_curr"] : $_POST["rdate_curr"] ;
	$datefrom_curr = ($_GET["datefrom_curr"]) ? $_GET["datefrom_curr"] : $_POST["datefrom_curr"] ;
	$dateto_curr = ($_GET["dateto_curr"]) ? $_GET["dateto_curr"] : $_POST["dateto_curr"] ;
	$rdate_comp = ($_GET["rdate_comp"]) ? $_GET["rdate_comp"] : $_POST["rdate_comp"] ;
	$datefrom_comp = ($_GET["datefrom_comp"]) ? $_GET["datefrom_comp"] : $_POST["datefrom_comp"] ;
	$dateto_comp = ($_GET["dateto_comp"]) ? $_GET["dateto_comp"] : $_POST["dateto_comp"] ;

/* --------------------- Validation Check Start ----------------------------	*/
	
	if (!$rdate_curr)			$rdate_curr = date("Y-m-d") ;

	$error = lang("Error") ;
	if ($repnum<1 or $repnum>6)		$err=lang("Invalid Report Number") ;
	if ($repnum==1 and !$rdate_curr)	$err=lang("Report Status Date (Current) missing");
	if ($repnum==2 and (!$datefrom_curr or !$dateto_curr or !$datefrom_comp or !$dateto_comp))
			$err=lang("Missing one of these:  Date from/to (Current/Comparison)");
	if ($repnum==3 and (!$rdate_curr or !$rdate_comp))
			$err=lang("Missing Report Status Date (Current or Comparison)");
	if ($repnum==4 and (!$datefrom_curr or !$dateto_curr))
			$err=lang("Missing Date from/to (Current).");
	if ($repnum==5 and !$rdate_curr)	$err=lang("Report Status Date (Current) missing");
	if ($rdate_curr) {
		$date=input2date($rdate_curr) ;
		if ($date=="")
			$err=lang("Invalid Report Status Date (Current)"); else $rdate_curr = $date ;
		}
	if ($datefrom_curr) {
		$date=input2date($datefrom_curr) ;
		if ($date=="")
			$err=lang("Invalid Report from Date (Current)"); else $datefrom_curr=$date;
		}
	if ($dateto_curr) {
		$date=input2date($dateto_curr) ;
		if ($date=="")
			$err=lang("Invalid Report to Date (Current)"); else $dateto_curr=$date ;
		}
	if ($rdate_comp) {
		$date=input2date($rdate_comp) ;
		if ($date=="")
			$err=lang("Invalid Report Status Date (Comparison)"); else $rdate_comp=$date;
		}
	if ($datefrom_comp) {
		$date=input2date($datefrom_comp) ;
		if ($date=="")
			$err=lang("Invalid Report from Date (Comparison)"); else $datefrom_comp=$date;
		}
	if ($dateto_comp) {
		$date=input2date($dateto_comp) ;
		if ($date=="")
			$err=lang("Invalid Report to Date (Comparison)"); else $dateto_comp=$date ;
		}
	if ($repnum==4 and (strtotime($dateto_curr)-strtotime($datefrom_curr))>200*24*60*60)
			$err=lang("(DateTo-DateFrom) must be < 200 days") ;
	if ($repnum==4 and !$err)	{
		$user = trim($phpgw_info["user"]["userid"]);
		$phpgw->db->query("SELECT * FROM resourcelock WHERE resource='ledgerlisting'");
		$phpgw->db->next_record() ;
		$used_by = $phpgw->db->f('used_by') ;
		if ($used_by=="") $phpgw->db->query("UPDATE resourcelock SET used_by='$user'");
			else $err=lang("Ledger Listing is being accessed by ").$used_by;
		}

	if ($err)	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

if (!$err)
	{
	switch ($repnum) {
		case 1:
			$getstr = "report_date=$rdate_curr&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.$phpgw->link("/ck-ledger/trialbalance.php",$getstr));
			$phpgw->common->phpgw_exit();
		case 2:
			$getstr = "start_this_period=$datefrom_curr&end_this_period=$dateto_curr&" ;
			$getstr.= "start_last_period=$datefrom_comp&end_last_period=$dateto_comp&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.$phpgw->link("/ck-ledger/incomestatement.php",$getstr));
			$phpgw->common->phpgw_exit();
		case 3:
			$getstr = "this_period=$rdate_curr&last_period=$rdate_comp&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.$phpgw->link("/ck-ledger/balancesheet.php",$getstr));
			$phpgw->common->phpgw_exit();
		case 4:
			$getstr = "start_date=$datefrom_curr&end_date=$dateto_curr&account=$account&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.$phpgw->link("/ck-ledger/ledgerlisting.php",$getstr));
			$phpgw->common->phpgw_exit();
		case 5:
			$getstr = "status_date=$rdate_curr" ;
			Header('Location: '.$phpgw->link("/ck-ledger/controlreport.php",$getstr));
			$phpgw->common->phpgw_exit();
		case 6:
			Header('Location: '.$phpgw->link("/ck-ledger/journalerrlist.php"));
			$phpgw->common->phpgw_exit();
		default:
			echo "Should not be here.  Weird Report Number" ;
		}
	}
else
	{
	$err = urlencode($err) ;
	$getstr = "repnum=$repnum&attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3&account=$account&";
	$getstr.= "rdate_curr=$rdate_curr&datefrom_curr=$datefrom_curr&dateto_curr=$dateto_curr&" ;
	$getstr.= "rdate_comp=$rdate_comp&datefrom_comp=$datefrom_comp&dateto_comp=$dateto_comp&" ;
	$getstr.= "err=$err" ;
	$return = $phpgw->link("/ck-ledger/reportfilter.php",$getstr) ;
	Header('Location: '.$return);
	$phpgw->common->phpgw_exit();
	}

?>
