<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: trialbalance.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"]["currentapp"] = 'ck-ledger';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$report_date = ($_GET["report_date"]) ? $_GET["report_date"] : $_POST["report_date"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$t->set_file('report','trialbalance.tpl');
	$t->set_block('report','account_row','account_section');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_trial_balance', lang('TRIAL BALANCE'));
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$phpgw->db->query('Select * from defaults');
		$phpgw->db->next_record();
		$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');	$a1ldf = $phpgw->db->f('attrib1ldesc');
		$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');	$a2ldf = $phpgw->db->f('attrib2ldesc');
		$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');	$a3ldf = $phpgw->db->f('attrib3ldesc');
		if ($attrib1<>'') {
			$phpgw->db->query("Select * from $a1tbl where id=$attrib1"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$phpgw->db->query("Select * from $a2tbl where id=$attrib2"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$phpgw->db->query("Select * from $a3tbl where id=$attrib3"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_notes', lang('Click (Detail) to review journal history'));
	$t->set_var('lang_account_desc', lang('ACCOUNT NUMBER AND DESCRIPTION'));
	$t->set_var('lang_dr', lang('DEBIT'));
	$t->set_var('lang_cr', lang('CREDIT'));
	$t->set_var('lang_total', lang('TOTAL'));
	$t->set_var('lang_detail', lang('DETAIL'));

	$user = trim($phpgw_info["user"]["userid"]);
	$temp1 = "gl1".$user.time() ;
	$temp2 = "gl2".$user.time() ;

/*-----------------Write Account List and Balances---------------------------------*/

$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT chart_id, 0.00 as dr, sum(amount) as cr FROM acc_trans " ;
$sql.=	"WHERE transdate<='$report_date' " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY chart_id ORDER BY chart_id" ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE $temp2 SET dr = -cr, cr = 0 WHERE cr < 0");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT accno,description,dr,cr,chart_id FROM $temp2,chart WHERE chart_id=id order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");
if ($phpgw->db->num_rows()==0) {
	$t->set_var('account_number','') ;
	$t->set_var('account_desc','');
	$t->set_var('dr_amount','-') ;
	$t->set_var('cr_amount','-') ;
	$t->parse('account_section','account_row',True);
	}
$dr_total = 0;
$cr_total = 0;
while ($phpgw->db->next_record()) {

	$accno			=	$phpgw->db->f('accno') ;
	$desc			=	$phpgw->db->f('description') ;
	$dr_amount		=	sprintf("%01.2f",$phpgw->db->f('dr'));
	$cr_amount		=	sprintf("%01.2f",$phpgw->db->f('cr'));
	$chart_id		=	$phpgw->db->f('chart_id') ;
	if ($dr_amount==0)		$dr_amount='-' ;
	if ($cr_amount==0)		$cr_amount='-' ;
	$dr_total		+=	$dr_amount ;
	$cr_total		+=	$cr_amount ;
	$filter = urlencode(" WHERE id=$chart_id ") ;
	$end = $report_date ;
	$getstr = "id=$chart_id&filter=$filter&attrib1=$attrib1&" ;
	$getstr.= "attrib2=$attrib2&attrib3=$attrib3&end=$end" ;
	$detail = $phpgw->link('/ck-ledger/accounthist.php',$getstr);
	$t->set_var('account_number',$accno) ;
	$t->set_var('account_desc',$desc);
	$t->set_var('dr_amount',$dr_amount) ;
	$t->set_var('cr_amount',$cr_amount) ;
	$t->set_var('detail',$detail) ;
	$t->parse('account_section','account_row', True);
	}

$t->set_var('total_dr',sprintf("%01.2f",$dr_total)) ;
$t->set_var('total_cr',sprintf("%01.2f",$cr_total)) ;

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link('/ck-ledger/reportfilter.php')) ;
    $t->set_var('lang_done',lang('Done'));
    $t->pparse('out','report');

?>
