<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: contriedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$oldctname = ($_GET["oldctname"]) ? $_GET["oldctname"] : $_POST["oldctname"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$cntr = CreateObject('ck-payroll.contri') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('report','contriscreen.tpl') ;
	$t->set_block('report','exem','exem_section');
	$t->set_block('report','ratetbl','rate_section');
	$t->set_var('lang_title',lang('Edit Company Contribution Type'));
	$msg1 = lang("Contribution Amount = (PayrollTotal-ExemptItem-Floor) * Rate(Row i) - Subtract") ;
	$msg2 = lang("Rate(Row i) requires Step(Row i) < (PayrollTotal-ExemptItem-Floor) <= Step(Row i+1)") ;
	$msg3 = lang("It follows that Step values have to be arranged in strictly ascending order") ;
	$t->set_var('message',"$msg1<br>$msg2<br>$msg3");
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete)) {
		$phpgw->db->query("SELECT * FROM contri WHERE id='$id'");
		$phpgw->db->next_record();
		$ct = $phpgw->db->Record ;
		$ct[desc] = $phpgw->db->f('description') ;
		$oldctname = $ct[name] ;
		}
	    else $ct = $_POST ;
	$cntr->contri_header_write($t, $ct) ;

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete)) {
		$phpgw->db->query("SELECT * FROM cntrexem WHERE cntrid='$id' ORDER BY id");
		$i=1;
		while ($phpgw->db->next_record()) {
			$ct['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
			$ct['exemmin'.$i]	=	$phpgw->db->f('min') ;
			$ct['exemactmin'.$i]	=	$phpgw->db->f('actmin') ;
			$ct['exemmax'.$i]	=	$phpgw->db->f('max') ;
			$ct['exemactmax'.$i]	=	$phpgw->db->f('actmax') ;
			$i++ ;
			}
		$phpgw->db->query("SELECT * FROM cntrrate WHERE cntrid='$id' ORDER BY id");
		$i=1;
		while ($phpgw->db->next_record()) {
			$ct['step'.$i]		=	$phpgw->db->f('step') ;
			$ct['rate'.$i]		=	$phpgw->db->f('rate') ;
			$ct['subtract'.$i]	=	$phpgw->db->f('subtract') ;
			$i++ ;
			}
		}

	$cntr->contri_detail_write($t, $ct,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $cntr->contri_validate($ct,$oldctname) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$cntr->contri_post($ct,$t,'edit','contriedit');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter&oldctname=$oldctname" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-payroll/contrilist.php",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_exnewrow',lang('Done'));
		$t->set_var('lang_rtnewrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-payroll/contriedit.php",$getstr)) ;
		$t->set_var('lang_post',lang('Post Company Contribution Type'));
		$t->set_var('lang_exnewrow',lang('Add New ExemptItem Row'));
		$t->set_var('lang_rtnewrow',lang('Add New Rate Table Row'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-payroll/contrilist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
