<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"]["currentapp"] = 'ck-payroll';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Payroll Audit Control Report'));
	$t->set_var('lang_date', lang('System Date'));
	$t->set_var('lang_payroll', lang('Payroll<br>Master'));
	$t->set_var('lang_nrtran', lang('Non-recurring<br>Item'));
	$t->set_var('lang_eatype', lang('Allowance<br>/Deduction<br>Type'));
	$t->set_var('lang_rdtn', lang('Reduction<br>/Tax Type'));
	$t->set_var('lang_cntr', lang('Company<br>Contribution<br>Type'));
	$t->set_var('lang_history', lang('Payroll History'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_total_netp', lang('Total Net Salary'));
	$t->set_var('lang_total_cntr', lang('Total Company Contribution'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT sum(amount) as amount from pyrohist where  type='NETP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$history_netp = $phpgw->db->f('amount') ;

$sql =	"SELECT sum(amount) as amount from pyrohist where  type='CTCR'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$history_cntr = $phpgw->db->f('amount') ;


$sql =	"SELECT count(id) as count FROM payroll" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payroll_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM pynr_trans" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$nrtran_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM pyrcode" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$eatype_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM reductn" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$rdtn_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM contri" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$cntr_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(trans_id) as count FROM pyrohist" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$history_count = $phpgw->db->f('count') ;


$sql =	"SELECT max(id) as id FROM payroll" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payroll_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM pynr_trans" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$nrtran_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM pyrcode" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$eatype_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM reductn" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$rdtn_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM contri" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$cntr_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(trans_id) as id FROM pyrohist" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$history_id = $phpgw->db->f('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_history_netp',sprintf("%01.2f",$history_netp)) ;
$t->set_var('sys_history_cntr',sprintf("%01.2f",$history_cntr)) ;

$t->set_var('sys_payroll_count',$payroll_count) ;
$t->set_var('sys_nrtran_count',$nrtran_count) ;
$t->set_var('sys_eatype_count',$eatype_count) ;
$t->set_var('sys_rdtn_count',$rdtn_count) ;
$t->set_var('sys_cntr_count',$cntr_count) ;
$t->set_var('sys_history_count',$history_count) ;

$t->set_var('sys_payroll_id',$payroll_id) ;
$t->set_var('sys_nrtran_id',$nrtran_id) ;
$t->set_var('sys_eatype_id',$eatype_id) ;
$t->set_var('sys_rdtn_id',$rdtn_id) ;
$t->set_var('sys_cntr_id',$cntr_id) ;
$t->set_var('sys_history_id',$history_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-payroll/reportfilter.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');

?>
