<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payroll.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class payroll {

//---- payroll Validation Checks

    function payroll_validate($p,$oldempid) {
	global $phpgw ;

	$err=""; $error = lang("Error") ;
	$lang_bs = lang('basesalary') ;
	$row = lang("Row") ;
	$phpgw->db->query("SELECT * from payroll WHERE empid='$p[empid]'");
	if ($p[empid]<>$oldempid and $phpgw->db->num_rows()>0)
		$err=lang("Individual Staff Payroll for this employee already exists");
	$salary = $p[salary] ;
	$phpgw->db->query("SELECT * from pyrcode where name='$lang_bs'");
	$phpgw->db->next_record();
	if ($salary<$phpgw->db->f('minamt'))		$err=lang("Basic Salary too low");
	if ($salary>$phpgw->db->f('maxamt'))		$err=lang("Basic Salary too high");
	if ($salary=="")				$err=lang("Basic Salary Missing");
	if ($salary<>"" and !is_numeric($salary))	$err=lang("Basic Salary must be numeric");
	if ($p[bankac]=="")				$err=lang("Bank Account Number Missing");
	if ($p[bankacname]=="")				$err=lang("Bank Account Name Missing");
	$pyrbs = "" ;
	For ($i=1;isset($p['eaid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$eaid = $p['eaid'.$i] ;
		$qty = $p['qty'.$i] ;
		$amt = $p['amount'.$i] ;
		$eaid = ($eaid=="") ? 0 : $eaid ;
		$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
		$phpgw->db->next_record();
		if ($phpgw->db->f('name')==$lang_bs)	$pyrbs=$lang_bs ;
		if ($qty<$phpgw->db->f('minqty'))	$err=$rowi.lang("Quantity too low");
		if ($qty>$phpgw->db->f('maxqty'))	$err=$rowi.lang("Quantity too high");
		if ($amt<$phpgw->db->f('minamt'))	$err=$rowi.lang("Amount too low");
		if ($amt>$phpgw->db->f('maxamt'))	$err=$rowi.lang("Amount too high");
		if ($qty=="")				$err=$rowi.lang("Quantity Missing");
		if ($qty<>"" and !is_numeric($qty))	$err=$rowi.lang("Quantity must be numeric");
		if ($amt=="")				$err=$rowi.lang("Amount Missing");
		if ($amt<>"" and !is_numeric($amt))	$err=$rowi.lang("Amount must be numeric");
		if ($phpgw->db->f('single')=="y") {
			For ($j=1;isset($p['eaid'.$j]);$j++) {
				$rowj = "[$row $j]" ;
				if ($p['eaid'.$i]==$p['eaid'.$j] and $i<>$j)
					$err=$rowi.$rowj.lang("Duplicative Allowance/Deduction");
				}
			}
		}
	if ($p[salary]>0 and $pyrbs=='')		$err=lang("Recurring (basesalary) Missing") ;
	For ($i=1;isset($p['rdtnid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		For ($j=1;isset($p['rdtnid'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($p['rdtnid'.$i]==$p['rdtnid'.$j] and $i<>$j)
				$err=$rowi.$rowj.lang("Duplicative Reduction");
			}
		}
	For ($i=1;isset($p['cntrid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		For ($j=1;isset($p['cntrid'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($p['cntrid'.$i]==$p['cntrid'.$j] and $i<>$j)
				$err=$rowi.$rowj.lang("Duplicative Contribution");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post payroll to Database

    function payroll_post($p, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $p[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO payroll (id,empid,salary,period,chart_id,bankac,bankacname) ";
			$sql.= "VALUES ('$id','$p[empid]','$p[salary]','$p[period]','$p[chart_id]'," ;
			$sql.= "'$p[bankac]','$p[bankacname]')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE payroll SET empid='$p[empid]',salary='$p[salary]'," ;
			$sql.=			"period='$p[period]',chart_id='$p[chart_id]'," ;
			$sql.=			"bankac='$p[bankac]',bankacname='$p[bankacname]' " ;
			$sql.="WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from payroll where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	if ($op<>'new') {
		$phpgw->db->query("DELETE from pyrc_trans where pyroid='$id'");
		$phpgw->db->query("DELETE from rdtn_trans where pyroid='$id'");
		$phpgw->db->query("DELETE from cntr_trans where pyroid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($p['eaid'.$i]);$i++) {
			$eaid		=	$p['eaid'.$i];
			$qty		=	$p['qty'.$i] ;
			$unit		=	$p['unit'.$i] ;
			$unitamt	=	$p['unitamt'.$i] ;
			$rate		=	$p['rate'.$i] ;
			$amount		=	$p['amount'.$i] ;
			$comment	=	$p['comment'.$i] ;
			$chart_id	=	$p['chart_id'.$i] ;
			$sql = "INSERT INTO pyrc_trans (pyroid,pyrcodeid,qty,unit,unitamt,rate,amount,comment,chart_id)" ;
			$sql.=	"VALUES ('$id','$eaid','$qty','$unit','$unitamt','$rate','$amount','$comment','$chart_id')" ;
			$phpgw->db->query($sql);
			}
		For ($i=1;isset($p['rdtnid'.$i]);$i++) {
			$rdtnid		=	$p['rdtnid'.$i];
			$phpgw->db->query("INSERT INTO rdtn_trans (pyroid,rdtnid) VALUES ('$id','$rdtnid')");
			}
		For ($i=1;isset($p['cntrid'.$i]);$i++) {
			$cntrid		=	$p['cntrid'.$i];
			$phpgw->db->query("INSERT INTO cntr_trans (pyroid,cntrid) VALUES ('$id','$cntrid')");
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Payroll Master Record") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write payroll Header

    function payroll_header_write(&$t, &$p) {
	global $phpgw ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($p[period]) :
		case "mn" :	$p[daypay] = $p[salary]/$phpgw->db->f('mndfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$p[daypay] = $p[salary]/$phpgw->db->f('smdfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$p[daypay] = $p[salary]/$phpgw->db->f('wkdfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$p[daypay] = $p[salary] ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$p[daypay] = $p[salary] * $phpgw->db->f('dyhfactor') ;
				$p[hourpay] = $p[salary] ;				break ;
		endswitch ;
	$p[daypay] = sprintf("%01.2f",$p[daypay]) ;
	$p[hourpay] = sprintf("%01.2f",$p[hourpay]) ;
	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_account',lang('Payroll Liability Account'));
	$t->set_var('lang_bankac',lang('Bank A/C#'));
	$t->set_var('lang_bankacname',lang('Bank Account Name'));
	$t->set_var('employee_selectlist',employee_selectlist('',$p[empid])) ;
	$t->set_var('id',$p[id]) ;
	$t->set_var('salary',$p[salary]) ;
	$t->set_var('period_selectlist',pperiod_selectlist('',$p[period])) ;
	$t->set_var('daypay',$p[daypay]) ;
	$t->set_var('hourpay',$p[hourpay]) ;
	$account_sl = account_selectlist("WHERE link like '%PY:%' or link like '%PY'",$p[chart_id]) ;
	$t->set_var('account_selectlist',$account_sl) ;
	$t->set_var('bankac',$p[bankac]) ;
	$t->set_var('bankacname',$p[bankacname]) ;
	$t->parse('out','report',True);
	}

//---- Write payroll Detail

    function payroll_detail_write(&$t, &$p, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$rdrow_ = lang('rdRow')." " ;
	$ctrow_ = lang('ctRow')." " ;
	$id = $p[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_eaid',lang("Recurring Allowance/Deduction"));
	$t->set_var('lang_basis',lang("Basis of Calculation"));
	$t->set_var('lang_qty',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_unitamt',lang("Unit Amount"));
	$t->set_var('lang_rate',lang("Pay Rate"));
	$t->set_var('lang_amount',lang("Amount"));
	$t->set_var('lang_comment',lang("Comment"));
	$t->set_var('lang_chartid',lang("Payroll Expense Account") );
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('lang_reductn',lang("Summary Level Reduction"));
	$t->set_var('lang_rdtnid',lang("Reduction"));
	$t->set_var('lang_contri',lang("Company Contribution"));
	$t->set_var('lang_cntrid',lang("Contribution Type"));

	$eaid_sl = "<OPTION value=''></OPTION>".eaid_selectlist('','','short') ;
	$account_sl = account_selectlist("WHERE link like '%PY_expense%'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	$tot_amount = 0 ;
	For ($i=1;isset($p['eaid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('eaid_fld','eaid'.$i) ;
			$t->set_var('basis_fld','basis'.$i) ;
			$t->set_var('qty_fld','qty'.$i) ;
			$t->set_var('unit_fld','unit'.$i) ;
			$t->set_var('unitamt_fld','unitamt'.$i) ;
			$t->set_var('rate_fld','rate'.$i) ;
			$t->set_var('amount_fld','amount'.$i) ;
			$t->set_var('comment_fld','comment'.$i) ;
			$t->set_var('chart_id_fld','chart_id'.$i) ;
			$t->set_var('eaid_selectlist',$eaid_sl) ;
			$t->set_var('basis','') ;
			$t->set_var('qty','') ;
			$t->set_var('unit','') ;
			$t->set_var('unitamt','') ;
			$t->set_var('rate','') ;
			$t->set_var('amount','') ;
			$t->set_var('comment','') ;
			$t->set_var('chart_id_selectlist',$account_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$qty = 1 ;
		$eaid	=	($p['eaid'.$i]=="") ? 0 : $p['eaid'.$i] ;
		$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
		$phpgw->db->next_record();
		$basis		=	$phpgw->db->f('basis') ;
		$unit		=	$phpgw->db->f('unit') ;
		$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
		$rate		=	$phpgw->db->f('rate') ;
		$chart_id	=	($p['rate'.$i]==0) ? $phpgw->db->f('chart_id') : $p['chart_id'.$i] ;

		if (substr_count($basis,'qty')>0)	{$qty = $p['qty'.$i]; $t->set_var('qty_readonly','');}
			else				$t->set_var('qty_readonly','readonly') ;
		if (substr_count($basis,'bs')>0)	$unitamt = $p[salary] ;
		if (substr_count($basis,'hp')>0)	$unitamt = $p[hourpay] ;
		if (substr_count($basis,'dp')>0)	$unitamt = $p[daypay] ;
		$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
		if (substr_count($basis,'amt')>0)	{$amount=$p['amount'.$i]; $t->set_var('amt_readonly','');}
			else				$t->set_var('amt_readonly','readonly') ;
		$t->set_var('eaid_fld','eaid'.$j) ;
		$t->set_var('basis_fld','basis'.$j) ;
		$t->set_var('qty_fld','qty'.$j) ;
		$t->set_var('unit_fld','unit'.$j) ;
		$t->set_var('unitamt_fld','unitamt'.$j) ;
		$t->set_var('rate_fld','rate'.$j) ;
		$t->set_var('amount_fld','amount'.$j) ;
		$t->set_var('comment_fld','comment'.$j) ;
		$t->set_var('chart_id_fld','chart_id'.$j) ;
		$t->set_var('eaid_selectlist',str_replace("'$eaid'","'$eaid' selected",$eaid_sl)) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$p['qty'.$j] = $qty ;
		$p['amount'.$j] = $amount ;
		$t->set_var('comment',lang('recurring')) ;
		$t->set_var('chart_id_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$account_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done");  else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done");  else $t->set_var('delrowno',$row_.$j);
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		$tot_amount += $amount ;
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow==lang('Add New Recurring Allowance/Deduction Row')) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('eaid_fld','eaid'.$i) ;
		$t->set_var('basis_fld','basis'.$i) ;
		$t->set_var('qty_fld','qty'.$i) ;
		$t->set_var('unit_fld','unit'.$i) ;
		$t->set_var('unitamt_fld','unitamt'.$i) ;
		$t->set_var('rate_fld','rate'.$i) ;
		$t->set_var('amount_fld','amount'.$i) ;
		$t->set_var('comment_fld','comment'.$i) ;
		$t->set_var('chart_id_fld','chart_id'.$i) ;
		$t->set_var('eaid_selectlist',$eaid_sl) ;
		$t->set_var('basis','') ;
		$t->set_var('qty','') ;
		$t->set_var('unit','') ;
		$t->set_var('unitamt','') ;
		$t->set_var('rate','') ;
		$t->set_var('amount','') ;
		$t->set_var('comment','') ;
		$t->set_var('chart_id_selectlist',$account_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('tot_amount',$tot_amount) ;


	$rdtnid_sl = rdtnid_selectlist('','','short') ;
	if (isset($delete))	$delrowno = intval(str_replace($rdrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($p['rdtnid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('rdtnid_fld','rdtnid'.$j) ;
		$rdtnid = $p['rdtnid'.$i] ;
		$t->set_var('rdtnid_selectlist',str_replace("'$rdtnid'","'$rdtnid' selected",$rdtnid_sl)) ;

		if ($posted)	$t->set_var('rddelrowno',"done") ;
			else	$t->set_var('rddelrowno',$rdrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rdtn_section','rdtn', True);
		}
	if ($i==1)			$t->set_var('rdtn_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('rdtn_section','') ;
	if ($newrow==lang('Add New Reduction Row')) {
		$t->set_var('rdtnid_fld','rdtnid'.$i) ;
		$t->set_var('rdtnid_selectlist',$rdtnid_sl) ;
		$t->set_var('rddelrowno',$rdrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rdtn_section','rdtn', True);
		}


	$cntrid_sl = cntrid_selectlist('','','short') ;
	if (isset($delete))	$delrowno = intval(str_replace($ctrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($p['cntrid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		$j = $i ;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$t->set_var('cntrid_fld','cntrid'.$j) ;
		$cntrid = $p['cntrid'.$i] ;
		$t->set_var('cntrid_selectlist',str_replace("'$cntrid'","'$cntrid' selected",$cntrid_sl)) ;

		if ($posted)	$t->set_var('ctdelrowno',"done") ;
			else	$t->set_var('ctdelrowno',$ctrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('cntr_section','cntr', True);
		}
	if ($i==1)			$t->set_var('cntr_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('cntr_section','') ;
	if ($newrow==lang('Add New Contribution Row')) {
		$t->set_var('cntrid_fld','cntrid'.$i) ;
		$t->set_var('cntrid_selectlist',$cntrid_sl) ;
		$t->set_var('ctdelrowno',$ctrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('cntr_section','cntr', True);
		}


	$t->parse('out','report',True);
	}

    }

?>


