<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: functions.inc.php,v 0.0.5 2002/02/11 C K Wu $ */


// This is loaded by default

    function init() {
	}

//---- Set Up Employee Select List

    function employee_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT id,name FROM employee $filter ORDER BY name");
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id');
		$name = $phpgw->db->f('name');
		$selectlist .= "<OPTION value='$id'>$name -- $id</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Account Number Select Option List

    function account_selectlist($filter,$default) {
	global $phpgw ;

	$sql="SELECT id, accno,description FROM chart $filter ORDER BY accno" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$accno = $phpgw->db->f('accno');
		$description = $phpgw->db->f('description');
		$selectlist .= "<OPTION value='$id'>$accno -- $description</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Department Select Option List

    function dept_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT * FROM department $filter ORDER BY name");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name') ;
		$desc = substr($phpgw->db->f('description'),0,20);
		$selectlist .= "<OPTION value='$id'>$desc</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Project Select Option List

    function project_selectlist($filter,$default,$len) {
	global $phpgw ;

	$phpgw->db->query("SELECT * FROM project $filter ORDER BY name");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name') ;
		$desc = substr($phpgw->db->f('description'),0,20);
		if ($len=='long')	$selectlist .= "<OPTION value='$id'>$name -- $desc</OPTION>" ;
			else		$selectlist .= "<OPTION value='$id'>$name</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Achievement Select Option List

    function achieve_selectlist($filter,$default,$len) {
	global $phpgw ;

	$phpgw->db->query("SELECT * FROM achievement $filter ORDER BY name");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name') ;
		$desc = substr($phpgw->db->f('description'),0,20);
		if ($len=='long')	$selectlist .= "<OPTION value='$id'>$name -- $desc</OPTION>" ;
			else		$selectlist .= "<OPTION value='$id'>$name</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Code Type Select Option List

    function hrcodetype_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT distinct type FROM hrcode $filter ORDER BY type");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$type = $phpgw->db->f('type');
		$selectlist .= "<OPTION value='$type'>$type</OPTION>" ;
		}
	if ($default<>'')	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Payroll Allowance/Deduction Code Select Option List

    function eaid_selectlist($filter,$default,$len) {
	global $phpgw ;

	$sql="SELECT id,name,description FROM pyrcode $filter ORDER BY name" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name');
		$desc = $phpgw->db->f('description');
		if ($len=='long')	$selectlist .= "<OPTION value='$id'>$desc -- $id</OPTION>" ;
			else		$selectlist .= "<OPTION value='$id'>$name -- $id</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Summary Level Reduction Select Option List

    function rdtnid_selectlist($filter,$default,$len) {
	global $phpgw ;

	$sql="SELECT id,name,description FROM reductn $filter ORDER BY name" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name');
		$desc = $phpgw->db->f('description');
		if ($len=='long')	$selectlist .= "<OPTION value='$id'>$name -- $desc -- $id</OPTION>" ;
			else		$selectlist .= "<OPTION value='$id'>$name -- $id</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Company Contribution Select Option List

    function cntrid_selectlist($filter,$default,$len) {
	global $phpgw ;

	$sql="SELECT id,name,description FROM contri $filter ORDER BY name" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$name = $phpgw->db->f('name');
		$desc = $phpgw->db->f('description');
		if ($len=='long')	$selectlist .= "<OPTION value='$id'>$name -- $desc -- $id</OPTION>" ;
			else		$selectlist .= "<OPTION value='$id'>$name -- $id</OPTION>" ;
		}
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Pay Period Select Option List

    function pperiod_selectlist($filter,$default) {
	global $phpgw ;

	$selectlist = "<OPTION value='mn'>".lang('Month')." -- mn</OPTION>" ;
	$selectlist.= "<OPTION value='sm'>".lang('Semi-monthly')." -- sm</OPTION>" ;
	$selectlist.= "<OPTION value='wk'>".lang('Week')." -- wk</OPTION>" ;
	$selectlist.= "<OPTION value='dy'>".lang('Day')." -- dy</OPTION>" ;
	$selectlist.= "<OPTION value='hr'>".lang('Hour')." -- hr</OPTION>" ;
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Basis Select Option List

    function basis_selectlist($filter,$default) {
	global $phpgw ;

	$phpgw->db->query("SELECT distinct basis FROM pyrcode $filter ORDER BY basis");
	$selectlist = "" ;
	While ($phpgw->db->next_record()) {
		$basis = $phpgw->db->f('basis');
		$selectlist .= "<OPTION value='$basis'>$basis</OPTION>" ;
		}
	if ($default<>'')	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Year Select Option List

    function year_selectlist($filter,$default) {

	$selectlist = "" ;
	For ($i=1951;$i<=2050;$i++) 	$selectlist .= "<OPTION value='$i'>$i</OPTION>" ;
	if ($default<>"")	$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Month Select Option List

    function month_selectlist($filter,$default) {

	$selectlist = "" ;
	For ($i=1;$i<=12;$i++)	 {
		$j=sprintf("%02d",$i);
		$selectlist .= "<OPTION value='$j'>$j</OPTION>" ;
		}
	if ($default<>"") {
		$default = sprintf("%02d",$default);
		$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
		}
	return $selectlist ;
	}

//---- Set Up Week Select Option List

    function week_selectlist($filter,$default) {

	$selectlist = "" ;
	For ($i=1;$i<=53;$i++)	 {
		$j=sprintf("%02d",$i);
		$selectlist .= "<OPTION value='$j'>$j</OPTION>" ;
		}
	if ($default<>"") {
		$default = sprintf("%02d",$default);
		$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
		}
	return $selectlist ;
	}

//---- Set Up Day Select Option List

    function day_selectlist($filter,$default) {

	$selectlist = "" ;
	For ($i=1;$i<=31;$i++) {
		$j=sprintf("%02d",$i);
		$selectlist .= "<OPTION value='$j'>$j</OPTION>" ;
		}
	if ($default<>"") {
		$default = sprintf("%02d",$default);
		$selectlist = str_replace("'$default'","'$default' selected",$selectlist) ;
		}
	return $selectlist ;
	}

//---- This function, input2date($idate), is made to check date-input from an HTML-form
 //--- and bring it to the YYYY-MM-DD format that it can be
 //--- insertet in a Date-Field of a MySQL-Table.
 //
 //--- Input-Formats can be:
 //--- "d.m.y" or "y.m.d" or "d.m" or "d"
 //--- if year or month and year are missing, these values are
 //--- taken from the current date.
 //
 //--- When the result-String is empty, the date-input was wrong.
 //
 //--- Usage: $date_ok = input2date($date_from_form_field);
 //

 function input2date($idate)
 {
   $token= "-./ ";

   $p1 = strtok($idate,$token);
   $p2 = strtok($token);
   $p3 = strtok($token);
   $p4 = strtok($token);

   $date= "";
   $y= ""; $m= ""; $d= "";

    // check 'd.m.y'
   if (($p1>0 && $p1<32) &&
       ($p2>0 && $p2<13) &&
       ($p3>32))
   {
     $y=$p3;
     $m=$p2;
     $d=$p1;
   }

    // check 'y.m.d'
   if ($y ==  "" &&
       ($p1>32) &&
       ($p2>0 && $p2<13) &&
       ($p3>0 && $p3<32))
   {
     $y=$p1;
     $m=$p2;
     $d=$p3;
   }

    // check 'd.m'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2>0 && $p2<13) &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=$p2;
     $d=$p1;
   }

    // check 'd'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2== "") &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=date( "m");
     $d=$p1;
   }

    // add 1900 or 2000 to year
   if ($y!= "" && $y<=99)
   {
     if ($y>=70) $y = $y + 1900;
     if ($y<70) $y = $y + 2000;
   }

   if ($y!= "")
   {
     if (checkdate($m, $d, $y))
       $date= "$y-$m-$d";
   }

   return $date;
 }

    init();

?>
