<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: nrtransdelete.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$nrt = CreateObject('ck-payroll.nrtrans') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','nrtransscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang("Delete Non-recurring Payroll Item"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to delete ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-payroll/nrtransdelete.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-payroll/nrtranslist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$phpgw->db->query("SELECT empid FROM pynr_trans WHERE id='$id'");
		$phpgw->db->next_record();
		$nr[empid] = $phpgw->db->f('empid') ;
		$nr[id] = $id ;
		$nrt->nrtrans_post($nr, $t,'delete','nrtransdelete');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-payroll/nrtranslist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-payroll/nrtranslist.php',$getstr)) ;
		$t->pparse('out','question',True);
		exit;
		}

/*------------- Write Non-recurring Payroll Item ----------------------------*/

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM pynr_trans a, payroll b, pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$nr = $phpgw->db->Record ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($nr[period]) :
		case "mn" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('mndfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('smdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('wkdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$nr[daypay] = $nr[salary] ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$nr[daypay] = $nr[salary] * $phpgw->db->f('dyhfactor') ;
				$nr[hourpay] = $nr[salary] ;				break ;
		endswitch ;
	$nr[daypay] = sprintf("%01.2f",$nr[daypay]) ;
	$nr[hourpay] = sprintf("%01.2f",$nr[hourpay]) ;

	$nrt->nrtrans_write($t, $nr) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link('/ck-payroll/nrtranslist.php',$getstr));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-payroll/nrtranslist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>

