<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reductnadd.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$rdtn = CreateObject('ck-payroll.reductn') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('report','reductnscreen.tpl') ;
	$t->set_block('report','exem','exem_section');
	$t->set_block('report','ratetbl','rate_section');
	$t->set_var('lang_title',lang('Add Summary Level Reduction'));
	$msg1 = lang("Reduction Amount = (PayrollTotal-ExemptItem-Floor) * Rate(Row i) - Subtract") ;
	$msg2 = lang("Rate(Row i) requires Step(Row i) < (PayrollTotal-ExemptItem-Floor) <= Step(Row i+1)") ;
	$msg3 = lang("It follows that Step values have to be arranged in strictly ascending order") ;
	$t->set_var('message',"$msg1<br>$msg2<br>$msg3");
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Summary Level Reduction to Screen Display ----------------------------*/

	$rdtn->reductn_header_write($t, $_POST) ;
	$rdtn->reductn_detail_write($t, $_POST,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Summary Level Reduction ----------------------------------------------*/

	if (isset($post)) {
		$err = $rdtn->reductn_validate($_POST,'') ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$rdtn->reductn_post($_POST,$t,'new','reductnadd');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-payroll/reductnlist.php",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_exnewrow',lang('Done'));
		$t->set_var('lang_rtnewrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-payroll/reductnadd.php",$getstr)) ;
		$t->set_var('lang_post',lang('Post Summary Level Reduction'));
		$t->set_var('lang_exnewrow',lang('Add New ExemptItem Row'));
		$t->set_var('lang_rtnewrow',lang('Add New Rate Table Row'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-payroll/reductnlist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
