<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reductnlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'reductnlist.tpl', 'reductn'=>'reductnlist.tpl'));
	$t->set_block('reductn','reductn_row','reductn_section');
	$msg = lang('Currently, there is no plan to implement Summary Level Additions.') ;
	$t->set_var('message',$msg);
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang("List of Summary Level Reductions"));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-payroll/reductnlist.php',lang('Reduction Name')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-payroll/reductnlist.php',lang('Reduction Description')));
$t->set_var('sort_locality',$nm->show_sort_order($sort,'locality',$order,'/ck-payroll/reductnlist.php',lang('Locality')));
$t->set_var('sort_floor',$nm->show_sort_order($sort,'floor',$order,'/ck-payroll/reductnlist.php',lang('Floor')));
$t->set_var('sort_min',$nm->show_sort_order($sort,'min',$order,'/ck-payroll/reductnlist.php',lang('Minimum')));
$t->set_var('sort_max',$nm->show_sort_order($sort,'max',$order,'/ck-payroll/reductnlist.php',lang('Maximum')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-payroll/reductnlist.php',lang('Audit Id')));

if (!$order) $order = "name" ;
if (!$sort)  $sort = "ASC" ;
$phpgw->db->query("SELECT * FROM reductn $where order by $order $sort");

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'description'	=> "",
				'locality'	=> "",
				'floor'		=> "",
				'min'		=> "",
				'max'		=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('reductn_section','reductn_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f("name"),
				'description'	=> $phpgw->db->f("description"),
				'locality'	=> $phpgw->db->f("locality"),
				'floor'		=> $phpgw->db->f("floor"),
				'min'		=> $phpgw->db->f("min"),
				'max'		=> $phpgw->db->f("max"),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-payroll/reductnview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-payroll/reductnedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-payroll/reductncopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-payroll/reductndelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('reductn_section','reductn_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add Summary Level Reduction"));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/reductnadd.php',$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));

	$t->pparse('out','reductn','report');

?>
