<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: genpayrollfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Report to Generate and to set Reporting Parameters :'));
	$msg1 = lang('Generation of Payroll report requires lengthy processing time.') ;
	$msg2 = lang('You should initiate report generation only during off-peak hours.');
	$t->set_var('lang_search_message',"$msg1  $msg2");

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Reporting Parameters'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));

	$dateformat = lang('Format: YYYY-MM-DD') ;
	$note1 = lang("If wrong action chosen, click (Report) to restart.") ;
	$note1a = lang("Press (Start Report Generattion) one more time to start.") ;

	$replist = array (	1=>"<OPTION value='1'>1 -- ".lang('Reserved')."</OPTION>",
				2=>"<OPTION value='2'>2 -- ".lang('Reserved')."</OPTION>",
				3=>"<OPTION value='3'>3 -- ".lang('Reserved')."</OPTION>",
				4=>"<OPTION value='4'>4 -- ".lang('Reserved')."</OPTION>",
				5=>"<OPTION value='5'>5 -- ".lang('Payroll Audit Control Report')."</OPTION>" ,
											) ;
	$filter = array (
				ftr1		=>	lang('Which Report') ,
				ftrtype1	=>	'select' ,
				ftrsl1		=>	'' ,
				ftrvar1		=>	'repnum' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	$note1 ,

				ftr2		=>	lang('Report Status as of') ,
				ftrtype2	=>	'input' ,
				ftrsl2		=>	'' ,
				ftrvar2		=>	'rdate' ,
				ftrdefault2	=>	'' ,
				ftrnote2	=>	$dateformat ,
									) ;

	if ($repnum=="")	Foreach ($replist as $key=>$choice)	$filter[ftrsl1] .= $choice ;
		else		$filter[ftrsl1] = $replist[$repnum];

	switch ($repnum) :
		case "" :	$filterstr = "1" ; break;
		case "1" :	$filterstr = "1" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		case "2" :	$filterstr = "1" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		case "3" :	$filterstr = "1" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		case "4" :	$filterstr = "1" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		case "5" :	$filterstr = "1" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		endswitch ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $repnum ;
		$filter["ftrdefault2"] = $rdate ;
		}

	$t->set_var('detail_section','');
	$t->set_var('select_section','');
	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		if (substr_count($filterstr,$i)==0)	continue ;
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$noselect = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

//	$next = ($repnum=="") ? "reportfilter" : "reportfilter_validate.php" ;
	$next = ($repnum=="") ? "reportfilter_validate.php" : "reportfilter_validate.php" ;
	$t->set_var('search_action',$phpgw->link("/ck-payroll/$next")) ;
	$t->set_var('lang_search',lang('Start Report Generation'));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/index.php')) ;
	$t->set_var('lang_add',lang('Return to Index Page'));
	$t->pparse('out','report',True);

?>


