<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array(	'currentapp'	=> 'ck-payroll',
					'noheader'	=> True,
					'nonavbar'	=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)		$err="Error flagged before validation." ;
	$error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)		$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($rdate) {
		$date=input2date($rdate) ;
		if ($date=="")	$err=lang("Invalid Report Status Date");
			else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;
	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{
		switch ($repnum) {
			case 1:
				Header('Location: '.$phpgw->link("/ck-payroll/reportfilter.php"));
				exit();
			case 2:
				Header('Location: '.$phpgw->link("/ck-payroll/reportfilter.php"));
				exit();
			case 3:
				Header('Location: '.$phpgw->link("/ck-payroll/reportfilter.php"));
				exit();
			case 4:
				Header('Location: '.$phpgw->link("/ck-payroll/reportfilter.php"));
				exit();
			case 5:
				$getstr = "rdate=$rdate" ;
				Header('Location: '.$phpgw->link("/ck-payroll/controlreport.php",$getstr));
				exit();
			default:
				echo lang("Should not be here.  Weird Report Number") ;
			}
		}
	else
		{
		$err = urlencode($err) ;
		$getstr = "repnum=$repnum&rdate=$rdate&err=$err" ;
		$return = $phpgw->link("/ck-payroll/reportfilter.php",$getstr) ;
		Header('Location: '.$return);
		exit() ;
		}

?>

