<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: schequelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'schequelist.tpl', 'scheque'=>'schequelist.tpl'));
	$t->set_block('scheque','scheque_row','scheque_section');
	$t->set_var('message',lang('This list may serve as a template for the Staff Autopay List'));

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Past Period Payroll (Ready for Generating Salary Cheque) List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/genpayrollfilter.php'));

$t->set_var('sort_empid',$nm->show_sort_order($sort,'empid',$order,'/ck-payroll/schequelist.php',lang('Employee ID')));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-payroll/schequelist.php',lang('Employee Name')));
$t->set_var('sort_bankacname',$nm->show_sort_order($sort,'bankacname',$order,'/ck-payroll/schequelist.php',lang('Bank Account Name')));
$t->set_var('sort_bankac',$nm->show_sort_order($sort,'bankac',$order,'/ck-payroll/schequelist.php',lang('Bank Account#')));
$t->set_var('sort_datefrom',$nm->show_sort_order($sort,'datefrom',$order,'/ck-payroll/schequelist.php',lang('Date From')));
$t->set_var('sort_dateto',$nm->show_sort_order($sort,'dateto',$order,'/ck-payroll/schequelist.php',lang('Date To')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-payroll/schequelist.php',lang('Cheque Amount')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-payroll/schequelist.php',lang('Audit Id')));
$t->set_var('lang_generate',lang('Generate Cheque (and Payment Journal)'));

$lang_from = lang('from') ;
$lang_to = lang('to') ;
$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
$empidmarker = $lang_empid.'-' ; $empidmarkerlen = strlen($empidmarker) ;
$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
$topos = "position('$tomarker' in description)+$tomarkerlen" ;
$descdatefrom = "substring(description,$frompos,10)" ;
$descdateto = "substring(description,$topos,10)" ;

if (!$order)	$order = "datefrom,dateto" ;
if (!$sort)	$sort = "ASC" ;
$sql =	"SELECT b.empid,name,bankacname,bankac,$descdatefrom as datefrom,$descdateto as dateto,amount,a.id " ;
$sql.=	"FROM gl a, pyrohist b, employee c, payroll d " ;
$sql.=	"$where and source='PYRO' and trans_id=a.id and type='NETP' and b.empid=c.id and b.empid=d.empid " ;
$sql.=	"order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'empid'		=> lang("No Matching Item Found"),
				'name'		=> "",
				'bankacname'	=> "",
				'bankac'	=> "",
				'datefrom'	=> "",
				'dateto'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'generate'	=> "",
									));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('scheque_section','scheque_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$empid	= $phpgw->db->f('empid') ;
	$datefrom = $phpgw->db->f('datefrom') ;
	$dateto = $phpgw->db->f('dateto') ;
	$getstr	= "id=$id&empid=$empid&datefrom=$datefrom&dateto=$dateto&filter=$filter" ;
	$amount = $phpgw->db->f('amount');
	$t->set_var(array(	'empid'		=> $empid,
				'name'		=> $phpgw->db->f('name'),
				'bankacname'	=> $phpgw->db->f('bankacname'),
				'bankac'	=> $phpgw->db->f('bankac'),
				'datefrom'	=> $datefrom,
				'dateto'	=> $dateto,
				'amount'	=> $amount,
				'id'		=> $id,
				'generate'	=> $phpgw->link('/ck-payroll/salarycheque.php',$getstr)
										));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('scheque_section','scheque_row',true);
	$tot_amount += $amount ;
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_total',lang('Total'));
	$t->set_var('tot_amount',$tot_amount);

	$t->pparse('out','scheque','report');

?>
