<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pontbulkemail.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-po',
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$where = stripslashes($filter) ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$shipto = ($_GET["shipto"]) ? $_GET["shipto"] : $_POST["shipto"] ;
	$filter=urlencode(stripslashes($filter));
	$db_type = $phpgw_info["server"]["db_type"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$t->set_file('screen','confirm.tpl') ;
	$t->set_file('report','pontoff.tpl') ;
	$t->set_block('report','item_row','item_section');
	$t->set_block('report','done','done_section');
	$t->set_var('done_section',"") ;

	$thank = lang('Thank you for being our preferred supplier') ;
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$t->set_var('lang_po',lang('OFFICIAL PURCHASE ORDER'));
	$t->set_var('lang_transdate',lang('PO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_ponumber',lang('Number'));
	$t->set_var('lang_vendor',lang('Vendor:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$shipto = (!$shipto) ? $phpgw->db->f('company') : $shipto ;
	$shiptoaddr1 = $phpgw->db->f('addr1') ;
	$shiptoaddr2 = $phpgw->db->f('addr2') ;
	$shiptoaddr3 = $phpgw->db->f('addr3') ;
	$shiptoaddr4 = $phpgw->db->f('addr4') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$po_rmkid = $phpgw->db->f('po_rmkid') ;
	$phpgw->db->query("SELECT * FROM remark where id='$po_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('detail') ;

	echo "<br><br>",lang("<b>Purchase Order [no tax] Despatch Log</b>"),"<br><br>" ;

	if (!$order) $order = "transdate" ;
	if (!$sort)  $sort = "ASC" ;
	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id " ;
		$sql1.=	"FROM po a, vendor b $where AND a.vendor=b.id " ;
		$sql2 =	"SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id " ;
		$sql2.=	"FROM po a,vendor b,ipmatch c $where AND a.vendor=b.id AND a.id=c.poid " ;
		$sql2.=	"GROUP BY transdate,duedate,ponumber,b.name,amount,a.id " ;
		$sql2.=	"HAVING sum(b_amount)>=amount " ;
		if ($db_type=="mysql")	{
			$user = trim($phpgw_info["user"]["userid"]) ;
			$temp1 = "pontl1".$user.time() ;
			$temp2 = "pontl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	   else	{
		$sql =  "SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id FROM po a, vendor b " ;
		$sql.=	"$where AND a.vendor=b.id ORDER BY $order $sort" ;
		}
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	echo "No Purchase Order [no tax] selected for despatch" ;
	   else	For ($i=1;$phpgw->db->next_record();$i++) $senditem[$i]=$phpgw->db->Record ;

For ($i=1;isset($senditem[$i]);$i++) {
	$t->set_var('item_section',"");
	$id	= $senditem[$i]['id'] ;

	$phpgw->db->query("SELECT * FROM po WHERE id='$id'");
	$phpgw->db->next_record();
	$vendor = $phpgw->db->f('vendor') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$ponumber = $phpgw->db->f('ponumber') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM vendor WHERE id='$vendor'");
	$phpgw->db->next_record();
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$vendoremail = $phpgw->db->f('email') ;
	$addr1 = $phpgw->db->f('addr1') ;
	$addr2 = $phpgw->db->f('addr2') ;
	$addr3 = $phpgw->db->f('addr3') ;
	$addr4 = $phpgw->db->f('addr4') ;
	$terms = $phpgw->db->f('terms') ;

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('ponumber',$ponumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shipto',$shipto) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

	/* ---------------------------- Begin list items --------------------------*/

	$phpgw->db->query("SELECT * FROM oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('cost') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty,
      		      	    		'price'		=> $price,
        	    	    		'discount'	=> $discount ,
         		   	    	'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("PO Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',$thank) ;
	$t->set_var('lang_remark',$remark) ;

	/*-------------------- Generate Email    ------------------------------------------*/

	$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
	$vendmsg = lang("Vendor") ;	$pomsg = lang("PO") ;
	$successmsg = lang("Email successfully sent to") ;
	$failuremsg = lang("Email fails to deliver to") ;
	if (!$vendoremail)				$err = lang("Vendor email address missing") ;
	if ($vendoremail and strpos($vendoremail,'@')=='')
							$err = lang("Invalid vendor email address") ;
	if (!$comemail)					$err = lang("Self return email address missing");
	if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid self return email address");
	if ($err)	echo "$vendmsg/$name -- $pomsg/$id -- $noemail -- $error: $err<br>" ;
	   else {
		$recipient = "$contact < $vendoremail >" ;
		$subject = lang("PO#: %1 dated %2",$ponumber,$transdate) ;
		$message = $t->parse('out','report',true) ;
		$headers = "From: $company < $comemail >\n" ;
		$headers.= "Bcc: $company < $comemail >\n" ;
		$headers.= "Content-Type: text/html; charset=$charset\n" ;
		$headers.= "Return-Path: $company < $comemail >\n" ;
		$result = mail($recipient,$subject,$message,$headers) ;
		if ($result)	echo "$vendmsg/$name -- $pomsg/$id -- $successmsg $vendoremail<br>" ;
			else	echo "$vendmsg/$name -- $pomsg/$id -- $failuremsg $vendoremail<br>" ;
		}

	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang("Despatch Completed")) ;
	$t->set_var('lang_yes',lang("Done")) ;
	$t->set_var('lang_no',lang("Done")) ;
	$t->set_var('yes_action',$phpgw->link('/ck-po/pontlist.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('no_action',$phpgw->link('/ck-po/pontlist.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->pparse('out','screen',true);

	if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");
	$phpgw->common->phpgw_footer();

?>
