<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: powtedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-po', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$fromnt = ($_GET["fromnt"]) ? $_GET["fromnt"] : $_POST["fromnt"] ;
	$filter=urlencode(stripslashes($filter));

	$po = CreateObject('ck-po.po') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$t->set_file('report','powtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Purchase Order (PO) [with Tax]'));
	$message = lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a customer.") ;
	$message.= "<br>".lang("Due date is an independent input subject to how urgent the ordered goods is needed.");
	$message.= "<br>".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$message.= "<br>".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "  ".lang("Posted (Tax Exempted) PO will appear in the Purchase Order [no Tax] list.");
	$message.= "<br><b>".lang("Manual tax input is allowed.");
	$message.= "  ".lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',$message);

/*------------- Write Purchase Order to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$phpgw->db->query("SELECT * FROM po WHERE id='$id' ORDER BY id");
		$phpgw->db->next_record();
		$p = $phpgw->db->Record ;
		$p[taxstatus] = $phpgw->db->f('taxincluded') ;
		}
	    else $p = $_POST ;
	$po->po_header_write($t, $p, 'wt') ;

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$firstime = True ;
		$phpgw->db->query("SELECT * FROM oitem WHERE trans_id='$id' ORDER BY id");
		$i=1;
		while ($phpgw->db->next_record()) {
			$p['itemid'.$i]		=	$phpgw->db->f('itemid') ;
			$p['itemtype'.$i]	=	$phpgw->db->f('itemtype') ;
			$p['description'.$i]	=	$phpgw->db->f('description') ;
			$p['qty'.$i]		=	$phpgw->db->f('qty') ;
			$p['unit'.$i]		=	$phpgw->db->f('unit') ;
			$p['cost'.$i]		=	$phpgw->db->f('cost') ;
			$p['discount'.$i]	=	$phpgw->db->f('discount') ;
			$p['tax1'.$i]		=	$phpgw->db->f('tax1') ;
			$p['tax2'.$i]		=	$phpgw->db->f('tax2') ;
			$i++ ;
			}
		}
	    else $p = $_POST ;
	
	$po->po_transform($p,$newrow,$delete) ;
	$po->po_detail_write($t,$p,$posted,$firstime) ;
	$t->parse('out','report',True);

/*-------------- Post Purchase Order ----------------------------------------------*/

	if (isset($post)) {
		$err = $po->po_validate($p) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted = $po->po_post($p, $t, $id, 'edit', 'powtedit') ;
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted) {
		if ($fromnt=="yes")	$t->set_var('action',$phpgw->link('/ck-po/pontlist.php',$getstr));
			else		$t->set_var('action',$phpgw->link('/ck-po/powtlist.php',$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-po/powtedit.php',"fromnt=$fromnt&".$getstr)) ;
		$t->set_var('lang_post',lang('Post PO [with Tax]'));
		$t->set_var('lang_newrow',lang('Add New Row & Refresh Page'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	if ($fromnt=="yes")	$t->set_var('done_action',$phpgw->link('/ck-po/pontlist.php',$getstr));
		else		$t->set_var('done_action',$phpgw->link('/ck-po/powtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
