<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: powtlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-po', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'powtlist.tpl', 'pos'=>'powtlist.tpl'));
	$t->set_block('pos','po_row','po_section');
	$db_type = $phpgw_info["server"]["db_type"] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Purchase Orders [with Tax]'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Purchase Orders [with Tax]'));
$t->set_var('add_action',$phpgw->link('/ck-po/powtadd.php',"filter=$filter"));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_billhist',lang('Billing History'));
$t->set_var('lang_opo',lang('Official PO'));
$t->set_var('lang_bulk',lang('Bulk Despatch'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-po/powtlist.php',lang('Purchase Order Date')));
$t->set_var('sort_duedate',$nm->show_sort_order($sort,'duedate',$order,'/ck-po/powtlist.php',lang('Due Date')));
$t->set_var('sort_vendor',$nm->show_sort_order($sort,'vendor',$order,'/ck-po/powtlist.php',lang('Vendor')));
$t->set_var('sort_ponumber',$nm->show_sort_order($sort,'ponumber',$order,'/ck-po/powtlist.php',lang('PO#')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-po/powtlist.php',lang('Amount')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-po/powtlist.php',lang('Audit Id')));

$last10 = substr($where,strlen($where)-10,10) ;
if ($last10==' AND OPEN '){
	$where = substr($where,0,strlen($where)-10) ;
	$sql1 =	"SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id " ;
	$sql1.=	"FROM po a, vendor b $where AND a.vendor=b.id " ;
	$sql2 =	"SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id " ;
	$sql2.=	"FROM po a,vendor b,ipmatch c $where AND a.vendor=b.id AND a.id=c.poid " ;
	$sql2.=	"GROUP BY transdate,duedate,ponumber,b.name,amount,a.id " ;
	$sql2.=	"HAVING sum(b_amount)>=amount " ;
	if ($db_type=="mysql")	{
		$user = trim($phpgw_info["user"]["userid"]) ;
		$temp1 = "powtl1".$user.time() ;
		$temp2 = "powtl2".$user.time() ;
		$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
		$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
		$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
		$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL" ;
		}
		else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
	}
else	{
	$sql =  "SELECT transdate,duedate,ponumber,b.name as vendor,amount,a.id as id FROM po a, vendor b " ;
	$sql.=	"$where AND a.vendor=b.id ORDER BY $order $sort" ;
	}
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------
if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'duedate'	=> "",
				'vendor'	=> "",
				'ponumber'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'view'		=> "",
				'billhist'	=> "",
				'opo'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('po_section','po_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'duedate'	=> $phpgw->db->f('duedate'),
            	    		'vendor'	=> $phpgw->db->f('vendor'),
            	    		'ponumber'	=> $phpgw->db->f('ponumber'),
            	    		'amount'	=> $phpgw->db->f('amount'),
				'id'		=> $phpgw->db->f('id'),
		'view'		=> $phpgw->link('/ck-po/powtview.php',$getstr),
		'billhist'	=> $phpgw->link('/ck-po/pobillhist.php',$getstr),
		'opo'		=> $phpgw->link('/ck-po/powtoff.php',$getstr),
		'edit'		=> $phpgw->link('/ck-po/powtedit.php',$getstr),
		'copy'		=> $phpgw->link('/ck-po/powtcopy.php',$getstr),
		'delete'	=> $phpgw->link('/ck-po/powtdelete.php',$getstr) ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('po_section','po_row',true);
	}

$t->set_var('bulk_action',$phpgw->link('/ck-po/powtbulk.php',"order=$order&sort=$sort&".$getstr));
$disabled = ($id=="") ? "disabled" : "" ;
$t->set_var('disabled',$disabled) ;
if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','pos','report');

?>
