<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: vendorubpo.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-po', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'vendorubpo.tpl', 'po'=>'vendorubpo.tpl'));
	$t->set_block('po','po_row','po_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

/*---------------------------------------------------------------------------------*/

	$sql = "SELECT name FROM vendor WHERE id='$id'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$name = $phpgw->db->f('name') ;
	$t->set_var('lang_title',lang("List of Unbilled PO (Outstanding Purchase Commitment) for Vendor")." -- $name") ;
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));

	$t->set_var('sort_ponumber',$nm->show_sort_order($sort,"ponumber&id=$id",$order,'/ck-po/vendorubpo.php',lang('PO Number')));
	$t->set_var('sort_transdate',$nm->show_sort_order($sort,"transdate&id=$id",$order,'/ck-po/vendorubpo.php',lang('PO Date')));
	$t->set_var('sort_duedate',$nm->show_sort_order($sort,"duedate&id=$id",$order,'/ck-po/vendorubpo.php',lang('Due Date')));
	$t->set_var('sort_amount',$nm->show_sort_order($sort,"amount&id=$id",$order,'/ck-po/vendorubpo.php',lang('PO Amount')));
	$t->set_var('sort_billedamount',$nm->show_sort_order($sort,"billedamount&id=$id",$order,'/ck-po/vendorubpo.php',lang('Billed Amount')));
	$t->set_var('sort_osamount',$nm->show_sort_order($sort,"osamount&id=$id",$order,'/ck-po/vendorubpo.php',lang('O/S Amount')));
	$t->set_var('lang_id',lang('Audit ID')) ;
	$t->set_var('lang_overdue',lang('Days O/D')) ;
	$t->set_var('lang_notdue',lang('Not Due')) ;
	$t->set_var('lang_age30',lang('1-30')) ;
	$t->set_var('lang_age60',lang('31-60')) ;
	$t->set_var('lang_age90',lang('61-90')) ;
	$t->set_var('lang_age120',lang('91-120')) ;
	$t->set_var('lang_age120plus',lang('120+')) ;
	$t->set_var('lang_unallocated',lang('Unallocated')) ;
	$t->set_var('lang_net',lang('Net O/S')) ;

	$sql ="SELECT sum(amount) as totbilled FROM ap WHERE vendor='$id'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$totbilled = $phpgw->db->f('totbilled') ;
	$sql ="SELECT sum(b_amount) as allocated FROM ap a, ipmatch b WHERE vendor='$id' and a.id=invoiceid";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$allocated = $phpgw->db->f('allocated') ;
	$unallocated = $totbilled-$allocated ;

	$user = trim($phpgw_info["user"]["userid"]);
	$temp1 = "po1".$user.time() ;
	$temp2 = "po2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT ponumber,id,transdate,duedate,amount,0.0 as billedamount FROM po WHERE vendor='$id' ";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT ponumber,id,transdate,duedate,0.0 as amount,sum(b_amount) as billedamount " ;
	$sql.= "FROM po a, ipmatch b ";
	$sql.= "WHERE vendor='$id' and a.id=b.poid GROUP BY transdate,duedate,id,ponumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT ponumber,id,transdate,duedate,sum(amount) as amount,sum(billedamount) as billedamount,0.0 as osamount " ;
	$sql.= "FROM $temp1 GROUP BY transdate,duedate,id,ponumber ";
	$phpgw->db->query($sql);
	$sql = "UPDATE $temp2 SET osamount=amount-billedamount" ;
	$phpgw->db->query($sql);

	if (!$order) 	$order = "duedate,id" ;
	if (!$sort)  	$sort = "ASC" ;
	$sql = "SELECT * FROM $temp2 WHERE osamount > 0 ORDER BY $order $sort" ;
	$phpgw->db->query($sql) ;

	if ($phpgw->db->num_rows()==0) {
		$t->set_var('ponumber',lang('No PO outstanding')) ;
		$t->set_var('transdate','.') ;
		$t->set_var('duedate','.') ;
		$t->set_var('overdue','.') ;
		$t->set_var('poamount','.') ;
		$t->set_var('billedamount','.') ;
		$t->set_var('osamount','.') ;
		$t->set_var('id','.') ;
		$t->set_var('notdue','.') ;
		$t->set_var('age30','.') ;
		$t->set_var('age60','.') ;
		$t->set_var('age90','.') ;
		$t->set_var('age120','.') ;
		$t->set_var('age120plus','.') ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('po_section','po_row',True);
		}
	$sumamount = $sumbilled = $sumos = 0 ;
	$sumnotdue = $sum30 = $sum60 = $sum90 = $sum120 = $sum120plus = 0 ;
	while ($phpgw->db->next_record()) {

		$ponumber	=	$phpgw->db->f('ponumber') ;
		$transdate	=	$phpgw->db->f('transdate') ;
		$duedate	=	$phpgw->db->f('duedate') ;
		$amount		=	$phpgw->db->f('amount') ;
		$billedamount	=	$phpgw->db->f('billedamount') ;
		$osamount	=	$phpgw->db->f('osamount') ;
		$poid		=	$phpgw->db->f('id') ;

		$overdue = (strtotime(date("Y-m-d"))-strtotime($duedate))/86400 ;
		$age = $overdue < 0 ? 0 : floor($overdue) ;
		$notdue = $age30 = $age60 = $age90 = $age120 = $age120plus = "." ;

		if ($age==0)			$notdue = $osamount ;
		if ($age>0 and $age<31)		$age30 = $osamount ;
		if ($age>30 and $age<61)	$age60 = $osamount ;
		if ($age>60 and $age<91)	$age90 = $osamount ;
		if ($age>90 and $age<121)	$age120 = $osamount ;
		if ($age>120)			$age120plus = $osamount ;

		$t->set_var('ponumber',$ponumber) ;
		$t->set_var('transdate',$transdate) ;
		$t->set_var('duedate',$duedate) ;
		$t->set_var('poamount',$amount) ;
		$t->set_var('billedamount',$billedamount) ;
		$t->set_var('osamount',$osamount) ;
		$t->set_var('id',$poid) ;
		$t->set_var('overdue',$overdue) ;
		$t->set_var('notdue',$notdue) ;
		$t->set_var('age30',$age30) ;
		$t->set_var('age60',$age60) ;
		$t->set_var('age90',$age90) ;
		$t->set_var('age120',$age120) ;
		$t->set_var('age120plus',$age120plus) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('po_section','po_row', True);

		$sumamount	+=	$amount ;
		$sumbilled	+=	$billedamount ;
		$sumos		+=	$osamount ;
		$sumnotdue	+=	$notdue ;
		$sum30		+=	$age30 ;
		$sum60		+=	$age60 ;
		$sum90		+=	$age90 ;
		$sum120		+=	$age120 ;
		$sum120plus	+=	$age120plus ;
		}
	$t->set_var('summary',lang('Summary')) ;
	$t->set_var('sumamount',$sumamount) ;
	$t->set_var('sumbilled',$sumbilled) ;
	$t->set_var('sumos',$sumos) ;
	$t->set_var('sumnotdue',$sumnotdue) ;
	$t->set_var('sum30',$sum30) ;
	$t->set_var('sum60',$sum60) ;
	$t->set_var('sum90',$sum90) ;
	$t->set_var('sum120',$sum120) ;
	$t->set_var('sum120plus',$sum120plus) ;
	$t->set_var('unallocated',$unallocated) ;
	$t->set_var('net',$sumos-$unallocated) ;

	$sql = "DROP TABLE $temp1, $temp2" ;
	$phpgw->db->query($sql);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-po/vendorlist.php',"filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','po','report');

?>
