<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: csntfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-c', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$customer = ($_GET["customer"]) ? $_GET["customer"] : $_POST["customer"] ;
	$cashier = ($_GET["cashier"]) ? $_GET["cashier"] : $_POST["cashier"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$posnumber = ($_GET["posnumber"]) ? $_GET["posnumber"] : $_POST["posnumber"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-c'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted Cash Sales [no Tax] :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$filter = array (	cond1		=>	lang('Customer') ,
			condvar1	=>	'customer' ,
			selectlist1	=>	"<OPTION value='ALL'></OPTION>".customer_selectlist('',''),
			conddefault1	=>	'ALL' ,
			condnote1	=>	lang('Select the appropriate customer') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Cashier') ,
			condvar2	=>	'cashier' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Search for target key word in the cashier field'),
			checkbox3	=>	'no',
			cond3		=>	lang('Cash Sale Date (from)') ,
			condvar3	=>	'from' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date [format: YYYY-MM-DD]'),
			checkbox4	=>	'no',
			cond4		=>	lang('Cash Sale Date (to)') ,
			condvar4	=>	'to' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Must be a valid date [format: YYYY-MM-DD]') ,
			checkbox5	=>	'no',
			cond5		=>	lang('Cash Sale Number') ,
			condvar5	=>	'posnumber' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for target key word/number in the cash sale number field') ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $customer ;
	$filter["conddefault2"] = $cashier ;
	$filter["conddefault3"] = $from ;
	$filter["conddefault4"]	= $to ;
	$filter["conddefault5"] = $posnumber ;
	}

$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	if ($filter['checkbox'.$i]=='yes')	$t->set_var('checkbox',"type='checkbox'");
		else				$t->set_var('checkbox',"");
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-pos-c/csntfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-pos-c/csntadd.php')) ;
	$t->set_var('lang_add',lang('Add New Cash Sale [no Tax]'));
	$t->pparse('out','report',True);

?>
