<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cswtmemo.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-pos-c',
					'noheader'	=> True,
					'nonavbar'	=> True,
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-c'));
	$t->set_file('report','cswtmemo.tpl') ;
	$t->set_block('report','item','item_section');
	$t->set_block('report','addon','addon_section');
	$t->set_block('report','qcash','qcash_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Sales Memo Image (Use browser to print the Sales Memo shown above)');
	$t->set_var('lang_title',$title);
	$notes=lang('[This is a sample subject to tailoring per individual printer & Sales Memo format]');
	$t->set_var('lang_notes',$notes);
	$t->set_var('charset',lang('charset'));
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$tax1cap = $phpgw->db->f('postax1cap') ;
	$tax2cap = $phpgw->db->f('postax2cap') ;
	$sm_rmkid = $phpgw->db->f('sm_rmkid') ;
	$phpgw->db->query("SELECT * FROM remark where id='$sm_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('detail') ;

	$phpgw->db->query("SELECT * FROM pos WHERE id='$id'");
	$phpgw->db->next_record();
	$transdate = $phpgw->db->f('transdate') ;
	$posnumber = $phpgw->db->f('posnumber') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;

	$t->set_var('lang_memo',lang('SALE MEMO'));
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_posnumber',lang('Ref. Number'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Gross Amount'));
	$t->set_var('lang_netamount',lang('Net Amount').'<br>'.lang('(net of tax)'));
	$t->set_var('lang_tax1',$tax1cap.'<br>'.lang('(Rate)'));
	$t->set_var('lang_tax2',$tax2cap.'<br>'.lang('(Rate)'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('posnumber',$posnumber) ;

// ---------------------------- Begin list items -----------------------------------------

	$user = trim($phpgw_info["user"]["userid"]);
	$temp = "memo".$user.time() ;

	$phpgw->db->query("SELECT * FROM pos WHERE id='$id'") ;
	$phpgw->db->next_record() ;
	$taxincluded = $phpgw->db->f('taxincluded') ;

	$total = $totnet = $tottax1 = $tottax2 = 0 ;
	$sql =	"CREATE TABLE $temp AS " ;
	$sql.=	"SELECT a.id as id,itemid,description,qty,price,discount,tax1,tax2 from positem a, parts b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='i' and itemid=b.id " ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp (id,itemid,description,qty,price,discount,tax1,tax2) " ;
	$sql.=	"SELECT a.id as id,itemid,description,qty,price,discount,tax1,tax2 from positem a, service b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='s' and itemid=b.id " ;
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp ORDER BY id" ;
	$phpgw->db->query($sql) ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('price') ;
		$discount = $phpgw->db->f('discount') ;
		$tax1 = number_format($phpgw->db->f('tax1'),2,".",'') ;
		$tax2 = number_format($phpgw->db->f('tax2'),2,".",'') ;
		$amount = ($taxincluded=='t') ? number_format($qty*$price-$discount,2,".",'') : number_format($qty*$price-$discount+$tax1+$tax2,2,".",'') ;
		$netamount = number_format($amount-$tax1-$tax2,2,".",'') ;
		$tax1rate = number_format($tax1/$netamount*100,2,".",'') ;
		$tax2rate = number_format($tax2/$netamount*100,2,".",'') ;
		$tax1str = "$tax1 ($tax1rate%)" ;
		$tax2str = "$tax2 ($tax2rate%)" ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $phpgw->db->f('description'),
					'qty'		=> $qty,
					'price'		=> $price,
					'discount'	=> $discount ,
					'amount'	=> $amount ,
					'netamount'	=> $netamount ,
					'tax1'		=> $tax1str ,
					'tax2'		=> $tax2str ));
		$t->parse('item_section','item',true);
		$total+= $amount ;
		$totnet += $netamount ;
		$tottax1 += $tax1 ;
		$tottax2 += $tax2 ;
		}
	$t->set_var('lang_total',lang("Total Purchase (Currency:")." $currency)") ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('total_netamount',$totnet) ;
	$t->set_var('total_tax1',$tottax1) ;
	$t->set_var('total_tax2',$tottax2) ;
	$t->set_var('lang_addon',lang("Add-on Charges/Discounts:")) ;

	$totalp = $total ;
	$totaotax1 = $totaotax2 = 0 ;
	$sql = "SELECT itemid,name,value,a.factor as factor,tax1,tax2 FROM positem a, addon b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='a' and itemid=b.id " ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()<=0)			$t->set_var('addon_section',"") ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$value = $phpgw->db->f('value') ;
		$factor = $phpgw->db->f('factor') ;
		$basis = ($value == $totnet) ? " ".lang('Net Amount') : " ".lang('Gross Amount') ;
		$amount = $value * $factor ;
		$tax1 = number_format($phpgw->db->f('tax1'),2,".",'') ;
		$tax2 = number_format($phpgw->db->f('tax2'),2,".",'') ;
		$tax1rate = number_format($tax1/$amount*100,2,".",'') ;
		$tax2rate = number_format($tax2/$amount*100,2,".",'') ;
		$tax1str = "$tax1 ($tax1rate%)" ;
		$tax2str = "$tax2 ($tax2rate%)" ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $phpgw->db->f('name'),
					'factor'	=> $factor*100,
					'basis'		=> $basis ,
					'amount'	=> $amount ,
					'netamount'	=> '' ,
					'tax1'		=> $tax1str ,
					'tax2'		=> $tax2str ));
		$t->parse('addon_section','addon',true);
		$totalp+= $amount ;
		$totaotax1 += $tax1 ;
		$totaotax2 += $tax2 ;
		}
	$t->set_var('lang_totalt',lang("Total Tax on Addon's")) ;
	$t->set_var('total_addontax',$totaotax1+$totaotax2) ;
	$t->set_var('total_aotax1',$totaotax1) ;
	$t->set_var('total_aotax2',$totaotax2) ;
	$t->set_var('lang_totalp',lang("Total Payable (Currency:")." $currency)") ;
	$t->set_var('total_pamount',$totalp+$totaotax1+$totaotax2) ;
	$t->set_var('total_aotax1',$totaotax1) ;
	$t->set_var('total_aotax2',$totaotax2) ;
	$t->set_var('lang_qcash',lang("Customer Payments:")) ;

	$sql = "SELECT itemid,name,qty,a.value as value FROM positem a, qcash b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='q' and itemid=b.id " ;
	$phpgw->db->query($sql) ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$qty = $phpgw->db->f('qty') ;
		$value = $phpgw->db->f('value') ;
		$amount = $qty * $value ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $phpgw->db->f('name'),
					'qty'		=> $qty,
					'value'		=> $value,
					'amount'	=> $amount ));
		$t->parse('qcash_section','qcash',true);
		}
	$t->set_var('lang_totalc',lang("Total Change (Currency:")." $currency)") ;
	$phpgw->db->query("SELECT value FROM positem WHERE trans_id='$id' and itemtype='c'") ;
	$phpgw->db->next_record() ;
	$change = $phpgw->db->f('value') ? $phpgw->db->f('value') : 0 ;
	$t->set_var('total_camount',$change) ;

	$t->set_var('lang_thank',lang('Thank you for shopping with us!')) ;
	$t->set_var('lang_remark',$remark) ;

	$phpgw->db->query("DROP TABLE $temp");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-pos-c/cswtlist.php',"filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>


