<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: addonlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'addonlist.tpl', 'addon'=>'addonlist.tpl'));
	$t->set_block('addon','addon_row','addon_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Add-On Charge/Reduction'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New AddOn Charge/Reduction'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/addonadd.php',"filter=$filter"));
$t->set_var('lang_note',lang('Factor: based on Cash Sale Total; Basis: g-gross sale, n-net sale'));
$t->set_var('lang_factor',lang('Factor'));
$t->set_var('lang_basis',lang('Basis'));
$t->set_var('lang_count',lang('Count per Transaction'));
$t->set_var('lang_sale',lang('Sales per Transaction'));
$t->set_var('lang_splan',lang('Sales Plan'));
$t->set_var('lang_date',lang('Date'));

$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-pos-m/addonlist.php',lang('AddOn Charge/Reduction Name'),$filter));
$t->set_var('sort_factor',$nm->show_sort_order($sort,'factor',$order,'/ck-pos-m/addonlist.php',lang('Factor'),$filter));
$t->set_var('sort_basis',$nm->show_sort_order($sort,'basis',$order,'/ck-pos-m/addonlist.php',lang('Basis'),$filter));
$t->set_var('sort_mincount',$nm->show_sort_order($sort,'mincount',$order,'/ck-pos-m/addonlist.php',lang('Min'),$filter));
$t->set_var('sort_maxcount',$nm->show_sort_order($sort,'maxcount',$order,'/ck-pos-m/addonlist.php',lang('Max'),$filter));
$t->set_var('sort_minsale',$nm->show_sort_order($sort,'minsale',$order,'/ck-pos-m/addonlist.php',lang('Min'),$filter));
$t->set_var('sort_maxsale',$nm->show_sort_order($sort,'maxsale',$order,'/ck-pos-m/addonlist.php',lang('Max'),$filter));
$t->set_var('sort_splan_id',$nm->show_sort_order($sort,'splan_id',$order,'/ck-pos-m/addonlist.php',lang('ID'),$filter));
$t->set_var('sort_start',$nm->show_sort_order($sort,'start',$order,'/ck-pos-m/addonlist.php',lang('Valid from'),$filter));
$t->set_var('sort_endd',$nm->show_sort_order($sort,'endd',$order,'/ck-pos-m/addonlist.php',lang('Valid to'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-pos-m/addonlist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from addon $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'factor'	=> "",
				'basis'		=> "",
				'mincount'	=> "",
				'maxcount'	=> "",
				'minsale'	=> "",
				'maxsale'	=> "",
				'splan_id'	=> "",
				'start'		=> "",
				'endd'		=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('addon_section','addon_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'factor'	=> $phpgw->db->f('factor'),
				'basis'		=> $phpgw->db->f('basis'),
				'mincount'	=> $phpgw->db->f('mincount'),
				'maxcount'	=> $phpgw->db->f('maxcount'),
				'minsale'	=> $phpgw->db->f('minsale'),
				'maxsale'	=> $phpgw->db->f('maxsale'),
				'splan_id'	=> $phpgw->db->f('splan_id'),
				'start'		=> $phpgw->db->f('start'),
				'endd'		=> $phpgw->db->f('endd'),
				'id'		=> $id,
		'view'	=> $phpgw->link('/ck-pos-m/addonview.php',$getstr),
		'edit'	=> $phpgw->link('/ck-pos-m/addonedit.php',$getstr),
		'copy'	=> $phpgw->link('/ck-pos-m/addoncopy.php',$getstr),
		'delete'=> $phpgw->link('/ck-pos-m/addondelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('addon_section','addon_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','addon','report');

?>
