<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashbalview.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','cashbalview.tpl') ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Quasi-Cash Balances (Detail View)'));
$t->set_var('lang_cashbox',lang('Cash Box Name'));
$t->set_var('lang_done',lang('Done'));
$t->set_var('done_action',$phpgw->link('/ck-pos-m/cashballist.php',"filter=$filter"));
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-pos-m/cashbalview.php',lang('Cash Sale Date'),$filter));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,'/ck-pos-m/cashbalview.php',lang('Shift'),$filter));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-pos-m/cashbalview.php',lang('Quasi-Cash Name'),$filter));
$t->set_var('sort_posnumber',$nm->show_sort_order($sort,'posnumber',$order,'/ck-pos-m/cashbalview.php',lang('Cash Sale#'),$filter));
$t->set_var('sort_qty',$nm->show_sort_order($sort,'qty',$order,'/ck-pos-m/cashbalview.php',lang('Qty'),$filter));
$t->set_var('sort_value',$nm->show_sort_order($sort,'value',$order,'/ck-pos-m/cashbalview.php',lang('Value'),$filter));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-pos-m/cashbalview.php',lang('Amount'),$filter));
$t->set_var('lang_view',lang('View Detail'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

$rpos = strrpos($where,"'") ;
$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
$cboxid = substr($where,$lpos) ;
$phpgw->db->query("SELECT name FROM cashbox WHERE id=$cboxid");
$phpgw->db->next_record() ;
$t->set_var('cashbox',$phpgw->db->f('name')) ;

// -------------------------------- Write Quasi-Cash Balances (Detail View) -----------------------------------------

if (!$order) {$order = "posnumber" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,posnumber,qty,a.value as value,";
$sql.=		"qty*a.value as amount " ;
$sql.=	"FROM positem a, pos b, qcash c " ;
$sql.=	"$where and itemid=$id and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"ORDER BY $order $sort" ;
if ($id==0)	{
	$sql =	"SELECT transdate,shift,'Cash Change' as name,posnumber,qty,value,qty*value as amount " ;
	$sql.=	"FROM positem a, pos b " ;
	$sql.=	"$where and itemtype='c' and a.trans_id=b.id ORDER BY $order $sort" ;
	}
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'posnumber'	=> "",
				'qty'		=> "",
				'value'		=> "",
				'amount'	=> ""		)) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbal_section','cashbal',True);
	}
$total == 0 ;
while ($phpgw->db->next_record()) {
	$amount = number_format($phpgw->db->f('amount'),2,".",'') ;
	$name = $phpgw->db->f('name') ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name,
				'posnumber'	=> $phpgw->db->f('posnumber'),
				'qty'		=> $phpgw->db->f('qty') ,
				'value'		=> $phpgw->db->f('value') ,
				'amount'	=> $amount 		)) ;
	if ($name=="Cash")	$cashamount = number_format($amount,2,".",'') ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbal_section','cashbal',true);
	$total += $amount ;
	}

$t->parse('cashbal','cashbal_section',true);
$t->set_var('lang_total',lang("Total for this Shift -")." $name") ;
$t->set_var('total',$total) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);

?>
