<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cbtranfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$shift = ($_GET["shift"]) ? $_GET["shift"] : $_POST["shift"] ;
	$manager = ($_GET["manager"]) ? $_GET["manager"] : $_POST["manager"] ;
	$cashier = ($_GET["cashier"]) ? $_GET["cashier"] : $_POST["cashier"] ;
	$name = ($_GET["name"]) ? $_GET["name"] : $_POST["name"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$cbtnumber = ($_GET["cbtnumber"]) ? $_GET["cbtnumber"] : $_POST["cbtnumber"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted Cash Box Transactions :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Item Search Screen --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$morning = lang('Morning') ;
$afternoon = lang('Afternoon') ;
$overnight = lang('Overnight') ;
$filter = array (	cond1		=>	lang('Shift') ,
			condvar1	=>	'shift' ,
			selectlist1	=>	"<OPTION value='ALL'></OPTION><OPTION value='1'>1 - $morning</OPTION><OPTION value='2'>2 - $afternoon</OPTION><OPTION value='3'>3 - $overnight</OPTION>",
			conddefault1	=>	'ALL' ,
			condnote1	=>	lang('Select the appropriate shift') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Manager') ,
			condvar2	=>	'manager' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Search for target key word in the manager field'),
			checkbox3	=>	'no',
			cond3		=>	lang('Cashier') ,
			condvar3	=>	'cashier' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Search for target key word in the cashier field'),
			checkbox4	=>	'no',
			cond4		=>	lang('Cash Box Name') ,
			condvar4	=>	'name' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for target key word in the cash box name field'),
			checkbox5	=>	'no',
			cond5		=>	lang('Cash Sale Date (from)') ,
			condvar5	=>	'from' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Must be a valid date [format: YYYY-MM-DD]'),
			checkbox6	=>	'no',
			cond6		=>	lang('Cash Sale Date (to)') ,
			condvar6	=>	'to' ,
			conddefault6	=>	'' ,
			condnote6	=>	lang('Must be a valid date [format: YYYY-MM-DD]') ,
			checkbox7	=>	'no',
			cond7		=>	lang('Cash Box Transaction Number') ,
			condvar7	=>	'cbtnumber' ,
			conddefault7	=>	'' ,
			condnote7	=>	lang('Search for target key word/number in the cashbox transaction number field') ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $shift ;
	$filter["conddefault2"] = $manager ;
	$filter["conddefault3"] = $cashier ;
	$filter["conddefault4"] = $name ;
	$filter["conddefault5"] = $from ;
	$filter["conddefault6"]	= $to ;
	$filter["conddefault7"] = $cbtnumber ;
	}

$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	if ($filter['checkbox'.$i]=='yes')	$t->set_var('checkbox',"type='checkbox'");
		else				$t->set_var('checkbox',"");
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-pos-m/cbtranfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-pos-m/cbtranadd.php')) ;
	$t->set_var('lang_add',lang('Add New Cash Box Transaction'));
	$t->pparse('out','report',True);

?>
