<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"]["currentapp"] = 'ck-pos-m';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Point of Sale Audit Control Report'));
	$t->set_var('lang_detail', lang('Detail'));
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_sprice', lang('Special Price'));
	$t->set_var('lang_addon', lang('Add On'));
	$t->set_var('lang_qcash', lang('Quasi Cash'));
	$t->set_var('lang_tax', lang('Tax Type'));
	$t->set_var('lang_pos', lang('Header Record'));
	$t->set_var('lang_positem', lang('Detail Record'));
	$t->set_var('lang_receipt', lang('Receipt'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_status_note', " ".lang('(note the effect of postdated journals)'));
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_netamount', lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', lang('Total Tax'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount, count(id) as count, max(id) as id from pos " ;
$sql.=	"WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$pos_amount = $phpgw->db->f('amount') ;
$pos_netamount = $phpgw->db->f('netamount') ;
$pos_count = $phpgw->db->f('count') ;
$pos_id = $phpgw->db->f('id') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as positem_netamount from positem a,pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t' and (itemtype='i' or itemtype='s')";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount = $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(qty*price-discount) as positem_netamount from positem a,pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and (b.taxincluded='f' or b.taxincluded='e') and " .
	" (itemtype='i' or itemtype='s')" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount+= $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as positem_netamount from positem a,pos b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and itemtype='a'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount+= $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as addon_tax from positem a,pos b,tax c " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and itemtype='a' and " ;
$sql.=	"chart_id=incacc_id and taxgroup='cs'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$addon_tax = $phpgw->db->f('addon_tax') ;
$positem_netamount-= $addon_tax ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from positem a,pos b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') + $addon_tax ;

$sql =	"SELECT count(a.id) as count, max(a.id) as id from positem a,pos b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_count = $phpgw->db->f('count') ;
$positem_id = $phpgw->db->f('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('pos_amount',sprintf("%01.2f",$pos_amount)) ;
$t->set_var('pos_netamount',sprintf("%01.2f",$pos_netamount)) ;
$t->set_var('positem_netamount',sprintf("%01.2f",$positem_netamount)) ;
$t->set_var('positem_tax',sprintf("%01.2f",$positem_tax)) ;
$t->set_var('receipt_amount',sprintf("%01.2f",$receipt_amount)) ;
$t->set_var('pos_count',$pos_count) ;
$t->set_var('positem_count',$positem_count) ;
$t->set_var('receipt_count',$receipt_count) ;
$t->set_var('pos_id',$pos_id) ;
$t->set_var('positem_id',$positem_id) ;
$t->set_var('receipt_id',$receipt_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount, count(id) as count, max(id) as id from pos ";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$pos_amount = $phpgw->db->f('amount') ;
$pos_netamount = $phpgw->db->f('netamount') ;
$pos_count = $phpgw->db->f('count') ;
$pos_id = $phpgw->db->f('id') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as positem_netamount from positem a,pos b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t' and (itemtype='i' or itemtype='s')" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount = $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(qty*price-discount) as positem_netamount from positem a,pos b " .
	"WHERE a.trans_id=b.id and (b.taxincluded='f' or b.taxincluded='e') and (itemtype='i' or itemtype='s')";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount+= $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as positem_netamount from positem a,pos b ";
$sql.=	"WHERE a.trans_id=b.id and itemtype='a'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_netamount+= $phpgw->db->f('positem_netamount') ;
$sql =	"SELECT sum(value*factor) as addon_tax from positem a,pos b,tax c " ;
$sql.=	"WHERE a.trans_id=b.id and itemtype='a' and chart_id=incacc_id and taxgroup='cs'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$addon_tax = $phpgw->db->f('addon_tax') ;
$positem_netamount-= $addon_tax ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from positem a,pos b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') + $addon_tax ;

$sql =	"SELECT count(a.id) as count, max(a.id) as id from positem a,pos b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$positem_count = $phpgw->db->f('count') ;
$positem_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id,count(id) as count FROM sprice" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$sprice_id = $phpgw->db->f('id') ;
$sprice_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id,count(id) as count FROM addon" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$addon_id = $phpgw->db->f('id') ;
$addon_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id,count(id) as count FROM qcash" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$qcash_id = $phpgw->db->f('id') ;
$qcash_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id,count(id) as count FROM tax WHERE taxgroup='cs'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_id = $phpgw->db->f('id') ;
$tax_count = $phpgw->db->f('count') ;


$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_pos_amount',sprintf("%01.2f",$pos_amount)) ;
$t->set_var('sys_pos_netamount',sprintf("%01.2f",$pos_netamount)) ;
$t->set_var('sys_positem_netamount',sprintf("%01.2f",$positem_netamount)) ;
$t->set_var('sys_positem_tax',sprintf("%01.2f",$positem_tax)) ;
$t->set_var('sys_sprice_count',$sprice_count) ;
$t->set_var('sys_addon_count',$addon_count) ;
$t->set_var('sys_qcash_count',$qcash_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_pos_count',$pos_count) ;
$t->set_var('sys_positem_count',$positem_count) ;
$t->set_var('sys_sprice_id',$sprice_id) ;
$t->set_var('sys_addon_id',$addon_id) ;
$t->set_var('sys_qcash_id',$qcash_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_pos_id',$pos_id) ;
$t->set_var('sys_positem_id',$positem_id) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-pos-m/reportfilter.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	$phpgw->common->phpgw_footer();
?>
