<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cashbox.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class cashbox {

//---- Cash Box Detail Validation Checks

    function cashbox_validate($c,$oldcashier) {
	global $phpgw ;

	$err="";
	if (!$c[name] or $c[name]=="")		$err=lang('Error: Cash Box Name missing');
	if (!$c[cashier] or $c[cashier]=="")	$err=lang('Error: Cashier missing');
		else	{
			$phpgw->db->query("SELECT * from cashbox WHERE cashier='$c[cashier]'") ;
			if ($phpgw->db->num_rows()<>0 and $c[cashier]<>$oldcashier)
						$err=lang('Error: Cashier already assigned to other cashbox');
			}
	if ($c[maxcash] and !is_numeric($c[maxcash]))	$err=lang('Error: Cash Warning Level must be numeric');
	$admin = False ;
	$user = trim($phpgw_info["user"]["userid"]);
	$groups = ExecMethod('phpgwapi.accounts.membership',$user) ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin)					$err=lang('Error: Action not allowed for non [Admins] group users');

	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Cash Box Detail to Database

    function cashbox_post($c, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $c[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO cashbox(id,name,cashier,location,shift,maxcash,notes) " ;
			$sql.="VALUES ('$id','$c[name]','$c[cashier]','$c[location]','$c[shift]','$c[maxcash]','$c[notes]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE cashbox SET name='$c[name]',cashier='$c[cashier]',location='$c[location]'," ;
			$sql.="shift='$c[shift]',maxcash='$c[maxcash]',notes='$c[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM cashbox WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Cash Box") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Cash Box Detail

    function cashbox_write(&$t, &$c) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_cashier',lang('Cashier for Current Shift'));
	$t->set_var('lang_remark',lang('[to assign this cashier to a diff. cashbox, enter N/A here]'));
	$t->set_var('lang_location',lang('Location'));
	$t->set_var('lang_shift',lang('Current Shift'));
	$t->set_var('lang_maxcash',lang('Cash Full Warning Level'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('id',$c[id]);
	$t->set_var('name',$c[name]);
	$t->set_var('cashier',$c[cashier]);
	$t->set_var('shift',$c[shift]);
	$t->set_var('shift_sl',shift_selectlist("",$c[shift]));
	$t->set_var('location',$c[location]);
	$t->set_var('maxcash',$c[maxcash]);
	$t->set_var('notes',$c[notes]);
	$t->parse('out','report',True);
	}

    }

?>
