<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: qcashlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report' =>'qcashlist.tpl',	'qcash' =>'qcashlist.tpl'));
	$t->set_block('qcash','qcash_row','qcash_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Quasi-Cash'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Quasi-Cash'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/qcashadd.php',"filter=$filter"));
$t->set_var('lang_sale',lang('Cash Sale Value'));
$t->set_var('lang_qty',lang('Qty per Transaction'));
$t->set_var('lang_value',lang('Value per Transaction'));
$t->set_var('lang_splan',lang('Sales Plan'));
$t->set_var('lang_date',lang('Date'));

$t->set_var('sort_name',$phpgw->nextmatchs->show_sort_order($sort,'name',$order,'/ck-pos-m/qcashlist.php',lang('Quasi-Cash Name'),$filter));
$t->set_var('sort_value',$phpgw->nextmatchs->show_sort_order($sort,'value',$order,'/ck-pos-m/qcashlist.php',lang('Face Value'),$filter));
$t->set_var('sort_minsale',$phpgw->nextmatchs->show_sort_order($sort,'minsale',$order,'/ck-pos-m/qcashlist.php',lang('Min'),$filter));
$t->set_var('sort_maxsale',$phpgw->nextmatchs->show_sort_order($sort,'maxsale',$order,'/ck-pos-m/qcashlist.php',lang('Max'),$filter));
$t->set_var('sort_minqty',$phpgw->nextmatchs->show_sort_order($sort,'minqty',$order,'/ck-pos-m/qcashlist.php',lang('Min'),$filter));
$t->set_var('sort_maxqty',$phpgw->nextmatchs->show_sort_order($sort,'maxqty',$order,'/ck-pos-m/qcashlist.php',lang('Max'),$filter));
$t->set_var('sort_minvalue',$phpgw->nextmatchs->show_sort_order($sort,'minvalue',$order,'/ck-pos-m/qcashlist.php',lang('Min'),$filter));
$t->set_var('sort_maxvalue',$phpgw->nextmatchs->show_sort_order($sort,'maxvalue',$order,'/ck-pos-m/qcashlist.php',lang('Max'),$filter));
$t->set_var('sort_splan_id',$phpgw->nextmatchs->show_sort_order($sort,'splan_id',$order,'/ck-pos-m/qcashlist.php',lang('ID'),$filter));
$t->set_var('sort_start',$phpgw->nextmatchs->show_sort_order($sort,'start',$order,'/ck-pos-m/qcashlist.php',lang('Valid from'),$filter));
$t->set_var('sort_endd',$phpgw->nextmatchs->show_sort_order($sort,'endd',$order,'/ck-pos-m/qcashlist.php',lang('Valid to'),$filter));
$t->set_var('sort_id',$phpgw->nextmatchs->show_sort_order($sort,'id',$order,'/ck-pos-m/qcashlist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from qcash $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'value'		=> "",
				'minsale'	=> "",
				'maxsale'	=> "",
				'minqty'	=> "",
				'maxqty'	=> "",
				'minvalue'	=> "",
				'maxvalue'	=> "",
				'splan_id'	=> "",
				'start'		=> "",
				'endd'		=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('qcash_section','qcash_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'value'		=> $phpgw->db->f('value'),
				'minsale'	=> $phpgw->db->f('minsale'),
				'maxsale'	=> $phpgw->db->f('maxsale'),
				'minqty'	=> $phpgw->db->f('minqty'),
				'maxqty'	=> $phpgw->db->f('maxqty'),
				'minvalue'	=> $phpgw->db->f('minvalue'),
				'maxvalue'	=> $phpgw->db->f('maxvalue'),
				'splan_id'	=> $phpgw->db->f('splan_id'),
				'start'		=> $phpgw->db->f('start'),
				'endd'		=> $phpgw->db->f('endd'),
				'id'		=> $id,
		'view'	=> $phpgw->link('/ck-pos-m/qcashview.php',$getstr),
		'edit'	=> $phpgw->link('/ck-pos-m/qcashedit.php',$getstr),
		'copy'	=> $phpgw->link('/ck-pos-m/qcashcopy.php',$getstr),
		'delete'=> $phpgw->link('/ck-pos-m/qcashdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('qcash_section','qcash_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','qcash','report');

?>
