<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.tax.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class tax {

//---- Tax Detail Validation Checks

    function tax_validate($tx) {
	global $phpgw ;
	$err="";
	if ($tx[taxnumber]=="")				$err=lang('Error: Tax Name/Number Missing');
	if ($tx[rate] and !is_numeric($tx[rate]))	$err=lang('Error: Tax Rate must be numeric');
	if ($tx[rate]<0 or $tx[rate]>10)		$err=lang('Error: Rate must be 0-10(assumed maximum)');
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post Tax Detail to Database

    function tax_post($tx, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $tx[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO tax(id,taxnumber,rate,chart_id,notes,taxgroup) ";
			$sql.="VALUES ('$id','$tx[taxnumber]','$tx[rate]','$tx[chart_id]','$tx[notes]','ar')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql ="UPDATE tax SET taxnumber='$tx[taxnumber]',rate='$tx[rate]',chart_id='$tx[chart_id]'," ;
			$sql.="notes='$tx[notes]',taxgroup='ar' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM tax WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Tax") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Tax Detail

    function tax_write(&$t, &$tx) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_taxnumber',lang('Name/Number'));
	$t->set_var('lang_rate',lang('Rate'));
	$t->set_var('lang_account',lang('Associated Ledger A/C'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('id',$tx[id]);
	$t->set_var('taxnumber',$tx[taxnumber]);
	$t->set_var('rate',$tx[rate]);
	$t->set_var('chart_id',$tx[chart_id]);
	$t->set_var('acc_selectlist',account_selectlist("WHERE link like '%AR_tax%'",$tx[chart_id]));
	$notes = $tx[notes];
	$pos = strpos($notes,"--log--") ;
	$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
	$t->set_var('notes',$notes);
	$t->parse('out','report',True);
	}

    }

?>

