<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: quoteconvert.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-so',	    'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$filter=urlencode(stripslashes($filter));

	$so = CreateObject('ck-so.so') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-so'));
	$t->set_file('report','sowtscreen.tpl') ;
	$t->set_var('lang_title',lang('Convert Quotation to Sales Order [With Tax]'));
	$t->set_var('readonly','');
	$t->set_var('disabled','');
	$message = lang("UC - Unit Cost, BTUP - Before Tax Unit Price.") ;
	$message.= "  ".lang("Due date is an independent input subject to how urgent the ordered goods is needed.");
	$message.= "<br>".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "  ".lang("Depending on tax rate setting, [copy] may not retain the tax figure from source so.") ;
	$message.= "<br>".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list") ;
	$message.= "<br><b>".lang("Manual tax input is allowed.");
	$message.= "  ".lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',$message);

/*------------- Write Sales Order to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$phpgw->db->query("SELECT * FROM quote WHERE id='$id'");
		$phpgw->db->next_record();
		$s = $phpgw->db->Record ;
		$s[transdate] = $s[duedate] = "" ;
		$s[taxstatus] = $phpgw->db->f('taxincluded') ;
		if ($s[amount]==$s[netamount])	$s[taxstatus] = "e" ;
		}
	    else $s = $_POST ;
	if ($s[taxstatus]=="e")	{
		$t->set_file('report','sontscreen.tpl') ;
		$t->set_var('lang_title',lang('Convert Quotation to Sales Order [Without Tax]'));
		}
	$so->so_header_write($t, $s, $taxstatus) ;

	$t->set_block('report','detail','detail_section');

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$phpgw->db->query("SELECT * FROM oitem WHERE trans_id='$id'");
		$i=1;
		while ($phpgw->db->next_record()) {
			$s['itemid'.$i]		=	$phpgw->db->f('itemid') ;
			$s['itemtype'.$i]	=	$phpgw->db->f('itemtype') ;
			$s['parts_id'.$i]	=	$phpgw->db->f('parts_id') ;
			$s['description'.$i]	=	$phpgw->db->f('description') ;
			$s['qty'.$i]		=	$phpgw->db->f('qty') ;
			$s['unit'.$i]		=	$phpgw->db->f('unit') ;
			$s['sellprice'.$i]	=	$phpgw->db->f('sellprice') ;
			$s['discount'.$i]	=	$phpgw->db->f('discount') ;
			$s['tax1'.$i]		=	$phpgw->db->f('tax1') ;
			$s['tax2'.$i]		=	$phpgw->db->f('tax2') ;
			$i++ ;
			}
		}
	    else $s = $_POST ;

	$so->so_transform($s,$newrow,$delete) ;
	$so->so_detail_write($t,$s,$posted) ;
	$t->parse('out','report',True);

/*-------------- Post Sales Order ----------------------------------------------*/

	if (isset($post)) {
		$err = $so->so_validate($s) ;
		$t->set_var('message',$err);
		if ($err=='') { $posted = $so->so_post($s, $t, $id, 'new', 'quoteconvert', True) ; }
		}

/*--------------------Write bottom Section------------------------------------------*/

	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-so/quotefilter.php'));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-so/quoteconvert.php')) ;
		if ($taxstatus=="e")	$t->set_var('lang_post',lang('Post SO [without Tax]'));
			else		$t->set_var('lang_post',lang('Post SO [with Tax]'));
		$t->set_var('lang_newrow',lang('Add New Row & Refresh Page'));
		$t->set_var('lang_update',lang('Refresh Page'));
		}
	$t->set_var('done_action',$phpgw->link('/ck-so/quotefilter.php'));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>

