<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: quotewtedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-quote',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$fromnt = ($_GET["fromnt"]) ? $_GET["fromnt"] : $_POST["fromnt"] ;
	$filter=urlencode(stripslashes($filter));

	$quo = CreateObject('ck-quote.quote') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-quote'));
	$t->set_file('report','quotewtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Quotation [with Tax]'));
	$message = lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a vendor.") ;
	$message.= "<br>".lang("Due date is an independent input subject to how urgent the ordered goods is needed.");
	$message.= "<br>".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$message.= "<br>".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "  ".lang("Posted (Tax Exempted) Quotation will appear in the Quotation [no Tax] list.");
	$message.= "<br><b>".lang("Manual tax input is allowed.");
	$message.= "  ".lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',$message);

/*------------- Write Quotation to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$phpgw->db->query("SELECT * FROM quote WHERE id='$id'");
		$phpgw->db->next_record();
		$q = $phpgw->db->Record ;
		$q[taxstatus] = $phpgw->db->f('taxincluded') ;
		}
	    else $q = $_POST ;
	$quo->quote_header_write($t, $q, 'wt') ;

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$firstime = True ;
		$phpgw->db->query("SELECT * FROM oitem WHERE trans_id='$id' ORDER BY id");
		$i=1;
		while ($phpgw->db->next_record()) {
			$q['itemid'.$i]		=	$phpgw->db->f('itemid') ;
			$q['itemtype'.$i]	=	$phpgw->db->f('itemtype') ;
			$q['description'.$i]	=	$phpgw->db->f('description') ;
			$q['qty'.$i]		=	$phpgw->db->f('qty') ;
			$q['unit'.$i]		=	$phpgw->db->f('unit') ;
			$q['sellprice'.$i]	=	$phpgw->db->f('sellprice') ;
			$q['discount'.$i]	=	$phpgw->db->f('discount') ;
			$q['tax1'.$i]		=	$phpgw->db->f('tax1') ;
			$q['tax2'.$i]		=	$phpgw->db->f('tax2') ;
			$i++ ;
			}
		}
	    else $q = $_POST ;

	$quo->quote_transform($q,$newrow,$delete) ;
	$quo->quote_detail_write($t,$q,$posted,$firstime) ;
	$t->parse('out','report',True);

/*-------------- Post Quotation ----------------------------------------------*/

	if (isset($post)) {
		$err = $quo->quote_validate($q) ;
		$t->set_var('message',$err);
		if ($err=='') { $posted = $quo->quote_post($q, $t, $id, 'edit', 'quotewtedit') ; }
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted) {
		if ($fromnt=="yes")	$t->set_var('action',$phpgw->link('/ck-quote/quotentlist.php',$getstr));
			else		$t->set_var('action',$phpgw->link('/ck-quote/quotewtlist.php',$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-quote/quotewtedit.php',"fromnt=$fromnt&".$getstr)) ;
		$t->set_var('lang_post',lang('Update Quotation [with Tax]'));
		$t->set_var('lang_newrow',lang('Add New Row & Refresh Page'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	if ($fromnt=="yes")	$t->set_var('done_action',$phpgw->link('/ck-quote/quotentlist.php',$getstr));
		else		$t->set_var('done_action',$phpgw->link('/ck-quote/quotewtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>

