<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-quote',  'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$customer = ($_GET["customer"]) ? $_GET["customer"] : $_POST["customer"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-quote'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Report to Generate and to set Report Parameters :'));
	$msg1 = lang('Generation of Quotation report requires lengthy processing time.') ;
	$msg2 = lang('You should initiate report generation only during off-peak hours.');
	$t->set_var('lang_search_message',"$msg1<br>$msg2") ;

/* ------------- Display Report Generation Parameters ----------------------- */

$t->set_var('lang_criteria',lang('Reporting Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$reserved = lang('Reserved') ;
$replist = array (	1	=>	"<OPTION value='1'>1 -- $reserved</OPTION>",
			2	=>	"<OPTION value='2'>2 -- $reserved</OPTION>",
			3	=>	"<OPTION value='3'>3 -- $reserved</OPTION>",
			4	=>	"<OPTION value='4'>4 -- $reserved</OPTION>",
			5	=>	"<OPTION value='5'>5 -- ".lang('Quotation Audit Control Report')."</OPTION>" ) ;
$filter = array (cond1		=>	lang('Which Report') ,
		condvar1	=>	'repnum' ,
		conddefault1	=>	'' ,
		condnote1	=>	lang('If wrong report chosen, click [Report] to restart'),
		cond2		=>	lang('Which Customer') ,
		condvar2	=>	'customer' ,
		selectlist2	=>	customer_selectlist('',$customer),
		conddefault2	=>	'' ,
		condnote2	=>	lang('Select the target customer') ,

		cond3		=>	lang('Report Status as of') ,
		condvar3	=>	'rdate' ,
		conddefault3	=>	'' ,
		condnote3	=>	lang('Format: YYYY-MM-DD') ) ;

if ($err) {
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $repnum ;
	$filter["conddefault2"] = $customer ;
	$filter["conddefault3"] = $rdate ;
	}
$t->set_var('condition',$filter[cond1]) ;
$t->set_var('var',$filter[condvar1]) ;
$t->set_var('note',$filter[condnote1]);
if (!$repnum) 	For ($i=1;isset($replist[$i]);$i++)	{$selectlist .= $replist[$i] ;}
    else 	$selectlist = $replist[$repnum];
$t->set_var('selectlist',$selectlist);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

If (!$repnum) 	{$t->set_var('detail_section',"");}
	else
	For ($i=3;isset($filter['cond'.$i]);$i++)	{
		$print = False ;
		Switch ($repnum) :
			case "1" :
				$print = $i==3 ? True : False ;	break;
			case "2" :
				$print = $i==3 ? True : False ;	break;
			case "3" :
				$print = $i==3 ? True : False ;	break;
			case "4" :
				$print = $i==3 ? True : False ;	break;
			case "5" :
				$print = $i==3 ? True : False ;	break;
		endswitch;
		if ($print)	{
			$t->set_var('condition',$filter['cond'.$i]);
			$t->set_var('var',$filter['condvar'.$i]);
			$t->set_var('default',$filter['conddefault'.$i]);
			$t->set_var('note',$filter['condnote'.$i]);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$repnum) {
		$t->set_var('search_action',$phpgw->link('/ck-quote/reportfilter.php')) ;
		$t->set_var('lang_search',lang('Input Report Generation Parameters'));
		}
	    else {
		$t->set_var('search_action',$phpgw->link('/ck-quote/reportfilter_validate.php')) ;
		$t->set_var('lang_search',lang('Start Report Generation'));
		}
	$t->set_var('add_action',$phpgw->link('/ck-quote/reportfilter.php')) ;
	$t->set_var('lang_add',lang('Done'));
	$t->pparse('out','report',True);
?>
