<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sontordack.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'	=> 'ck-so',
					'noheader'	=> True,
					'nonavbar'	=> True,
			 'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$sdate = ($_GET["sdate"]) ? $_GET["sdate"] : $_POST["sdate"] ;
	$regenerate = ($_GET["regenerate"]) ? $_GET["regenerate"] : $_POST["regenerate"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-so'));
	$t->set_file(array('report'	=> 'sontordack.tpl',
 	                   'items'	=> 'sontordack.tpl'));
	$t->set_block('items','item_row','item_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Order Acknowledgement (OA) Image (Use browser to print OA shown above)');
	$t->set_var('lang_title',$title);
	$notes=lang('[This is a sample subject to tailoring per individual printer & order acknowledgement format]');
	$notes.=lang('<br>For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_notes',$notes);
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;

	$phpgw->db->query("SELECT * FROM so WHERE id='$id'");
	$phpgw->db->next_record();
	$customer = $phpgw->db->f('customer') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$sonumber = $phpgw->db->f('sonumber') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM customer WHERE id='$customer'");
	$phpgw->db->next_record();
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$addr1 = $phpgw->db->f('addr1') ;
	$addr2 = $phpgw->db->f('addr2') ;
	$addr3 = $phpgw->db->f('addr3') ;
	$addr4 = $phpgw->db->f('addr4') ;
	$terms = $phpgw->db->f('terms') ;
	$shiptoname = $phpgw->db->f('shiptoname') ;
	$shiptoaddr1 = $phpgw->db->f('shiptoaddr1') ;
	$shiptoaddr2 = $phpgw->db->f('shiptoaddr2') ;
	$shiptoaddr3 = $phpgw->db->f('shiptoaddr3') ;
	$shiptoaddr4 = $phpgw->db->f('shiptoaddr4') ;

	$t->set_var('lang_oa',lang('ORDER ACKNOWLEDGEMENT'));
	$t->set_var('lang_transdate',lang('Order Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_sonumber',lang('Number'));
	$t->set_var('lang_billto',lang('Bill To:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('sonumber',$sonumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shiptoname',$shiptoname) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$phpgw->db->query("SELECT * FROM oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('sellprice') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array('itemid'	=> $itemid,
				'description'	=> $description,
				'qty'		=> $qty,
				'price'		=> $price,
				'discount'	=> $discount ,
				'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("Order Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',lang("Thank you for your valued business!")) ;
	$t->set_var('lang_remark',$remark) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('email_action',$phpgw->link('/ck-so/sontordack.php',"id=$id&filter=$filter")) ;
	$t->set_var('lang_email',lang('Email OA'));
	$t->set_var('done_action',$phpgw->link('/ck-so/sontlist.php',"filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	if ($email)	{
		$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
		$custmsg = lang("Customer") ;	$somsg = lang("SO") ;
		$successmsg = lang("Email successfully sent to") ;
		$failuremsg = lang("Email fails to deliver to") ;

		if (!$custemail)				$err = lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email") ;
		if (!$comemail)					$err = lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid company return email");
		if ($err) {
			$notes = "$custmsg/$name -- $somsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_notes',$notes) ;
			}
		   else {
			$recipient = "$contact < $custemail >" ;
			$subject = lang("SO#: %1 dated %2",$sonumber,$transdate) ;
			$message = $t->parse('out','items',report) ;
			$message = substr($message,0,strpos($message,'<!-- BEGIN done -->')) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Content-Type: text/html; charset=$charset\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$notes = "$custmsg/$name -- $somsg/$id -- $successmsg $custemail" ;
				else	$notes = "$custmsg/$name -- $somsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_notes',$notes);
			}
		}
	$t->pparse('out','items',report);

?>
