<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sqmatchclear.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-so', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$sqmatch = CreateObject('ck-so.sqmatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-so'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','sqmatchscreen.tpl') ;
	$t->set_block('report','acceptedlist','acceptedlist_section');
	$t->set_block('report','pendinglist','pendinglist_section');
	$t->set_var('lang_title',lang("Clear SO/Quotation Matching Detail"));
	$t->set_var('warning','') ;
	$t->set_var('message1','') ;
	$t->set_var('message2','') ;
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to clear ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-so/sqmatchclear.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$sq[id] = $id ;
		$sqmatch->sqmatch_post($sq, $t,'clear','ismatchclear');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		exit;
		}

/*------------- Write SO/Quotation Matching Detail to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM so WHERE id='$id'");
$phpgw->db->next_record();
$customer = $phpgw->db->f('customer') ;
$sq = $phpgw->db->Record ;
$sqmatch->sqmatch_header_write($t, $sq) ;

$sql ="SELECT quotenumber,id,duedate,amount,a_amount FROM quote, sqmatch ";
$sql.="WHERE soid='$id' and id=quoteid";
$phpgw->db->query($sql);
$i=1;
while ($phpgw->db->next_record()) {
	$sq['aquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
	$sq['aquoteid'.$i]	=	$phpgw->db->f('id') ;
	$sq['aduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$sq['aquoteamount'.$i]	=	$phpgw->db->f('amount') ;
	$sq['aa_amount'.$i]	=	$phpgw->db->f('a_amount') ;
	$sq['anewaamount'.$i]	=	"" ;
	$i++ ;
	}

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "is1".$user.time() ;
$temp2 = "is2".$user.time() ;
$sql = "CREATE TABLE $temp1 AS " ;
$sql.="SELECT quotenumber,id,duedate,amount,0.0 as a_amount,0.0 as acceptedamount FROM quote WHERE customer='$customer' ";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,a_amount,0.0 as acceptedamount FROM quote, sqmatch ";
$sql.= "WHERE id=quoteid and soid='$id'";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,0.0 as a_amount,sum(a_amount) as acceptedamount " ;
$sql.= "FROM quote a, sqmatch b ";
$sql.= "WHERE customer='$customer' and a.id=b.quoteid GROUP BY duedate,id,quotenumber";
$phpgw->db->query($sql);
$sql = "CREATE TABLE $temp2 AS " ;
$sql.= "SELECT quotenumber,id,duedate,sum(amount) as amount,sum(a_amount) as a_amount,sum(acceptedamount) as acceptedamt " ;
$sql.= "FROM $temp1 GROUP BY duedate,id,quotenumber ";
$phpgw->db->query($sql);
$sql = "SELECT * FROM $temp2 ORDER BY quotenumber" ;
$phpgw->db->query($sql) ;

$i=1;
$fullyaccepted = False ;
while ($phpgw->db->next_record()) {
	$quoteamount		=	$phpgw->db->f('amount') ;
	$acceptedamt		=	$phpgw->db->f('acceptedamt') ;
	$sq['pdquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
	$sq['pdquoteid'.$i]	=	$phpgw->db->f('id') ;
	$sq['pdduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$sq['pdquoteamount'.$i]	=	$quoteamount ;
	$sq['pda_amount'.$i]	=	$phpgw->db->f('a_amount') ;
	$sq['pda_othamt'.$i]	=	$acceptedamt-$phpgw->db->f('a_amount') ;
	$sq['pdacceptedamt'.$i]	=	$acceptedamt ;
	$sq['pdosamount'.$i]	=	$quoteamount - $acceptedamt ;
	$i++ ;
	}
$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

$sqmatch->sqmatch_detail_write($t,$sq,True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_match',lang("Auto-allocate Invoice's Remaining Amount by :"));
	$t->set_var('action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr));
	$t->set_var('lang_match_equal',lang('Done'));
	$t->set_var('lang_match_fifo',lang('Done'));
	$t->set_var('lang_clear',lang('Done'));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
