<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sqmatchedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-so', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$move = ($_GET["move"]) ? $_GET["move"] : $_POST["move"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$clear = ($_GET["clear"]) ? $_GET["clear"] : $_POST["clear"] ;
	$match_equal = ($_GET["match_equal"]) ? $_GET["match_equal"] : $_POST["match_equal"] ;
	$match_fifo = ($_GET["match_fifo"]) ? $_GET["match_fifo"] : $_POST["match_fifo"] ;
	$filter=urlencode(stripslashes($filter));

	$sqmatch = CreateObject('ck-so.sqmatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-so'));
	$t->set_file('report','sqmatchscreen.tpl') ;
	$t->set_block('report','acceptedlist','acceptedlist_section');
	$t->set_block('report','pendinglist','pendinglist_section');
	$t->set_var('lang_title',lang('Edit SO/Quotation Matching Detail'));
	$warning1 = lang("Because a quotation or its line items can be accepted more than once,") ;
	$warning2 = lang("total accepted amount for a quotation is allowed to exceed the quotation's original full value.") ;
	$warning3 = lang("Thus, user would have to be extra careful not to match SO against the wrong Quotation.") ;
	$warning4 = lang("Also, auto-allocation or matching is less likely to result in the desired correct matching.") ;
	$message1 = lang("If either auto-allocation button is clicked, the [Amount Accepted via this SO to be updated to] field will be ignored and blanked out.") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('warning',"<font size='-1'>[$warning1 $warning2   $warning3   $warning4]</font>") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;

/*------------- Write SO/Quotation Matching to Screen Display ----------------------------*/

if (!isset($post) and !isset($move) and !isset($update) and !isset($clear) and !isset($match_equal) and !isset($match_fifo)) {
	$phpgw->db->query("SELECT * FROM so WHERE id='$id'");
	$phpgw->db->next_record();
	$sq = $phpgw->db->Record ;
	}
    else $sq = $HTTP_POST_VARS ;
$customer = $sq[customer] ;
$sqmatch->sqmatch_header_write($t, $sq) ;

if (!isset($post) and !isset($move) and !isset($update) and !isset($clear) and !isset($match_equal) and !isset($match_fifo)) {
	$sql ="SELECT quotenumber,id,duedate,amount,a_amount FROM quote, sqmatch ";
	$sql.="WHERE soid='$id' and id=quoteid";
	$phpgw->db->query($sql);
	$i=1;
	while ($phpgw->db->next_record()) {
		$sq['aquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
		$sq['aquoteid'.$i]	=	$phpgw->db->f('id') ;
		$sq['aduedate'.$i]	=	$phpgw->db->f('duedate') ;
		$sq['aquoteamount'.$i]	=	$phpgw->db->f('amount') ;
		$sq['aa_amount'.$i]	=	$phpgw->db->f('a_amount') ;
		$sq['anewaamount'.$i]	=	"" ;
		$i++ ;
		}

	$user = trim($phpgw_info["user"]["userid"]);
	$temp1 = "is1".$user.time() ;
	$temp2 = "is2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT quotenumber,id,duedate,amount,0.0 as a_amount,0.0 as acceptedamount FROM quote WHERE customer='$customer' ";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,a_amount,0.0 as acceptedamount FROM quote, sqmatch ";
	$sql.= "WHERE id=quoteid and soid='$id'";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,0.0 as a_amount,sum(a_amount) as acceptedamount " ;
	$sql.= "FROM quote a, sqmatch b ";
	$sql.= "WHERE customer='$customer' and a.id=b.quoteid GROUP BY duedate,id,quotenumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT quotenumber,id,duedate,sum(amount) as amount,sum(a_amount) as a_amount,sum(acceptedamount) as acceptedamt " ;
	$sql.= "FROM $temp1 GROUP BY duedate,id,quotenumber ";
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp2 ORDER BY duedate,quotenumber" ;
	$phpgw->db->query($sql) ;

	$i=1;
	$fullyaccepted = False ;
	while ($phpgw->db->next_record()) {
		$quoteamount		=	$phpgw->db->f('amount') ;
		$acceptedamt		=	$phpgw->db->f('acceptedamt') ;
		$sq['pdquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
		$sq['pdquoteid'.$i]	=	$phpgw->db->f('id') ;
		$sq['pdduedate'.$i]	=	$phpgw->db->f('duedate') ;
		$sq['pdquoteamount'.$i]	=	$quoteamount ;
		$sq['pda_amount'.$i]	=	$phpgw->db->f('a_amount') ;
		$sq['pda_othamt'.$i]	=	$acceptedamt-$phpgw->db->f('a_amount') ;
		$sq['pdacceptedamt'.$i]	=	$acceptedamt ;
		$sq['pdosamount'.$i]	=	$quoteamount - $acceptedamt ;
		$i++ ;
		}
	$sql = "DROP TABLE $temp1, $temp2" ;
	$phpgw->db->query($sql);
	}
    else $sq = $HTTP_POST_VARS ;

if (isset($clear))		{$msg = $sqmatch->match_clear($sq) ; $t->set_var('message1',$msg) ;}
if (isset($match_equal))	{$msg = $sqmatch->match_equal($sq) ; $t->set_var('message1',$msg) ;}
if (isset($match_fifo))		{$msg = $sqmatch->match_fifo($sq) ; $t->set_var('message1',$msg) ;}

$sqmatch->sqmatch_detail_write($t,$sq,$posted);

$t->parse('out','report',True);

/*-------------- Post SO/Quotation Matching ----------------------------------------------*/

if (isset($post)) {
	$err = $sqmatch->sqmatch_validate($sq) ;
	$t->set_var('message2',$err);
	if ($err=='') { $posted = $sqmatch->sqmatch_post($sq, $t, 'edit', 'sqmatchedit') ; }
	}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_match',lang("Auto-allocate SO's Remaining Amount by :"));
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr));
		$t->set_var('lang_match_equal',lang('Done'));
		$t->set_var('lang_match_fifo',lang('Done'));
		$t->set_var('lang_clear',lang('Done'));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-so/sqmatchedit.php',$getstr)) ;
		$t->set_var('lang_match_equal',lang('Matching Oldest Equal Amount'));
		$t->set_var('lang_match_fifo',lang('FIFO Scheme'));
		$t->set_var('lang_clear',lang('Clear Allocation'));
		$t->set_var('lang_post',lang('Post SO/Quotation Matching'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
