<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sqmatchview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-so', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$sqmatch = CreateObject('ck-so.sqmatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-so'));
	$t->set_file('report','sqmatchscreen.tpl') ;
	$t->set_block('report','acceptedlist','acceptedlist_section');
	$t->set_block('report','pendinglist','pendinglist_section');
	$t->set_var('lang_title',lang('View SO/Quotation Matching Detail'));
	$warn1 = lang("Because a quotation or its line items can be accepted more than once,") ;
	$warn2 = lang("total accepted amount for a quotation is allowed to exceed the quotation's original full value.") ;
	$warn3 = lang("Thus, user would have to be extra careful not to match SO against the wrong Quotation.") ;
	$warning = "<font size='-1'>[$warn1 $warn2  $warn3]</font>" ;
	$message1 = lang("Which Invoice got allocated first will affect the final Invoice/SO pairing") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;
	$t->set_var('warning',$warning) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');

/*------------- Write SO/Quotation Matching to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM so WHERE id='$id'");
$phpgw->db->next_record();
$customer = $phpgw->db->f('customer') ;
$sq = $phpgw->db->Record ;
$sqmatch->sqmatch_header_write($t, $sq) ;

$sql ="SELECT quotenumber,id,duedate,amount,a_amount FROM quote, sqmatch WHERE soid='$id' and id=quoteid";
$phpgw->db->query($sql);
$i=1;
while ($phpgw->db->next_record()) {
	$sq['aquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
	$sq['aquoteid'.$i]	=	$phpgw->db->f('id') ;
	$sq['aduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$sq['aquoteamount'.$i]	=	$phpgw->db->f('amount') ;
	$sq['aa_amount'.$i]	=	$phpgw->db->f('a_amount') ;
	$sq['anewaamount'.$i]	=	"" ;
	$i++ ;
	}

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "sq1".$user.time() ;
$temp2 = "sq2".$user.time() ;
$sql = "CREATE TABLE $temp1 AS " ;
$sql.="SELECT quotenumber,id,duedate,amount,0.0 as a_amount,0.0 as acceptedamount FROM quote WHERE customer='$customer' ";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,a_amount,0.0 as acceptedamount FROM quote, sqmatch ";
$sql.= "WHERE id=quoteid and soid='$id'";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT quotenumber,id,duedate,0.0 as amount,0.0 as a_amount,sum(a_amount) as acceptedamount " ;
$sql.= "FROM quote a, sqmatch b ";
$sql.= "WHERE customer='$customer' and a.id=b.quoteid GROUP BY duedate,id,quotenumber";
$phpgw->db->query($sql);
$sql = "CREATE TABLE $temp2 AS " ;
$sql.= "SELECT quotenumber,id,duedate,sum(amount) as amount,sum(a_amount) as a_amount,sum(acceptedamount) as acceptedamt " ;
$sql.= "FROM $temp1 GROUP BY duedate,id,quotenumber ";
$phpgw->db->query($sql);
$sql = "SELECT * FROM $temp2 ORDER BY quotenumber" ;
$phpgw->db->query($sql) ;

$i=1;
$fullyaccepted = False ;
while ($phpgw->db->next_record()) {
	$quoteamount		=	$phpgw->db->f('amount') ;
	$acceptedamt		=	$phpgw->db->f('acceptedamt') ;
	$sq['pdquotenumber'.$i]	=	$phpgw->db->f('quotenumber') ;
	$sq['pdquoteid'.$i]	=	$phpgw->db->f('id') ;
	$sq['pdduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$sq['pdquoteamount'.$i]	=	$quoteamount ;
	$sq['pda_amount'.$i]	=	$phpgw->db->f('a_amount') ;
	$sq['pda_othamt'.$i]	=	$acceptedamt-$phpgw->db->f('a_amount') ;
	$sq['pdacceptedamt'.$i]	=	$acceptedamt ;
	$sq['pdosamount'.$i]	=	$quoteamount - $acceptedamt ;
	$i++ ;
	}

$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

$sqmatch->sqmatch_detail_write($t,$sq,True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_match',lang("Auto-allocate Invoice's Remaining Amount by :"));
	$t->set_var('action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr)) ;
	$t->set_var('lang_match_equal',lang('Done'));
	$t->set_var('lang_match_fifo',lang('Done'));
	$t->set_var('lang_clear',lang('Done'));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-so/sqmatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
