<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: approvetslist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'approvetslist.tpl', 'approvets'=>'approvetslist.tpl'));
	$t->set_block('approvets','approvets_row','approvets_section');
	$t->set_var('message','');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Staff Timesheet Approval List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/approvefilter.php'));

$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-sss/approvetslist.php',lang('Employee')));
$t->set_var('sort_year',$nm->show_sort_order($sort,'year',$order,'/ck-sss/approvetslist.php',lang('Year')));
$t->set_var('sort_week',$nm->show_sort_order($sort,'week',$order,'/ck-sss/approvetslist.php',lang('Week')));
$t->set_var('sort_hour_ttl',$nm->show_sort_order($sort,'hour_ttl',$order,'/ck-sss/approvetslist.php',lang('Working Hours')));
$t->set_var('sort_day_ttl',$nm->show_sort_order($sort,'day_ttl',$order,'/ck-sss/approvetslist.php',lang('Days on Leave')));
$t->set_var('sort_approved_by',$nm->show_sort_order($sort,'approved_by',$order,'/ck-sss/approvetslist.php',lang('Approved By')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-sss/approvetslist.php',lang('Audit Id')));
$t->set_var('lang_approve',lang('Approve/Reject'));

if (!$order) {$order = "name,year,week" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT name,year,week,hour_ttl,day_ttl,approved_by,a.id FROM timesheet a, employee b  " ;
$sql.=  "$where and empid=b.id ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'year'		=> "",
				'week'		=> "",
				'hour_ttl'	=> "",
				'day_ttl'	=> "",
				'approved_by'	=> "",
				'id'		=> "",
				'approve'	=> "",
									));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('approvets_section','approvets_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$approved_by	= $phpgw->db->f('approved_by') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'year'		=> $phpgw->db->f('year'),
				'week'		=> $phpgw->db->f('week'),
				'hour_ttl'	=> $phpgw->db->f('hour_ttl'),
				'day_ttl'	=> $phpgw->db->f('day_ttl'),
				'approved_by'	=> $approved_by,
				'id'		=> $id,
				'approve'	=> $phpgw->link('/ck-sss/timesheetapprove.php',$getstr)
										));
	if ($approved_by<>'')	$t->set_var('lang_approve','') ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('approvets_section','approvets_row',true);
	$t->set_var('lang_approve',lang('Approve/Reject'));
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','approvets','report');

?>
