<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: employeelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'employeelist.tpl', 'employee'=>'employeelist.tpl'));
	$t->set_block('employee','employee_row','employee_section');
	$message = lang("EC - Emergency Contact; PR - Performance Review; BP - Benefit Plan") ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Employee List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/index.php'));
	$t->set_var('message',$message);

$t->set_var('lang_auxiinfo',lang('Edit Auxillary Employee Information'));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-sss/employeelist.php',lang('Employee Name/#')));
$t->set_var('sort_prefix',$nm->show_sort_order($sort,'prefix',$order,'/ck-sss/employeelist.php',lang('Prefix')));
$t->set_var('sort_family',$nm->show_sort_order($sort,'family',$order,'/ck-sss/employeelist.php',lang('Family Name')));
$t->set_var('sort_given',$nm->show_sort_order($sort,'given',$order,'/ck-sss/employeelist.php',lang('Given Name')));
$t->set_var('sort_suffix',$nm->show_sort_order($sort,'suffix',$order,'/ck-sss/employeelist.php',lang('Suffix')));
$t->set_var('sort_username',$nm->show_sort_order($sort,'username',$order,'/ck-sss/employeelist.php',lang('User Name')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-sss/employeelist.php',lang('Audit Id')));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_photo',lang('Photo'));
$t->set_var('lang_address',lang('Address'));
$t->set_var('lang_phone',lang('Phone'));
$t->set_var('lang_email',lang('Email'));
$t->set_var('lang_ec',lang('EC'));

$phpgw->db->query("SELECT * FROM defaults");
$phpgw->db->next_record() ;
$photoyn = $phpgw->db->f('photoyn') ;
$addressyn = $phpgw->db->f('addressyn') ;
$phoneyn = $phpgw->db->f('phoneyn') ;
$emailyn = $phpgw->db->f('emailyn') ;
$ecyn = $phpgw->db->f('ecyn') ;

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from employee $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'			=> "No personnel info found",
				'prefix'		=> "",
				'family'		=> "",
				'given'			=> "",
				'suffix'		=> "",
				'username'		=> "",
				'id'			=> "",
				'view'			=> "",
				'photo'			=> "",
				'address'		=> "",
				'phone'			=> "",
				'email'			=> "",
				'ec'			=> "",
								));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('employee_section','employee_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'prefix'	=> $phpgw->db->f('prefix'),
				'family'	=> $phpgw->db->f('family'),
				'given'		=> $phpgw->db->f('given'),
				'suffix'	=> $phpgw->db->f('suffix'),
				'username'	=> $phpgw->db->f('username'),
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-sss/employeeview.php',$getstr),
				'photo'		=> $phpgw->link('/ck-sss/photoedit.php',$getstr),
				'address'	=> $phpgw->link('/ck-sss/addressedit.php',$getstr),
				'phone'		=> $phpgw->link('/ck-sss/phoneedit.php',$getstr),
				'email'		=> $phpgw->link('/ck-sss/emailedit.php',$getstr),
				'ec'		=> $phpgw->link('/ck-sss/ecedit.php',$getstr),
												));
	if ($photoyn=='no')	$t->set_var( array('lang_photo'=>'','photo'=>'') ) ;
	if ($addressyn=='no')	$t->set_var( array('lang_address'=>'','address'=>'') ) ;
	if ($phoneyn=='no')	$t->set_var( array('lang_phone'=>'','phone'=>'') ) ;
	if ($emailyn=='no')	$t->set_var( array('lang_email'=>'','email'=>'') ) ;
	if ($ecyn=='no')	$t->set_var( array('lang_ec'=>'','ec'=>'') ) ;

	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('employee_section','employee_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','employee','report');

?>
