<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expenseappsview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$expapp = CreateObject('ck-sss.expenseapp') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file(array('view'=>'expenseappscreen.tpl', 'report'=>'expenseappscreen.tpl'));
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang("View Expense/Allowance Claim"));
	$msg1 = lang('Pay Period');
	$msg2 = lang('mn - Month, sm - Semi-monthly, wk - Week, dy - Day, hr - Hour');
	$msg3 = lang('Basis of Calculation');
	$msg4 = lang('bs - basic salary, pc - allowance/deduction unit amount,') ;
	$msg5 = lang('dp - imputed daily pay, hp - imputed hourly pay, qty - inputted qty, amt - inputted amount');
	$t->set_var('message',"$msg1:  $msg2<br>$msg3:  $msg4 $msg5");
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');

/* ------------------- Print Expense/Allowance Claim Details -------------------------------- */

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM pynr_trans a, payroll b, pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$nr = $phpgw->db->Record ;
	
	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($nr[period]) :
		case "mn" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('mndfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('smdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('wkdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$nr[daypay] = $nr[salary] ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$nr[daypay] = $nr[salary] * $phpgw->db->f('dyhfactor') ;
				$nr[hourpay] = $nr[salary] ;				break ;
		endswitch ;
	$nr[daypay] = sprintf("%01.2f",$nr[daypay]) ;
	$nr[hourpay] = sprintf("%01.2f",$nr[hourpay]) ;

	$expapp->expenseapp_write($t, $nr) ;

	$t->set_var('action',$phpgw->link('/ck-sss/expenseapplist.php',"filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_refresh',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-sss/expenseapplist.php',"filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->set_var('qty_readonly','readonly');
	$t->set_var('amt_readonly','readonly');
	$t->pparse('out','report', True );

?>
