<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payroll.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class payroll {

//---- Write payroll Header

    function payroll_header_write(&$t, &$p) {
	global $phpgw ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($p[period]) :
		case "mn" :	$p[daypay] = $p[salary]/$phpgw->db->f('mndfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$p[daypay] = $p[salary]/$phpgw->db->f('smdfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$p[daypay] = $p[salary]/$phpgw->db->f('wkdfactor') ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$p[daypay] = $p[salary] ;
				$p[hourpay] = $p[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$p[daypay] = $p[salary] * $phpgw->db->f('dyhfactor') ;
				$p[hourpay] = $p[salary] ;				break ;
		endswitch ;
	$p[daypay] = sprintf("%01.2f",$p[daypay]) ;
	$p[hourpay] = sprintf("%01.2f",$p[hourpay]) ;
	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_salary',lang('Current Basic Salary'));
	$t->set_var('lang_period',lang('Current Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Current Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Current Hourly Pay'));
	$t->set_var('employee_selectlist',employee_selectlist("WHERE id=$p[empid]",'')) ;
	$t->set_var('id',$p[id]) ;
	$t->set_var('salary',$p[salary]) ;
	$t->set_var('period',$p[period]) ;
	$t->set_var('daypay',$p[daypay]) ;
	$t->set_var('hourpay',$p[hourpay]) ;
	$t->parse('out','report',True);
	}

//---- Write payroll Detail

    function payroll_detail_write(&$t, &$p, $period) {
	global $phpgw,$phpgw_info ;

	$id = $p[id] ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_eaid',lang("Recurring Item"));
	$t->set_var('lang_basis',lang("Basis of Calculation"));
	$t->set_var('lang_qty',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_unitamt',lang("Unit Amount"));
	$t->set_var('lang_rate',lang("Pay Rate"));
	$t->set_var('lang_amount',lang("Amount"));
	$t->set_var('lang_comment',lang("Comment"));
	$t->set_var('lang_total',lang('Total Recurring'));

	$t->set_var('lang_nreaid',lang("Non-Recurring Allowance/Deduction"));
	$t->set_var('lang_nrapproved_by',lang("Approved By"));
	$t->set_var('lang_nrbasis',lang("Basis of Calculation"));
	$t->set_var('lang_nrqty',lang("Quantity"));
	$t->set_var('lang_nrunit',lang("Unit"));
	$t->set_var('lang_nrunitamt',lang("Unit Amount"));
	$t->set_var('lang_nrrate',lang("Pay Rate"));
	$t->set_var('lang_nramount',lang("Amount"));
	$t->set_var('lang_nrcomment',lang("Comment"));
	$t->set_var('lang_nrtotal',lang('Total Non-Recurring (Expense/Allowance Claim)'));

	$t->set_var('lang_reductn',lang("Summary Level Reduction"));
	$t->set_var('lang_rdtnid',lang("Reduction Type"));
	$t->set_var('lang_rdbaseamt',lang("Base"));
	$t->set_var('lang_rdfloor',lang("Floor"));
	$t->set_var('lang_rdrate',lang("Rate"));
	$t->set_var('lang_rdsubtract',lang("Subtract"));
	$t->set_var('lang_rdamount',lang("Amount"));
	$t->set_var('lang_rdremark',lang("Remark"));
	$t->set_var('lang_rdtotal',lang("Total Reduction"));
	$t->set_var('lang_net',lang("Net Payroll This Period"));

	$t->set_var('lang_contri',lang("Company Contribution"));
	$t->set_var('lang_cntrid',lang("Contribution Type"));
	$t->set_var('lang_ctbaseamt',lang("Base"));
	$t->set_var('lang_ctfloor',lang("Floor"));
	$t->set_var('lang_ctrate',lang("Rate"));
	$t->set_var('lang_ctsubtract',lang("Subtract"));
	$t->set_var('lang_ctamount',lang("Amount"));
	$t->set_var('lang_ctremark',lang("Remark"));
	$t->set_var('lang_cttotal',lang("Total Contribution"));

	$float = ($phpgw_info["server"]["db_type"]=="mysql") ? "double" : "float" ;
	$user = trim($phpgw_info["user"]["userid"]);
	$temp = "pyr".$user.time() ;
	$phpgw->db->query("CREATE TABLE $temp (pyrcodeid int,amount $float)");

	$tot_amount = 0 ;	$t->set_var('detail_section','') ;
	For ($i=1;isset($p['eaid'.$i]);$i++) {
		if ($period=='PAST') {
			$eaid	=	$p['eaid'.$i] ;
			$basis	=	$p['basis'.$i] ;
			$qty	=	$p['qty'.$i] ;
			$unit	=	$p['unit'.$i] ;
			$unitamt=	$p['unitamt'.$i] ;
			$rate	=	$p['rate'.$i] ;
			$amount	=	$p['amount'.$i] ;
			}
		   else {
			$qty = 1 ;
			$eaid	=	$p['eaid'.$i] ;
			$phpgw->db->query("SELECT * from pyrcode where id='$eaid'");
			$phpgw->db->next_record();
			$basis		= $phpgw->db->f('basis') ;
			$unit		= $phpgw->db->f('unit') ;
			$unitamt	= (substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
			$rate		= $phpgw->db->f('rate') ;
			if (substr_count($basis,'qty')>0)	$qty = $p['qty'.$i];
			if (substr_count($basis,'bs')>0)	$unitamt = $p[salary] ;
			if (substr_count($basis,'hp')>0)	$unitamt = $p[hourpay] ;
			if (substr_count($basis,'dp')>0)	$unitamt = $p[daypay] ;
			$amount = sprintf("%01.2f",sprintf("%01.4f",$qty*$unitamt*$rate)) ;
			if (substr_count($basis,'amt')>0)	$amount=$p['amount'.$i];
			}
		$t->set_var('eaid_selectlist',eaid_selectlist("WHERE id=$eaid",'','short')) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$p['qty'.$j] = $qty ;
		$p['amount'.$j] = $amount ;
		$t->set_var('comment',lang('recurring')) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);

		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$eaid','$amount')");
		$tot_amount += $amount ;
		}
	$t->set_var('tot_amount',$tot_amount) ;

	$tot_nramount = 0 ;	$t->set_var('nrdetail_section','') ;
	For ($i=1;isset($p['nreaid'.$i]);$i++) {
		if ($period=='PAST') {
			$nreaid		=	$p['nreaid'.$i] ;
			$nrbasis	=	$p['nrbasis'.$i] ;
			$nrqty		=	$p['nrqty'.$i] ;
			$nrunit		=	$p['nrunit'.$i] ;
			$nrunitamt	=	$p['nrunitamt'.$i] ;
			$nrrate		=	$p['nrrate'.$i] ;
			$nramount	=	$p['nramount'.$i] ;
			$nrcomment	=	$p['nrcomment'.$i] ;
			}
		   else {
			$nrqty = 1 ;
			$nreaid	=	$p['nreaid'.$i] ;
			$phpgw->db->query("SELECT * from pyrcode where id='$nreaid'");
			$phpgw->db->next_record();
			$nrbasis	= $phpgw->db->f('basis') ;
			$nrunit		= $phpgw->db->f('unit') ;
			$nrunitamt	= (substr_count($nrbasis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
			$nrrate		= $phpgw->db->f('rate') ;
			if (substr_count($nrbasis,'qty')>0)	$nrqty = $p['nrqty'.$i];
			if (substr_count($nrbasis,'bs')>0)	$nrunitamt = $p[salary] ;
			if (substr_count($nrbasis,'hp')>0)	$nrunitamt = $p[hourpay] ;
			if (substr_count($nrbasis,'dp')>0)	$nrunitamt = $p[daypay] ;
			$nramount = sprintf("%01.2f",sprintf("%01.4f",$nrqty*$nrunitamt*$nrrate)) ;
			if (substr_count($nrbasis,'amt')>0)	$nramount=$p['nramount'.$i];
			}
		$t->set_var('nreaid_selectlist',eaid_selectlist("WHERE id=$nreaid",'','short')) ;
		$t->set_var('nrapproved_by',$p['nrapproved_by'.$i]) ;
		$t->set_var('nrbasis',$nrbasis) ;
		$t->set_var('nrqty',$nrqty) ;
		$t->set_var('nrunit',$nrunit) ;
		$t->set_var('nrunitamt',$nrunitamt) ;
		$t->set_var('nrrate',$nrrate) ;
		$t->set_var('nramount',$nramount) ;
		$p['nrqty'.$j] = $nrqty ;
		$p['nramount'.$j] = $nramount ;
		$t->set_var('nrcomment',$p['nrcomment'.$i]) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('nrdetail_section','nrdetail', True);

		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$nreaid','$nramount')");
		$tot_nramount += $nramount ;
		}
	$t->set_var('tot_nramount',$tot_nramount) ;

	$tot_rdamount = 0 ;	$t->set_var('rdtn_section','') ;
	For ($i=1;isset($p['rdtnid'.$i]);$i++) {
		if ($period=='PAST') {
			$rdtnid		=	$p['rdtnid'.$i] ;
			$rdbaseamt	=	$p['rdbase'.$i] ;
			$rdfloor	=	$p['rdfloor'.$i] ;
			$rdrate		=	$p['rdrate'.$i] ;
			$rdsubtract	=	$p['rdsubtract'.$i] ;
			$rdamount	=	$p['rdamount'.$i] ;
			$rdremark	=	$p['rdcomment'.$i] ;
			}
		   else {
			$rdtnid = $p['rdtnid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemamt = $phpgw->db->f('exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmin = $phpgw->db->f('exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmax = $phpgw->db->f('exemmax') ;
			$rdbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as rdstep from rdtnrate a,reductn b " ;
			$sql.=	"WHERE ($rdbaseamt-floor)>=step and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$rdstep = $phpgw->db->f('rdstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax from rdtnrate a,reductn b " ;
			$sql.=	"WHERE step='$rdstep' and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$rdfloor = $phpgw->db->f('floor') ;
			$rdrate = $phpgw->db->f('rate') ;
			$rdsubtract = $phpgw->db->f('subtract') ;
			$rdmin = $phpgw->db->f('min') ;
			$rdactmin = $phpgw->db->f('actmin') ;
			$rdmax = $phpgw->db->f('max') ;
			$rdactmax = $phpgw->db->f('actmax') ;
			$rdamount = sprintf("%01.2f",($rdbaseamt-$rdfloor) * $rdrate - $rdsubtract) ;
			$rdremark = "" ;
			if ($rdamount<$rdmin) {
				$rdamount = ($rdactmin=="lmt") ? $rdmin : 0 ;
				$rdremark = ($rdactmin=="lmt") ? lang('Set to Min') : lang('Min Reject') ;
				}
			if ($rdamount>$rdmax) {
				$rdamount = ($rdactmax=="lmt") ? $rdmax : 0 ;
				$rdremark = ($rdactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
				}
			}
		$t->set_var('rdtnid_selectlist',rdtnid_selectlist("WHERE id=$rdtnid",'','short')) ;
		$t->set_var('rdbaseamt',$rdbaseamt) ;
		$t->set_var('rdfloor',$rdfloor) ;
		$t->set_var('rdrate',$rdrate) ;
		$t->set_var('rdsubtract',$rdsubtract) ;
		$t->set_var('rdamount',$rdamount) ;
		$t->set_var('rdremark',$rdremark) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('rdtn_section','rdtn', True);
		$tot_rdamount += $rdamount ;
		}
	$t->set_var('tot_rdamount',$tot_rdamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$tot_ctamount = 0 ;	$t->set_var('cntr_section','') ;
	For ($i=1;isset($p['cntrid'.$i]);$i++) {
		if ($period=='PAST') {
			$cntrid		=	$p['cntrid'.$i] ;
			$ctbaseamt	=	$p['ctbase'.$i] ;
			$ctfloor	=	$p['ctfloor'.$i] ;
			$ctrate		=	$p['ctrate'.$i] ;
			$ctsubtract	=	$p['ctsubtract'.$i] ;
			$ctamount	=	$p['ctamount'.$i] ;
			$ctremark	=	$p['ctcomment'.$i] ;
			}
		   else {
			$cntrid = $p['cntrid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemamt = $phpgw->db->f('exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmin = $phpgw->db->f('exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmax = $phpgw->db->f('exemmax') ;
			$ctbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as ctstep from cntrrate a,contri b " ;
			$sql.=	"WHERE ($ctbaseamt-floor)>=step and cntrid='$cntrid' and b.id='$cntrid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$ctstep = $phpgw->db->f('ctstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax from cntrrate a,contri b " ;
			$sql.=	"WHERE step='$ctstep' and cntrid='$cntrid' and b.id='$cntrid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$ctfloor = $phpgw->db->f('floor') ;
			$ctrate = $phpgw->db->f('rate') ;
			$ctsubtract = $phpgw->db->f('subtract') ;
			$ctmin = $phpgw->db->f('min') ;
			$ctactmin = $phpgw->db->f('actmin') ;
			$ctmax = $phpgw->db->f('max') ;
			$ctactmax = $phpgw->db->f('actmax') ;
			$ctamount = sprintf("%01.2f",($ctbaseamt-$ctfloor) * $ctrate - $ctsubtract) ;
			$ctremark = "" ;
			if ($ctamount<$ctmin) {
				$ctamount = ($ctactmin=="lmt") ? $ctmin : 0 ;
				$ctremark = ($ctactmin=="lmt") ? lang('Set to Min') : lang('Min Reject') ;
				}
			if ($ctamount>$ctmax) {
				$ctamount = ($ctactmax=="lmt") ? $ctmax : 0 ;
				$ctremark = ($ctactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
				}
			}
		$t->set_var('cntrid_selectlist',cntrid_selectlist("WHERE id=$cntrid",'','short')) ;
		$t->set_var('ctbaseamt',$ctbaseamt) ;
		$t->set_var('ctfloor',$ctfloor) ;
		$t->set_var('ctrate',$ctrate) ;
		$t->set_var('ctsubtract',$ctsubtract) ;
		$t->set_var('ctamount',$ctamount) ;
		$t->set_var('ctremark',$ctremark) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('cntr_section','cntr', True);
		$tot_ctamount += $ctamount ;
		}
	$t->set_var('tot_ctamount',$tot_ctamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$t->parse('out','report',True);

	$phpgw->db->query("DROP TABLE $temp");

	}

    }

?>

