<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: leavelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'leavelist.tpl', 'leave'=>'leavelist.tpl'));
	$t->set_block('leave','leave_row','leave_section');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Leave Record List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/leavefilter.php'));
	$t->set_var('message',"");

$t->set_var('sort_staff',$nm->show_sort_order($sort,'staff',$order,'/ck-sss/leavelist.php',lang('Employee Name/#')));
$t->set_var('sort_leavefrom',$nm->show_sort_order($sort,'leavefrom',$order,'/ck-sss/leavelist.php',lang('Leave From')));
$t->set_var('sort_leaveto',$nm->show_sort_order($sort,'leaveto',$order,'/ck-sss/leavelist.php',lang('Leave To')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-sss/leavelist.php',lang('Leave Description')));
$t->set_var('sort_duration',$nm->show_sort_order($sort,'duration',$order,'/ck-sss/leavelist.php',lang('Duration in Work Days')));

$lang_leave = lang('leave') ;
if (!$order) {$order = "leavefrom" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT b.name as staff,leavefrom,leaveto,description,duration " ;
$sql.=  "FROM leave a, employee b, hrcode c " ;
$sql.=  "$where and empid=b.id and leavecode=c.name and c.type='$lang_leave' " ;
$sql.=	"order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'staff'		=> lang("No Matching Item Found"),
				'leavefrom'	=> "",
				'leaveto'	=> "",
				'description'	=> "",
				'duration'	=> ""
							));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('leave_section','leave_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'staff'		=> $phpgw->db->f('staff'),
				'leavefrom'	=> $phpgw->db->f('leavefrom'),
				'leaveto'	=> $phpgw->db->f('leaveto'),
				'description'	=> $phpgw->db->f('description'),
				'duration'	=> $phpgw->db->f('duration')
										));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('leave_section','leave_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','leave','report');

?>
