<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrollcurr.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$py = CreateObject('ck-sss.payroll') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file('report','payrollview.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','nrdetail','nrdetail_section');
	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');

	$t->set_var('lang_title',lang('View Expected Current Period Payroll'));
	$msg1 = lang('Basis of Calculation');
	$msg2 = lang('bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,') ;
	$msg3 = lang('hp - imputed hourly pay, qty - qty input, amt - amount input');
	$msg4 = lang('Reduction/Contribution');
	$msg5 = lang('Base = TotalRecurring + TotalNonRecurring - ExemptItem(Subject to Min/Max Action)') ;
	$msg6 = lang('Amount = (Base - Floor) * Rate - Subtract') ;
	$t->set_var('message',"<b>$msg1:</b><br>$msg2<br>$msg3<br><b>$msg4:</b><br>$msg5<br>$msg6") ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM payroll WHERE id='$id'");
	$phpgw->db->next_record();
	$p = $phpgw->db->Record ;
	$py->payroll_header_write($t, $p) ;

	$phpgw->db->query("SELECT * FROM pyrc_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$p['qty'.$i]		=	$phpgw->db->f('qty') ;
		$p['rate'.$i]		=	$phpgw->db->f('rate') ;
		$p['amount'.$i]		=	$phpgw->db->f('amount') ;
		$p['comment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM pynr_trans WHERE empid='$p[empid]' and approved_by<>'' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['nreaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$p['nrapproved_by'.$i]	=	$phpgw->db->f('approved_by') ;
		$p['nrqty'.$i]		=	$phpgw->db->f('qty') ;
		$p['nrunit'.$i]		=	$phpgw->db->f('unit') ;
		$p['nrunitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$p['nrrate'.$i]		=	$phpgw->db->f('rate') ;
		$p['nramount'.$i]	=	$phpgw->db->f('amount') ;
		$p['nrcomment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM rdtn_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$p['rdtnid'.$i] = $phpgw->db->f('rdtnid') ;
	$phpgw->db->query("SELECT * FROM cntr_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$p['cntrid'.$i] = $phpgw->db->f('cntrid') ;

	$py->payroll_detail_write($t, $p, "CURR");

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('action',$phpgw->link("/ck-sss/payrollfilter.php",$getstr));
	$t->set_var('done_action',$phpgw->link("/ck-sss/payrollfilter.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
