<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ipmatch.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class ipmatch {

//---- Ipmatch Detail Validation Checks

    function ipmatch_validate($ip) {
	global $phpgw ;
	$err=""; $error=lang("Error");
	$sum_bnewbamt = 0 ;
	For ($i=1;isset($ip['bpoid'.$i]);$i++) {
		$bnewbamt = $ip['bnewbamount'.$i] ;
		$row = lang("Row") ;  $rowi = "[$row $i]" ;
		if ($bnewbamt<0)			$err=$rowi.lang("New Amount Billed must be +ve");
		if ($bnewbamt>$ip[amount])		$err=$rowi.lang("New Amount Billed > Invoice Amt");
		if ($bnewbamt>$ip['bpoamount'.$i])	$err=$rowi.lang("New Amount Billed > PO Amount");
		if (!is_numeric($bnewbamt) and strlen($bnewbamt)>0)
							$err=$rowi.lang("New Amt Billed must be numeric");
		$sum_bnewbamt += ($bnewbamt=="") ? $ip['bb_amount'.$i] : $bnewbamt ;
		}
	if ($sum_bnewbamt>$ip[amount])			$err=lang("Total Amount Billed > Invoice Amount");
	For ($i=1;isset($ip['ubpoid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($ip['ubosamount'.$i]<0)		$err=$rowi.lang("UNBILLED PO overbilled");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post ipmatch to Database

    function ipmatch_post($ip, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $ip[id] ;
	
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "edit" :	$actioned = lang("updated") ;	break ;
		case "clear" :	$actioned = lang("cleared") ;	break ;
		endswitch ;
	$phpgw->db->query("DELETE from ipmatch where invoiceid=$id");
	if ($op<>'clear') {
		For ($i=1;isset($ip['bpoid'.$i]);$i++) {
			$b_amt = $ip['bnewbamount'.$i]=="" ? $ip['bb_amount'.$i] : $ip['bnewbamount'.$i] ;
			if ($b_amt<>0) {
				$poid	= $ip['bpoid'.$i] ;
				$sql="INSERT INTO ipmatch (poid,invoiceid,b_amount) VALUES ('$poid','$id','$b_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$invoice = lang("Invoice") ;
	$matching = lang("matching to PO") ;
	$t->set_var("message2","<b>$invoice [id#$id] $matching $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$Invoice [id#$id] $matching $actioned.</b>") ;
	return True ;
	}

//---- Write Ipmatch (Invoice) Header

    function ipmatch_header_write(&$t, $ip) {
	global $phpgw ;

	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_invnumber',lang('Invoice#:'));
	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_amount',lang('Invoice Amount:'));
	$t->set_var('lang_transdate',lang('Invoice Date:'));
	$t->set_var('lang_duedate',lang('Due Date:'));
	$t->set_var('vendor',$ip[vendor]) ;
	$t->set_var('vendor_selectlist',vendor_selectlist("WHERE id=$ip[vendor]",'')) ;
	$t->set_var('invnumber',$ip[invnumber]) ;
	$t->set_var('id',$ip[id]) ;
	$t->set_var('amount',$ip[amount]) ;
	$t->set_var('transdate',$ip[transdate]) ;
	$t->set_var('duedate',$ip[duedate]) ;
	$t->parse('out','report',True);
	}


//---- Write Ipmatch Detail

    function ipmatch_detail_write(&$t,&$ip,$posted) {
	global $phpgw,$phpgw_info ;

	$moverow_ = lang('Move Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_bltitle',lang('List of Fully/Partially BILLED PO billed by this Invoice'));
	$t->set_var('lang_bponumber',lang('PO#'));
	$t->set_var('lang_bpoid',lang('PO ID'));
	$t->set_var('lang_bduedate',lang('Due Date'));
	$t->set_var('lang_bfullamount',lang('Full PO Amount'));
	$t->set_var('lang_bbilled',lang('Amount Billed<br>via this Invoice'));
	$t->set_var('lang_bnewbamount',lang('Amount Billed via this<br>Invoice to be Updated to'));
	$msgunderallo = lang("[Invoice underallocated to PO]");
	$sum_bpoamount = $sum_bb_amount = $sum_bnewbamount = 0 ;
	For ($i=1;isset($ip['bpoid'.$i]);$i++) {
		$t->set_var('bponumber_fld','bponumber'.$i);
		$t->set_var('bpoid_fld','bpoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bpoamount_fld','bpoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bponumber',$ip['bponumber'.$i]) ;
		$bpoid = $ip['bpoid'.$i] ;
		$t->set_var('bpoid',$bpoid) ;
		$t->set_var('bduedate',$ip['bduedate'.$i]) ;
		$t->set_var('bpoamount',$ip['bpoamount'.$i]) ;
		$t->set_var('bb_amount',$ip['bb_amount'.$i]) ;
		$bnewbamount = $ip['bnewbamount'.$i] ;

		if (is_numeric($bnewbamount))		$t->set_var('bnewbamount',"") ;
			else				$t->set_var('bnewbamount',$bnewbamount) ;
		if (strlen($bnewbamount)>0 and is_numeric($bnewbamount)) {
			For ($j=1;isset($ip['ubpoid'.$j]);$j++) {
				if ($bpoid==$ip['ubpoid'.$j]) {
					$ip['ubb_amount'.$j] = $bnewbamount ;
					$ip['ubbilledamt'.$j]= $ip['ubb_amount'.$j] + $ip['ubb_othamt'.$j];
					$ip['ubosamount'.$j] = $ip['ubpoamount'.$j] - $ip['ubbilledamt'.$j] ;
					break ;
					}
				}
			if (!isset($ip['ubpoid'.$j])) {

				$user = trim($phpgw_info["user"]["userid"]);
				$tmp = "ipm".$user.time() ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=		"SELECT ponumber,id,duedate,amount,0.0 as b_amount,sum(b_amount) as billedamt " ;
				$sql.=			"FROM po,ipmatch WHERE id='$bpoid' and poid='$bpoid' " ;
				$sql.=			"GROUP BY ponumber,id,duedate,amount" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=		"SELECT ponumber,id,duedate,amount,b_amount,0.0 as billedamt FROM po,ipmatch ";
				$sql.=			"WHERE id='$bpoid' and poid='$bpoid' and invoiceid='$ip[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT ponumber,id,duedate,amount,sum(b_amount) as b_amount,sum(billedamt) as billedamt " ;
				$sql.= "FROM $tmp GROUP BY ponumber,id,duedate,amount " ;
				$phpgw->db->query($sql) ;

				while ($phpgw->db->next_record()) {
					$ip['ubponumber'.$j]	=	$phpgw->db->f('ponumber') ;
					$ip['ubpoid'.$j]	=	$phpgw->db->f('id') ;
					$ip['ubduedate'.$j]	=	$phpgw->db->f('duedate') ;
					$ip['ubpoamount'.$j]	=	$phpgw->db->f('amount') ;
					$ip['ubb_amount'.$j]	=	$bnewbamount ;
					$ip['ubb_othamt'.$j]	=	$phpgw->db->f('billedamt')-$phpgw->db->f('b_amount');
					$ip['ubbilledamt'.$j]	=	$ip['ubb_amount'.$j] + $ip['ubb_othamt'.$j];
					$ip['ubosamount'.$j]	=	$ip['ubpoamount'.$j] - $ip['ubbilledamt'.$j] ;
					$j++ ;
					}

				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);

				}
			$t->set_var('bb_amount',$bnewbamount) ;
			$ip['bb_amount'.$i] = $bnewbamount ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bpoamount		+= $ip['bpoamount'.$i] ;
		$sum_bb_amount		+= $ip['bb_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('billedlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$ip[move])) ;
	if ($movrowno<>0) {
		$t->set_var('bponumber_fld','bponumber'.$i);
		$t->set_var('bpoid_fld','bpoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bpoamount_fld','bpoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bponumber',$ip['ubponumber'.$movrowno]) ;
		$t->set_var('bpoid',$ip['ubpoid'.$movrowno]) ;
		$t->set_var('bduedate',$ip['ubduedate'.$movrowno]) ;
		$t->set_var('bpoamount',$ip['ubpoamount'.$movrowno]) ;
		$t->set_var('bb_amount',0) ;
		$t->set_var('bnewbamount',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bpoamount	+= $ip['ubpoamount'.$movrowno] ;
		}
	$msg = ($ip[amount]>$sum_bb_amount) ? "  <b>$msgunderallo</b>" : "" ;
	$t->set_var('lang_total',lang('Total Amount').$msg);
	$t->set_var('sum_bpoamount',$sum_bpoamount);
	$t->set_var('sum_bb_amount',$sum_bb_amount);
	$t->set_var('sum_bnewbamount',$sum_bnewbamount);
	$t->set_var('lang_ubltitle',lang('List of Fully/Partially UNBILLED PO accrued on this vendor'));
	$t->set_var('lang_ubponumber',lang('PO#'));
	$t->set_var('lang_ubpoid',lang('PO ID'));
	$t->set_var('lang_ubduedate',lang('Due Date'));
	$t->set_var('lang_ubfullamount',lang('Full PO Amount'));
	$t->set_var('lang_ubb_amount',lang('Amount Billed via this Invoice'));
	$t->set_var('lang_ubb_othamt',lang('Amount Billed via other Invoices'));
	$t->set_var('lang_ubbilledamt',lang('Total Amount Billed'));
	$t->set_var('lang_ubosamount',lang('Outstanding Unbilled Amount'));
	$t->set_var('lang_ubmove2billed',lang('Move to Billed List'));
	For ($i=1;isset($ip['ubpoid'.$i]);$i++) {
		$t->set_var('ubponumber_fld','ubponumber'.$i);
		$t->set_var('ubpoid_fld','ubpoid'.$i);
		$t->set_var('ubduedate_fld','ubduedate'.$i);
		$t->set_var('ubpoamount_fld','ubpoamount'.$i);
		$t->set_var('ubb_amount_fld','ubb_amount'.$i);
		$t->set_var('ubb_othamt_fld','ubb_othamt'.$i);
		$t->set_var('ubbilledamt_fld','ubbilledamt'.$i) ;
		$t->set_var('ubosamount_fld','ubosamount'.$i);
		$t->set_var('ubponumber',$ip['ubponumber'.$i]) ;
		$t->set_var('ubpoid',$ip['ubpoid'.$i]) ;
		$t->set_var('ubduedate',$ip['ubduedate'.$i]) ;
		$t->set_var('ubpoamount',$ip['ubpoamount'.$i]) ;
		$t->set_var('ubb_amount',$ip['ubb_amount'.$i]) ;
		$t->set_var('ubb_othamt',$ip['ubb_othamt'.$i]) ;
		$t->set_var('ubbilledamt',$ip['ubbilledamt'.$i]) ;
		$t->set_var('ubosamount',$ip['ubosamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($ip['bpoid'.$j]);$j++) {
			if ($ip['ubpoid'.$i]==$ip['bpoid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)		$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)			$t->set_var('rowno',"done") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('unbilledlist_section','unbilledlist', True);
		}
	if ($i==1)	$t->set_var('unbilledlist_section',"");
	}

//---- Perform Invoice/PO Matching on Balance Amount by Matching Equal Amount

    function match_equal(&$ip) {
	global $phpgw ;

	if (!isset($ip[ubpoid1]))	$message1 = lang("All POs already settled") ;
	   else {
		$temp = $ip ;
		For ($j=1;isset($ip['ubpoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$ip['ubponumber'.$j]	=	$temp['ubponumber'.$key] ;
			$ip['ubpoid'.$j]	=	$temp['ubpoid'.$key] ;
			$ip['ubduedate'.$j]	=	$val ;
			$ip['ubpoamount'.$j]	=	$temp['ubpoamount'.$key] ;
			$ip['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$ip['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$ip['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$ip['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $ip[amount] ;
	For ($i=1;isset($ip['bpoid'.$i]);$i++)	{
		$bal -= $ip['bb_amount'.$i] ;
		$ip['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Invoice is alreadly fully allocated.") ;
	   else {
		For ($j=1;isset($ip['ubpoid'.$j]);$j++) {
			if ($ip['ubosamount'.$j]==$bal) {
				$ip['ubb_amount'.$j] += $bal ;
				$ip['ubbilledamt'.$j] += $bal ;
				$ip['ubosamount'.$j]  = 0 ;
				$poid = $ip['ubpoid'.$j] ;
				For ($i=1;isset($ip['bpoid'.$i]);$i++) {
					if ($ip['bpoid'.$i]==$poid) {
						$ip['bb_amount'.$i] += $bal ;
						$ip['bnewbamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($ip['bpoid'.$i])) {
					$ip['bponumber'.$i]	= $ip['ubponumber'.$j] ;
					$ip['bpoid'.$i]		= $ip['ubpoid'.$j] ;
					$ip['bduedate'.$i]	= $ip['ubduedate'.$j] ;
					$ip['bpoamount'.$i]	= $ip['ubpoamount'.$j];
					$ip['bb_amount'.$i]	= $bal ;
					$ip['bnewbamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($ip['ubpoid'.$j]))	$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Invoice/PO Matching on Balance Amount by FIFO Scheme

    function match_fifo(&$ip) {
	global $phpgw ;

	if (!isset($ip[ubpoid1]))	$message1 = lang("All POs already settled") ;
	   else {
		$temp = $ip ;
		For ($j=1;isset($ip['ubpoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$ip['ubponumber'.$j]	=	$temp['ubponumber'.$key] ;
			$ip['ubpoid'.$j]	=	$temp['ubpoid'.$key] ;
			$ip['ubduedate'.$j]	=	$val ;
			$ip['ubpoamount'.$j]	=	$temp['ubpoamount'.$key] ;
			$ip['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$ip['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$ip['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$ip['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $ip[amount] ;
	For ($i=1;isset($ip['bpoid'.$i]);$i++)	{
		$bal -= $ip['bb_amount'.$i] ;
		$ip['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Invoice is alreadly fully allocated.") ;
	   else {
		For ($j=1;isset($ip['ubpoid'.$j]);$j++) {
			$ubosamt = $ip['ubosamount'.$j] ;
			if ($ubosamt>0)	{
				if ($bal>=$ubosamt) {
					$ip['ubb_amount'.$j] += $ubosamt ;
					$ip['ubbilledamt'.$j] += $ubosamt ;
					$ip['ubosamount'.$j]  = 0 ;
					$poid = $ip['ubpoid'.$j] ;
					For ($i=1;isset($ip['bpoid'.$i]);$i++) {
						if ($ip['bpoid'.$i]==$poid) {
							$ip['bb_amount'.$i] += $ubosamt ;
							$ip['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($ip['bpoid'.$i])) {
						$ip['bponumber'.$i]	= $ip['ubponumber'.$j] ;
						$ip['bpoid'.$i]		= $poid ;
						$ip['bduedate'.$i]	= $ip['ubduedate'.$j] ;
						$ip['bpoamount'.$i]	= $ip['ubpoamount'.$j];
						$ip['bb_amount'.$i]	+= $ubosamt ;
						$ip['bnewbamount'.$i]	= "" ;
						}
					$bal -= $ubosamt ;
					}
				   else {
					$ip['ubb_amount'.$j] += $bal ;
					$ip['ubbilledamt'.$j] += $bal ;
					$ip['ubosamount'.$j]  -= $bal ;
					$poid = $ip['ubpoid'.$j] ;
					For ($i=1;(isset($ip['bpoid'.$i]) and $bal>0);$i++) {
						if ($ip['bpoid'.$i]==$poid) {
							$ip['bb_amount'.$i] += $bal ;
							$ip['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($ip['bpoid'.$i])) {
						$ip['bponumber'.$i]	= $ip['ubponumber'.$j] ;
						$ip['bpoid'.$i]		= $poid ;
						$ip['bduedate'.$i]	= $ip['ubduedate'.$j] ;
						$ip['bpoamount'.$i]	= $ip['ubpoamount'.$j];
						$ip['bb_amount'.$i]	= $bal ;
						$ip['bnewbamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Invoice/PO Matching

    function match_clear(&$ip) {
	global $phpgw ;

	For ($i=1;isset($ip['bpoid'.$i]);$i++)	{
		$poid = $ip['bpoid'.$i] ;
		$bbamt = $ip['bb_amount'.$i] ;
		For ($j=1;isset($ip['ubpoid'.$j]);$j++) {
			if ($ip['ubpoid'.$j]==$poid) {
				$ip['ubb_amount'.$j] = 0 ;
				$ip['ubbilledamt'.$j] -= $bbamt ;
				$ip['ubosamount'.$j]  += $bbamt ;
				break ;
				}
			}
		if (!isset($ip['ubpoid'.$j])) {
			$ip['ubponumber'.$j]	=	$ip['bponumber'.$i] ;
			$ip['ubpoid'.$j]	=	$poid ;
			$ip['ubduedate'.$j]	=	$ip['bduedate'.$i] ;
			$ip['ubpoamount'.$j]	=	$ip['bpoamount'.$i] ;
			$ip['ubb_amount'.$j]	=	0 ;
			$ip['ubb_othamt'.$j]	=	$ip['bpoamount'.$i] - $bbamt ;
			$ip['ubbilledamt'.$j]	=	$ip['ubb_othamt'.$j] ;
			$ip['ubosamount'.$j]	=	$bbamt ;
			}
		unset($ip['bpoid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current Invoice cleared") ;
	return "<b>$message</b>" ;
	}

    }

?>
