<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicewtdelete.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$invoice = CreateObject('ck-ap.invoice') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','invoicewtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Delete Invoice [with Tax]'));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to delete ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-ap/invoicewtdelete.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-ap/invoicewtlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$iv[id] = $id ;
		$invoice->invoice_post($iv, $t, $id, 'delete','invoicewtdelete', 'APWT');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-ap/invoicewtlist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-ap/invoicewtlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		exit;
		}

/*------------- Write Invoice Detail to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ap WHERE id='$id'");
	$phpgw->db->next_record();
	$iv = $phpgw->db->Record ;
	$iv[taxstatus] = $phpgw->db->f('taxincluded') ;
	$iv[vendor] = $phpgw->db->f('vendor') ;
	$invoice->invoice_header_write($t, $iv, 'wt') ;

	$phpgw->db->query("SELECT * FROM invoice WHERE trans_id='$id' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$iv['itemid'.$i]		=	$phpgw->db->f('itemid') ;
		$iv['itemtype'.$i]		=	$phpgw->db->f('itemtype') ;
		$iv['description'.$i]		=	$phpgw->db->f('description') ;
		$iv['qty'.$i]			=	-$phpgw->db->f('qty') ;
		$iv['unit'.$i]			=	$phpgw->db->f('unit') ;
		$iv['cost'.$i]			=	$phpgw->db->f('cost') ;
		$iv['discount'.$i]		=	$phpgw->db->f('discount') ;
		$iv['inventory_accno_id'.$i]	=	$phpgw->db->f('inventory_accno_id') ;
		$iv['expense_accno_id'.$i]	=	$phpgw->db->f('expense_accno_id') ;
		$iv['tax1'.$i]			=	$phpgw->db->f('tax1') ;
		$iv['tax2'.$i]			=	$phpgw->db->f('tax2') ;
		$iv['tax1_accno_id'.$i]		=	$phpgw->db->f('tax1_accno_id') ;
		$iv['tax2_accno_id'.$i]		=	$phpgw->db->f('tax2_accno_id') ;
		$i++ ;
		}
	$invoice->invoice_detail_write($t,$iv,True,True) ;

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('action',$phpgw->link('/ck-ap/invoicewtlist.php',$getstr));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ap/invoicewtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
