<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicewtfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$vendor = ($_GET["vendor"]) ? $_GET["vendor"] : $_POST["vendor"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$invnumber = ($_GET["invnumber"]) ? $_GET["invnumber"] : $_POST["invnumber"] ;
	$ordnumber = ($_GET["ordnumber"]) ? $_GET["ordnumber"] : $_POST["ordnumber"] ;
	$opentran = ($_GET["opentran"]) ? $_GET["opentran"] : $_POST["opentran"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted invoices [with Tax] :'));
	$msg1 = lang('If during data entry/maintenance, all taxes are deleted, the resultant invoice will be moved to the no tax list');
	$msg2 = lang('To search for all items, leave fields blank');
	$t->set_var('lang_search_message',"$msg1;    $msg2.");

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$warning = "<b>".lang("Make sure you have completed all payment allocation before checking on unsettled invoices")."</b>" ;
$filter = array (	cond1		=>	lang('Vendor') ,
			condvar1	=>	'vendor' ,
			selectlist1	=>	"<OPTION value='ALL'></OPTION>".vendor_selectlist('',''),
			conddefault1	=>	'ALL' ,
			condnote1	=>	lang('Select the appropriate vendor') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Invoice Date (from)') ,
			condvar2	=>	'from' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Must be a valid date [format: YYYY-MM-DD]'),
			checkbox3	=>	'no',
			cond3		=>	lang('Invoice Date (to)') ,
			condvar3	=>	'to' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date [format: YYYY-MM-DD]') ,
			checkbox4	=>	'no',
			cond4		=>	lang('Invoice Number') ,
			condvar4	=>	'invnumber' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for target key word/number in the invoice number field') ,
			checkbox5	=>	'no',
			cond5		=>	lang('Order Number') ,
			condvar5	=>	'ordnumber' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for target key word/number in the order number field') ,
			checkbox6	=>	'yes',
			cond6		=>	lang('Unsettled Invoices Only') ,
			condvar6	=>	'opentran' ,
			conddefault6	=>	'' ,
			condnote6	=>	lang("Click box if only non fully paid invoices are to be retrieved")."<br>$warning" ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $vendor ;
	$filter["conddefault2"] = $from ;
	$filter["conddefault3"]	= $to ;
	$filter["conddefault4"] = $invnumber ;
	$filter["conddefault5"] = $ordnumber ;
	$filter["conddefault6"] = $opentran ;
	}

$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	if ($filter['checkbox'.$i]=='yes') {
		$t->set_var('checkbox',"type='checkbox'");
		$t->set_var('default',"yes");
		if ($filter['conddefault'.$i]=='yes')	$t->set_var('checked',"checked");
			else				$t->set_var('checked',"");
		}
	   else	{
		$t->set_var('checkbox',"");
		$t->set_var('checked',"");
		}
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-ap/invoicewtfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-ap/invoicewtadd.php')) ;
	$t->set_var('lang_add',lang('Add New Invoice [with Tax]'));
	$t->pparse('out','report',True);

?>
