<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payacctran.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$repl_nonbs = ($_GET["repl_nonbs"]) ? $_GET["repl_nonbs"] : $_POST["repl_nonbs"] ;
	$repl_all = ($_GET["repl_all"]) ? $_GET["repl_all"] : $_POST["repl_all"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$payat = CreateObject('ck-ap.payacctran') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','payacctranscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View & Edit Payment Accounting Entries'));
	$msg1 = lang("This screen is for adjusting the accounting entries' attribute codes") ;
	$msg2 = lang("and for splitting the entries across different attributes,") ;
	$msg3 = lang("therefore, the total Dr/Cr amount should not be changed.") ;
	$msg4 = lang("B/S - Balance Sheet.") ;
	$t->set_var('message',"$msg1 $msg2 $msg3  $msg4") ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Payment Accounting Entries to Screen Display ----------------------------*/

	$firstime = substr_count($_SERVER['HTTP_REFERER'],'list.php') > 0 ;
	if ($firstime) {
//	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$phpgw->db->query("SELECT * FROM gl WHERE id='$id'");
		$phpgw->db->next_record();
		$pat = $phpgw->db->Record ;
		$phpgw->db->query("SELECT sum(amount) as total FROM acc_trans WHERE trans_id='$id' and amount>0");
		$phpgw->db->next_record();
		$pat[total] = $phpgw->db->f('total') ;
		}
	    else $pat = $_POST ;
	$payat->payacctran_header_write($t, $pat) ;

	if ($firstime) {
//	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete) and !isset($repl_nonbs) and !isset($repl_all)) {
		$sql = "SELECT chart_id, amount, attrib1, attrib2, attrib3 from acc_trans a, chart b " ;
		$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$pat['accno'.$i]	=	$phpgw->db->f('chart_id') ;
			$pat['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
			$pat['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
			$pat['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
			$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
			$dr			=	sprintf("%01.2f",-$cr) ;
			if ($cr>0)	$dr='';		else $cr='';
			$pat['dr'.$i]		= 	$dr ;
			$pat['cr'.$i]		= 	$cr ;
			$i++ ;
			}
		}
	    else $pat = $_POST ;

	if (isset($reload)) {
		unset($pat) ;
		$pat[id] = $id ;
		$phpgw->db->query("SELECT * FROM payment WHERE id='$id'") ;
		$phpgw->db->next_record();
		$payamt = $phpgw->db->f('amount') ;
		$pat['accno1']	=	$phpgw->db->f('dr_accno_id') ;
		$pat['dr1']	= 	sprintf("%01.2f",$payamt) ;
		$pat['cr1']	= 	"" ;
		$pat['accno2']	=	$phpgw->db->f('cr_accno_id') ;
		$pat['dr2']	= 	"" ;
		$pat['cr2']	= 	sprintf("%01.2f",$payamt) ;
		}

	if (isset($repl_all)) {
		For ($i=1;isset($pat['accno'.$i]);$i++) {
			$pat['attrib1'.$i]	=	$pat['attrib1_cap'] ;
			$pat['attrib2'.$i]	=	$pat['attrib2_cap'] ;
			$pat['attrib3'.$i]	=	$pat['attrib3_cap'] ;
			}
		}

	if (isset($repl_nonbs)) {
		For ($i=1;isset($pat['accno'.$i]);$i++) {
			$accid = $pat['accno'.$i] ;
			$phpgw->db->query("SELECT category FROM chart WHERE id='$accid'") ;
			$phpgw->db->next_record();
			$cat = $phpgw->db->f('category') ;
			if ($cat=="I" or $cat=="E") {
				$pat['attrib1'.$i]	=	$pat['attrib1_cap'] ;
				$pat['attrib2'.$i]	=	$pat['attrib2_cap'] ;
				$pat['attrib3'.$i]	=	$pat['attrib3_cap'] ;
				}
			}
		}

	$payat->payacctran_detail_write($t, $pat, $posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Payment Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $payat->payacctran_validate($pat) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$payat->payacctran_post($pat,$t,'edit','payacctran');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_replicate',lang('Replicate Attribute Values from Caption :'));
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-ap/paymentlist.php",$getstr));
		$t->set_var('lang_nonbs',lang('Done'));
		$t->set_var('lang_all',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-ap/payacctran.php",$getstr)) ;
		$t->set_var('lang_nonbs',lang('non B/S accounts only'));
		$t->set_var('lang_all',lang('All'));
		$t->set_var('lang_update',lang('Post Payment Accounting Entries'));
		$t->set_var('lang_newrow',lang('Add New Row'));
		$t->set_var('lang_reload',lang('Reload Default'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-ap/paymentlist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
