<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: paymentcopy.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$move = ($_GET["move"]) ? $_GET["move"] : $_POST["move"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$clear = ($_GET["clear"]) ? $_GET["clear"] : $_POST["clear"] ;
	$match_equal = ($_GET["match_equal"]) ? $_GET["match_equal"] : $_POST["match_equal"] ;
	$match_fifo = ($_GET["match_fifo"]) ? $_GET["match_fifo"] : $_POST["match_fifo"] ;
	$oldvendor = ($_GET["oldvendor"]) ? $_GET["oldvendor"] : $_POST["oldvendor"] ;
	$filter=urlencode(stripslashes($filter));

	$py = CreateObject('ck-ap.payment') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','paymentscreen.tpl') ;
	$t->set_block('report','paidlist','paidlist_section');
	$t->set_block('report','unpaidlist','unpaidlist_section');
	$t->set_var('lang_title',lang('Copy Payment (settlement details not copied)'));
	$message1 = lang("Which Invoice got allocated first will affect the final Payment/Invoice pairing") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;

/*------------- Write Payment to Screen Display ----------------------------*/

if (!isset($post) and !isset($move) and !isset($update) and !isset($clear) and !isset($match_equal) and !isset($match_fifo)) {
	$phpgw->db->query("SELECT * FROM payment WHERE id='$id'");
	$phpgw->db->next_record();
	$ph = $phpgw->db->Record ;
	}
    else $ph = $_POST ;
$vendor = $ph[vendor] ;
$ph[id] = "" ;
$py->payment_header_write($t, $ph) ;

if ($vendor<>$oldvendor) {

	$user = trim($phpgw_info["user"]["userid"]);
	$temp1 = "py1".$user.time() ;
	$temp2 = "py2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT invnumber,id,duedate,amount,0.0 as s_amount,0.0 as paidamount FROM ap WHERE vendor='$vendor' ";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,id,duedate,0.0 as amount,s_amount,0.0 as paidamount FROM ap, p_match ";
	$sql.= "WHERE id=invoiceid and paymentid='$id'";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,id,duedate,0.0 as amount,0.0 as s_amount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ap a, p_match b ";
	$sql.= "WHERE vendor='$vendor' and a.id=b.invoiceid GROUP BY duedate,id,invnumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT invnumber,id,duedate,sum(amount) as amount,sum(s_amount) as s_amount,sum(paidamount) as paidamt " ;
	$sql.= "FROM $temp1 GROUP BY duedate,id,invnumber ";
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > paidamt ORDER BY invnumber" ;
	$phpgw->db->query($sql) ;

	$i=1;
	while ($phpgw->db->next_record()) {
		$upinvoiceamt			=	$phpgw->db->f('amount') ;
		$uppaidamount			=	$phpgw->db->f('paidamt') ;
		$p['upinvnumber'.$i]		=	$phpgw->db->f('invnumber') ;
		$p['upinvoiceid'.$i]		=	$phpgw->db->f('id') ;
		$p['upduedate'.$i]		=	$phpgw->db->f('duedate') ;
		$p['upinvoiceamt'.$i]		=	$upinvoiceamt ;
		$p['ups_amount'.$i]		=	0 ;
		$p['ups_othamt'.$i]		=	$uppaidamount ;
		$p['uppaidamount'.$i]		=	$uppaidamount ;
		$p['uposamount'.$i]		=	$upinvoiceamt - $uppaidamount ;
		$i++ ;
		}
	$phpgw->db->query("DROP TABLE $temp1, $temp2");
	if ($oldvendor<>"") {
		$msg = lang("<b>Vendor has been changed or newly picked.  All matchings start afresh</b>");
		$t->set_var('message1',$msg) ;
		}
	unset($clear) ;
	unset($match_equal) ;
	unset($match_fifo) ;
	unset($post) ;
	unset($move) ;
	unset($p[move]) ;
	}
    else $p = $_POST ;

if ($p[amount]<>$p[oldamount]) {
	$py->match_clear($p) ;
	$msg = lang("<b>Payment amount has been changed, all matchings start afresh</b>") ;
	$t->set_var('message1',$msg) ;
	unset($clear) ;
	unset($match_equal) ;
	unset($match_fifo) ;
	unset($post) ;
	unset($move) ;
	unset($r[move]) ;
	}

if (isset($clear))		{$msg = $py->match_clear($p) ; $t->set_var('message1',$msg) ;}
if (isset($match_equal))	{$msg = $py->match_equal($p) ; $t->set_var('message1',$msg) ;}
if (isset($match_fifo))		{$msg = $py->match_fifo($p) ; $t->set_var('message1',$msg) ;}

$py->payment_detail_write($t,$p,$post);

$t->parse('out','report',True);

/*-------------- Post Payment ----------------------------------------------*/

if (isset($post)) {
	$err = $py->payment_validate($p) ;
	$t->set_var('message2',$err);
	if ($err=='') { $posted = $py->payment_post($p, $t, $id, 'new', 'paymentcopy') ; }
	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_match',lang("Auto-allocate Payment's Remaining Amount by :"));
	$getstr = "filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-ap/paymentlist.php',$getstr));
		$t->set_var('lang_match_equal',lang('Done'));
		$t->set_var('lang_match_fifo',lang('Done'));
		$t->set_var('lang_clear',lang('Done'));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly','readonly');
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-ap/paymentcopy.php',$getstr)) ;
		$t->set_var('lang_match_equal',lang('Matching Oldest Equal Amount'));
		$t->set_var('lang_match_fifo',lang('FIFO Scheme'));
		$t->set_var('lang_clear',lang('Clear Allocation'));
		$t->set_var('lang_post',lang('Post Payment'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly','');
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link('/ck-ap/paymentlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
