<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: paymentview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ap', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$py = CreateObject('ck-ap.payment') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ap'));
	$t->set_file('report','paymentscreen.tpl') ;
	$t->set_block('report','paidlist','paidlist_section');
	$t->set_block('report','unpaidlist','unpaidlist_section');
	$t->set_var('lang_title',lang('View Payment Detail'));
	$message1 = lang("Which Invoice got allocated first will affect the final Payment/Invoice pairing") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');

/*------------- Write Payment to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM payment WHERE id='$id'");
$phpgw->db->next_record();
$vendor = $phpgw->db->f('vendor') ;
$p[amount] = $phpgw->db->f('amount') ;
$py->payment_header_write($t, $phpgw->db->Record) ;

$sql ="SELECT invnumber,id,duedate,amount,s_amount FROM ap,p_match WHERE paymentid='$id' and id=invoiceid";
$phpgw->db->query($sql);
$i=1;
while ($phpgw->db->next_record()) {
	$p['pinvnumber'.$i]	=	$phpgw->db->f('invnumber') ;
	$p['pinvoiceid'.$i]	=	$phpgw->db->f('id') ;
	$p['pduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$p['pinvoiceamt'.$i]	=	$phpgw->db->f('amount') ;
	$p['ps_amount'.$i]	=	$phpgw->db->f('s_amount') ;
	$p['pnewsamount'.$i]	=	"" ;
	$i++ ;
	}

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "py1".$user.time() ;
$temp2 = "py2".$user.time() ;
$sql = "CREATE TABLE $temp1 AS " ;
$sql.="SELECT invnumber,id,duedate,amount,0.0 as s_amount,0.0 as paidamount FROM ap WHERE vendor='$vendor' ";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT invnumber,id,duedate,0.0 as amount,s_amount,0.0 as paidamount FROM ap, p_match ";
$sql.= "WHERE id=invoiceid and paymentid='$id'";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT invnumber,id,duedate,0.0 as amount,0.0 as s_amount,sum(s_amount) as paidamount " ;
$sql.= "FROM ap a, p_match b ";
$sql.= "WHERE vendor='$vendor' and a.id=b.invoiceid GROUP BY duedate,id,invnumber";
$phpgw->db->query($sql);
$sql = "CREATE TABLE $temp2 AS " ;
$sql.= "SELECT invnumber,id,duedate,sum(amount) as amount,sum(s_amount) as s_amount,sum(paidamount) as paidamt " ;
$sql.= "FROM $temp1 GROUP BY duedate,id,invnumber ";
$phpgw->db->query($sql);
$sql = "SELECT * FROM $temp2 WHERE amount > paidamt ORDER BY invnumber" ;
$phpgw->db->query($sql) ;

$i=1;
while ($phpgw->db->next_record()) {
	$upinvoiceamt		=	$phpgw->db->f('amount') ;
	$uppaidamount		=	$phpgw->db->f('paidamt') ;
	$p['upinvnumber'.$i]	=	$phpgw->db->f('invnumber') ;
	$p['upinvoiceid'.$i]	=	$phpgw->db->f('id') ;
	$p['upduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$p['upinvoiceamt'.$i]	=	$upinvoiceamt ;
	$p['ups_amount'.$i]	=	$phpgw->db->f('s_amount') ;
	$p['ups_othamt'.$i]	=	$uppaidamount-$phpgw->db->f('s_amount') ;
	$p['uppaidamount'.$i]	=	$uppaidamount ;
	$p['uposamount'.$i]	=	$upinvoiceamt - $uppaidamount ;
	$i++ ;
	}
$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

$py->payment_detail_write($t,$p,True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_match',lang("Auto-allocate Payment's Remaining Amount by :"));
	$t->set_var('action',$phpgw->link('/ck-ap/paymentlist.php',$getstr)) ;
	$t->set_var('lang_match_equal',lang('Done'));
	$t->set_var('lang_match_fifo',lang('Done'));
	$t->set_var('lang_clear',lang('Done'));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ap/paymentlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
