<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ismatch.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class ismatch {

//---- Ismatch Detail Validation Checks

    function ismatch_validate($is) {
	global $phpgw ;
	$err=""; $error=lang("Error");
	$row = lang("Row") ;
	$sum_bnewbamt = 0 ;
	For ($i=1;isset($is['bsoid'.$i]);$i++) {
		$bnewbamt = $is['bnewbamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($bnewbamt<0)			$err=$rowi.lang("New Amount Billed must be +ve");
		if ($bnewbamt>$is[amount])		$err=$rowi.lang("New Amount Billed > Invoice Amt");
		if ($bnewbamt>$is['bsoamount'.$i])	$err=$rowi.lang("New Amount Billed > SO Amount");
		if (!is_numeric($bnewbamt) and strlen($bnewbamt)>0)
							$err=$rowi.lang("New Amt Billed must be numeric");
		$sum_bnewbamt += ($bnewbamt=="") ? $is['bb_amount'.$i] : $bnewbamt ;
		}
	if ($sum_bnewbamt>$is[amount])			$err=lang("Total Amount Billed > Invoice Amount");
	For ($i=1;isset($is['ubsoid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($is['ubosamount'.$i]<0)		$err=$rowi.lang("UNBILLED SO overbilled");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post ismatch to Database

    function ismatch_post($is, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $is[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "edit" :	$actioned = lang("updated") ;	break ;
		case "clear" :	$actioned = lang("cleared") ;	break ;
		endswitch ;
	$phpgw->db->query("DELETE from ismatch where invoiceid=$id");
	if ($op<>'clear') {
		For ($i=1;isset($is['bsoid'.$i]);$i++) {
			$b_amt = $is['bnewbamount'.$i]=="" ? $is['bb_amount'.$i] : $is['bnewbamount'.$i] ;
			if ($b_amt<>0) {
				$soid	= $is['bsoid'.$i] ;
				$sql="INSERT INTO ismatch (soid,invoiceid,b_amount) VALUES ('$soid','$id','$b_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Invoice"); $matching = lang("matching to SO");
	$t->set_var("message2","<b>$tran [id#$id] $matching $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$tran [id#$id] $matching $actioned.</b>") ;
	return True ;
	}

//---- Write Ismatch (Invoice) Header

    function ismatch_header_write(&$t, $is) {
	global $phpgw ;

	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_invnumber',lang('Invoice#:')."  ");
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_amount',lang('Invoice Amount:')." ");
	$t->set_var('lang_transdate',lang('Invoice Date:')."  ");
	$t->set_var('lang_duedate',lang('Due Date:')."  ");
	$t->set_var('customer',$is[customer]) ;
	$t->set_var('customer_selectlist',customer_selectlist("WHERE id=$is[customer]",'')) ;
	$t->set_var('invnumber',$is[invnumber]) ;
	$t->set_var('id',$is[id]) ;
	$t->set_var('amount',$is[amount]) ;
	$t->set_var('transdate',$is[transdate]) ;
	$t->set_var('duedate',$is[duedate]) ;
	$t->parse('out','report',True);
	}

//---- Write Ismatch Detail

    function ismatch_detail_write(&$t,&$is,$posted) {
	global $phpgw,$phpgw_info ;

	$moverow_ = lang('Move Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_bltitle',lang('List of Fully/Partially BILLED SO billed by this Invoice'));
	$t->set_var('lang_bsonumber',lang('SO#'));
	$t->set_var('lang_bsoid',lang('SO ID'));
	$t->set_var('lang_bduedate',lang('Due Date'));
	$t->set_var('lang_bfullamount',lang('Full SO Amount'));
	$t->set_var('lang_bbilled',lang('Amount Billed<br>via this Invoice'));
	$t->set_var('lang_bnewbamount',lang('Amount Billed via this<br>Invoice to be Updated to'));
	$sum_bsoamount = $sum_bb_amount = $sum_bnewbamount = 0 ;
	For ($i=1;isset($is['bsoid'.$i]);$i++) {
		$t->set_var('bsonumber_fld','bsonumber'.$i);
		$t->set_var('bsoid_fld','bsoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bsoamount_fld','bsoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bsonumber',$is['bsonumber'.$i]) ;
		$bsoid = $is['bsoid'.$i] ;
		$t->set_var('bsoid',$bsoid) ;
		$t->set_var('bduedate',$is['bduedate'.$i]) ;
		$t->set_var('bsoamount',$is['bsoamount'.$i]) ;
		$t->set_var('bb_amount',$is['bb_amount'.$i]) ;
		$bnewbamount = $is['bnewbamount'.$i] ;
		if (is_numeric($bnewbamount))		$t->set_var('bnewbamount',"") ;
			else				$t->set_var('bnewbamount',$bnewbamount) ;
		if (strlen($bnewbamount)>0 and is_numeric($bnewbamount)) {
			For ($j=1;isset($is['ubsoid'.$j]);$j++) {
				if ($bsoid==$is['ubsoid'.$j]) {
					$is['ubb_amount'.$j] = $bnewbamount ;
					$is['ubbilledamt'.$j]= $is['ubb_amount'.$j] + $is['ubb_othamt'.$j];
					$is['ubosamount'.$j] = $is['ubsoamount'.$j] - $is['ubbilledamt'.$j] ;
					break ;
					}
				}
			if (!isset($is['ubsoid'.$j])) {
				$user = trim($phpgw_info["user"]["userid"]);
				$tmp = "ism".$user.time() ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=		"SELECT sonumber,id,duedate,amount,0.0 as b_amount,sum(b_amount) as billedamt " ;
				$sql.=			"FROM so,ismatch WHERE id='$bsoid' and soid='$bsoid' " ;
				$sql.=			"GROUP BY sonumber,id,duedate,amount" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=		"SELECT sonumber,id,duedate,amount,b_amount,0.0 as billedamt FROM so,ismatch ";
				$sql.=			"WHERE id='$bsoid' and soid='$bsoid' and invoiceid='$is[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT sonumber,id,duedate,amount,sum(b_amount) as b_amount,sum(billedamt) as billedamt " ;
				$sql.= "FROM $tmp GROUP BY sonumber,id,duedate,amount " ;
				$phpgw->db->query($sql) ;

				while ($phpgw->db->next_record()) {
					$is['ubsonumber'.$j]	=	$phpgw->db->f('sonumber') ;
					$is['ubsoid'.$j]	=	$phpgw->db->f('id') ;
					$is['ubduedate'.$j]	=	$phpgw->db->f('duedate') ;
					$is['ubsoamount'.$j]	=	$phpgw->db->f('amount') ;
					$is['ubb_amount'.$j]	=	$bnewbamount ;
					$is['ubb_othamt'.$j]	=	$phpgw->db->f('billedamt')-$phpgw->db->f('b_amount');
					$is['ubbilledamt'.$j]	=	$is['ubb_amount'.$j] + $is['ubb_othamt'.$j];
					$is['ubosamount'.$j]	=	$is['ubsoamount'.$j] - $is['ubbilledamt'.$j] ;
					$j++ ;
					}
				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);
				}
			$t->set_var('bb_amount',$bnewbamount) ;
			$is['bb_amount'.$i] = $bnewbamount ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bsoamount		+= $is['bsoamount'.$i] ;
		$sum_bb_amount		+= $is['bb_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('billedlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$is[move])) ;
	if ($movrowno<>0) {
		$t->set_var('bsonumber_fld','bsonumber'.$i);
		$t->set_var('bsoid_fld','bsoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bsoamount_fld','bsoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bsonumber',$is['ubsonumber'.$movrowno]) ;
		$t->set_var('bsoid',$is['ubsoid'.$movrowno]) ;
		$t->set_var('bduedate',$is['ubduedate'.$movrowno]) ;
		$t->set_var('bsoamount',$is['ubsoamount'.$movrowno]) ;
		$t->set_var('bb_amount',0) ;
		$t->set_var('bnewbamount',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bsoamount	+= $is['ubsoamount'.$movrowno] ;
		}
	$msg = ($is[amount]>$sum_bb_amount) ? lang("[Invoice underallocated to SO]") : "" ;
	$t->set_var('lang_total',lang('Total Amount')." ".$msg);
	$t->set_var('sum_bsoamount',$sum_bsoamount);
	$t->set_var('sum_bb_amount',$sum_bb_amount);
	$t->set_var('sum_bnewbamount',$sum_bnewbamount);
	$t->set_var('lang_ubltitle',lang('List of Fully/Partially UNBILLED SO accrued on this customer'));
	$t->set_var('lang_ubsonumber',lang('SO#'));
	$t->set_var('lang_ubsoid',lang('SO ID'));
	$t->set_var('lang_ubduedate',lang('Due Date'));
	$t->set_var('lang_ubfullamount',lang('Full SO Amount'));
	$t->set_var('lang_ubb_amount',lang('Amount Billed via this Invoice'));
	$t->set_var('lang_ubb_othamt',lang('Amount Billed via other Invoices'));
	$t->set_var('lang_ubbilledamt',lang('Total Amount Billed'));
	$t->set_var('lang_ubosamount',lang('Outstanding Unbilled Amount'));
	$t->set_var('lang_ubmove2billed',lang('Move to Billed List'));
	For ($i=1;isset($is['ubsoid'.$i]);$i++) {
		$t->set_var('ubsonumber_fld','ubsonumber'.$i);
		$t->set_var('ubsoid_fld','ubsoid'.$i);
		$t->set_var('ubduedate_fld','ubduedate'.$i);
		$t->set_var('ubsoamount_fld','ubsoamount'.$i);
		$t->set_var('ubb_amount_fld','ubb_amount'.$i);
		$t->set_var('ubb_othamt_fld','ubb_othamt'.$i);
		$t->set_var('ubbilledamt_fld','ubbilledamt'.$i) ;
		$t->set_var('ubosamount_fld','ubosamount'.$i);
		$t->set_var('ubsonumber',$is['ubsonumber'.$i]) ;
		$t->set_var('ubsoid',$is['ubsoid'.$i]) ;
		$t->set_var('ubduedate',$is['ubduedate'.$i]) ;
		$t->set_var('ubsoamount',$is['ubsoamount'.$i]) ;
		$t->set_var('ubb_amount',$is['ubb_amount'.$i]) ;
		$t->set_var('ubb_othamt',$is['ubb_othamt'.$i]) ;
		$t->set_var('ubbilledamt',$is['ubbilledamt'.$i]) ;
		$t->set_var('ubosamount',$is['ubosamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($is['bsoid'.$j]);$j++) {
			if ($is['ubsoid'.$i]==$is['bsoid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)		$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)			$t->set_var('rowno',lang("done")) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('unbilledlist_section','unbilledlist', True);
		}
	if ($i==1)	$t->set_var('unbilledlist_section',"");
	}

//---- Perform Invoice/SO Matching on Balance Amount by Matching Equal Amount

    function match_equal(&$is) {
	global $phpgw ;

	if (!isset($is[ubsoid1]))	$message1 = lang("All SOs already settled") ;
	   else {
		$temp = $is ;
		For ($j=1;isset($is['ubsoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$is['ubsonumber'.$j]	=	$temp['ubsonumber'.$key] ;
			$is['ubsoid'.$j]	=	$temp['ubsoid'.$key] ;
			$is['ubduedate'.$j]	=	$val ;
			$is['ubsoamount'.$j]	=	$temp['ubsoamount'.$key] ;
			$is['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$is['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$is['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$is['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $is[amount] ;
	For ($i=1;isset($is['bsoid'.$i]);$i++)	{
		$bal -= $is['bb_amount'.$i] ;
		$is['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Invoice is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($is['ubsoid'.$j]);$j++) {
			if ($is['ubosamount'.$j]==$bal) {
				$is['ubb_amount'.$j] += $bal ;
				$is['ubbilledamt'.$j] += $bal ;
				$is['ubosamount'.$j]  = 0 ;
				$soid = $is['ubsoid'.$j] ;
				For ($i=1;isset($is['bsoid'.$i]);$i++) {
					if ($is['bsoid'.$i]==$soid) {
						$is['bb_amount'.$i] += $bal ;
						$is['bnewbamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($is['bsoid'.$i])) {
					$is['bsonumber'.$i]	= $is['ubsonumber'.$j] ;
					$is['bsoid'.$i]		= $is['ubsoid'.$j] ;
					$is['bduedate'.$i]	= $is['ubduedate'.$j] ;
					$is['bsoamount'.$i]	= $is['ubsoamount'.$j];
					$is['bb_amount'.$i]	= $bal ;
					$is['bnewbamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($is['ubsoid'.$j]))	$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Invoice/SO Matching on Balance Amount by FIFO Scheme

    function match_fifo(&$is) {
	global $phpgw ;

	if (!isset($is[ubsoid1]))	$message1 = lang("All SOs already settled") ;
	   else {
		$temp = $is ;
		For ($j=1;isset($is['ubsoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$is['ubsonumber'.$j]	=	$temp['ubsonumber'.$key] ;
			$is['ubsoid'.$j]	=	$temp['ubsoid'.$key] ;
			$is['ubduedate'.$j]	=	$val ;
			$is['ubsoamount'.$j]	=	$temp['ubsoamount'.$key] ;
			$is['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$is['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$is['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$is['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $is[amount] ;
	For ($i=1;isset($is['bsoid'.$i]);$i++)	{
		$bal -= $is['bb_amount'.$i] ;
		$is['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Invoice is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($is['ubsoid'.$j]);$j++) {
			$ubosamt = $is['ubosamount'.$j] ;
			if ($ubosamt>0) {
				if ($bal>=$ubosamt) {
					$is['ubb_amount'.$j] += $ubosamt ;
					$is['ubbilledamt'.$j] += $ubosamt ;
					$is['ubosamount'.$j]  = 0 ;
					$soid = $is['ubsoid'.$j] ;
					For ($i=1;isset($is['bsoid'.$i]);$i++) {
						if ($is['bsoid'.$i]==$soid) {
							$is['bb_amount'.$i] += $ubosamt ;
							$is['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($is['bsoid'.$i])) {
						$is['bsonumber'.$i]	= $is['ubsonumber'.$j] ;
						$is['bsoid'.$i]		= $soid ;
						$is['bduedate'.$i]	= $is['ubduedate'.$j] ;
						$is['bsoamount'.$i]	= $is['ubsoamount'.$j];
						$is['bb_amount'.$i]	+= $ubosamt ;
						$is['bnewbamount'.$i]	= "" ;
						}
					$bal -= $ubosamt ;
					}
				   else {
					$is['ubb_amount'.$j] += $bal ;
					$is['ubbilledamt'.$j] += $bal ;
					$is['ubosamount'.$j]  -= $bal ;
					$soid = $is['ubsoid'.$j] ;
					For ($i=1;(isset($is['bsoid'.$i]) and $bal>0);$i++) {
						if ($is['bsoid'.$i]==$soid) {
							$is['bb_amount'.$i] += $bal ;
							$is['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($is['bsoid'.$i])) {
						$is['bsonumber'.$i]	= $is['ubsonumber'.$j] ;
						$is['bsoid'.$i]		= $soid ;
						$is['bduedate'.$i]	= $is['ubduedate'.$j] ;
						$is['bsoamount'.$i]	= $is['ubsoamount'.$j];
						$is['bb_amount'.$i]	= $bal ;
						$is['bnewbamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Invoice/SO Matching

    function match_clear(&$is) {
	global $phpgw ;

	For ($i=1;isset($is['bsoid'.$i]);$i++)	{
		$soid = $is['bsoid'.$i] ;
		$bbamt = $is['bb_amount'.$i] ;
		For ($j=1;isset($is['ubsoid'.$j]);$j++) {
			if ($is['ubsoid'.$j]==$soid) {
				$is['ubb_amount'.$j] = 0 ;
				$is['ubbilledamt'.$j] -= $bbamt ;
				$is['ubosamount'.$j]  += $bbamt ;
				break ;
				}
			}
		if (!isset($is['ubsoid'.$j])) {
			$is['ubsonumber'.$j]	=	$is['bsonumber'.$i] ;
			$is['ubsoid'.$j]	=	$soid ;
			$is['ubduedate'.$j]	=	$is['bduedate'.$i] ;
			$is['ubsoamount'.$j]	=	$is['bsoamount'.$i] ;
			$is['ubb_amount'.$j]	=	0 ;
			$is['ubb_othamt'.$j]	=	$is['bsoamount'.$i] - $bbamt ;
			$is['ubbilledamt'.$j]	=	$is['ubb_othamt'.$j] ;
			$is['ubosamount'.$j]	=	$bbamt ;
			}
		unset($is['bsoid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current Invoice cleared") ;
	return "<b>$message</b>" ;
	}

    }

?>
