<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invrpthist.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ar', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$filter=urlencode(stripslashes($filter));

	$invoice = CreateObject('ck-ar.invoice') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','invrpthistscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View Invoice Receipt History'));
	$t->set_var('message',lang('Press [done] button at Detail screen to work on detail transaction maintenance'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

/*------------- Write Invoice to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ar WHERE id='$id'");
	$phpgw->db->next_record();
	$duedate = $phpgw->db->f('duedate') ;
	$invamount = $phpgw->db->f('amount') ;
	$netamount = $phpgw->db->f('netamount') ;
	$invoice->invoice_header_write($t, $phpgw->db->Record, "e") ;

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_receiptid',lang('Receipt ID<br>/Days Overdue'));
	$t->set_var('lang_rptamount',lang('Receipt Amount'));
	$t->set_var('lang_samount',lang('Amount Settled'));
	$t->set_var('lang_osamount',lang('Outstanding Amount'));
	$t->set_var('lang_title_detail',lang('Detail'));

	$t->set_var('date',$duedate);
	$t->set_var('description','<- '.lang('Due Date').' / '.lang('Invoice Amount').' ->');
	$t->set_var('receiptid','.');
	$t->set_var('rptamount','.');
	$t->set_var('samount','.');
	$t->set_var('osamount',$invamount);
	$t->set_var('lang_item',lang('Invoice'));
	if ($invamount==$netamount)	{
		$ifilter = urlencode(" WHERE amount=netamount and a.id=$id ") ;
		$item = $phpgw->link('/ck-ar/invoicentview.php',"id=$id&filter=$ifilter");
		}
	  else	{
	  	$ifilter = urlencode(" WHERE amount<>netamount and a.id=$id ") ;
		$item = $phpgw->link('/ck-ar/invoicewtview.php',"id=$id&filter=$ifilter");
		}
	$t->set_var('item',$item) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,rptnumber,amount,s_amount FROM receipt a, r_match b " ;
	$sql.= "WHERE invoiceid='$id' and id=receiptid ORDER BY transdate" ;
	$phpgw->db->query($sql);
	$osamount = $invamount ;
	while ($phpgw->db->next_record()) {
		$t->set_var('date',$phpgw->db->f('transdate'));
		$lang_rptno = lang('Rpt#/Cheque#') ;
		$t->set_var('description',"$lang_rptno:    ".$phpgw->db->f('rptnumber'));
		$id = $phpgw->db->f('id');
		$t->set_var('receiptid',$id);
		$t->set_var('rptamount',$phpgw->db->f('amount'));
		$samount = $phpgw->db->f('s_amount') ;
		$t->set_var('samount',$samount);
		$osamount -= $samount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('lang_item',lang('Receipt'));
		$rfilter = urlencode(" WHERE a.id=$id ") ;
		$item = $phpgw->link('/ck-ar/receiptview.php',"id=$id&filter=$rfilter");
		$t->set_var('item',$item) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description','<- '.lang('System Date').' / '.lang('Days Overdue').' ->');
	$overdue = (time()-strtotime($duedate))/86400 ;
	$overdue = ($overdue<0 or $osamount<=0) ? "N/A" : floor($overdue) ;
	$t->set_var('receiptid',$overdue);
	$t->set_var('rptamount','.');
	$t->set_var('samount','.');
	$t->set_var('osamount','.');
	$t->set_var('lang_item','');
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	if ($invamount==$netamount)
		$t->set_var('action',$phpgw->link('/ck-ar/invoicentlist.php',"filter=$filter")) ;
	    else $t->set_var('action',$phpgw->link('/ck-ar/invoicewtlist.php',"filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	if ($invamount==$netamount)
		$t->set_var('done_action',$phpgw->link('/ck-ar/invoicentlist.php',"filter=$filter")) ;
	    else $t->set_var('done_action',$phpgw->link('/ck-ar/invoicewtlist.php',"filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
