<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ismatchview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ar', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$ismatch = CreateObject('ck-ar.ismatch') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file('report','ismatchscreen.tpl') ;
	$t->set_block('report','billedlist','billedlist_section');
	$t->set_block('report','unbilledlist','unbilledlist_section');
	$t->set_var('lang_title',lang('View Invoice/SO Matching Detail'));
	$message1 = lang("Which Invoice got allocated first will affect the final Invoice/SO pairing") ;
	$message2 = lang("If the PAID/UNPAID Lists get too complicated, press [clear allocation] button to start afresh") ;
	$t->set_var('message1',$message1) ;
	$t->set_var('message2',$message2) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');

/*------------- Write Invoice/SO Matching to Screen Display ----------------------------*/

$phpgw->db->query("SELECT * FROM ar WHERE id='$id'");
$phpgw->db->next_record();
$customer = $phpgw->db->f('customer') ;
$is = $phpgw->db->Record ;
$ismatch->ismatch_header_write($t, $is) ;

$sql ="SELECT sonumber,id,duedate,amount,b_amount FROM so, ismatch WHERE invoiceid='$id' and id=soid";
$phpgw->db->query($sql);
$i=1;
while ($phpgw->db->next_record()) {
	$is['bsonumber'.$i]	=	$phpgw->db->f('sonumber') ;
	$is['bsoid'.$i]		=	$phpgw->db->f('id') ;
	$is['bduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$is['bsoamount'.$i]	=	$phpgw->db->f('amount') ;
	$is['bb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
	$is['bnewbamount'.$i]	=	"" ;
	$i++ ;
	}

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "is1".$user.time() ;
$temp2 = "is2".$user.time() ;
$sql = "CREATE TABLE $temp1 AS " ;
$sql.="SELECT sonumber,id,duedate,amount,0.0 as b_amount,0.0 as billedamount FROM so WHERE customer='$customer' ";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT sonumber,id,duedate,0.0 as amount,b_amount,0.0 as billedamount FROM so, ismatch ";
$sql.= "WHERE id=soid and invoiceid='$id'";
$phpgw->db->query($sql);
$sql = "INSERT INTO $temp1 " ;
$sql.= "SELECT sonumber,id,duedate,0.0 as amount,0.0 as b_amount,sum(b_amount) as billedamount " ;
$sql.= "FROM so a, ismatch b ";
$sql.= "WHERE customer='$customer' and a.id=b.soid GROUP BY duedate,id,sonumber";
$phpgw->db->query($sql);
$sql = "CREATE TABLE $temp2 AS " ;
$sql.= "SELECT sonumber,id,duedate,sum(amount) as amount,sum(b_amount) as b_amount,sum(billedamount) as billedamt " ;
$sql.= "FROM $temp1 GROUP BY duedate,id,sonumber ";
$phpgw->db->query($sql);
$sql = "SELECT * FROM $temp2 WHERE amount > billedamt ORDER BY sonumber" ;
$phpgw->db->query($sql) ;

$i=1;
$fullybilled = False ;
while ($phpgw->db->next_record()) {
	$soamount		=	$phpgw->db->f('amount') ;
	$billedamt		=	$phpgw->db->f('billedamt') ;
	$is['ubsonumber'.$i]	=	$phpgw->db->f('sonumber') ;
	$is['ubsoid'.$i]	=	$phpgw->db->f('id') ;
	$is['ubduedate'.$i]	=	$phpgw->db->f('duedate') ;
	$is['ubsoamount'.$i]	=	$soamount ;
	$is['ubb_amount'.$i]	=	$phpgw->db->f('b_amount') ;
	$is['ubb_othamt'.$i]	=	$billedamt-$phpgw->db->f('b_amount') ;
	$is['ubbilledamt'.$i]	=	$billedamt ;
	$is['ubosamount'.$i]	=	$soamount - $billedamt ;
	$i++ ;
	}

$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

$ismatch->ismatch_detail_write($t,$is,True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('lang_match',lang("Auto-allocate Invoice's Remaining Amount by :"));
	$t->set_var('action',$phpgw->link('/ck-ar/ismatchlist.php',$getstr)) ;
	$t->set_var('lang_match_equal',lang('Done'));
	$t->set_var('lang_match_fifo',lang('Done'));
	$t->set_var('lang_clear',lang('Done'));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-ar/ismatchlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
