<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: statementbulk.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-ar',
					'noheader'	=> True,
					'nonavbar'	=> True,
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$sdate = ($_GET["sdate"]) ? $_GET["sdate"] : $_POST["sdate"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file(array('report'		=> 'customerstatement.tpl',
 	                   'items'		=> 'customerstatement.tpl'));
	$t->set_block('items','item_row','item_section');
	$t->set_var('charset',lang('charset'));
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;

	$err=""; $error=lang("Error") ;
	if (isset($start))	{
		if (input2date($start)=="")	$err=lang('Invalid Statement Start Date');
		$jdstart = mktime(0,0,0,intval(substr($start,5,2)),intval(substr($start,8,2)),intval(substr($start,0,4))) ;
		}
	if (isset($end))	{
		if (input2date($end)=="")	$err=lang('Invalid Statement End Date');
		$jdend = mktime(0,0,0,intval(substr($end,5,2)),intval(substr($end,8,2)),intval(substr($end,0,4))) ;
		}
	if (isset($sdate))	{
		if (input2date($sdate)=="")	$err=lang('Invalid Statement Date');
		$jdsdate = mktime(0,0,0,intval(substr($sdate,5,2)),intval(substr($sdate,8,2)),intval(substr($sdate,0,4))) ;
		}
	if ($jdstart>$jdend)			$err=lang('Statement Start later than Statement End');
	if ($jdsdate<$jdend)			$err=lang('Statement date earlier than Statement End');

	if ($err)	$err="<b>$error: $err</b>" ;

	$start = (!$start) ? date("Y-m-d",mktime(0,0,0,date("m")-1,1,date("Y"))) : $start ;
	$end = (!$end) ? date("Y-m-d",mktime(0,0,0,date("m"),0,date("Y"))) : $end ;
	$sdate = (!$sdate) ? date("Y-m-d") : $sdate ;

	if ($email==lang('Email Statement') and $err=="") {
		$getstring = "start=$start&end=$end&sdate=$sdate&" ;
		$getstring.= "order=$order&sort=$sort&filter=$filter" ;
		Header('Location: '.$phpgw->link('/ck-ar/statementbulkemail.php',$getstring)) ;
		$phpgw->common->phpgw_exit();
		}

/*------------- Write Statement Header to Screen Display ----------------------------*/

	$t->set_var('lang_statement',lang('STATEMENT'));
	$t->set_var('lang_start',lang('Statement Start'));
	$t->set_var('start',$start) ;
	$t->set_var('lang_end',lang('Statement End'));
	$t->set_var('end',$end) ;
	$t->set_var('lang_sdate',lang('Statement Date'));
	$t->set_var('sdate',$sdate) ;
	$t->set_var('lang_customer',lang('Customer:'));

	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_invoice_amount',lang('Invoice<br>Amount'));
	$t->set_var('lang_payment_received',lang('Payment<br>Received'));
	$t->set_var('lang_balance',lang('Balance'));
	$t->set_var('lang_remark',lang('Remark'));

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$footer = $phpgw->db->f('inv_remark') ;

	$phpgw->db->query("SELECT * FROM customer WHERE id='$id'");
	$phpgw->db->next_record();
	$t->set_var('name',$phpgw->db->f('name')) ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$custfax = $phpgw->db->f('fax') ;
	$t->set_var('addr1',$phpgw->db->f('addr1')) ;
	$t->set_var('addr2',$phpgw->db->f('addr2')) ;
	$t->set_var('addr3',$phpgw->db->f('addr3')) ;
	$t->set_var('addr4',$phpgw->db->f('addr4')) ;
	$t->set_var('comment1',"") ;
	$t->set_var('comment2',"") ;
	$t->set_var('comment3',lang("All monetary figures are in")." $currency") ;
	$t->set_var('comment4',lang("For Credit Balance, there is no need to pay/remit")) ;

/*---------------------------------------------------------------------------------*/

if ($err=="")	{

	$temp1 = "arst1".time() ;
	$temp2 = "arst2".time() ;

/*------------Collect all transactions related to this customer ($temp1)------------------*/
	$sql =	"CREATE TABLE $temp1 AS " .
		"SELECT 'i' as flag,transdate,duedate,amount,invnumber as description FROM ar " .
		"WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp1 (flag,transdate,amount,description) " .
		"SELECT 'r',transdate, -amount, rptnumber FROM receipt " .
		"WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);

/*------------Create intra period detail transactions ($temp2)----------------------------*/
	$sql =	"CREATE TABLE $temp2 AS SELECT * FROM $temp1 WHERE " .
		"transdate>='$start' and transdate<='$end'" ;
	$phpgw->db->query($sql);

/*-------------Calculate intra period transaction summary, ending and beginning balance------------------*/
	$phpgw->db->query("SELECT sum(amount) as amount from $temp2");
	$phpgw->db->next_record() ;
	$transum = $phpgw->db->f('amount');
	$phpgw->db->query("SELECT sum(amount) as amount from $temp1");
	$phpgw->db->next_record() ;
	$endbal = $phpgw->db->f('amount');
	$begin = $endbal - $transum;

/*-------------Print Statement Body --------------------------------------------*/

	$remark = ($begin<0) ? lang("[CR]") : "" ;
	$t->set_var(array(	'transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> lang("Bal. Brought Forward"),
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $begin,
	      	    		'remark'	=> $remark ));
	$t->parse('item_section','item_row',true);

	$phpgw->db->query("SELECT * FROM $temp2 ORDER BY transdate");
	while ($phpgw->db->next_record()) {
		$remark = "" ;
		$flag = $phpgw->db->f('flag') ;
		$transdate = $phpgw->db->f('transdate') ;
		$duedate = ($flag=="i") ? $phpgw->db->f('duedate') : "" ;
		$description = $phpgw->db->f('description') ;
		$age = $phpgw->db->f('age') ;
		$invamt = ($flag=="i") ? $phpgw->db->f('amount') : "" ;
		$rptamt = ($flag=="r") ? -$phpgw->db->f('amount') : "" ;
		$remark = ($flag=="r") ? lang("THANK YOU") : $remark ;
		$t->set_var(array(	'transdate'	=> $transdate,
					'duedate'	=> $duedate,
					'description'	=> $description,
					'invamt'	=> $invamt,
					'rptamt'	=> $rptamt,
					'balance'	=> "",
	     	 	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$remark = ($endbal<0) ? lang("[CR]") : "" ;
	$t->set_var(array(	'transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> lang("Bal. Carried Forward"),
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $endbal,
	      	    		'remark'	=> $remark ));
	$t->parse('item_section','item_row',true);

	$t->set_var('lang_thank',lang("Thank you for your continuous patronage")) ;
	$t->set_var('lang_footer',$footer) ;

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title =lang('If the sample displayed is OK, press [Email ...] button to start bulk despatch');
	$t->set_var('lang_title',$title);
	$note1=lang('For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_note1',$note1);
	$note2=lang('To generate statement of a different period, modify the appropriate statement field(s), then press regenerate.');
	$t->set_var('lang_note2',$note2);

	$phpgw->db->query("DROP TABLE $temp1");
	$phpgw->db->query("DROP TABLE $temp2");

	}
else {
 	$t->set_var('lang_title',$err);
	$t->set_var('item_section',"") ;
	$t->set_var('lang_thank',"") ;
	$t->set_var('lang_footer',"") ;
	$t->set_var('lang_note1',"");
	$t->set_var('lang_note2',"");
	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('regenerate_action',$phpgw->link('/ck-ar/statementbulk.php',"id=$id&order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('lang_regenerate',lang('Regenerate Statement'));
	$t->set_var('lang_email',lang('Email Statement'));

	$t->set_var('done_action',$phpgw->link('/ck-ar/customerlist.php',"order=$order&sort=$sort&filter=$filter"));
	$t->set_var('lang_done',lang('Done'));

	$t->pparse('out','items',report);

?>
