<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: statementbulkemail.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'	=> 'ck-ar',
		 	   'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$sdate = ($_GET["sdate"]) ? $_GET["sdate"] : $_POST["sdate"] ;
	$filter=urlencode(stripslashes($filter));

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ar'));
	$t->set_file('screen','confirm.tpl') ;
	$t->set_file('report','customerstatement.tpl') ;
	$t->set_block('report','item_row','item_section');
	$t->set_block('report','done','done_section');
	$t->set_var('done_section',"") ;
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('logo_url',$phpgw->link('/ck-ledadmin/logo.png')) ;
	echo "<br><br>",lang("<b>Statement Email Despatch Log</b>"),"<br><br>" ;

/*------------- Setup Statement Caption/Legend Details ----------------------------*/

	$t->set_var('lang_statement',lang('STATEMENT'));
	$t->set_var('lang_start',lang('Statement Start'));
	$t->set_var('start',$start) ;
	$t->set_var('lang_end',lang('Statement End'));
	$t->set_var('end',$end) ;
	$t->set_var('lang_sdate',lang('Statement Date'));
	$t->set_var('sdate',$sdate) ;
	$t->set_var('lang_customer',lang('Customer:'));

	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_invoice_amount',lang('Invoice<br>Amount'));
	$t->set_var('lang_payment_received',lang('Payment<br>Received'));
	$t->set_var('lang_balance',lang('Balance'));
	$t->set_var('lang_remark',lang('Remark'));

	$phpgw->db->query("SELECT * FROM defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$footer = $phpgw->db->f('inv_remark') ;

	if (!$order) {$order = "name" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT * from customer $where order by ".$order." ".$sort ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	echo lang("No customer statement selected for despatch") ;
		else	For ($i=1;$phpgw->db->next_record();$i++) $senditem[$i]=$phpgw->db->Record ;

For ($i=1;isset($senditem[$i]);$i++) {
	$t->set_var('item_section',"");
	$id = $senditem[$i]['id'] ;
	$phpgw->db->query("SELECT * FROM customer WHERE id='$id'");
	$phpgw->db->next_record();
	$custname = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$custfax = $phpgw->db->f('fax') ;
	$t->set_var('name',$custname) ;
	$t->set_var('addr1',$phpgw->db->f('addr1')) ;
	$t->set_var('addr2',$phpgw->db->f('addr2')) ;
	$t->set_var('addr3',$phpgw->db->f('addr3')) ;
	$t->set_var('addr4',$phpgw->db->f('addr4')) ;
	$t->set_var('comment1',"") ;
	$t->set_var('comment2',"") ;
	$t->set_var('comment3',lang("All monetary figures are in")." $currency") ;
	$t->set_var('comment4',lang("For Credit Balance, there is no need to pay/remit")) ;

	/*---------------------------------------------------------------------------------*/

	$temp1 = "arst1".time() ;
	$temp2 = "arst2".time() ;

	/*------------Collect all transactions related to this customer ($temp1)------------------*/
	
	$sql =	"CREATE TABLE $temp1 AS " .
		"SELECT 'i' as flag,transdate,duedate,amount,invnumber as description FROM ar " .
		"WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp1 (flag,transdate,amount,description) " .
		"SELECT 'r',transdate, -amount, rptnumber FROM receipt " .
		"WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);

	/*------------Create intra period detail transactions ($temp2)----------------------------*/

	$sql =	"CREATE TABLE $temp2 AS SELECT * FROM $temp1 WHERE " .
		"transdate>='$start' and transdate<='$end'" ;
	$phpgw->db->query($sql);

	/*-------------Calculate intra period transaction summary, ending and beginning balance---*/
	
	$phpgw->db->query("SELECT sum(amount) as amount from $temp2");
	$phpgw->db->next_record() ;
	$transum = $phpgw->db->f('amount');
	$phpgw->db->query("SELECT sum(amount) as amount from $temp1");
	$phpgw->db->next_record() ;
	$endbal = $phpgw->db->f('amount');
	$begin = $endbal - $transum;

	/*-------------Print Statement Body --------------------------------------------*/

	$remark = ($begin<0) ? lang("[CR]") : "" ;
	$t->set_var(array(	'transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> lang("Bal. Brought Forward"),
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $begin,
	      	    		'remark'	=> $remark ));
	$t->parse('item_section','item_row',true);

	$phpgw->db->query("SELECT * FROM $temp2 ORDER BY transdate");
	while ($phpgw->db->next_record()) {
		$remark = "" ;
		$flag = $phpgw->db->f('flag') ;
		$transdate = $phpgw->db->f('transdate') ;
		$duedate = ($flag=="i") ? $phpgw->db->f('duedate') : "" ;
		$description = $phpgw->db->f('description') ;
		$age = $phpgw->db->f('age') ;
		$invamt = ($flag=="i") ? $phpgw->db->f('amount') : "" ;
		$rptamt = ($flag=="r") ? -$phpgw->db->f('amount') : "" ;
		$remark = ($flag=="r") ? lang("THANK YOU") : $remark ;
		$t->set_var(array(	'transdate'	=> $transdate,
					'duedate'	=> $duedate,
					'description'	=> $description,
					'invamt'	=> $invamt,
					'rptamt'	=> $rptamt,
					'balance'	=> "",
	     	 	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$remark = ($endbal<0) ? lang("[CR]") : "" ;
	$t->set_var(array(	'transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> lang("Bal. Carried Forward"),
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $endbal,
	      	    		'remark'	=> $remark ));
	$t->parse('item_section','item_row',true);

	$t->set_var('lang_thank',lang("Thank you for your continuous patronage")) ;
	$t->set_var('lang_footer',$footer) ;

	$phpgw->db->query("DROP TABLE $temp1");
	$phpgw->db->query("DROP TABLE $temp2");

	$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
	$custmsg = lang("Customer") ;	$statmsg = lang("Statement for customer") ;
	$successmsg = lang("Email successfully sent to") ;
	$failuremsg = lang("Email fails to deliver to") ;
	if (!$custemail)				$err = lang("Customer email address missing") ;
	if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email address") ;
	if (!$comemail)					$err = lang("Self return email address missing");
	if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid self return email address");
	
	if ($err)	echo "$statmsg, $custname -- $noemail -- $error: $err<br>" ;
	   else {
		$recipient = "$contact < $custemail >" ;
		$subject = lang("Statement of Account from %1 to %2",$start,$end) ;
		$message = $t->parse('out','report',true) ;
		$headers = "From: $company < $comemail >\n" ;
		$headers.= "Bcc: $company < $comemail >\n" ;
		$headers.= "Content-Type: text/html; charset=$charset\n" ;
		$headers.= "Return-Path: $company < $comemail >\n" ;
		$result = mail($recipient,$subject,$message,$headers) ;
		if ($result)	echo "$statmsg, $custname -- $successmsg $custemail<br>" ;
			else	echo "$statmsg, $custname -- $failuremsg $custemail<br>" ;
		}

	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang("Despatch Completed")) ;
	$t->set_var('lang_yes',lang("Done")) ;
	$t->set_var('lang_no',lang("Done")) ;
	$t->set_var('yes_action',$phpgw->link('/ck-ar/customerlist.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('no_action',$phpgw->link('/ck-ar/customerlist.php',"order=$order&sort=$sort&filter=$filter")) ;
	$t->pparse('out','screen',true);
	$phpgw->common->phpgw_footer();

?>
