<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-bank', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'importlist.tpl',  'imports'=>'importlist.tpl'));
	$t->set_block('imports','import_row','import_section');
	$db_type = $phpgw_info["server"]["db_type"] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Ledger Items targeted for import'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Import Displayed Items into Reconciliation Worksheet'));
$t->set_var('add_action',$phpgw->link('/ck-bank/import2wksht.php',"filter=$filter"));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$langid = lang(' Id') ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-bank/importlist.php',lang('import Date')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,'/ck-bank/importlist.php',lang('Source')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-bank/importlist.php',lang('Description')));
$t->set_var('sort_refnumber',$nm->show_sort_order($sort,'refnumber',$order,'/ck-bank/importlist.php',lang('Ref Number')));
$t->set_var('sort_cheque',$nm->show_sort_order($sort,'cheque',$order,'/ck-bank/importlist.php',lang('Cheque')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-bank/importlist.php',lang('Amount (Dr being +ve)')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-bank/importlist.php',lang('Audit Id')));

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "br1".$user.time() ;
$temp2 = "br2".$user.time() ;
$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=	"SELECT trans_id,a.transdate,source,description,amount " ;
$sql.=	"FROM acc_trans a, gl b $where and trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT trans_id,a.transdate,source,description,paynumber as refnumber,cheque,a.amount " ;
$sql.=	"FROM $temp1 a, payment b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT trans_id,a.transdate,source,description,rptnumber,b.cheque,a.amount " ;
$sql.=	"FROM $temp1 a, receipt b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (trans_id,transdate,source,description,amount) " ;
$sql.=	"SELect * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE $temp2 SET amount=-amount");

$imported = "(" ;
$phpgw->db->query("SELECT trans_id FROM bkr_trans");
while ($phpgw->db->next_record())	$imported.= $phpgw->db->f('trans_id')."," ;
$imported = substr($imported,0,strlen($imported)-1).")";
$phpgw->db->query("DELETE FROM $temp2 WHERE trans_id IN $imported");

$sql =  "SELECT *,trans_id as id FROM $temp2 ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'refnumber'	=> "",
				'cheque'	=> "",
				'amount'	=> "",
				'id'		=> ""				));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('import_section','import_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$getstr  = "id=$id&filter=$filter" ;
	$source = $phpgw->db->f('source') ;
	$desc = $phpgw->db->f('description') ;
	$cheque = $phpgw->db->f('cheque') ;
	if ($source=="PYPY") {
		$dashpos = strpos($desc,"-") ;
		$blkpos = strpos($desc," ") ;
		$cheque = substr($desc,$dashpos+1,$blkpos-$dashpos) ;
		}
	$t->set_var(array(
		'transdate'		=> $phpgw->db->f('transdate'),
		'source'		=> $source,
		'description'		=> $desc,
		'refnumber'		=> $phpgw->db->f('refnumber'),
		'cheque'		=> $cheque,
		'amount'		=> $phpgw->db->f('amount'),
		'id'			=> $id					 ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('import_section','import_row',true);
	}
	
if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','imports','report');
?>
