<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ledger.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class ledger {

//---- ledger Detail Validation Checks

    function ledger_validate($l) {
	global $phpgw ;
	$err="";
	if ($err)	$err = "<b>$err</b>" ;
	return $err ;
	}

//---- Post ledger Detail to Database

    function ledger_post($l, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $l[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			break ;
		case "edit" :
			$sql ="UPDATE bkr_trans SET status='$l[status]' WHERE trans_id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM bkr_trans WHERE trans_id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

//	if ($op<>'new')		$phpgw->db->query("DELETE FROM ledgertax WHERE ledger_id=$id and (taxtype=1 or taxtype=2)") ;
//	if ($op<>'delete') {
//		if ($t1<>"")	$phpgw->db->query("INSERT INTO ledgertax(ledger_id,tax_id,taxtype) VALUES('$id','$t1','1')");
//		if ($t2<>"")	$phpgw->db->query("INSERT INTO ledgertax(ledger_id,tax_id,taxtype) VALUES('$id','$t2','2')");
//		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Ledger Item") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Ledger Item Detail

    function ledger_write(&$t, &$l) {
	global $phpgw ;

	$msg = lang("Non-payment items that (had) appeared in bank statement should also be flagged 'Cleared'.") ;
	$t->set_var('lang_transdate',lang('Ledger Date'));
	$t->set_var('lang_refnumber',lang('Ref Number'));
	$t->set_var('lang_cheque',lang('Cheque Number'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_status',lang('Status'));
	$t->set_var('lang_source',lang('Source'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('id',$l[id]);
	$t->set_var('transdate',$l[transdate]);
	$t->set_var('refnumber',$l[refnumber]);
	$t->set_var('cheque',$l[cheque]);
	$t->set_var('amount',$l[amount]);
	$t->set_var('status',$l[status]);
	$t->set_var('source',$l[source]);
	$t->set_var('description',$l[description]);
	$status_sl = str_replace("'$l[status]'","'$l[status]'"." selected",status_selectlist() ) ;
	$t->set_var('status_selectlist',$status_sl);
	$t->set_var('message',$msg);

	$t->parse('out','report',True);
	}

    }

?>
