<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ledgerbulk.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-bank', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$status = ($_GET["status"]) ? $_GET["status"] : $_POST["status"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('question','confirm.tpl');
	$t->set_file(array('report'=>'ledgerbulk.tpl',  'ledgers'=>'ledgerbulk.tpl'));
	$t->set_block('ledgers','ledger_row','ledger_section');
	$db_type = $phpgw_info["server"]["db_type"] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_bankac',lang('Bank Account'));
$pos = strpos($where,'chart_id=') ;
$posspace = strpos($where,' ',$pos) ;
$chart_id = substr($where,$pos+9,$posspace-$pos-9) ;
$phpgw->db->query("SELECT accno,description FROM chart WHERE id=$chart_id");
$phpgw->db->next_record() ;
$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
$t->set_var('bankac',$bankac);

$t->set_var('lang_post',lang('Post Bulk Update'));
$t->set_var('lang_delete',lang('Delete items in this list'));
$getstr = "filter=$filter&sort=$sort&order=$order" ;
$t->set_var('post_action',$phpgw->link('/ck-bank/ledgerbulk.php',$getstr));

if (isset($post) or isset($delete)) {
	$id = $chart_id ;
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$script = "ledgerbulk" ;
	$op = (isset($post)) ? 'edit' : 'delete' ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	}
if (isset($post)) {
	foreach ($status as $key => $value)
		$phpgw->db->query("UPDATE bkr_trans SET status='$value' WHERE trans_id=$key");
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('lang_post',lang('Done - Bulk Update Posted'));
	$t->set_var('lang_delete',lang('Done'));
	$t->set_var('post_action',$phpgw->link('/ck-bank/ledgerlist.php',$getstr));
	}
if (isset($delete)) {
	foreach ($status as $key => $value)
		$phpgw->db->query("DELETE FROM bkr_trans WHERE trans_id=$key");
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_delete',lang('Done - Items deleted'));
	$t->set_var('post_action',$phpgw->link('/ck-bank/ledgerlist.php',$getstr));
	}

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Ledger Items'));
$t->set_var('lang_sorthead','');
$t->set_var('lang_status',lang('Cheque/Item Status'));
$t->set_var('lang_transdate',lang('ledger Date'));
$t->set_var('lang_source',lang('Source'));
$t->set_var('lang_description',lang('Description'));
$t->set_var('lang_refnumber',lang('Ref Number'));
$t->set_var('lang_cheque',lang('Cheque'));
$t->set_var('lang_amount',lang('Amount<br>(Dr being +ve)'));
$t->set_var('lang_cleared',lang('Cleared'));
$t->set_var('lang_stopped',lang('Stopped'));
$t->set_var('lang_neither',lang('Neither'));
$t->set_var('lang_id',lang('Audit Id'));

if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT *,trans_id as id FROM bkr_trans $where ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'refnumber'	=> "",
				'cheque'	=> "",
				'amount'	=> "",
				'id'		=> ""			)) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('ledger_section','ledger_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$cchecked = ($phpgw->db->f('status')=="c") ? 'checked' : '' ;
	$schecked = ($phpgw->db->f('status')=="s") ? 'checked' : '' ;
	$nchecked = ($phpgw->db->f('status')=="") ? 'checked' : '' ;
	$t->set_var(array(
		'transdate'	=> $phpgw->db->f('transdate'),
		'source'	=> $phpgw->db->f('source'),
		'description'	=> $phpgw->db->f('description'),
		'refnumber'	=> $phpgw->db->f('refnumber'),
		'cheque'	=> $phpgw->db->f('cheque'),
		'amount'	=> $phpgw->db->f('amount'),
		'cchecked'	=> $cchecked,
		'schecked'	=> $schecked,
		'nchecked'	=> $nchecked,
		'id'		=> $id					));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('ledger_section','ledger_row',true);
	}
	
// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','ledgers','report');
?>
