<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=> 'ck-bank', 'enable_nextmatchs_class'=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$bankbal = ($_GET["bankbal"]) ? $_GET["bankbal"] : $_POST["bankbal"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Report to Generate and to set Report Parameters :'));
	$t->set_var('lang_search_message',"");

/* ------------- Display Report Generation Parameters ----------------------- */

$t->set_var('lang_criteria',lang('Reporting Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$statement = lang('Bank Reconciliation Statement') ;
$reserved = lang('Reserved') ;
$controlreport = lang('Bank Reconciliation Audit Control Report') ;
$replist = array (	1	=>	"<OPTION value='1'>1 -- $statement</OPTION>",
			2	=>	"<OPTION value='2'>2 -- $reserved</OPTION>",
			3	=>	"<OPTION value='3'>3 -- $reserved</OPTION>",
			4	=>	"<OPTION value='4'>4 -- $reserved</OPTION>",
			5	=>	"<OPTION value='5'>5 -- $controlreport</OPTION>" ) ;
$bankac_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",'');
$filter = array (	cond1		=>	lang('Which Report') ,
			condvar1	=>	'repnum' ,
			conddefault1	=>	'' ,
			condnote1	=>	lang('If wrong report chosen, click [Report] to restart'),
			cond2		=>	lang('Bank Account') ,
			condvar2	=>	'chart_id' ,
			selectlist2	=>	$bankac_sl,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Select the appropriate bank account') ,

			cond3		=>	lang('Reconciliation Period from') ,
			condvar3	=>	'from' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Format: YYYY-MM-DD'),

			cond4		=>	lang('Reconciliation Period to') ,
			condvar4	=>	'to' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Format: YYYY-MM-DD'),

			cond5		=>	lang('Bank Balance as of BR Date') ,
			condvar5	=>	'bankbal' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Enter Bank Statement Balance as of Bank Reconcilation Date.  Must be numeric.')
			) ;

if ($err) {
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $repnum ;
	$filter["conddefault2"] = $chart_id ;
	$filter["conddefault3"] = $from ;
	$filter["conddefault4"] = $to ;
	$filter["conddefault5"] = $bankbal ;
	}
$t->set_var('condition',$filter[cond1]) ;
$t->set_var('var',$filter[condvar1]) ;
$t->set_var('note',$filter[condnote1]);
if (!$repnum) 		For ($i=1;isset($replist[$i]);$i++)	{$selectlist .= $replist[$i] ;}
    else 		$selectlist = $replist[$repnum];
$t->set_var('selectlist',$selectlist);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);
if ($repnum==1 or $repnum==5) {
	$t->set_var('condition',$filter[cond2]) ;
	$t->set_var('var',$filter[condvar2]) ;
	$default = $filter[conddefault2] ;
	$t->set_var('selectlist',str_replace("'$default'","'$default' selected",$filter[selectlist2]));
	$t->set_var('note',$filter[condnote2]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('select_section','select', True);
	}

If (!$repnum) 	{$t->set_var('detail_section',"");}
	else
	For ($i=3;isset($filter['cond'.$i]);$i++)	{
		$print = False ;
		Switch ($repnum) :
			case "1" :
				$print = ($i==3 or $i==4 or $i==5) ? True : False ;	break;
			case "2" :
				$print = False ; $t->set_var('detail_section','');	break;
			case "3" :
				$print = False ; $t->set_var('detail_section','');	break;
			case "4" :
				$print = False ; $t->set_var('detail_section','');	break;
			case "5" :
				$print = ($i==3 or $i==4) ? True : False ;				break;
		endswitch;
		if ($print)	{
			$t->set_var('condition',$filter['cond'.$i]);
			$t->set_var('var',$filter['condvar'.$i]);
			$t->set_var('default',$filter['conddefault'.$i]);
			$t->set_var('note',$filter['condnote'.$i]);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$repnum) {
		$t->set_var('search_action',$phpgw->link('/ck-bank/reportfilter.php')) ;
		$t->set_var('lang_search',lang('Input Report Generation Parameters'));
		}
	    else {
		$t->set_var('search_action',$phpgw->link('/ck-bank/reportfilter_validate.php')) ;
		$t->set_var('lang_search',lang('Start Report Generation'));
		}
	$t->set_var('add_action',$phpgw->link('/ck-bank/reportfilter.php')) ;
	$t->set_var('lang_add',lang('Done'));
	$t->pparse('out','report',True);

?>
