<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: worksheetfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-bank', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$beginbal = ($_GET["beginbal"]) ? $_GET["beginbal"] : $_POST["beginbal"] ;
	$endbal = ($_GET["endbal"]) ? $_GET["endbal"] : $_POST["endbal"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Enter Reconciliation Worksheet Parameters :'));
	$t->set_var('lang_search_message','');

/* ------------- Read and Write Filter --------------------------- */

$t->set_var('lang_criteria',lang('Parameter'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$bankac_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",'');
$filter = array (	cond1		=>	lang('Bank Account') ,
			condvar1	=>	'chart_id' ,
			selectlist1	=>	$bankac_sl,
			conddefault1	=>	'' ,
			condnote1	=>	lang('Select the appropriate bank account') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Reconciliation Period from') ,
			condvar2	=>	'from' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Must be a valid date; format: YYYY-MM-DD'),
			checkbox3	=>	'no',
			cond3		=>	lang('Reconciliation Period to') ,
			condvar3	=>	'to' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date; format: YYYY-MM-DD') ,
			checkbox4	=>	'no',
			cond4		=>	lang('Beginning Bank Statement Balance') ,
			condvar4	=>	'beginbal' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Must be a number') ,
			checkbox5	=>	'no',
			cond5		=>	lang('Ending Bank Statement Balance') ,
			condvar5	=>	'endbal' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Must be a number')		) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $chart_id ;
	$filter["conddefault2"] = $from ;
	$filter["conddefault3"]	= $to ;
	$filter["conddefault4"]	= $beginbal ;
	$filter["conddefault5"]	= $endbal ;
	}

$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	if ($filter['checkbox'.$i]=='yes') {
		$t->set_var('checkbox',"type='checkbox'");
		$t->set_var('default',"yes");
		if ($filter['conddefault'.$i]=='yes')	$t->set_var('checked',"checked");
			else				$t->set_var('checked',"");
		}
	   else	{
		$t->set_var('checkbox',"");
		$t->set_var('checked',"");
		}
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-bank/worksheetfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Worksheet Generation'));
	$t->set_var('add_action',$phpgw->link('/ck-bank/worksheetfilter.php')) ;
	$t->set_var('lang_add',lang('N/A'));
	$t->pparse('out','report',True);
?>
