<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attendfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$dept = ($_GET["dept"]) ? $_GET["dept"] : $_POST["dept"] ;
	$type = ($_GET["type"]) ? $_GET["type"] : $_POST["type"] ;
	$name = ($_GET["name"]) ? $_GET["name"] : $_POST["name"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among existing Attendance Record :'));
	$searchmsg = lang('To search for all items, leave fields blank') ;
	$msg1 = lang('Attendance Records are auto-created via staff signing in/out.') ;
	$msg2 = lang('Normally, HR staff should not create/amend attendance records.') ;
	$t->set_var('lang_search_message',"$searchmsg<br>[$msg1  $msg2]");

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Searching Criteria'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));
	$nullopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='sign-in'>".lang('sign-in')."</OPTION>" ;
	$type_sl.= "<OPTION value='sign-out'>".lang('sign-out')."</OPTION>" ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$attendmsg = lang('Attendance Record falling within (from/to) period will be listed.') ;

	$filter = array (
				ftr1		=>	lang('Department') ,
				ftrtype1	=>	'select' ,
				ftrsl1		=>	$nullopt.dept_selectlist('','') ,
				ftrvar1		=>	'dept' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	lang('Search for Attendance Record of target Department'),

				ftr2		=>	lang('Record Type') ,
				ftrtype2	=>	'select' ,
				ftrsl2		=>	$nullopt.$type_sl ,
				ftrvar2		=>	'type' ,
				ftrdefault2	=>	'' ,
				ftrnote2	=>	lang('Search for the target Record Type'),

				ftr3		=>	lang('Employee Name/#') ,
				ftrtype3	=>	'input' ,
				ftrvar3		=>	'name' ,
				ftrdefault3	=>	'' ,
				ftrnote3	=>	lang('Search for target key word in the Employee Name Field') ,

				ftr4		=>	lang('Attendance Period From') ,
				ftrtype4	=>	'input' ,
				ftrvar4		=>	'datefrom' ,
				ftrdefault4	=>	'' ,
				ftrnote4	=>	"$attendmsg  $dateformat" ,

				ftr5		=>	lang('Attendance Period To') ,
				ftrtype5	=>	'input' ,
				ftrvar5		=>	'dateto' ,
				ftrdefault5	=>	'' ,
				ftrnote5	=>	"$attendmsg  $dateformat"
															 ) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $dept ;
		$filter["ftrdefault2"] = $type ;
		$filter["ftrdefault3"] = $name ;
		$filter["ftrdefault4"] = $datefrom ;
		$filter["ftrdefault5"] = $dateto ;
		}

	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-hr/attendfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-hr/attendadd.php')) ;
	$t->set_var('lang_add',lang('Add New Attendance Record'));
	$t->pparse('out','report',True);

?>
