<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: datesedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$dt = CreateObject('ck-hr.dates') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$t->set_file('report','datesscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Important Dates'));
	$msg1 = lang("Notification is to be done manually via the Nofiication List.") ;
	$msg2 = lang("Auto-email notification will be a future enhancement.") ;
	$msg3 = lang("If the screen display gets too complicated, click [Reload from Employee Record] to start afresh.") ;
	$t->set_var('message',"$msg1  $msg2  $msg3") ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete)) {
		$phpgw->db->query("SELECT * FROM employee WHERE id='$id'");
		$phpgw->db->next_record();
		$d = $phpgw->db->Record ;
		}
	    else $d = $_POST ;
	$dt->dates_header_write($t, $d) ;

	if ((!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete)) or isset($reload)) {
		$d = "" ;
		$d[name] = $_POST ;
		$d[id] = $_POST ;
		$phpgw->db->query("SELECT * from dates where empid='$id' order by empdate");
		For ($i=1;$phpgw->db->next_record();$i++) {
			$empdate		=	$phpgw->db->f('empdate') ;
			$d['year'.$i]		=	substr($empdate,0,4) ;
			$d['month'.$i]		=	substr($empdate,5,2) ;
			$d['day'.$i]		=	substr($empdate,8,2) ;
			$d['datecode'.$i]	=	$phpgw->db->f('datecode') ;
			$d['notify'.$i]		=	$phpgw->db->f('notify') ;
			}
		}

	$dt->dates_detail_write($t, $d,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $dt->dates_validate($d) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$dt->dates_post($d,$t,'edit','datesedit');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_reload',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-hr/datesedit.php",$getstr)) ;
		$t->set_var('lang_update',lang('Post Important Dates'));
		$t->set_var('lang_newrow',lang('Add New Row'));
		$t->set_var('lang_reload',lang('Reload from Employee Record'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
