<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ecedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$ec = CreateObject('ck-hr.ec') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$t->set_file('report','ecscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Emergency Contact'));
	$message = lang("If the screen display gets too complicated, click [Reload from Employee Record] to start afresh.") ;
	$t->set_var('message',$message) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Emergency Contact to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete)) {
		$phpgw->db->query("SELECT * FROM employee WHERE id='$id'");
		$phpgw->db->next_record();
		$e = $phpgw->db->Record ;
		}
	    else $e = $_POST ;
	$ec->ec_header_write($t, $e) ;

	if ((!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete)) or isset($reload)) {
		$e = "" ;
		$e[name] = $_POST ;
		$e[id] = $_POST ;
		$phpgw->db->query("SELECT * from ec where empid='$id' order by eccode");
		For ($i=1;$phpgw->db->next_record();$i++) {
			$e['prefix'.$i]	=	$phpgw->db->f('prefix') ;
			$e['family'.$i]	=	$phpgw->db->f('family') ;
			$e['given'.$i]	=	$phpgw->db->f('given') ;
			$e['suffix'.$i]	=	$phpgw->db->f('suffix') ;
			$e['contact'.$i]=	$phpgw->db->f('contact') ;
			$e['relation'.$i]=	$phpgw->db->f('relation') ;
			$e['eccode'.$i]	=	$phpgw->db->f('eccode') ;
			}
		}

	$ec->ec_detail_write($t, $e,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Emergency Contact ----------------------------------------------*/

	if (isset($post)) {
		$err = $ec->ec_validate($e) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$ec->ec_post($e,$t,'edit','ecedit');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_reload',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-hr/ecedit.php",$getstr)) ;
		$t->set_var('lang_update',lang('Post Emergency Contact'));
		$t->set_var('lang_newrow',lang('Add New Row'));
		$t->set_var('lang_reload',lang('Reload from Employee Record'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
