<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: hrcodelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array(	'report'=>'hrcodelist.tpl','hrcode'	=>'hrcodelist.tpl'));
	$t->set_block('hrcode','hrcode_row','hrcode_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang("List of HR Codes"));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_type',$nm->show_sort_order($sort,'type',$order,'/ck-hr/hrcodelist.php',lang('Type')));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-hr/hrcodelist.php',lang('Name')));
$t->set_var('sort_description',$nm->show_sort_order($sort,"description",$order,'/ck-hr/hrcodelist.php',lang('Description')));
$t->set_var('sort_allowdelete',$nm->show_sort_order($sort,"allowdelete",$order,'/ck-hr/hrcodelist.php',lang('Allow<br>Delete')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-hr/hrcodelist.php',lang('Audit Id')));

if (!$order) $order = "type,name" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * from hrcode $where order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'type'		=> lang("No Matching Item Found"),
				'name'		=> "",
				'description'	=> "",
				'allowdelete'	=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('hrcode_section','hrcode_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$allowdelete = $phpgw->db->f("allowdelete") ;
	$allowdelete = ($allowdelete=="y" or $allowdelete=="Y") ? lang("Yes") : lang("No") ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'type'		=> $phpgw->db->f("type"),
				'name'		=> $phpgw->db->f("name"),
				'description'	=> $phpgw->db->f("description"),
				'allowdelete'	=> $allowdelete,
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-hr/hrcodeview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-hr/hrcodeedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-hr/hrcodecopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-hr/hrcodedelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('hrcode_section','hrcode_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add New HR code"));
	$t->set_var('add_action',$phpgw->link('/ck-hr/hrcodeadd.php',$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));

	$t->pparse('out','hrcode','report');

?>
