<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.activity.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class activity {

//---- Activity Detail Validation Checks

    function activity_validate($a) {
	global $phpgw ;

	$err=""; $error=lang('Error') ;
	if ($a[name]=="")		$err=lang('Activity name Missing');
	if ($a[description]=="")	$err=lang('Activity description Missing');
	if (!is_numeric($a[rate]))	$err=lang('Pay Rate must be numeric');
	if (!is_numeric($a[factor]))	$err=lang('Pay Factor must be numeric');
	if ($err)			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Activity Detail to Database

    function activity_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $a[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql = "INSERT INTO activity (id,name,description,rate,factor) " ;
			$sql.= "VALUES('$id','$a[name]','$a[description]','$a[rate]','$a[factor]')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE activity SET name='$a[name]',description='$a[description]'," ;
			$sql.= "rate='$a[rate]',factor='$a[factor]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from activity where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Activity") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Activity Detail

    function activity_write(&$t, &$a) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit ID:  '));
	$t->set_var('lang_name',lang('Activity Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_rate',lang('Per Unit Pay Rate'));
	$t->set_var('lang_factor',lang('Pay Factor'));
	$id = $a[id] ;
	$t->set_var('id',$id);
	$t->set_var('name',$a[name]);
	$t->set_var('description',$a[description]);
	$t->set_var('rate',$a[rate]);
	$t->set_var('factor',$a[factor]);
	$t->parse('out','report',True);
	}

    }

?>
