<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.dates.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class dates {

//---- Dates Validation Checks

    function dates_validate($d) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$lang_date = lang('date') ;
	$b1=$b2=$b3=$bd=$c1=$c2=$c3=$hd=$pc=$p1=$p2=$p3=$p4=$td=$wa = "" ;
	For ($i=1;isset($d['year'.$i]);$i++) {
		$empdate	=	$d['year'.$i].'-'.$d['month'.$i].'-'.$d['day'.$i] ;
		$date = input2date($empdate) ;
		$row = lang("Row") ;
		if ($date=="")			$err="[$row $i]".lang("Error: Invalid Date");
		$datecode = $d['datecode'.$i] ;
		$phpgw->db->query("SELECT name FROM hrcode where type='$lang_date' and name='$datecode'");
		$phpgw->db->next_record() ;
		switch ($phpgw->db->f('name')) :
			case "BA" :	if ($ba<>"") $err="[$row $i]".lang("Duplicate BA day") ;	$ba = strtotime($empdate) ;	break ;
			case "BD" :	if ($bd<>"") $err="[$row $i]".lang("Duplicate BD day") ;	$bd = strtotime($empdate) ;	break ;
			case "C1" :	if ($c1<>"") $err="[$row $i]".lang("Duplicate C1 day") ;	$c1 = strtotime($empdate) ;	break ;
			case "C2" :	if ($c2<>"") $err="[$row $i]".lang("Duplicate C2 day") ;	$c2 = strtotime($empdate) ;	break ;
			case "HD" :	if ($hd<>"") $err="[$row $i]".lang("Duplicate HD day") ;	$hd = strtotime($empdate) ;	break ;
			case "PC" :	if ($pc<>"") $err="[$row $i]".lang("Duplicate PC day") ;	$pc = strtotime($empdate) ;	break ;
			case "P1" :	if ($p1<>"") $err="[$row $i]".lang("Duplicate P1 day") ;	$p1 = strtotime($empdate) ;	break ;
			case "P2" :	if ($p2<>"") $err="[$row $i]".lang("Duplicate P2 day") ;	$p2 = strtotime($empdate) ;	break ;
			case "S1" :	if ($s1<>"") $err="[$row $i]".lang("Duplicate S1 day") ;	$s1 = strtotime($empdate) ;	break ;
			case "S2" :	if ($s2<>"") $err="[$row $i]".lang("Duplicate S2 day") ;	$s2 = strtotime($empdate) ;	break ;
			case "TD" :	if ($td<>"") $err="[$row $i]".lang("Duplicate TD day") ;	$td = strtotime($empdate) ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($bd<>"" and $c1<>"" and $c1<$bd)	$err = lang("Contract 1 ending date earlier than Birthday");
		if ($bd<>"" and $c2<>"" and $c2<$bd)	$err = lang("Contract 2 ending date earlier than Birthday");
		if ($bd<>"" and $hd<>"" and $hd<$bd)	$err = lang("Hire Day earlier than Birthday");
		if ($bd<>"" and $pc<>"" and $pc<$bd)	$err = lang("Probation Completion date earlier than Birthday");
		if ($bd<>"" and $p1<>"" and $p1<$bd)	$err = lang("Performance Review Day 1 earlier than Birthday");
		if ($bd<>"" and $p2<>"" and $p2<$bd)	$err = lang("Performance Review Day 2 earlier than Birthday");
		if ($bd<>"" and $s1<>"" and $s1<$bd)	$err = lang("Salary Review Day 1 earlier than Birthday");
		if ($bd<>"" and $s2<>"" and $s2<$bd)	$err = lang("Salary Review Day 2 earlier than Birthday");
		if ($bd<>"" and $td<>"" and $td<$bd)	$err = lang("Termination Day earlier than Birthday");

		if ($hd=="")				$err = lang("Hire Day missing") ;
		if ($hd<>"" and $c1<>"" and $c1<$hd)	$err = lang("Contract 1 ending date earlier than Hire Day");
		if ($hd<>"" and $c2<>"" and $c2<$hd)	$err = lang("Contract 2 ending date earlier than Hire Day");
		if ($hd<>"" and $pc<>"" and $pc<=$hd)	$err = lang("Probation Completion date earlier than or = Hire Day");
		if ($hd<>"" and $p1<>"" and $p1<=$hd)	$err = lang("Performance Review Day 1 earlier than or = Hire Day");
		if ($hd<>"" and $p2<>"" and $p2<=$hd)	$err = lang("Performance Review Day 2 earlier than or = Hire Day");
		if ($hd<>"" and $s1<>"" and $s1<=$hd)	$err = lang("Salary Review Day 1 earlier than or = Hire Day");
		if ($hd<>"" and $s2<>"" and $s2<=$hd)	$err = lang("Salary Review Day 2 earlier than or = Hire Day");
		if ($hd<>"" and $td<>"" and $td<$hd)	$err = lang("Termination Day earlier than Hire Day");
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Dates to Database

    function dates_post($d, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $d[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from dates where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($d['year'.$i]);$i++) {
			$empdate	=	$d['year'.$i].'-'.$d['month'.$i].'-'.$d['day'.$i] ;
			$datecode	=	$d['datecode'.$i] ;
			$notify		=	($d['notify'.$i]=="") ? 0 : $d['notify'.$i] ;
			$sql = "INSERT INTO dates(empid,empdate,datecode,notify) " ;
			$sql.= "VALUES('$id','$empdate','$datecode','$notify')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Important Dates for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Dates Header

    function dates_header_write(&$t, $d) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$d[name]) ;
	$t->set_var('id',$d[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Dates Detail

    function dates_detail_write(&$t, $d, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $d[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_year',lang("Year"));
	$t->set_var('lang_month',lang("Month"));
	$t->set_var('lang_day',lang("Day"));
	$t->set_var('lang_datecode',lang("Date Code -- Description") );
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_notify',lang('Notify'));
	$t->set_var('lang_delete',lang('Delete'));

	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_date = lang('date') ;
	$year_sl = year_selectlist('','') ;
	$month_sl = month_selectlist('','') ;
	$day_sl = day_selectlist('','') ;
	$datecode_sl = hrcodename_selectlist("WHERE type='$lang_date'",'',"long") ;
	$notify_sl = $blankopt.employee_selectlist('','') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($d['year'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('year_fld','year'.$i) ;
			$t->set_var('month_fld','month'.$i) ;
			$t->set_var('day_fld','day'.$i) ;
			$t->set_var('datecode_fld','datecode'.$i) ;
			$t->set_var('notify_fld','notify'.$i);
			$t->set_var('year_selectlist',$year_sl);
			$t->set_var('month_selectlist',$month_sl) ;
			$t->set_var('day_selectlist',$day_sl) ;
			$t->set_var('datecode_selectlist',$datecode_sl) ;
			$t->set_var('notify_selectlist',employee_selectlist('','')) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$year		=	$d['year'.$i] ;
		$month		=	$d['month'.$i] ;
		$day		=	$d['day'.$i] ;
		$datecode	=	$d['datecode'.$i] ;
		$notify		=	$d['notify'.$i] ;

		$t->set_var('year_fld','year'.$j) ;
		$t->set_var('month_fld','month'.$j) ;
		$t->set_var('day_fld','day'.$j) ;
		$t->set_var('datecode_fld','datecode'.$j) ;
		$t->set_var('notify_fld','notify'.$j);

		$t->set_var('year_selectlist',str_replace("'$year'","'$year' selected",$year_sl)) ;
		$t->set_var('month_selectlist',str_replace("'$month'","'$month' selected",$month_sl)) ;
		$t->set_var('day_selectlist',str_replace("'$day'","'$day' selected",$day_sl)) ;
		$t->set_var('datecode_selectlist',str_replace("'$datecode'","'$datecode' selected",$datecode_sl)) ;
		$t->set_var('notify_selectlist',str_replace("'$notify'","'$notify' selected",$notify_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('year_fld','year'.$i) ;
		$t->set_var('month_fld','month'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('datecode_fld','datecode'.$i) ;
		$t->set_var('notify_fld','notify'.$i);
		$t->set_var('year_selectlist',$year_sl);
		$t->set_var('month_selectlist',$month_sl) ;
		$t->set_var('day_selectlist',$day_sl) ;
		$t->set_var('datecode_selectlist',$datecode_sl) ;
		$t->set_var('notify_selectlist',$notify_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>

