<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: notifylist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;
	$db_type = $phpgw_info["server"]["db_type"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'notifylist.tpl', 'notify'=>'notifylist.tpl'));
	$t->set_block('notify','notify_row','notify_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang("Human Resources Notification List"));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_notifyparty',$nm->show_sort_order($sort,'notifyparty',$order,'/ck-hr/notifylist.php',lang('Party to Notify'),$filter));
$t->set_var('sort_empdate',$nm->show_sort_order($sort,'empdate',$order,'/ck-hr/notifylist.php',lang('Event Day'),$filter));
$t->set_var('sort_description',$nm->show_sort_order($sort,"description",$order,'/ck-hr/notifylist.php',lang('Event Description'),$filter));
$t->set_var('sort_employee',$nm->show_sort_order($sort,'employee',$order,'/ck-hr/notifylist.php',lang('Employee Involved'),$filter));
$t->set_var('sort_empid',$nm->show_sort_order($sort,'empid',$order,'/ck-hr/notifylist.php',lang('Employee Id'),$filter));

if (!$order) $order = "notifyparty" ;
if (!$sort)  $sort = "ASC" ;

$user = trim($phpgw_info["user"]["userid"]);
$temp = "nl1".$user.time() ;
$lang_date = lang('date') ;
$fullname = ($db_type=="mysql") ? "concat(family,', ',given)" : "(family||', '||given)" ;
$sql = "CREATE TABLE $temp AS " ;
$sql.= "SELECT $fullname as notifyparty,empdate,description,empid " ;
$sql.= "FROM employee a,dates b,hrcode c " ;
$sql.= "$where and notify=a.id and type='$lang_date' and datecode=c.name " ;
$phpgw->db->query($sql);
$sql = "SELECT notifyparty,empdate,description,$fullname as employee,empid " ;
$sql.= "FROM employee a,$temp b WHERE empid=a.id " ;
$sql.= "ORDER BY $order $sort" ;
$phpgw->db->query($sql) ;

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'notifyparty'	=> lang("No Matching Item Found"),
				'empdate'	=> "",
				'description'	=> "",
				'employee'	=> "",
				'empid'		=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('notify_section','notify_row',True);
	}
while ($phpgw->db->next_record()) {
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'notifyparty'	=> $phpgw->db->f("notifyparty"),
				'empdate'	=> $phpgw->db->f("empdate"),
				'description'	=> $phpgw->db->f("description"),
				'employee'	=> $phpgw->db->f("employee"),
				'empid'		=> $phpgw->db->f("empid")	  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('notify_section','notify_row',true);
	}

$phpgw->db->query("DROP TABLE $temp");

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Done"));
	$t->set_var('add_action',$phpgw->link('/ck-hr/reportfilter.php'));

	$t->pparse('out','notify','report');

?>
