<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array(	'currentapp'	=> 'ck-hr',
					'noheader'	=> True,
					'nonavbar'	=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$event = ($_GET["event"]) ? $_GET["event"] : $_POST["event"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)		$err="Error flagged before validation." ;
	$error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)		$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($datefrom) {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=lang("Invalid Period from Date");
			else	$datefrom = $date ;
		}
//	    else	$datefrom=date("Y-m-d") ;
	if ($dateto) {
		$date=input2date($dateto) ;
		if ($date=="")	$err=lang("Invalid Period to Date");
			else	$dateto = $date ;
		}
//	    else	$dateto=date("Y-m-d") ;
	if ($rdate) {
		$date=input2date($rdate) ;
		if ($date=="")	$err=lang("Invalid Report Status Date");
			else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;
	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{
		switch ($repnum) {
			case 1:
				$where = " WHERE 1=1 " ;
				if ($event)		$where .= " AND datecode = '$event' " ;
				if ($datefrom)		$where .= " AND empdate >= '$datefrom' ";
				if ($dateto)		$where .= " AND empdate <= '$dateto' " ;
				$where = urlencode($where) ;
				$getstr = "event=$event&datefrom=$datefrom&dateto=$dateto&filter=$where" ;
				Header('Location: '.$phpgw->link("/ck-hr/notifylist.php",$getstr));
				exit();
			case 2:
				Header('Location: '.$phpgw->link("/ck-hr/reportfilter.php"));
				exit();
			case 3:
				Header('Location: '.$phpgw->link("/ck-hr/reportfilter.php"));
				exit();
			case 4:
				Header('Location: '.$phpgw->link("/ck-hr/reportfilter.php"));
				exit();
			case 5:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.$phpgw->link("/ck-hr/controlreport.php","$param_list"));
				exit();
			default:
				echo lang("Should not be here.  Weird Report Number") ;
			}
		}
	else
		{
		$err = urlencode($err) ;
		$getstr = "repnum=$repnum&datefrom=$datefrom&dateto=$dateto&rdate=$rdate&err=$err" ;
		$return = $phpgw->link("/ck-hr/reportfilter.php",$getstr) ;
		Header('Location: '.$return);
		exit() ;
		}

?>
