<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: timesheetcopy.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$replicate = ($_GET["replicate"]) ? $_GET["replicate"] : $_POST["replicate"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$tsh = CreateObject('ck-hr.timesheet') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$t->set_file('report','timesheetscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Copy Timesheet'));
	$t->set_var('message',"") ;

/*------------- Write Timesheet to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete) and !isset($replicate)) {
		$sql = "SELECT empid,name,year,week FROM timesheet a,employee b " ;
		$sql.= "WHERE a.id=$id and empid=b.id";
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$ts = $phpgw->db->Record ;
		}
    	else $ts = $_POST ;
	$tsh->timesheet_header_write($t, $ts, '') ;

	if (!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete) and !isset($replicate)) {
		$sql = "SELECT a.*,b.* from ts_trans a, timesheet b " ;
		$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
		$phpgw->db->query($sql);
		$ts[tsyear0] = date("Y") ;
		$ts[tsmonth0] = date("m") ;
		$ts[tsday0] = date("d") ;
		$i=1;
		while ($phpgw->db->next_record()) {
			$transdate		=	$phpgw->db->f('transdate') ;
			$ts['tsyear'.$i]	=	substr($transdate,0,4) ;
			$ts['tsmonth'.$i]	=	substr($transdate,5,2) ;
			$ts['tsday'.$i]		=	substr($transdate,8,2) ;
			$ts['project'.$i]	=	$phpgw->db->f('project') ;
			$ts['activity'.$i]	=	$phpgw->db->f('activity') ;
			$ts['hour'.$i]		=	$phpgw->db->f('hour') ;
			$ts['day'.$i]		=	$phpgw->db->f('day') ;
			$ts['achieve'.$i]	=	$phpgw->db->f('achieve') ;
			$ts['achival'.$i]	=	$phpgw->db->f('achival') ;
			$ts['achiunit'.$i]	=	$phpgw->db->f('achiunit') ;
			$i++ ;
			}
		}
	    else $ts = $_POST ;

	if (isset($replicate)) {
		For ($i=1;isset($ts['tsyear'.$i]);$i++) {
			$ts['tsyear'.$i]	=	$ts['tsyear0'] ;
			$ts['tsmonth'.$i]	=	$ts['tsmonth0'] ;
			$ts['tsday'.$i]		=	$ts['tsday0'] ;
			}
		}

	$tsh->timesheet_detail_write($t, $ts, $posted, $insert, $delete, $newrow);

	$t->parse('out','report',True);

/*-------------- Post timesheet----------------------------------------------*/

	if (isset($post)) {
		$err = $tsh->timesheet_validate($ts) ;
		$t->set_var('message',$err);
		if ($err=='') $posted = $tsh->timesheet_post($ts,$t,'new','timesheetcopy');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-hr/timesheetlist.php',$getstr));
		$t->set_var('lang_replicate',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-hr/timesheetcopy.php',$getstr)) ;
		$t->set_var('lang_replicate',lang('Replicate from Caption'));
		$t->set_var('lang_update',lang('Post timesheet'));
		$t->set_var('lang_newrow',lang('Add new row'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link('/ck-hr/timesheetlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
