<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"]["currentapp"] = 'ck-inv';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$status_date = ($_GET["status_date"]) ? $_GET["status_date"] : $_POST["status_date"] ;

/*---------------------------------------------------------------------------------*/

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir(ck-inv));
    $t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Inventory Audit Control Report'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_parts', lang('Inventory<br>/Parts'));
	$t->set_var('lang_gr', lang('Goods<br>Receipt'));
	$t->set_var('lang_grtran', lang('Individual GR<br>Item/Line'));
	$t->set_var('lang_gd', lang('Goods<br>Delivery'));
	$t->set_var('lang_gdtran', lang('Individual GD<br>Item/Line'));
	$t->set_var('lang_ia', lang('Inventory<br>Adjustment'));
	$t->set_var('lang_iatran', lang('Individual IA<br>Item/Line'));
	$t->set_var('lang_current_status', lang('TOTAL DATABASE STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));
	$lang_na = lang('N/A') ;

/*-----------------Gather and Write Database Info---------------------------------*/

$t->set_var('system_date',date("Y-m-d",time())) ;

$sql =	"SELECT count(id) as parts_count, max(id) as max_id from parts WHERE inventory_accno_id<>0" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('parts_count',$phpgw->db->f('parts_count')) ;
$t->set_var('latest_parts_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as gr_count, max(id) as max_id from il WHERE substring(source,1,2)='GR'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('gr_count',$phpgw->db->f('gr_count')) ;
$t->set_var('latest_gr_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as gd_count, max(id) as max_id from il WHERE substring(source,1,2)='GD'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('gd_count',$phpgw->db->f('gd_count')) ;
$t->set_var('latest_gd_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as ia_count, max(id) as max_id from il WHERE substring(source,1,2)='IA'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('ia_count',$phpgw->db->f('ia_count')) ;
$t->set_var('latest_ia_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(trans_id) as cnt from inv_trans, il WHERE trans_id=id and substring(source,1,2)='GR'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('grtran_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_grtran_id',$lang_na) ;

$sql =	"SELECT count(trans_id) as cnt from inv_trans, il WHERE trans_id=id and substring(source,1,2)='GD'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('gdtran_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_gdtran_id',$lang_na) ;

$sql =	"SELECT count(trans_id) as cnt from inv_trans, il WHERE trans_id=id and substring(source,1,2)='IA'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('iatran_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_iatran_id',$lang_na) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-inv/index.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	$phpgw->common->phpgw_footer();
?>
