<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: gdlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-inv', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'gdlist.tpl', 'gd'=>'gdlist.tpl'));
	$t->set_block('gd','gd_row','gd_section');

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Goods Delivery (GD)'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add Goods Delivery'));
$t->set_var('add_action',$phpgw->link('/ck-inv/gdadd.php',"filter=$filter"));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_dn',lang('Delivery Note'));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-inv/gdlist.php',lang('GD Date')));
$t->set_var('sort_customer',$nm->show_sort_order($sort,'name',$order,'/ck-inv/gdlist.php',lang('Customer')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,'/ck-inv/gdlist.php',lang('Source Info')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-inv/gdlist.php',lang('Description')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-inv/gdlist.php',lang('Audit Id')));

$sql =  "SELECT transdate,name,source,description,a.id as id from il a,customer b $where and a.to_from=b.id order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found") ,
				'customer'	=> "",
				'source'	=> "",
				'description'	=> "",
				'id'		=> "",
				'view'		=> "",
				'dn'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('gd_section','gd_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'customer'	=> $phpgw->db->f('name'),
				'source'	=> $phpgw->db->f('source'),
	       	    		'description'	=> $phpgw->db->f('description'),
				'id'		=> $phpgw->db->f('id'),
				'view'		=> $phpgw->link('/ck-inv/gdview.php',$getstr),
				'dn'		=> $phpgw->link('/ck-inv/gddn.php',$getstr),
				'edit'		=> $phpgw->link('/ck-inv/gdedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-inv/gdcopy.php',$getstr),
				'delete'	=> $phpgw->link('/ck-inv/gddelete.php',$getstr) ));
	if (substr($phpgw->db->f('source'),0,2)=="CS") {
		$t->set_var(array(	'lang_edit'	=> "",
					'lang_copy'	=> "",
					'lang_reverse'	=> "",
					'lang_delete'	=> "",
					'edit'		=> "",
					'copy'		=> "",
					'reverse'	=> "",
					'delete'	=> "")) ;
		}
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('gd_section','gd_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','gd','report');

?>
