<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: iafilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-inv',  'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$source = ($_GET["source"]) ? $_GET["source"] : $_POST["source"] ;
	$description = ($_GET["description"]) ? $_GET["description"] : $_POST["description"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among posted Inventory Adjustments (IA) :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Inventory Adjustment Detail --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));
$filter = array (	cond2		=>	lang('Inventory Adjustment Date (from)') ,
			condvar2	=>	'from' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Must be a valid date (format: YYYY-MM-DD)'),
			cond3		=>	lang('Inventory Adjustment Date (to)') ,
			condvar3	=>	'to' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date (format: YYYY-MM-DD)') ,
			cond4		=>	lang('Source') ,
			condvar4	=>	'source' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for target key word in the IA source field') ,
			cond5		=>	lang('Description') ,
			condvar5	=>	'description' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for target key word in the IA description field') ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault2"] = $from ;
	$filter["conddefault3"]	= $to ;
	$filter["conddefault4"] = $source ;
	$filter["conddefault5"] = $description ;
	}

$t->set_var('select_section',"");
For ($i=2;isset($filter['cond'.$i]);$i++)	{
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-inv/iafilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-inv/iaadd.php')) ;
	$t->set_var('lang_add',lang('Add New Inventory Adjustment'));
	$t->pparse('out','report',True);

?>
