<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ialist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-inv', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'ialist.tpl', 'ia'=>'ialist.tpl'));
	$t->set_block('ia','ia_row','ia_section');

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Inventory Adjustment (IA)'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add Inventory Adjustment'));
$t->set_var('add_action',$phpgw->link('/ck-inv/iaadd.php',"filter=$filter"));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_reverse',lang('Reverse'));
$t->set_var('lang_delete',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-inv/ialist.php',lang('IA Date')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,'/ck-inv/ialist.php',lang('Source Info')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-inv/ialist.php',lang('Description')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-inv/ialist.php',lang('Audit Id')));

$sql =  "SELECT * from il $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found") ,
				'source'	=> "",
				'description'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'reverse'	=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('ia_section','ia_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'source'	=> $phpgw->db->f('source'),
				'description'	=> $phpgw->db->f('description'),
				'id'		=> $phpgw->db->f('id'),
				'view'		=> $phpgw->link('/ck-inv/iaview.php',$getstr),
				'edit'		=> $phpgw->link('/ck-inv/iaedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-inv/iacopy.php',$getstr),
				'reverse'	=> $phpgw->link('/ck-inv/iareverse.php',$getstr),
				'delete'	=> $phpgw->link('/ck-inv/iadelete.php',$getstr) ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('ia_section','ia_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','ia','report');

?>
