<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.alternate.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	class alternate {

//---- Alternate Validation Checks

    function alternate_validate($alt,$edit) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	if (!$edit)	{
		$sql =  "SELECT distinct * from alternate where alternate_id=$alt[target]" ;
		$phpgw->db->query($sql);
		if ($phpgw->db->next_record())		$err=lang("Alternate already exists");
		}
	For ($i=1;isset($alt['item'.$i]);$i++) {
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($alt['item'.$i]==$alt[target])	$err=$rowi.lang("Alternate cannot be itself");
		For ($j=1;isset($alt['item'.$j]);$j++) {
			$rowij = "[$row $i/$j]" ;
			if ($alt['item'.$i]==$alt['item'.$j] and $i<>$j)
							$err=$rowij.lang("Duplicative Alternate");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Alternate to Database

    function alternate_post($alt, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $alt[target] ;
	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "new" :	$type = lang("New") ;	$actioned = lang("added") ;	break ;
		case "edit" :	$type = lang("Old") ;	$actioned = lang("updated") ;	break ;
		case "delete" :	$type = lang("Old") ;	$actioned = lang("deleted") ;	break ;
		endswitch ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM alternate WHERE alternate_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($alt['item'.$i]);$i++) {
			$item	= $alt['item'.$i];
			$phpgw->db->query("INSERT INTO alternate (alternate_id,item_id) VALUES ('$id','$item')");
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Alternate for Part") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;

	}

//---- Write Alternate Header

    function alternate_header_write(&$t, $alt, $fixalt) {
	global $phpgw ;

	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_target',lang("Target Part"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$part_list =($fixalt)?part_selectlist("WHERE id='$alt[id]'",''):part_selectlist("",$alt[target]);
	$t->set_var('part_sl',$part_list);
	$t->set_var('id',$alt[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Alternate Detail

    function alternate_detail_write(&$t, $alt, $posted, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_alt',lang('Alternate Part/Service'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_list = item_selectlist("",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($alt['item'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id = $alt['item'.$i] ;
			if (isset($delete) and $i>$rowno) {$j=$i-1;} else {$j=$i;}
			$t->set_var('item_fld','item'.$j) ;
			$t->set_var('option_block',str_replace("'$item_id'","'$item_id' selected",$item_list));
			if ($posted)	$t->set_var('rowno',"done") ;	else	$t->set_var('rowno',$row_.$j) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)		$i=1 ;
	if ($i==1)				$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item'.$i) ;
		$t->set_var('option_block',$item_list);
		$t->set_var('rowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

    }

?>
