<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: inventoryfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'		=> 'ck-inv',
			 	 'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$partnumber = ($_GET["partnumber"]) ? $_GET["partnumber"] : $_POST["partnumber"] ;
	$description = ($_GET["description"]) ? $_GET["description"] : $_POST["description"] ;
	$notes = ($_GET["notes"]) ? $_GET["notes"] : $_POST["notes"] ;
	$bin = ($_GET["bin"]) ? $_GET["bin"] : $_POST["bin"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','filter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among existing Inventory :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Searching Criteria'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));
	$filter = array (	cond1		=>	lang('Name/Number') ,
				condvalue1	=>	'partnumber' ,
				conddefault1	=>	'' ,
				condnote1	=>	lang('Search for target character/numeric combination in the Part Name/# field'),
				cond2		=>	lang('Description') ,
				condvalue2	=>	'description' ,
				conddefault2	=>	'' ,
				condnote2	=>	lang('Search for target key word in the Inventory Description field'),
				cond3		=>	lang('Notes') ,
				condvalue3	=>	'notes' ,
				conddefault3	=>	'' ,
				condnote3	=>	lang('Search for target key word in the Inventory Notes field') ,
				cond4		=>	lang('Bin Location') ,
				condvalue4	=>	'bin' ,
				conddefault4	=>	'' ,
				condnote4	=>	lang('Search for target key word in the Bin Location field') ) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["conddefault1"] = $partnumber ;
		$filter["conddefault2"] = $description ;
		$filter["conddefault3"] = $notes ;
		$filter["conddefault4"] = $bin ;
		}

	For ($i=1;isset($filter['cond'.$i]);$i++)	{
		$t->set_var('condition',$filter['cond'.$i]);
		$t->set_var('value',$filter['condvalue'.$i]);
		$t->set_var('default',$filter['conddefault'.$i]);
		$t->set_var('note',$filter['condnote'.$i]);
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-inv/inventoryfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-inv/inventoryadd.php')) ;
	$t->set_var('lang_add',lang('Add New Inventory'));
	$t->pparse('out','report',True);

?>
