<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: inventoryhist.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp' => 'ck-inv',
			    'enable_nextmatchs_class' => True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','inventoryhist.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View Inventory Balance and In/Out History'));
	$t->set_var('message','') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$db_type = $phpgw_info["server"]["db_type"] ;
	$note1 =lang('Bal - Stock Balance; IA - Inventory Adjustment; GR - Goods Receipt; GD - Goods Delivery; CS - Cash Sale.');
	$note2 =lang('Press (done) button at View Detail screen to go on to transaction maintenance');

	$err="";
	if (isset($start))	{
		if (input2date($start)=="")		$err=lang("Error: Invalid History Start Date");
		$jdstart = mktime(0,0,0,intval(substr($start,5,2)),intval(substr($start,8,2)),intval(substr($start,0,4))) ;
		$today = mktime(0,0,0,date("m"),date("d"),date("Y")) ;
		if ($jdstart>$today)			$err=lang("Error: Start Date > System day") ;
		}
	if ($err)	$err = "<b>$err</b>" ;
	$start = (!$start) ? date("Y-m-d",mktime(0,0,0,date("m")-1,1,date("Y"))) : $start ;

/*------------- Write (Inventory) Header to Screen Display ----------------------------*/

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_number',lang('Part#/Description'));
	$t->set_var('lang_bin',lang('Bin Location'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_note',$note2);

	$phpgw->db->query("SELECT * FROM parts WHERE id='$id'");
	$phpgw->db->next_record();
	$t->set_var('id',$id);
	$t->set_var('partnumber',$phpgw->db->f('partnumber'));
	$t->set_var('bin',$phpgw->db->f('bin'));
	$desc = $phpgw->db->f('partnumber')." -- ".$phpgw->db->f('description') ;
	$t->set_var('desc',$desc);
	$t->set_var('notes',$phpgw->db->f('notes'));

/*------------- Write Inventory History to Screen Display ----------------------------*/

	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_type',lang('Type'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_ordnumber',lang('Order Number'));
	$t->set_var('lang_qty_pos',lang('Qty Received<br>/(+ve)Adjusted'));
	$t->set_var('lang_qty_neg',lang('Qty Issued<br>/(-ve)Adjusted'));
	$t->set_var('lang_balance',lang('Balance'));
	$t->set_var('lang_viewdetail',lang('View Detail'));

if ($err=="") {

	$sql = "SELECT sum(qty) as sumqty FROM inv_trans a,il b " ;
	$sql.= "WHERE parts_id=$id and a.trans_id=b.id and a.transdate<'$start'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$t->set_var('date',$start);
	$t->set_var('type',lang("Bal"));
	$t->set_var('description',lang("Beginning Balance"));
	$t->set_var('ordnumber','');
	$t->set_var('qty_pos','');
	$t->set_var('qty_neg','');
	$sumqty = $phpgw->db->f('sumqty') ;
	$sumqty = isset($sumqty) ? $sumqty : 0 ;
	$t->set_var('balance',$sumqty);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);

	$iasql = "SELECT a.transdate,source,description,'' as ordnumber,qty,trans_id FROM inv_trans a,il b ";
	$iasql.= "WHERE parts_id=$id and a.trans_id=b.id and substring(source,1,2)='IA' " ;
	$iasql.= "and a.transdate>='$start' " ;
	$posql = "SELECT a.transdate,source,description,ponumber as ordnumber,qty,trans_id FROM inv_trans a,il b,po c ";
	$posql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id " ;
	$posql.= "and a.transdate>='$start' " ;
	$sosql = "SELECT a.transdate,source,description,sonumber as ordnumber,qty,trans_id FROM inv_trans a,il b,so c ";
	$sosql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id " ;
	$sosql.= "and a.transdate>='$start' " ;
	$cssql = "SELECT a.transdate,source,description,'' as ordnumber,qty,trans_id FROM inv_trans a,il b,pos c ";
	$cssql.= "WHERE parts_id=$id and a.trans_id=b.id and order_id=c.id " ;
	$cssql.= "and a.transdate>='$start' " ;

	if ($db_type=="mysql")	{
		$temp = "ihist".time() ;
		$phpgw->db->query("CREATE TABLE $temp AS $posql") ;
		$phpgw->db->query("INSERT INTO $temp $sosql") ;
		$phpgw->db->query("INSERT INTO $temp $iasql") ;
		$phpgw->db->query("INSERT INTO $temp $cssql") ;
		$phpgw->db->query("SELECT * from $temp ORDER BY transdate") ;
		}
	    else {
		$sql = "$iasql UNION $sosql UNION $posql UNION $cssql ORDER BY transdate" ;
		$phpgw->db->query($sql);
		}
	$balance = $sumqty ;
	while ($phpgw->db->next_record()) {
		$t->set_var('date',$phpgw->db->f('transdate'));
		$t->set_var('type',substr($phpgw->db->f('source'),0,2));
		$t->set_var('description',$phpgw->db->f('description'));
		$t->set_var('ordnumber',$phpgw->db->f('ordnumber'));
		$qty = $phpgw->db->f('qty') ;
		if ($qty>=0) {
			$t->set_var('qty_pos',$qty);
			$t->set_var('qty_neg',".");
			}
		  else {
			$t->set_var('qty_pos',".");
			$t->set_var('qty_neg',$qty);
			}
		$balance += $qty ;

		$t->set_var('balance',$balance);
		$transcode = substr($phpgw->db->f('source'),0,4);
		$trans_id = $phpgw->db->f('trans_id');
		$ifilter = urlencode(" WHERE id=$trans_id ") ;
		$afilter = urlencode(" WHERE a.id=$trans_id ") ;
		switch ($transcode) :
			case "IA" :	$jscript = $oscript = "/ck-inv/iaview.php" ;
					$jfilter = $ofilter = $ifilter ;		break ;
			case "GR" :	$jscript = $oscript = "/ck-inv/grview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "GD" :	$jscript = $oscript = "/ck-inv/gdview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "CSNT" :	$jscript = "/ck-inv/gdview.php" ;
					$oscript = "/ck-pos-c/csntview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			case "CSWT" :	$jscript = "/ck-inv/gdview.php" ;
					$oscript = "/ck-pos-c/cswtview.php" ;
					$jfilter = $ofilter = $afilter ;		break ;
			default : 	$script = "error" ;				break ;
			endswitch ;
		$t->set_var('journal',$phpgw->link("$jscript","id=$trans_id&filter=$jfilter"));
		$t->set_var('lang_journal',lang("Inv Tran"));
		$t->set_var('origin',$phpgw->link("$oscript","id=$trans_id&filter=$ofilter"));
		$t->set_var('lang_origin',lang("Origin"));
		if ($script=="error")	{
			$t->set_var('origin',"");
			$t->set_var('lang_origin',"<b>".lang("Error")."</b>");
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('type',lang("Bal"));
	$t->set_var('description',lang("Current Balance"));
	$t->set_var('ordnumber','');
	$t->set_var('qty_pos','');
	$t->set_var('qty_neg','');
	$t->set_var('balance',$balance);
	$t->set_var('journal',"");
	$t->set_var('lang_journal',"");
	$t->set_var('origin',"");
	$t->set_var('lang_origin',"");
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	if ($db_type=="mysql")		$phpgw->db->query("DROP TABLE $temp") ;
	}

else {
	$note1 = $err ;
	$t->set_var('detail_section',"") ;
	}

/*--------------------Write bottom Section------------------------------------------*/

	$filter=urlencode(stripslashes($filter));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_note2',$note2);
	$t->set_var('lang_start',lang('History Start Date'));
	$t->set_var('start',$start);
	$t->set_var('lang_regenerate',lang('Regenerate (after changing History Start Date)'));
	$t->set_var('regenerate_action',$phpgw->link('/ck-inv/inventoryhist.php',"id=$id&filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-inv/inventorylist.php',"filter=$filter")) ;
	$t->pparse('out','report',True);

?>
