<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminbuild.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"]["currentapp"] = 'ck-ledadmin';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$chart = ($_GET["chart"]) ? $_GET["chart"] : $_POST["chart"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$t->set_file('report','confirm.tpl');
	$db_type = $phpgw_info["server"]["db_type"] ;

/*---------------------------------------------------------------------------------*/

	$sqlchart = "insert into chart (id,accno,description,charttype,gifi,category,link) values " ;
	$sqlhrcode = "insert into hrcode (id,type,name,description) values " ;
	$sqlvend = "insert into vendor (id,name,contact,notes,taxincluded) values ";
	$sqlcust = "insert into customer (id,name,contact,notes,taxincluded) values ";
	$sqltax = "insert into tax (id,chart_id,rate,taxnumber,taxgroup) values " ;
	$sqlqc = "insert into qcash (id,name,value,minsale,maxsale,minqty,maxqty,minvalue,maxvalue," ;
	$sqlqc.= 	"posacc_id,start,endd,splan_id,notes) values " ;
	$sqlremark = "insert into remark (id,name,detail) values " ;
	$sqldef = "insert into defaults (company,addr1,addr2,addr3,addr4,contact," ;
	$sqldef.= 	"inventory_accno_id,income_accno_id,expense_accno_id,nativecurr,weightunit," ;
	$sqldef.= 	"yearend,version,inv_rmkid,rmd_rmkid,po_rmkid,quo_rmkid,sm_rmkid," ;
	$sqldef.= 	"aptax1cap,aptax2cap,aptax1pref,aptax2pref," ;
	$sqldef.= 	"artax1cap,artax2cap,artax1pref,artax2pref," ;
	$sqldef.= 	"postax1cap,postax2cap,postax1pref,postax2pref," ;
	$sqldef.=	"attrib1cap,attrib2cap,attrib3cap,attrib1tbl,attrib2tbl," ;
	$sqldef.= 	"attrib3tbl,attrib1sdesc,attrib2sdesc,attrib3sdesc,attrib1ldesc,attrib2ldesc," ;
	$sqldef.= 	"attrib3ldesc,attrib1tblmn,attrib2tblmn,attrib3tblmn,attrib1cnval," ;
	$sqldef.= 	"attrib2cnval,attrib3cnval,photoyn,addressyn,phoneyn,emailyn,ecyn," ;
	$sqldef.=	"mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor) values " ;
	$sqllock = "insert into resourcelock (resource) values " ;
	$sqlachieve = "insert into achievement (id,name,description) values " ;

/*------------------------------------------------------------------------------------*/

	$sid = '10001' ;

	$sqlval	= array (	"1000,'".lang("CURRENT ASSETS")."','H',NULL,'A','')" ,
				"1060,'".lang("Bank Account")."','A',NULL,'A','AR_paid:AP_paid:PY_paid:CS')" ,
				"1065,'".lang("Petty Cash")."','A',NULL,'A','AR_paid:AP_paid:PY_paid:CS')" ,
				"1070,'".lang("Cash at Point of Sale")."','A',NULL,'A','CS')" ,
				"1075,'".lang("Cash in transit")."','A',NULL,'A','CS')" ,
				"1200,'".lang("Accounts Receivables")."','A',NULL,'A','AR:CS')" ,
				"1240,'".lang("Staff Loan Recoverable")."','A',NULL,'A','AR:PY_expense:PY')" ,
				"1290,'".lang("Allowance for doubtful debt")."','A',NULL,'A','')" ,
				"1310,'".lang("CA GST Recoverable")."','A',NULL,'A','AP_tax')" ,
				"1311,'".lang("CA PST Recoverable")."','A',NULL,'A','AP_tax')" ,

				"1500,'".lang("INVENTORY ASSETS")."','H',NULL,'A','')" ,
				"1520,'".lang("Inventory / Hardware")."','A',NULL,'A','IC')" ,
				"1530,'".lang("Inventory / Software")."','A',NULL,'A','IC')" ,
				"1540,'".lang("Inventory / Aftermarket Parts")."','A',NULL,'A','IC')" ,
				"1550,'".lang("Inventory / Restaurant Supplies")."','A',NULL,'A','IC')" ,

				"1800,'".lang("CAPITAL ASSETS")."','H',NULL,'A','')" ,
				"1820,'".lang("Office Furniture & Equipment")."','A',NULL,'A','AP_amount')" ,
				"1825,'".lang("Accum. Amort. -Furn. & Equip.")."','A',NULL,'A','')" ,
				"1840,'".lang("Vehicle")."','A',NULL,'A','AP_amount')" ,
				"1845,'".lang("Accum. Amort. -Vehicle")."','A',NULL,'A','')" ,
				
				"2000,'".lang("CURRENT LIABILITIES")."','H',NULL,'L','')" ,
				"2100,'".lang("Accounts Payable")."','A',NULL,'L','AP')" ,
				"2130,'".lang("Staff Salary Payable")."','A',NULL,'L','PY')" ,
				"2160,'".lang("Corporate Taxes Payable")."','A',NULL,'L','')" ,
				"2190,'".lang("Individual Income Tax Payable")."','A',NULL,'L','PY')" ,
				"2210,'".lang("Workers Comp Payable")."','A',NULL,'L','PY')" ,
				"2220,'".lang("Vacation Pay Payable")."','A',NULL,'L','PY')" ,
				"2250,'".lang("Pension Plan Payable")."','A',NULL,'L','PY')" ,
				"2260,'".lang("Employment Insurance Payable")."','A',NULL,'L','PY')" ,
				"2280,'".lang("Payroll Taxes Payable")."','A',NULL,'L','PY')" ,
				"2310,'".lang("CA GST Payable")."','A',NULL,'L','AR_tax:CS_tax')" ,
				"2311,'".lang("CA PST Payable")."','A',NULL,'L','AR_tax:CS_tax')" ,
				"2319,'".lang("Local VAT Payable")."','A',NULL,'L','AR_tax:CS_tax')" ,
				
				"2600,'".lang("LONG TERM LIABILITIES")."','H',NULL,'L','')" ,
				"2620,'".lang("Bank Loans")."','A',NULL,'L','')" ,
				"2680,'".lang("Loans from Shareholders")."','A',NULL,'L','')" ,

				"3300,'".lang("SHARE CAPITAL")."','H',NULL,'Q','')" ,
				"3350,'".lang("Common Shares")."','A',NULL,'Q','')" ,
				"3360,'".lang("Fund Balance")."','A',NULL,'Q','')" ,
				"3500,'".lang("RETAINED EARNINGS")."','H',NULL,'Q','')" ,
				"3590,'".lang("Retained Earnings - prior years")."','A',NULL,'Q','')" ,
				"3600,'".lang("Current Earnings")."','A',NULL,'Q','')" ,

				"4000,'".lang("SALES REVENUE")."','H',NULL,'I','')" ,
				"4020,'".lang("Sales / Hardware")."','A',NULL,'I','AR_amount:IC_sale')" ,
				"4030,'".lang("Sales / Software")."','A',NULL,'I','AR_amount:IC_sale')" ,
				"4040,'".lang("Sales / Aftermarket Parts")."','A',NULL,'I','AR_amount:IC_sale')" ,

				"4300,'".lang("CONSULTING REVENUE")."','H',NULL,'I','')" ,
				"4320,'".lang("Consulting")."','A',NULL,'I','AR_amount:SV_income')" ,
				"4330,'".lang("Programming")."','A',NULL,'I','AR_amount:SV_income')" ,

				"4400,'".lang("OTHER REVENUE")."','H',NULL,'I','')" ,
				"4410,'".lang("Sales / Restaurant")."','A',NULL,'I','AR_amount:SV_income')" ,
				"4430,'".lang("Shipping & Handling")."','A',NULL,'I','AR_amount:SV_income')" ,
				"4435,'".lang("Service Charge")."','A',NULL,'I','AR_amount:SV_income')" ,
				"4440,'".lang("Interest")."','A',NULL,'I','AR_amount:SV_income')" ,
				"4450,'".lang("Foreign Exchange Gain")."','A',NULL,'I','FX_gain')" ,
				"4699,'".lang("Miscellaneous Income")."','A',NULL,'I','AR_amount:SV_income')" ,

				"5000,'".lang("COST OF GOODS SOLD")."','H',NULL,'E','')" ,
				"5010,'".lang("Purchases")."','A',NULL,'E','AP_amount:IC_cogs:SV_expense')" ,
				"5020,'".lang("COGS / Hardware")."','A',NULL,'E','AP_amount:IC_cogs')" ,
				"5030,'".lang("COGS / Software")."','A',NULL,'E','AP_amount:IC_cogs')" ,
				"5040,'".lang("COGS / Aftermarket Parts")."','A',NULL,'E','AP_amount:IC_cogs')" ,
				"5100,'".lang("Freight")."','A',NULL,'E','AP_amount:SV_expense')" ,

				"5400,'".lang("PAYROLL EXPENSES")."','H',NULL,'E','')" ,
				"5410,'".lang("Wages & Salaries")."','A',NULL,'E','PY_expense')" ,
				"5420,'".lang("Employment Insurance Expense")."','A',NULL,'E','PY_expense')",
				"5430,'".lang("Pension Plan Expense")."','A',NULL,'E','PY_expense')" ,
				"5440,'".lang("Workers Compensation Expense")."','A',NULL,'E','PY_expense')" ,
				"5470,'".lang("Employee Benefits")."','A',NULL,'E','PY_expense')" ,

				"5600,'".lang("GENERAL & ADMINISTRATIVE EXPENSES")."','H',NULL,'E','')" ,
				"5610,'".lang("Sales Commission")."','A',NULL,'E','AP_amount:PY_expense')" ,
				"5613,'".lang("Sales Discount")."','A',NULL,'E','AP_amount:SV_expense:CS')" ,
				"5620,'".lang("Accounting & Legal")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5630,'".lang("Advertising & Promotions")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5640,'".lang("Bad Debts")."','A',NULL,'E','')" ,
				"5650,'".lang("Capital Cost Allowance Expense")."','A',NULL,'E','')" ,
				"5660,'".lang("Amortization Expense")."','A',NULL,'E','')" ,
				"5680,'".lang("Income Taxes")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5685,'".lang("Insurance")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5690,'".lang("Interest & Bank Charges")."','A',NULL,'E','SV_expense')" ,
				"5700,'".lang("Office Supplies")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5710,'".lang("Restaurant Supplies")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5760,'".lang("Rent")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5765,'".lang("Repair & Maintenance")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5780,'".lang("Telephone")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5781,'".lang("Internet")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5785,'".lang("Travel & Entertainment")."','A',NULL,'E','AP_amount:SV_expense:PY_expense')" ,
				"5790,'".lang("Utilities")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5795,'".lang("Registrations")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5800,'".lang("Licenses")."','A',NULL,'E','AP_amount:SV_expense')" ,
				"5810,'".lang("Foreign Exchange Loss")."','A',NULL,'E','FX_loss')" ,
				"5899,'".lang("Miscellaneous Expense")."','A',NULL,'E','AP_amount:SV_expense:PY_expense')" ,
				"9001,'".lang("Suspense Account")."','A',NULL,'E','')",
					) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlchart ('$sid',$sqlv");
		$sid++;
		}
	
	$phpgw->db->query("UPDATE chart set gifi=0");	

	$accno	= "select id from chart where accno" ;
	$phpgw->db->query("$accno=1060"); $phpgw->db->next_record(); $ac1060=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1070"); $phpgw->db->next_record(); $ac1070=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1075"); $phpgw->db->next_record(); $ac1075=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1200"); $phpgw->db->next_record(); $ac1200=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1310"); $phpgw->db->next_record(); $ac1310=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1311"); $phpgw->db->next_record(); $ac1311=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=1520"); $phpgw->db->next_record(); $ac1520=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=2310"); $phpgw->db->next_record(); $ac2310=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=2311"); $phpgw->db->next_record(); $ac2311=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=2319"); $phpgw->db->next_record(); $ac2319=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=4020"); $phpgw->db->next_record(); $ac4020=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=5020"); $phpgw->db->next_record(); $ac5020=$phpgw->db->f('id') ;
	$phpgw->db->query("$accno=5613"); $phpgw->db->next_record(); $ac5613=$phpgw->db->f('id') ;

/*------------------------------------------------------------------------------------*/

	$sqlval	= array (	"'".lang('prefix')."','Mr','".lang('Mr')."')" ,
				"'".lang('prefix')."','Ms','".lang('Ms')."')" ,
				"'".lang('prefix')."','Sr','".lang('Senor')."')" ,
				"'".lang('prefix')."','Sra','".lang('Senorita')."')" ,

				"'".lang('suffix')."','esp','".lang('Esquire')."')" ,
				"'".lang('suffix')."','khan','".lang('Khan')."')" ,
				"'".lang('suffix')."','san','".lang('San')."')" ,

				"'".lang('grade')."','BD','".lang('Board of Directors')."')" ,
				"'".lang('grade')."','CEO','".lang('Chief Executive Officer')."')" ,
				"'".lang('grade')."','P','".lang('President')."')" ,
				"'".lang('grade')."','VP','".lang('Vice President')."')" ,
				"'".lang('grade')."','DVP','".lang('Deputy Vice President')."')" ,

				"'".lang('date')."','BA','".lang('Birthday Anniversary')."')" ,
				"'".lang('date')."','BD','".lang('Birthday')."')" ,
				"'".lang('date')."','C1','".lang('Contract 1 ends')."')" ,
				"'".lang('date')."','C2','".lang('Contract 2 ends')."')" ,
				"'".lang('date')."','HD','".lang('Hire Day')."')" ,
				"'".lang('date')."','PC','".lang('Probation Completion')."')" ,
				"'".lang('date')."','P1','".lang('Performance Review Date 1')."')" ,
				"'".lang('date')."','P2','".lang('Performance Review Date 2')."')" ,
				"'".lang('date')."','S1','".lang('Salary Review Date 1')."')" ,
				"'".lang('date')."','S2','".lang('Salary Review Date 2')."')" ,
				"'".lang('date')."','TD','".lang('Termination Date')."')" ,

				"'".lang('leave')."','AL','".lang('Annual Leave')."')" ,
				"'".lang('leave')."','CL','".lang('Compationate Leave')."')" ,
				"'".lang('leave')."','JI','".lang('Leave due to Job Injury')."')" ,
				"'".lang('leave')."','JS','".lang('Jury Service')."')" ,
				"'".lang('leave')."','ML','".lang('Maternity Leave')."')" ,
				"'".lang('leave')."','SL','".lang('Sick Leave')."')" ,
				"'".lang('leave')."','UA','".lang('Unauthorised Absence')."')" ,
				"'".lang('leave')."','UL','".lang('Unpaid Leave')."')" ,

				"'".lang('address')."','HD','".lang('Home (Domestic)')."')" ,
				"'".lang('address')."','HI','".lang('Home (International)')."')" ,
				"'".lang('address')."','PA','".lang('Parcel')."')" ,
				"'".lang('address')."','PO','".lang('Postal')."')" ,

				"'".lang('zip')."','00000','".lang('N/A')."')" ,

				"'".lang('phone')."','P1PD','".lang('Phone (Business - Direct)')."')" ,
				"'".lang('phone')."','P2PM','".lang('Phone (Business - Message)')."')" ,
				"'".lang('phone')."','P3MO','".lang('Phone (Mobile)')."')" ,
				"'".lang('phone')."','P4PA','".lang('Pager')."')" ,
				"'".lang('phone')."','P5PH','".lang('Phone (Home)')."')" ,
				"'".lang('phone')."','P6FB','".lang('Fax (Business)')."')" ,
				"'".lang('phone')."','P7FH','".lang('Fax (Home)')."')" ,
				"'".lang('phone')."','P8PI','".lang('Phone (ISDN)')."')" ,
				"'".lang('phone')."','P9PV','".lang('Phone (Video)')."')" ,

				"'".lang('relation')."','PA','".lang('Parent')."')" ,
				"'".lang('relation')."','BS','".lang('Brother/Sister')."')" ,
				"'".lang('relation')."','CH','".lang('Child')."')" ,
				"'".lang('relation')."','GP','".lang('Grand Parent')."')" ,
				"'".lang('relation')."','GC','".lang('Grand Child')."')" ,
				"'".lang('relation')."','UA','".lang('Uncle/Aunt')."')" ,
				"'".lang('relation')."','CS','".lang('Cousin')."')" ,
				"'".lang('relation')."','FM','".lang('Other Family Member')."')" ,
				"'".lang('relation')."','NB','".lang('Neighbour')."')" ,

				"'".lang('ec')."','EC1','".lang('Emergency Contact 1')."')" ,
				"'".lang('ec')."','EC2','".lang('Emergency Contact 2')."')" ,
				"'".lang('ec')."','EC3','".lang('Emergency Contact 3')."')" ,
				"'".lang('ec')."','NK','".lang('Next of Kin')."')" ,

				"'".lang('pr')."','PR0','".lang('Awful - Warning TBC')."')" ,
				"'".lang('pr')."','PR1','".lang('Very Poor')."')" ,
				"'".lang('pr')."','PR2','".lang('Poor')."')" ,
				"'".lang('pr')."','PR3','".lang('Undesirable')."')" ,
				"'".lang('pr')."','PR4','".lang('Below Par')."')" ,
				"'".lang('pr')."','PR5','".lang('Acceptable')."')" ,
				"'".lang('pr')."','PR6','".lang('Fine')."')" ,
				"'".lang('pr')."','PR7','".lang('Good')."')" ,
				"'".lang('pr')."','PR8','".lang('Very Good')."')" ,
				"'".lang('pr')."','PR9','".lang('Excellent - Award TBC')."')" ,

				"'".lang('email')."','BUSI','".lang('Email (Business)')."')",
				"'".lang('email')."','PRIV','".lang('Email (Private)')."')",
				"'".lang('email')."','PROJ','".lang('Email (Project)')."')",

				"'".lang('role')."','SysAdm','".lang('System Administrator')."')" ,
				"'".lang('role')."','AccAdm','".lang('Accounting Administrator')."')" ,
				"'".lang('role')."','AccMgr','".lang('Accounting Manager')."')" ,
				"'".lang('role')."','InvAdm','".lang('Inventory Administrator')."')" ,
				"'".lang('role')."','InvMgr','".lang('Inventory Manager')."')" ,
				"'".lang('role')."','SvcAdm','".lang('Service Administrator')."')" ,
				"'".lang('role')."','SvcMgr','".lang('Service Manager')."')" ,
				"'".lang('role')."','APAdm','".lang('Accounts Payable Administrator')."')" ,
				"'".lang('role')."','APMgr','".lang('Accounts Payable Manager')."')" ,
				"'".lang('role')."','ARAdm','".lang('Accounts Receivable Administrator')."')" ,
				"'".lang('role')."','ARMgr','".lang('Accounts Receivable Manager')."')" ,
				"'".lang('role')."','PurAdm','".lang('Purchasing Administrator')."')" ,
				"'".lang('role')."','PurMgr','".lang('Purchasing Manager')."')" ,
				"'".lang('role')."','SalAdm','".lang('Sales Administrator')."')" ,
				"'".lang('role')."','SalMgr','".lang('Sales Manager')."')" ,
				"'".lang('role')."','CSAdm','".lang('Cash Sale Administrator - Cashier')."')" ,
				"'".lang('role')."','CSMgr','".lang('Cash Sale Manager')."')" ,
				"'".lang('role')."','HRAdm','".lang('Human Resources Administrator')."')" ,
				"'".lang('role')."','HRMgr','".lang('Human Resources Manager')."')" ,
				"'".lang('role')."','PyrAdm','".lang('Payroll Administrator')."')" ,
				"'".lang('role')."','PyrMgr','".lang('Payroll Manager')."')"

													) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$sqlval	= array (
	"'".lang('country')."','AS','".lang('American Samoa')."')" ,			"'".lang('country')."','AI','".lang('Anguilla')."')" ,
	"'".lang('country')."','AQ','".lang('Antarctica')."')" ,			"'".lang('country')."','AG','".lang('Antigua and Barbuda')."')" ,
	"'".lang('country')."','EG','".lang('Arab Republic of Egypt')."')" ,		"'".lang('country')."','AR','".lang('Argentine Republic')."')" ,
	"'".lang('country')."','AW','".lang('Aruba')."')" ,				"'".lang('country')."','AU','".lang('Australia')."')" ,
	"'".lang('country')."','AZ','".lang('Azerbaijani Republic')."')" ,

	"'".lang('country')."','BB','".lang('Barbados')."')" ,				"'".lang('country')."','BZ','".lang('Belize')."')" ,
	"'".lang('country')."','BM','".lang('Bermuda')."')" ,				"'".lang('country')."','BV','".lang('Bouvet Island')."')" ,
	"'".lang('country')."','IO','".lang('British Indian Ocean Territory')."')" ,	"'".lang('country')."','BN','".lang('Brunei Darussalam')."')" ,
	"'".lang('country')."','BF','".lang('Burkina Faso (Upper Volta)')."')" ,

	"'".lang('country')."','CA','".lang('Canada')."')" ,				"'".lang('country')."','KY','".lang('Cayman Islands')."')" ,
	"'".lang('country')."','CF','".lang('Central African Republic')."')" ,		"'".lang('country')."','CX','".lang('Christmas Island')."')" ,
	"'".lang('country')."','CC','".lang('Cocos (Keeling) Islands')."')" ,		"'".lang('country')."','DM','".lang('Commonwealth of Dominica')."')" ,
	"'".lang('country')."','BS','".lang('Commonwealth of the Bahamas')."')",	"'".lang('country')."','MP','".lang('Commonwealth of the North Mariana Islands')."')" ,
	"'".lang('country')."','CK','".lang('Cook Islands')."')" ,			"'".lang('country')."','CZ','".lang('Czech Republic')."')" ,

	"'".lang('country')."','KP','".lang("Democratic People\'s Republic of Korea (North Korea)")."')" ,
	"'".lang('country')."','ST','".lang('Democratic Republic of Sao Tome and Principe')."')" ,
	"'".lang('country')."','CD','".lang('Democratic Republic of the Congo (Zaire)')."')" ,
	"'".lang('country')."','LK','".lang('Democratic Socialist Republic of Sri Lanka')."')" ,
	"'".lang('country')."','DO','".lang('Dominican Republic')."')" ,

	"'".lang('country')."','TP','".lang('East Timor')."')" ,			"'".lang('country')."','UY','".lang('Eastern Republic of Uruguay')."')" ,
	"'".lang('country')."','ER','".lang('Eritrea')."')" ,				"'".lang('country')."','ET','".lang('Ethiopia')."')" ,

	"'".lang('country')."','FO','".lang('Faeroe Islands')."')" ,			"'".lang('country')."','FK','".lang('Falkland Islands (Malvinas)')."')" ,
	"'".lang('country')."','DE','".lang('Federal Republic of Germany')."')",
	"'".lang('country')."','YU','".lang('Federal Republic of Yugoslavia (Serbia and Montenegro)')."')" ,
	"'".lang('country')."','FM','".lang('Federated States of Micronesia')."')" ,	"'".lang('country')."','BR','".lang('Federative Republic of Brazil')."')" ,
	"'".lang('country')."','MK','".lang('Former Yugoslav Republic of Macedonia')."')",
	"'".lang('country')."','FX','".lang('France, Metropolitan')."')" ,		"'".lang('country')."','GF','".lang('French Guiana')."')" ,
	"'".lang('country')."','PF','".lang('French Polynesia')."')" ,			"'".lang('country')."','FR','".lang('French Republic')."')" ,
	"'".lang('country')."','TF','".lang('French Southern Territories')."')" ,

	"'".lang('country')."','GA','".lang('Gabonese Republic')."')" ,			"'".lang('country')."','GI','".lang('Gibraltar')."')" ,
	"'".lang('country')."','LU','".lang('Grand Duchy of Luxembourg')."')" ,		"'".lang('country')."','GL','".lang('Greenland')."')" ,
	"'".lang('country')."','GD','".lang('Grenada')."')" ,				"'".lang('country')."','GP','".lang('Guadeloupe')."')" ,
	"'".lang('country')."','GU','".lang('Guam')."')" ,

	"'".lang('country')."','JO','".lang('Hashemite Kingdom of Jordan')."')" ,	"'".lang('country')."','HM','".lang('Heard and McDonald Islands')."')" ,
	"'".lang('country')."','GR','".lang('Hellenic Republic (Greece)')."')" ,	"'".lang('country')."','VA','".lang('Holy See (Vatican City State)')."')" ,
	"'".lang('country')."','HK','".lang('Hong Kong, China')."')" ,

	"'".lang('country')."','WS','".lang('Independent State of Samoa')."')" ,	"'".lang('country')."','IE','".lang('Ireland')."')" ,
	"'".lang('country')."','KM','".lang('Islamic Federal Republic of the Comoros')."')" ,
	"'".lang('country')."','IR','".lang('Islamic Republic of Iran')."')" ,		"'".lang('country')."','MR','".lang('Islamic Republic of Mauritania')."')" ,
	"'".lang('country')."','PK','".lang('Islamic Republic of Pakistan')."')" ,	"'".lang('country')."','AF','".lang('Islamic State of Afganistan')."')" ,
	"'".lang('country')."','IT','".lang('Italian Republic')."')" ,			"'".lang('country')."','JM','".lang('Jamaica')."')" ,
	"'".lang('country')."','JP','".lang('Japan')."')" ,

	"'".lang('country')."','BE','".lang('Kingdom of Belgium')."')" ,		"'".lang('country')."','BT','".lang('Kingdom of Bhutan')."')" ,
	"'".lang('country')."','KH','".lang('Kingdom of Cambodia')."')" ,		"'".lang('country')."','DK','".lang('Kingdom of Denmark')."')" ,
	"'".lang('country')."','LS','".lang('Kingdom of Lesotho')."')" ,		"'".lang('country')."','MA','".lang('Kingdom of Morocco')."')" ,
	"'".lang('country')."','NP','".lang('Kingdom of Nepal')."')" ,			"'".lang('country')."','NO','".lang('Kingdom of Norway')."')" ,
	"'".lang('country')."','SA','".lang('Kingdom of Saudi Arabia')."')" ,		"'".lang('country')."','ES','".lang('Kingdom of Spain')."')" ,
	"'".lang('country')."','SZ','".lang('Kingdom of Swaziland')."')" ,		"'".lang('country')."','SE','".lang('Kingdom of Sweden')."')" ,
	"'".lang('country')."','TH','".lang('Kingdom of Thailand')."')" ,		"'".lang('country')."','NL','".lang('Kingdom of the Netherlands')."')" ,
	"'".lang('country')."','TO','".lang('Kingdom of Tonga')."')" ,			"'".lang('country')."','KI','".lang('Kiribati')."')" ,
	"'".lang('country')."','KG','".lang('Kyrgyz Republic (Kyrgyzstan)')."')" ,	"'".lang('country')."','LA','".lang("Lao People\'s Democratic Republic(Laos)")."')" ,
	"'".lang('country')."','LB','".lang('Lebanese Republic')."')"
													) ;
	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$sqlval	= array (
	"'".lang('country')."','MO','".lang('Macau')."')" ,				"'".lang('country')."','MY','".lang('Malaysia')."')" ,
	"'".lang('country')."','MQ','".lang('Martinique')."')" ,			"'".lang('country')."','YT','".lang('Mayotte')."')" ,
	"'".lang('country')."','MN','".lang('Mongolia')."')" ,				"'".lang('country')."','MS','".lang('Montserrat')."')" ,
	"'".lang('country')."','AN','".lang('Netherlands Antilles')."')" ,		"'".lang('country')."','NC','".lang('New Caledonia')."')" ,
	"'".lang('country')."','NZ','".lang('New Zealand')."')" ,			"'".lang('country')."','NU','".lang('Niue')."')" ,
	"'".lang('country')."','NF','".lang('Norfolk Island')."')" ,

	"'".lang('country')."','PG','".lang('Papua New Guinea')."')" ,			"'".lang('country')."','DZ','".lang("People\'s Democratic Republic of Algeria")."')" ,
	"'".lang('country')."','BD','".lang("People\'s Republic of Bangladesh")."')" ,	"'".lang('country')."','CN','".lang("People\'s Republic of China")."')" ,
	"'".lang('country')."','PN','".lang('Pitcairn')."')" ,				"'".lang('country')."','PT','".lang('Portuguese Republic')."')" ,
	"'".lang('country')."','AD','".lang('Principality of Andorra')."')" ,		"'".lang('country')."','LI','".lang('Principality of Liechtenstein')."')" ,
	"'".lang('country')."','MC','".lang('Principality of Monaco')."')" ,		"'".lang('country')."','PR','".lang('Puerto Rico')."')" ,

	"'".lang('country')."','RE','".lang('Reunion Island')."')" ,			"'".lang('country')."','AL','".lang('Republic of Albania')."')" ,
	"'".lang('country')."','AO','".lang('Republic of Angola')."')" ,		"'".lang('country')."','AM','".lang('Republic of Armenia')."')" ,
	"'".lang('country')."','AT','".lang('Republic of Austria')."')" ,		"'".lang('country')."','BY','".lang('Republic of Belarus')."')" ,
	"'".lang('country')."','BJ','".lang('Republic of Benin')."')" ,			"'".lang('country')."','BO','".lang('Republic of Bolivia')."')" ,
	"'".lang('country')."','BA','".lang('Republic of Bosnia-Hercegovina')."')" ,	"'".lang('country')."','BW','".lang('Republic of Botswana')."')" ,
	"'".lang('country')."','BG','".lang('Republic of Bulgaria')."')" ,		"'".lang('country')."','BI','".lang('Republic of Burundi')."')" ,
	"'".lang('country')."','CM','".lang('Republic of Cameroon')."')" ,		"'".lang('country')."','CV','".lang('Republic of Cape Verde')."')" ,
	"'".lang('country')."','TD','".lang('Republic of Chad')."')" ,			"'".lang('country')."','CL','".lang('Republic of Chile')."')" ,
	"'".lang('country')."','CO','".lang('Republic of Colombia')."')" ,		"'".lang('country')."','CR','".lang('Republic of Costa Rica')."')" ,
	"'".lang('country')."','CI','".lang("Republic of Cote d\'Ivoire (Ivory Coast)")."')" ,
	"'".lang('country')."','HR','".lang('Republic of Croatia')."')" ,
	"'".lang('country')."','CU','".lang('Republic of Cuba')."')" ,			"'".lang('country')."','CY','".lang('Republic of Cyprus')."')" ,
	"'".lang('country')."','DJ','".lang('Republic of Djibouti')."')" ,		"'".lang('country')."','EC','".lang('Republic of Ecuador')."')" ,
	"'".lang('country')."','SV','".lang('Republic of El Salvador')."')" ,		"'".lang('country')."','GQ','".lang('Republic of Equatorial Guinea')."')" ,
	"'".lang('country')."','EE','".lang('Republic of Estonia')."')" ,		"'".lang('country')."','FJ','".lang('Republic of Fiji')."')" ,
	"'".lang('country')."','FI','".lang('Republic of Finland')."')" ,		"'".lang('country')."','GE','".lang('Republic of Georgia')."')" ,
	"'".lang('country')."','GH','".lang('Republic of Ghana')."')" ,			"'".lang('country')."','GT','".lang('Republic of Guatemala')."')" ,
	"'".lang('country')."','GN','".lang('Republic of Guinea')."')" ,		"'".lang('country')."','GW','".lang('Republic of Guinea-Bissau')."')" ,
	"'".lang('country')."','GY','".lang('Republic of Guyana')."')" ,		"'".lang('country')."','HT','".lang('Republic of Haiti')."')" ,
	"'".lang('country')."','HN','".lang('Republic of Hondura')."')" ,		"'".lang('country')."','HU','".lang('Republic of Hungary')."')" ,
	"'".lang('country')."','IS','".lang('Republic of Iceland')."')" ,		"'".lang('country')."','IN','".lang('Republic of India')."')" ,
	"'".lang('country')."','ID','".lang('Republic of Indonesia')."')" ,		"'".lang('country')."','IQ','".lang('Republic of Iraq')."')" ,
	"'".lang('country')."','KZ','".lang('Republic of Kazakhstan')."')" ,		"'".lang('country')."','KE','".lang('Republic of Kenya')."')" ,
	"'".lang('country')."','KR','".lang('Republic of Korea (South Korea)')."')" ,	"'".lang('country')."','LV','".lang('Republic of Latvia')."')" ,
	"'".lang('country')."','LR','".lang('Republic of Liberia')."')" ,		"'".lang('country')."','LT','".lang('Republic of Lithuania')."')" ,
	"'".lang('country')."','MG','".lang('Republic of Madagascar')."')" ,		"'".lang('country')."','MW','".lang('Republic of Malawi')."')" ,
	"'".lang('country')."','MV','".lang('Republic of Maldives')."')" ,		"'".lang('country')."','ML','".lang('Republic of Mali')."')" ,
	"'".lang('country')."','MT','".lang('Republic of Malta')."')" ,			"'".lang('country')."','MU','".lang('Republic of Mauritius')."')" ,
	"'".lang('country')."','MD','".lang('Republic of Moldova')."')" ,		"'".lang('country')."','MZ','".lang('Republic of Mozambique')."')" ,
	"'".lang('country')."','NA','".lang('Republic of Namibia')."')" ,		"'".lang('country')."','NR','".lang('Republic of Nauru')."')" ,
	"'".lang('country')."','NI','".lang('Republic of Nicaragua')."')" ,		"'".lang('country')."','NG','".lang('Republic of Nigeria')."')" ,
	"'".lang('country')."','PW','".lang('Republic of Palau')."')" ,			"'".lang('country')."','PA','".lang('Republic of Panama')."')" ,
	"'".lang('country')."','PY','".lang('Republic of Paraguay')."')" ,		"'".lang('country')."','PE','".lang('Republic of Peru')."')" ,
	"'".lang('country')."','PL','".lang('Republic of Poland')."')" ,		"'".lang('country')."','SM','".lang('Republic of San Marino')."')" ,
	"'".lang('country')."','SN','".lang('Republic of Senegal')."')" ,		"'".lang('country')."','SC','".lang('Republic of Seychelles')."')" ,
	"'".lang('country')."','SL','".lang('Republic of Sierra Leone')."')" ,		"'".lang('country')."','SG','".lang('Republic of Singapore')."')" ,
	"'".lang('country')."','SI','".lang('Republic of Slovenia')."')" ,		"'".lang('country')."','ZA','".lang('Republic of South Africa')."')" ,
	"'".lang('country')."','SD','".lang('Republic of Sudan')."')" ,			"'".lang('country')."','SR','".lang('Republic of Suriname')."')" ,
	"'".lang('country')."','TJ','".lang('Republic of Tajikistan')."')" ,		"'".lang('country')."','CG','".lang('Republic of Congo')."')" ,
	"'".lang('country')."','GM','".lang('Republic of Gambia')."')" ,		"'".lang('country')."','MH','".lang('Republic of Marshall Islands')."')" ,
	"'".lang('country')."','NE','".lang('Republic of Niger')."')" ,			"'".lang('country')."','PH','".lang('Republic of Philippines')."')" ,
	"'".lang('country')."','TT','".lang('Republic of Trinidad and Tobago')."')" ,	"'".lang('country')."','TN','".lang('Republic of Tunisia')."')" ,
	"'".lang('country')."','TR','".lang('Republic of Turkey')."')" ,		"'".lang('country')."','UG','".lang('Republic of Uganda')."')" ,
	"'".lang('country')."','UZ','".lang('Republic of Uzbekistan')."')" ,		"'".lang('country')."','VU','".lang('Republic of Vanuatu')."')" ,
	"'".lang('country')."','VE','".lang('Republic of Venezuela')."')" ,		"'".lang('country')."','YE','".lang('Republic of Yemen')."')" ,
	"'".lang('country')."','ZM','".lang('Republic of Zambia')."')" ,		"'".lang('country')."','ZW','".lang('Republic of Zimbabwe')."')" ,
													) ;
	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$sqlval	= array (
	"'".lang('country')."','RO','".lang('Romania')."')" ,				"'".lang('country')."','RU','".lang('Russian Federation')."')" ,
	"'".lang('country')."','RW','".lang('Rwandese Republic')."')" ,			"'".lang('country')."','SH','".lang('Saint Helena')."')" ,
	"'".lang('country')."','KN','".lang('Saint Kitts and Nevis')."')" ,		"'".lang('country')."','LC','".lang('Saint Lucia')."')" ,
	"'".lang('country')."','PM','".lang('Saint Pierre and Miquelon')."')" ,		"'".lang('country')."','VC','".lang('Saint Vincent and the Grenadines')."')" ,
	"'".lang('country')."','SK','".lang('Slovak Republic')."')" ,
	"'".lang('country')."','LY','".lang("Socialist People\'s Libyan Arab Jamahiriya (Libya)")."')" ,
	"'".lang('country')."','VN','".lang('Socialist Republic of Viet Nam')."')" ,	"'".lang('country')."','SB','".lang('Solomon Islands')."')" ,
	"'".lang('country')."','SO','".lang('Somali Democratic Republic')."')" ,
	"'".lang('country')."','GS','".lang('South Georgia and the South Sandwich Islands')."')" ,
	"'".lang('country')."','BH','".lang('State of Bahrain')."')" ,			"'".lang('country')."','IL','".lang('State of Israel')."')" ,
	"'".lang('country')."','KW','".lang('State of Kuwait')."')" ,			"'".lang('country')."','QA','".lang('State of Qatar')."')" ,
	"'".lang('country')."','OM','".lang('Sultanate of Oman')."')" ,			"'".lang('country')."','SJ','".lang('Svalbard and Jan Mayen Islands')."')" ,
	"'".lang('country')."','CH','".lang('Swiss Confederation')."')" ,		"'".lang('country')."','SY','".lang('Syrian Arab Republic')."')" ,

	"'".lang('country')."','TW','".lang('Taiwan, Province of China')."')" ,		"'".lang('country')."','TG','".lang('Togolese Republic')."')" ,
	"'".lang('country')."','TK','".lang('Tokelau')."')" ,				"'".lang('country')."','TM','".lang('Turkmenistan')."')" ,
	"'".lang('country')."','TC','".lang('Turks and Caicos Islands')."')" ,		"'".lang('country')."','TV','".lang('Tuvalu')."')" ,

	"'".lang('country')."','UA','".lang('Ukraine')."')" ,				"'".lang('country')."','MM','".lang('Union of Myanmar (Burma)')."')" ,
	"'".lang('country')."','AE','".lang('United Arab Emirates')."')" ,
	"'".lang('country')."','GB','".lang('United Kingdom of Great Britain and Northern Ireland')."')" ,
	"'".lang('country')."','TZ','".lang('United Republic of Tanzania')."')" ,
	"'".lang('country')."','UM','".lang('United States of Minor Outlying Islands')."')" ,
	"'".lang('country')."','US','".lang('United States of America (USA)')."')" ,	"'".lang('country')."','MX','".lang('United States of Mexico')."')" ,

	"'".lang('country')."','VG','".lang('Virgin Islands, British')."')" ,		"'".lang('country')."','VI','".lang('Virgin Islands of the United States')."')" ,
	"'".lang('country')."','WF','".lang('Wallis and Futuna Islands')."')" ,		"'".lang('country')."','EH','".lang('Western Sahara')."')" ,

	"'".lang('country')."','CT','".lang('Canton and Enderbury Island')."')" ,	"'".lang('country')."','NQ','".lang('Dronning Maud Land')."')" ,
	"'".lang('country')."','JT','".lang('Johnston and Sand Islands')."')" ,		"'".lang('country')."','MI','".lang('Midway Islands')."')" ,
	"'".lang('country')."','PC','".lang('Pacific Islands')."')" ,			"'".lang('country')."','UK','".lang('United Kingdom')."')" ,
	"'".lang('country')."','PU','".lang('United States Miscellaneous Pacific Islands')."')" ,
	"'".lang('country')."','WK','".lang('Wake Island')."')" ,
	"'".lang('country')."','BU','".lang('Burma [Union of Myanmar]')."')" ,
	"'".lang('country')."','CS','".lang("Czechoslovakia [Czech Republic / Slovak Republic]")."')" ,
	"'".lang('country')."','YD','".lang('Democratic Yemen [Republic of Yemen]')."')" ,
	"'".lang('country')."','DD','".lang('German Democratic Republic [Federal Republic of Germany]')."')" ,
	"'".lang('country')."','SU','".lang('Union of Soviet Socialist Republics [Russian Federation]')."')" ,
	"'".lang('country')."','HV','".lang('Upper Volta [Burkina Faso]')."')" ,
	"'".lang('country')."','ZR','".lang('Zaire [Democratic Republic of the Congo]')."')"
													) ;
	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$sqlval	= array (
	"'".lang('region')."','ABD','".lang('Aberdeen')."')" ,		"'".lang('region')."','AIR','".lang('Airport')."')" ,
	"'".lang('region')."','ALC','".lang('Ap Lei Chau')."')" ,	"'".lang('region')."','BEH','".lang('Beacon Hill')."')" ,
	"'".lang('region')."','CAB','".lang('Causeway Bay')."')" ,	"'".lang('region')."','CED','".lang('Central District')."')" ,
	"'".lang('region')."','CKL','".lang('Cha Kwo Ling')."')" ,	"'".lang('region')."','CHW','".lang('Chai Wan')."')" ,
	"'".lang('region')."','CLK','".lang('Chek Lap Kok')."')" ,	"'".lang('region')."','CHC','".lang('Cheung Chau')."')" ,
	"'".lang('region')."','CHS','".lang('Cheung Sha')."')" ,	"'".lang('region')."','CSW','".lang('Cheung Sha Wan')."')" ,
	"'".lang('region')."','CMW','".lang('Chi Ma Wan')."')" ,	"'".lang('region')."','CHK','".lang('Chung Hom Kok')."')" ,
	"'".lang('region')."','CWB','".lang('Clear Water Bay')."')" ,

	"'".lang('region')."','DIH','".lang('Diamond Hill')."')" ,	"'".lang('region')."','DIB','".lang('Discovery Bay')."')" ,
	"'".lang('region')."','FVP','".lang('Fairview Park')."')" ,	"'".lang('region')."','FLU','".lang('Fan Lau')."')" ,
	"'".lang('region')."','FNL','".lang('Fanling')."')" ,		"'".lang('region')."','FNS','".lang('Fei Ngo Shan')."')" ,
	"'".lang('region')."','GNI','".lang('Green Island')."')" ,	"'".lang('region')."','HYV','".lang('Happy Valley')."')" ,
	"'".lang('region')."','HLC','".lang('Hei Ling Chau')."')" ,	"'".lang('region')."','HMT','".lang('Ho Man Tin')."')" ,
	"'".lang('region')."','HGH','".lang('Hung Hom')."')" ,		"'".lang('region')."','JDL','".lang("Jardine\'s Lookout")."')" ,

	"'".lang('region')."','KOC','".lang('Kat O Chau')."')" ,	"'".lang('region')."','KSC','".lang('Kau Sai Chau')."')" ,
	"'".lang('region')."','KYC','".lang('Kau Yi Chau')."')" ,	"'".lang('region')."','KYT','".lang('Kennedy Town')."')" ,
	"'".lang('region')."','KGP','".lang("King\'s Park")."')" ,	"'".lang('region')."','KTC','".lang('Kiu Tsui Chau')."')" ,
	"'".lang('region')."','KLB','".lang('Kowloon Bay')."')" ,	"'".lang('region')."','KLC','".lang('Kowloon City')."')" ,
	"'".lang('region')."','KLT','".lang('Kowloon Tong')."')" ,	"'".lang('region')."','KIC','".lang('Kwai Chung')."')" ,
	"'".lang('region')."','KNT','".lang('Kwun Tong')."')" ,

	"'".lang('region')."','LCK','".lang('Lai Chi Kok')."')" ,	"'".lang('region')."','LMT','".lang('Lam Tin')."')" ,
	"'".lang('region')."','LMI','".lang('Lamma Island')."')" ,	"'".lang('region')."','LNT','".lang('Lantau')."')" ,
	"'".lang('region')."','LFS','".lang('Lau Fau Shan')."')" ,	"'".lang('region')."','LYM','".lang('Lei Yue Mun')."')" ,
	"'".lang('region')."','LWU','".lang('Lo Wu')."')" ,		"'".lang('region')."','LKK','".lang('Luk Keng')."')" ,
	"'".lang('region')."','LKC','".lang('Lung Kwu Chau')."')" ,	"'".lang('region')."','LYT','".lang('Lung Yeuk Tau')."')" ,

	"'".lang('region')."','MLS','".lang('Ma Liu Shiu')."')" ,	"'".lang('region')."','MMH','".lang('Ma Mei Ha')."')" ,
	"'".lang('region')."','MOS','".lang('Ma On Shan')."')" ,	"'".lang('region')."','MTK','".lang('Ma Tau Kok')."')" ,
	"'".lang('region')."','MTW','".lang('Ma Tau Wai')."')" ,	"'".lang('region')."','MWN','".lang('Ma Wan')."')" ,
	"'".lang('region')."','MYT','".lang('Ma Yau Tong')."')" ,	"'".lang('region')."','MLL','".lang('Mid-Levels')."')" ,
	"'".lang('region')."','MGK','".lang('Mong Kok')."')" ,		"'".lang('region')."','MTD','".lang('Mount Davis')."')" ,
	"'".lang('region')."','MWO','".lang('Mui Wo')."')" ,		"'".lang('region')."','NCW','".lang('Ngau Chi Wan')."')" ,
	"'".lang('region')."','NTK','".lang('Ngau Tau Kok')."')" ,	"'".lang('region')."','NPT','".lang('North Point')."')" ,

	"'".lang('region')."','PEK','".lang('Peak')."')" ,		"'".lang('region')."','PIL','".lang('Pearl Island')."')" ,
	"'".lang('region')."','PEC','".lang('Peng Chau')."')" ,		"'".lang('region')."','PYB','".lang("Penny\'s Bay")."')" ,
	"'".lang('region')."','PIC','".lang('Ping Chau')."')" ,		"'".lang('region')."','PTI','".lang('Po Toi Island')."')" ,
	"'".lang('region')."','PFL','".lang('Pok Fu Lam')."')" ,	"'".lang('region')."','PIO','".lang('Pui O')."')" ,
	"'".lang('region')."','QYB','".lang('Quarry Bay')."')" ,	"'".lang('region')."','QNW','".lang('Queensway')."')" ,
	"'".lang('region')."','RPB','".lang('Repulse Bay')."')" ,

	"'".lang('region')."','SKG','".lang('Sai Kung')."')" ,		"'".lang('region')."','SWH','".lang('Sai Wan Ho')."')" ,
	"'".lang('region')."','SYP','".lang('Sai Ying Pun')."')" ,	"'".lang('region')."','SAP','".lang('Sam pak')."')" ,
	"'".lang('region')."','SPK','".lang('San Po Kong')."')" ,	"'".lang('region')."','SMP','".lang('Sau Mau Ping')."')" ,
	"'".lang('region')."','SHC','".lang('Sha Chau')."')" ,		"'".lang('region')."','SLW','".lang('Sha Lo Wan')."')" ,
	"'".lang('region')."','STK','".lang('Sha Tau Kok')."')" ,	"'".lang('region')."','STN','".lang('Sha Tin')."')" ,
	"'".lang('region')."','SSP','".lang('Sham Shui Po')."')" ,	"'".lang('region')."','SMT','".lang('Sham Tseng')."')" ,
	"'".lang('region')."','SMW','".lang('Sham Wat')."')" ,		"'".lang('region')."','STP','".lang('Shatin Pass')."')" ,
	"'".lang('region')."','SKW','".lang('Shau Kei Wan')."')" ,	"'".lang('region')."','SKM','".lang('Shek Kip Mei')."')" ,
	"'".lang('region')."','SKK','".lang('Shek Kong')."')" ,		"'".lang('region')."','SKC','".lang('Shek Kwu Chau')."')" ,
	"'".lang('region')."','SKO','".lang('Shek O')."')" ,		"'".lang('region')."','SKPK','".lang('Shek Pik')."')" ,
	"'".lang('region')."','STT','".lang('Shek Tong Tsui')."')" ,	"'".lang('region')."','SGS','".lang('Sheung Shui')."')" ,
	"'".lang('region')."','SGW','".lang('Sheung Wan')."')" ,	"'".lang('region')."','SSH','".lang('Shouson Hill')."')" ,
	"'".lang('region')."','SIH','".lang('Shui Hau')."')" ,		"'".lang('region')."','SMB','".lang('Silver Mine Bay')."')" ,
	"'".lang('region')."','SLM','".lang('Siu Lam')."')" ,		"'".lang('region')."','SSW','".lang('Siu Sai Wan')."')" ,
	"'".lang('region')."','SKP','".lang('So Kon Po')."')" ,		"'".lang('region')."','SKT','".lang('So Kwun Tan')."')" ,
	"'".lang('region')."','SKNW','".lang('So Kwun Wat')."')" ,	"'".lang('region')."','STL','".lang('Stanley')."')" ,

	"'".lang('region')."','TKL','".lang('Ta Kwu Ling')."')" ,	"'".lang('region')."','TAC','".lang('Tai A Chau')."')" ,
	"'".lang('region')."','THG','".lang('Tai Hang')."')" ,		"'".lang('region')."','TKT','".lang('Tai Kok Tsui')."')" ,
	"'".lang('region')."','TLMC','".lang('Tai Lam Chung')."')" ,	"'".lang('region')."','TIO','".lang('Tai O')."')" ,
	"'".lang('region')."','TIP','".lang('Tai Po')."')" ,		"'".lang('region')."','TPK','".lang('Tai Po Kau')."')" ,
	"'".lang('region')."','TPLC','".lang('Tai Po Lam Chuen')."')" ,	"'".lang('region')."','TWP','".lang('Tai Wo Ping')."')" ,
	"'".lang('region')."','TPM','".lang('Tap Mun')."')" ,		"'".lang('region')."','TCN','".lang("Tat\'s Cairn")."')" ,
	"'".lang('region')."','TSW','".lang('Tin Shiu Wai')."')" ,	"'".lang('region')."','TIKL','".lang('Tiu Keng Leng')."')" ,
	"'".lang('region')."','TKW','".lang('To Kwa Wan')."')" ,	"'".lang('region')."','TGF','".lang('Tong Fuk')."')" ,
	"'".lang('region')."','TKO','".lang('Tseung Kwan O')."')" ,	"'".lang('region')."','TST','".lang('Tsim Sha Tsui')."')" ,
	"'".lang('region')."','TSTE','".lang('Tsim Sha Tsui East')."')" ,	"'".lang('region')."','TLT','".lang('Tsing Lung Tau')."')" ,
	"'".lang('region')."','TSY','".lang('Tsing Yi')."')" ,		"'".lang('region')."','TNW','".lang('Tsuen Wan')."')" ,
	"'".lang('region')."','TWS','".lang('Tsz Wan Shan')."')" ,	"'".lang('region')."','TMN','".lang('Tuen Mun')."')" ,
	"'".lang('region')."','TGC','".lang('Tung Chung')."')" ,	"'".lang('region')."','TLGC','".lang('Tung Lung Chau')."')" ,

	"'".lang('region')."','WHF','".lang('Wah Fu')."')" ,		"'".lang('region')."','WNC','".lang('Wan Chai')."')" ,
	"'".lang('region')."','WTH','".lang('Wang Tau Hom')."')" ,	"'".lang('region')."','WCH','".lang('Wong Chuk Hang')."')" ,
	"'".lang('region')."','WTS','".lang('Wong Tai Sin')."')" ,	"'".lang('region')."','WKT','".lang('Wu Kau Tang')."')" ,
	"'".lang('region')."','YMO','".lang('Yam O')."')" ,		"'".lang('region')."','YMT','".lang('Yau Ma Tei')."')" ,
	"'".lang('region')."','YTG','".lang('Yau Tong')."')" ,		"'".lang('region')."','YYC','".lang('Yau Yat Chuen')."')" ,
	"'".lang('region')."','YLG','".lang('Yi Long')."')" ,		"'".lang('region')."','YPK','".lang('Yi Pak')."')" ,
	"'".lang('region')."','YNL','".lang('Yuen Long')."')" ,		"'".lang('region')."','YLPH','".lang('Yuen Long Pat Heung')."')" ,
	"'".lang('region')."','YLST','".lang('Yuen Long San Tin')."')"
													) ;
	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$sqlval	= array (
				"'".lang('sign-in')."','SOS','".lang('Start of shift')."')" ,
				"'".lang('sign-in')."','RMB','".lang('Return (meal break)')."')" ,
				"'".lang('sign-in')."','RMWC','".lang('Return (meeting w/ client)')."')" ,
				"'".lang('sign-in')."','RMWV','".lang('Return (meeting w/ vendor)')."')" ,
				"'".lang('sign-in')."','RSMA','".lang('Return (meeting w/ doctor)')."')" ,
				"'".lang('sign-in')."','RUD','".lang('Return (urgent duty)')."')" ,
				"'".lang('sign-in')."','RST','".lang('Return (staff training)')."')" ,
				"'".lang('sign-in')."','RMPD','".lang('Return (purchase/delivery)')."')" ,
				"'".lang('sign-out')."','EOS','".lang('End of shift')."')" ,
				"'".lang('sign-out')."','MB','".lang('Meal Break')."')" ,
				"'".lang('sign-out')."','MWC','".lang('Meeting with client')."')" ,
				"'".lang('sign-out')."','MWV','".lang('Meeting with vendor')."')" ,
				"'".lang('sign-out')."','EES','".lang('Early exit - sick')."')" ,
				"'".lang('sign-out')."','EEWI','".lang('Early exit - work injury')."')"  ,
				"'".lang('sign-out')."','ST','".lang('Staff Training')."')"  ,
				"'".lang('sign-out')."','UDS','".lang('Urgent duty (supervisor auth.)')."')" ,
				"'".lang('sign-out')."','MPD','".lang('Miscel. Purchase/Delivery')."')" ,
				"'".lang('activity')."','CLTRA','".lang('Conducting Training Class')."')",
				"'".lang('activity')."','COPRO','".lang('Sewing Collar to Shirt')."')",
				"'".lang('activity')."','DOPRO','".lang('Processing Legal Document')."')",
				"'".lang('activity')."','OFSUP','".lang('Office Support Work')."')",
				"'".lang('activity')."','PCASS','".lang('Assembling X86 PC Units')."')",
				"'".lang('activity')."','PROGM','".lang('Writing Computer Program')."')",
				"'".lang('activity')."','SYSAN','".lang('Analysing System Setup')."')",
				"'".lang('activity')."','SYSDE','".lang('Designing Computer System')."')",
													) ;
	while (list($key,$sqlv)=each($sqlval)) {
		$phpgw->db->query("$sqlhrcode ('$sid',$sqlv");
		$sid++;
		}

	$phpgw->db->query("UPDATE hrcode set allowdelete='n'");
	
	$lang_n_a = lang('not_applicable') ;
	$lang_na = lang('Not Applicable') ;
	$lang_nm = lang('Do not modify nor delete') ;
	$sqlval = "('$sid','$lang_n_a','$lang_na - $lang_nm')";
	$phpgw->db->query($sqlachieve.$sqlval);						$sid++ ;

/*------------------------------------------------------------------------------------*/

	$warning = lang('Do not modify (except tax rate) nor Delete');
	$zzzzmyself = lang('zzzzMyself') ;
	$zzzzcash = lang('zzzzCash') ;
	$dummy = lang('Dummy Contact') ;
	$note = lang('Modifying tax rate of this page will change the AP/PO standard tax rate');
	$sqlval = "('$sid','$zzzzmyself','$dummy','$warning.  $note','f')";
	$phpgw->db->query($sqlvend.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$zzzzcash','$dummy','".lang('Do not modify nor Delete')."','f')";
	$phpgw->db->query($sqlcust.$sqlval);						$sid++ ;
	$note = lang('Modifying tax rate of this page will change the AR/SO/Quotation/POS standard tax rate');
	$sqlval = "('$sid','$zzzzmyself','$dummy','$warning.  $note','f')";
	$phpgw->db->query($sqlcust.$sqlval);						$sid++ ;

	$sqlval = "('$sid','$ac2310',0.07,'".lang('CA GST from customer')."','ar')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2311',0.08,'".lang('CA PST from customer')."','ar')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac1310',0.07,'".lang('CA GST paid to vendor')."','ap')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac1311',0.08,'".lang('CA PST paid to vendor')."','ap')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2310',0.07,'".lang('CA GST from cash sale')."','cs')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2311',0.08,'".lang('CA PST from cash sale')."','cs')";
	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;
//	$sqlval = "('$sid','$ac2319',0.1,'".lang('Local VAT from cash sale')."','cs')";
//	$phpgw->db->query($sqltax.$sqlval);						$sid++ ;

	$sqlval = "('$sid','".lang('Cash')."','0','0','999999','0','9999','0','10000'," ;
	$sqlval.= "'$ac1070','1970-01-01','2038-01-01','0','".lang('Multiple Cash Tender allowed')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Visa Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".lang('Visa Credit Card.  Be sure to check signature')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Master Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".lang('Master Credit Card.  Be sure to check signature')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('AE Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".lang('American Express Credit Card.  Be sure to check signature')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Octopus Card')."','0','0','9999','0','9999','0','999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".lang('Stored Value Smart Card')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('EPS')."','0','0','99999','0','9999','0','9999'," ;
	$sqlval.= "'$ac1060','1970-01-01','2038-01-01','0','".lang('Electronic Payment System providing direct bank account transfer')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Personal Cheque')."','0','100','99999','0','9999','0','5000'," ;
	$sqlval.= "'$ac1075','1970-01-01','2038-01-01','0','".lang('Personal Cheque - must check against PHOTOED ID')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Bank Cheque')."','0','0','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1075','1970-01-01','2038-01-01','0','".lang('Bank Cheque - MUST BE ISSUED BY A LOCAL BANK')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Workstation Trade-in')."','50','300','99999','0','1','0','50'," ;
	$sqlval.= "'$ac5613','1970-01-01','2038-01-01','0','".lang('Trade-in items assumed to carry no asset value')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('$10 Cash Coupon')."','10','150','9999','0','3','0','30'," ;
	$sqlval.= "'$ac5613','1970-01-01','2038-01-01','0','".lang('Company issued FOC Cash Coupon')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".lang('Exchange Coupon')."','0','80','9999','0','5','0','0'," ;
	$sqlval.= "'0','1970-01-01','2038-01-01','0','".lang('5 for 1 exchange for complimentary gift')."')";
	$phpgw->db->query($sqlqc.$sqlval);						$sid++ ;

	$lang_rmk = lang('Invoice Remark1') ;
	$rmk1 = lang("Interest on overdue amounts is charged at 1.5% per month from due date until the invoice is paid in full.");
	$rmk2 = lang("Items returned are subject to a 10% restocking charge.") ;
	$rmk3 = lang("A return authorization must be obtained from us before items are returned.") ;
	$rmk4 = lang("Item returned must be shipped with freight prepaid and properly and adequately insured.") ;
	$rmk5 = lang("We will not be responsible for any damage during transit.") ;
	$rmk6 = lang("E. & O.E.") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3  $rmk4  $rmk5<br><br>$rmk6')" ;
	$phpgw->db->query($sqlremark.$sqlval);		$inv_rmk1=$sid;		$sid++ ;
	$lang_rmk = lang('Reminder Remark1') ;
	$rmk1 = lang("This invoice is now due for payment.");
	$rmk2 = lang("Please settle this invoice as soon as possible.") ;
	$rmk3 = lang("If you have already remit/despatch payment, please ignore this reminder.") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3')" ;
	$phpgw->db->query($sqlremark.$sqlval);		$rmd_rmk1=$sid;		$sid++ ;
	$lang_rmk = lang('PO Remark1') ;
	$rmk1 = lang("We require an Official Purchase Order (PO) to be issued to commit and pay for delivery of goods and services.") ;
	$rmk2 = lang("Goods and services delivered to us without a supporting Official PO from us will be rejected and sent back.") ;
	$rmk3 = lang("Invoices submitted to our Accounts Department without an Official PO number referenced will not be paid.") ;
	$rmk4 = lang("Please insist on obtaining an Official PO from us before delivering any goods or service to us.") ;
	$rmk5 = lang("Other PO Terms and Conditions are listed at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3  $rmk4  $rmk5')" ;
	$phpgw->db->query($sqlremark.$sqlval);		$po_rmk1=$sid;		$sid++ ;
	$lang_rmk = lang('Quotation Remark1') ;
	$rmk1 = lang("Terms and Conditions of Sale are listed at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1')" ;
	$phpgw->db->query($sqlremark.$sqlval);		$quo_rmk1=$sid;		$sid++ ;
	$lang_rmk = lang('Sales Memo Remark1') ;
	$rmk1 = lang("Come and try out our online Shopping Mall at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1')" ;
	$phpgw->db->query($sqlremark.$sqlval);		$sm_rmk1=$sid;		$sid++ ;

	$comname = lang('Testing Company Limited') ;
	$addr1 = lang('addr1') ;
	$addr2 = lang('addr2') ;
	$addr3 = lang('addr3') ;
	$addr4 = lang('addr4') ;
	$acdept = lang('Accounts Department') ;
	$hkd = lang('HKD') ;
	$kg = lang('kg') ;
	$tax1 = lang('GST') ;
	$tax2 = lang('PST') ;
	$lang_fund = lang('Fund') ;
	$lang_proj = lang('Project') ;
	$lang_dept = lang('Department') ;
	$sqlval = "('$comname','$addr1','$addr2','$addr3','$addr4','$acdept'," ;
	$sqlval.= "'$ac1520','$ac4020','$ac5020','$hkd','$kg','2003-12-31','0.7.1',";
	$sqlval.= "'$inv_rmk1','$rmd_rmk1','$po_rmk1','$quo_rmk1','$sm_rmk1'," ;
	$sqlval.= "'$tax1','$tax2','i','','$tax1','$tax2','i','','$tax1','$tax2','i','i'," ;
	$sqlval.= "'$lang_fund','$lang_proj','$lang_dept','fund','project','department'," ;
	$sqlval.= "'name','name','name','description','description','description'," ;
	$sqlval.= "'yes','no','no','yes','no','no','','yes','yes','yes','yes'," ;
	$sqlval.= "20,10,5,140,70,35,7)" ;
	$phpgw->db->query($sqldef.$sqlval);						$sid++ ;

	$sqlval = "('ledgerlisting')";
	$phpgw->db->query($sqllock.$sqlval);

	$id = 20000 ;
	$script = "adminbuild" ;
	$app = $phpgw_info["flags"]["currentapp"] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = "INSERT INTO log (id,trans_id,app,script,userid,date,time,op) " ;
	$sql.= "VALUES ('$id','$id','$app','$script','$user','$date','$time','start')";
	$phpgw->db->query($sql) ;

	if ($db_type=="pgsql")		$phpgw->db->query("SELECT setval('id',20000)");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang('Chart of Accounts and other Master Data Added'));
	$t->set_var('lang_yes',lang('Done'));
	$t->set_var('lang_no',lang('Done'));
	$t->set_var('yes_action',$phpgw->link('/ck-ledadmin/adminfilter.php')) ;
	$t->set_var('no_action',$phpgw->link('/ck-ledadmin/adminfilter.php')) ;

	$t->pparse('out','report');

?>

