<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'		=> 'ck-ledadmin',
				  'enable_nextmatchs_class'	=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actn = ($_GET["actn"]) ? $_GET["actn"] : $_POST["actn"] ;
	$chart = ($_GET["chart"]) ? $_GET["chart"] : $_POST["chart"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Admin Action to Perform :'));
	$t->set_var('lang_search_message','');
	if (!$pass2)	unset($actn) ;

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Admin Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$actlist1 = lang('1 -- Setup Data Tables') ;
$actlist2 = lang('2 -- Build Chart of Accounts and other Master Data') ;
$actlist3 = lang('3 -- Create Test Data') ;
$actlist4 = lang('4 -- Delete all Data and Data Tables') ;
$actlist = array (	1=>"<OPTION value='1'>$actlist1</OPTION>",
			2=>"<OPTION value='2'>$actlist2</OPTION>",
			3=>"<OPTION value='3'>$actlist3</OPTION>",
			4=>"<OPTION value='4'>$actlist4</OPTION>" ) ;
$chartlist1 = lang('1 -- Default Chart of Account') ;
$chartlist2 = lang('2 -- PRC Chart of Account') ;
$chartlist3 = lang('3 -- Canadian Chart of Account') ;
$chartlist =	"<OPTION value='1'>$chartlist1</OPTION>" .
		"<OPTION value='2'>$chartlist2</OPTION>" .
		"<OPTION value='3'>$chartlist3</OPTION>" ;
$note7a = lang('Be sure you understand all implications of this action.') ;
$note7b = lang('To abandon action, press [Done].') ;
$note7c = lang('To continue, press [Start Action].') ;
$filter =array (cond1		=>	lang('Which Action') ,
		condvar1	=>	'actn' ,
		selectlist1	=>	'',
		conddefault1	=>	'' ,
		condnote1	=>	lang('If wrong action chosen, click [Admin/Setup] to restart'),
		cond2		=>	lang('Which Chart') ,
		condvar2	=>	'chart' ,
		selectlist2	=>	$chartlist,
		conddefault2	=>	'' ,
		condnote2	=>	lang('Select the target Chart of Account to install') ,

	cond3		=>	lang('Explanatory Message') ,
	condvalue3	=>	'var3' ,
	conddefault3	=>	lang('[No Input Required]') ,
	condnote3	=>	lang('Create all Data Tables.'),
	cond4		=>	lang('Explanatory Message') ,
	condvalue4	=>	'var4' ,
	conddefault4	=>	lang('[No Input Required]') ,
	condnote4	=>	lang('Generate chosen Chart of Accounts, tax and other essential data.'),
	cond5		=>	lang('Explanatory Message') ,
	condvalue5	=>	'var4' ,
	conddefault5	=>	lang('[No Input Required]') ,
	condnote5	=>	lang('Insert dummy test data.  These data should be deleted before the system goes into actual production.'),
	cond6		=>	lang('Explanatory Message') ,
	condvalue6	=>	'var5' ,
	conddefault6	=>	lang('[No Input Required]') ,
	condnote6	=>	'<b>'.lang('This action is non-reversible and DELETES ALL..ALL..ALL DATA')."</b>",
	cond7		=>	lang('Warning Message') ,
	condvalue7	=>	'var6' ,
	conddefault7	=>	lang('[No Input Required]') ,
	condnote7	=>	"<b>$note7a  $note7b  $note7c</b>" ) ;

if ($err) {
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $actn ;
	$filter["conddefault2"] = $chart ;
	}

$t->set_var('condition',$filter[cond1]) ;
$t->set_var('var',$filter[condvar1]) ;
$t->set_var('note',$filter[condnote1]);
if ($actn)	$selectlist = $actlist[$actn] ;
   else		For ($i=1;isset($actlist[$i]);$i++) $selectlist.= $actlist[$i] ;
$t->set_var('selectlist',$selectlist);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

if ($actn==2)	{
	$t->set_var('condition',$filter[cond2]) ;
	$t->set_var('var',$filter[condvar2]) ;
	$t->set_var('note',$filter[condnote2]);
	$t->set_var('selectlist',$filter[selectlist2]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('select_section','select',True);
	}

If ($actn) {
	For ($i=3;isset($filter['cond'.$i]);$i++)	{
		$print = False ;
		switch ($actn) :
			case "1" :	if ($i==3 or $i==7)	{$print = True;}	break;
			case "2" :	if ($i==4 or $i==7)	{$print = True;}	break;
			case "3" :	if ($i==5 or $i==7)	{$print = True;}	break;
			case "4" :	if ($i==6 or $i==7)	{$print = True;}	break;
			endswitch;
		if ($print)	{
			$t->set_var('condition',$filter['cond'.$i]);
			$t->set_var('var',$filter['condvar'.$i]);
			$t->set_var('default',$filter['conddefault'.$i]);
			$t->set_var('note',$filter['condnote'.$i]);
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			}
		}
	}
   else $t->set_var('detail_section',"");

$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

if (!$actn) {
	$t->set_var('search_action',$phpgw->link('/ck-ledadmin/adminfilter.php',"pass2=2")) ;
	$t->set_var('lang_search',lang('Input Admin Action Parameters'));
	}
    else {
	$t->set_var('search_action',$phpgw->link('/ck-ledadmin/adminfilter_validate.php',"actn=$actn")) ;
	$t->set_var('lang_search',lang('Start Action'));
	}
$t->set_var('add_action',$phpgw->link('/ck-ledadmin/index.php')) ;
$t->set_var('lang_add',lang('Done'));

$t->pparse('out','report',True);
?>
