<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array(	'currentapp'	=> 'ck-ledadmin',
					'noheader'	=> True,
					'nonavbar'	=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actn = ($_GET["actn"]) ? $_GET["actn"] : $_POST["actn"] ;
	$chart = ($_GET["chart"]) ? $_GET["chart"] : $_POST["chart"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)				$err=lang("Error:  Error flagged before validation.") ;
	if ($actn<1 or $actn>4)			$err=lang("Error:  Invalid Action Number.") ;
	if ($actn==2 and($chart<1 or $chart>3))	$err=lang("Error: Invalid Chart Number") ;
	if ($err)				$err="<b>$err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
		switch ($actn) {
			case 1:
				Header('Location: '.$phpgw->link("/ck-ledadmin/adminsetup.php"));
				$phpgw->common->phpgw_exit();
			case 2:
				$param_list = "chart=$chart" ;
				Header('Location: '.$phpgw->link("/ck-ledadmin/adminbuild.php","$param_list"));
				$phpgw->common->phpgw_exit();
			case 3:
				Header('Location: '.$phpgw->link("/ck-ledadmin/admincreate.php"));
				$phpgw->common->phpgw_exit();
			case 4:
				Header('Location: '.$phpgw->link("/ck-ledadmin/admindelete.php"));
				$phpgw->common->phpgw_exit();
			default:
				echo "Should not be here.  Weird Action Number" ;
			}
		}
	else
		{
		$err = urlencode($err) ;
		$return = $phpgw->link("/ck-ledadmin/adminfilter.php","actn=$actn&chart=$chart&err=$err") ;
		Header('Location: '.$return);
		$phpgw->common->phpgw_exit();
		}

?>
