<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: header.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
    $nm = CreateObject('phpgwapi.nextmatchs') ;
    $t->set_file(array('ledadmin_header' => 'header.tpl'));
    $info1 = lang('Ledger Admin') ;
    $info2 = lang("You must read each module's index page in detail.") ;
    $info3 = lang("It contains the Terms & Conditions of usage and re-distribution.") ;
    $t->set_var('info',"$info1  [$info2  $info3]");
    $t->set_var('bg_color',$phpgw_info["theme"]["th_bg"]);
    $t->set_var('tr_color',$nm->alternate_row_color()) ;

    $t->set_var('link_develop',$phpgw->link('/ck-ledadmin/admindevelop.php'));
    $t->set_var('lang_develop',lang('Developer Use Only'));
    $t->set_var('link_admin',$phpgw->link('/ck-ledadmin/adminfilter.php'));
    $t->set_var('lang_admin',lang('Admin/Setup'));
    $t->set_var('link_backup',$phpgw->link('/ck-ledadmin/backup.php'));
    $t->set_var('lang_backup',lang('Data Backup'));
    $t->set_var('link_restore',$phpgw->link('/ck-ledadmin/restore.php'));
    $t->set_var('lang_restore',lang('Data Restore'));
    $t->set_var('link_remark',$phpgw->link('/ck-ledadmin/remarkfilter.php'));
    $t->set_var('lang_remark',lang('Standard Remark'));
    $t->set_var('link_defaults',$phpgw->link('/ck-ledadmin/defaults.php'));
    $t->set_var('lang_defaults',lang('Default Values'));
    $t->set_var('link_log',$phpgw->link('/ck-ledadmin/logfilter.php'));
    $t->set_var('lang_log',lang('View Log'));
    $t->set_var('link_multiled',$phpgw->link('/ck-ledadmin/multiled.php'));
    $t->set_var('lang_multiled',lang('Multiple Ledger'));

	$admin = False ;
	$user = trim($phpgw_info["user"]["userid"]);
	$groups = ExecMethod('phpgwapi.accounts.membership',$user) ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin) {
		$t->set_var(array('link_admin'=>"", 'lang_admin'=>""));
		$t->set_var(array('link_restart'=>"", 'lang_restart'=>""));
		}

    $t->pparse('out','ledadmin_header');
?>
