<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: logfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-ledadmin', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$op = ($_GET["op"]) ? $_GET["op"] : $_POST["op"] ;
	$from_date = ($_GET["from_date"]) ? $_GET["from_date"] : $_POST["from_date"] ;
	$to_date = ($_GET["to_date"]) ? $_GET["to_date"] : $_POST["to_date"] ;
	$from_id = ($_GET["from_id"]) ? $_GET["from_id"] : $_POST["from_id"] ;
	$to_id = ($_GET["to_id"]) ? $_GET["to_id"] : $_POST["to_id"] ;
	$script = ($_GET["script"]) ? $_GET["script"] : $_POST["script"] ;
	$userid = ($_GET["userid"]) ? $_GET["userid"] : $_POST["userid"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledadmin'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search and view selected log entries :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Searching Criteria'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$oplistnew = lang('new -- new record inserted') ;
$oplistedit = lang('edit -- old record edited') ;
$oplistdelete = lang('delete -- old record deleted') ;
$opliststart = lang('start -- start of log') ;
$oplist =	"<OPTION value=''></OPTION>".
		"<OPTION value='new'>$oplistnew</OPTION>" .
		"<OPTION value='edit'>$oplistedit</OPTION>" .
		"<OPTION value='delete'>$oplistdelete</OPTION>" .
		"<OPTION value='start'>$opliststart</OPTION>" ;

$filter = array (	cond1		=>	lang('Operation') ,
			condvar1	=>	'op' ,
			selectlist1	=>	$oplist,
			conddefault1	=>	'' ,
			condnote1	=>	lang('Select records of specific operation') ,
			checkbox2	=>	'no',
			cond2		=>	lang('Date (from)') ,
			condvar2	=>	'from_date' ,
			conddefault2	=>	'' ,
			condnote2	=>	lang('Must be a valid date; format: YYYY-MM-DD'),
			checkbox3	=>	'no',
			cond3		=>	lang('Date (to)') ,
			condvar3	=>	'to_date' ,
			conddefault3	=>	'' ,
			condnote3	=>	lang('Must be a valid date; format: YYYY-MM-DD') ,
			checkbox4	=>	'no',
			cond4		=>	lang('Transaction ID (from)') ,
			condvar4	=>	'from_id' ,
			conddefault4	=>	'' ,
			condnote4	=>	lang('Search for record with transaction id starting from') ,
			checkbox5	=>	'no',
			cond5		=>	lang('Transaction ID (to)') ,
			condvar5	=>	'to_id' ,
			conddefault5	=>	'' ,
			condnote5	=>	lang('Search for record with transaction id ending at') ,
			checkbox6	=>	'no',
			cond6		=>	lang('Script') ,
			condvar6	=>	'script' ,
			conddefault6	=>	'' ,
			condnote6	=>	lang('Search for target keyword in the script name field') ,
			checkbox7	=>	'no',
			cond7		=>	lang('User ID') ,
			condvar7	=>	'userid' ,
			conddefault7	=>	'' ,
			condnote7	=>	lang('Search for target keyword/number in the User ID field') ) ;

if ($err)
	{
	$t->set_var('lang_search_message',$err) ;
	$filter["conddefault1"] = $op ;
	$filter["conddefault2"] = $from_date ;
	$filter["conddefault3"]	= $to_date ;
	$filter["conddefault4"] = $from_id ;
	$filter["conddefault5"] = $to_id ;
	$filter["conddefault6"] = $script ;
	$filter["conddefault7"] = $userid ;
	}

$t->set_var('condition',$filter[cond1]);
$t->set_var('var',$filter[condvar1]);
$s = str_replace("'$filter[conddefault1]'","'$filter[conddefault1]'"." selected",$filter[selectlist1]) ;
$t->set_var('selectlist',$s);
$t->set_var('note',$filter[condnote1]);
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('select_section','select', True);

For ($i=2;isset($filter['cond'.$i]);$i++)	{
	$t->set_var('condition',$filter['cond'.$i]);
	$t->set_var('var',$filter['condvar'.$i]);
	$t->set_var('default',$filter['conddefault'.$i]);
	if ($filter['checkbox'.$i]=='yes') {
		$t->set_var('checkbox',"type='checkbox'");
		$t->set_var('default',"yes");
		if ($filter['conddefault'.$i]=='yes')	$t->set_var('checked',"checked");
			else				$t->set_var('checked',"");
		}
	   else	{
		$t->set_var('checkbox',"");
		$t->set_var('checked',"");
		}
	$t->set_var('note',$filter['condnote'.$i]);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);
	}

$t->parse('out','report',True);


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-ledadmin/logfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-ledadmin/index.php')) ;
	$t->set_var('lang_add',lang('Done'));
	$t->pparse('out','report',True);
	$phpgw->common->phpgw_footer();
?>
