<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: accountlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'accountlist.tpl',  'accounts'=>'accountlist.tpl'));
	$t->set_block('accounts','account_row','account_section');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Chart of Accounts'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Add New Account'));
	$t->set_var('add_action',$phpgw->link('/ck-ledger/accountadd.php',"filter=$filter"));

$t->set_var('sort_accno',$nm->show_sort_order($sort,'accno',$order,'/ck-ledger/accountlist.php',lang('Account')));
$t->set_var('sort_desc',$nm->show_sort_order($sort,'description',$order,'/ck-ledger/accountlist.php',lang('Description')));
$t->set_var('sort_category',$nm->show_sort_order($sort,'category',$order,'/ck-ledger/accountlist.php',lang('Category')));
$t->set_var('sort_charttype',$nm->show_sort_order($sort,'charttype',$order,'/ck-ledger/accountlist.php',lang('Type')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-ledger/accountlist.php',lang('Audit Id')));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_hist',lang('History'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "accno" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from chart $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'accno'		=> "",
				'description'	=> lang("No Matching Item Found"),
				'category'	=> "",
				'type'		=> "",
				'id'		=> "",
				'view'		=> "",
				'hist'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('account_section','account_row',True);
	}
while ($phpgw->db->next_record()) {

	$accno				= $phpgw->db->f('accno') ;
	$description			= $phpgw->db->f('description') ;
	$category			= $phpgw->db->f('category') ;
	$charttype			= $phpgw->db->f('charttype') ;
	$id				= $phpgw->db->f('id') ;
	$getstr				= "id=$id&filter=$filter" ;
	switch ($category) {
		case "A": $category = lang("Asset");			break;
		case "L": $category = lang("Liability");		break;
		case "Q": $category = lang("Equity");			break;
		case "I": $category = lang("Income") ;			break;
		case "E": $category = lang("Expense") ;			break;
		default:  $category = "Cat Error";			break;
		}
	if ($charttype=="A")	$type = lang("Account - posting allowed");
		else		$type = lang("HEADING (NO POSTING)");
	$hist = ($charttype=="H") ? "" : $phpgw->link('/ck-ledger/accounthist.php',$getstr) ;
	$lang_hist = ($charttype=="H") ? "" : lang('History') ;
	$t->set_var(array(	'lang_hist'	=> $lang_hist,
				'accno'		=> $accno,
				'description'	=> $description,
				'category'	=> $category,
				'type'		=> $type,
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-ledger/accountview.php',$getstr),
				'hist'		=> $hist,
				'edit'		=> $phpgw->link('/ck-ledger/accountedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-ledger/accountcopy.php',$getstr),
				'delete'	=> $phpgw->link('/ck-ledger/accountdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	if ($charttype=="H")		$t->set_var('tr_color','') ;
	$t->parse('account_section','account_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','accounts','report');
?>
