<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attriblist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$qfield = ($_GET["qfield"]) ? $_GET["qfield"] : $_POST["qfield"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;
	$attrib = isset($attrib) ? $attrib : $qfield ;
	$qfield = $attrib ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'attriblist.tpl', 'attrib'=>'attriblist.tpl'));
	$t->set_block('attrib','attrib_row','attrib_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$msg1 = lang("This is for illustrative purpose only.") ;
	$msg2.= lang("Other modules will provide better facility to process these data.") ;
	$t->set_var('message',"$msg1  $msg2");

//---------------------------- list variable template-declarations -------------------------

$table = substr($where,0,strpos($where," ")) ;
$attrib = substr($where,strpos($where,"=")-1,1) ;
$phpgw->db->query("Select * from defaults");
$phpgw->db->next_record() ;
switch ($attrib) :
	case "1" :	$sdfld=$phpgw->db->f('attrib1sdesc');
			$ldfld=$phpgw->db->f('attrib1ldesc');
			$caption=$phpgw->db->f('attrib1cap'); break ;
	case "2" :	$sdfld=$phpgw->db->f('attrib2sdesc');
			$ldfld=$phpgw->db->f('attrib2ldesc');
			$caption=$phpgw->db->f('attrib2cap'); break ;
	case "3" :	$sdfld=$phpgw->db->f('attrib3sdesc');
			$ldfld=$phpgw->db->f('attrib3ldesc');
			$caption=$phpgw->db->f('attrib3cap'); break ;
	endswitch ;
$t->set_var('lang_title',lang("List of %1",$caption));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_sdesc',$phpgw->nextmatchs->show_sort_order($sort,"$sdfld",$order,'/ck-ledger/attriblist.php',$sdfld,$filter));
$t->set_var('sort_ldesc',$phpgw->nextmatchs->show_sort_order($sort,"$ldfld",$order,'/ck-ledger/attriblist.php',$ldfld,$filter));
$t->set_var('sort_id',$phpgw->nextmatchs->show_sort_order($sort,'id',$order,'/ck-ledger/attriblist.php',lang('Audit Id'),$filter));

if (!$order) $order = $sdfld ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * from $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'sdesc'		=> lang("No Matching Item Found"),
				'ldesc'		=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('attrib_section','attrib_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&attrib=$attrib&caption=$caption&" ;
	$getstr.= "table=$table&sdfld=$sdfld&ldfld=$ldfld&filter=$filter" ;
	$t->set_var(array(	'sdesc'		=> $phpgw->db->f("$sdfld"),
				'ldesc'		=> $phpgw->db->f("$ldfld"),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-ledger/attribview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-ledger/attribedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-ledger/attribcopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-ledger/attribdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('attrib_section','attrib_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add New %1",$caption));
	$t->set_var('add_action',$phpgw->link('/ck-ledger/attribadd.php',$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->pparse('out','attrib','report');

?>
