<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-ledger', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$repnum = ($_GET["repnum"]) ? $_GET["repnum"] : $_POST["repnum"] ;
	$account = ($_GET["account"]) ? $_GET["account"] : $_POST["account"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;
	$rdate_curr = ($_GET["rdate_curr"]) ? $_GET["rdate_curr"] : $_POST["rdate_curr"] ;
	$datefrom_curr = ($_GET["datefrom_curr"]) ? $_GET["datefrom_curr"] : $_POST["datefrom_curr"] ;
	$dateto_curr = ($_GET["dateto_curr"]) ? $_GET["dateto_curr"] : $_POST["dateto_curr"] ;
	$rdate_comp = ($_GET["rdate_comp"]) ? $_GET["rdate_comp"] : $_POST["rdate_comp"] ;
	$datefrom_comp = ($_GET["datefrom_comp"]) ? $_GET["datefrom_comp"] : $_POST["datefrom_comp"] ;
	$dateto_comp = ($_GET["dateto_comp"]) ? $_GET["dateto_comp"] : $_POST["dateto_comp"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$phpgw_info['theme']['bg04']) ;
	$t->set_var('lang_title',lang('Choose Report to Generate and to set Report Parameters :'));
	$msg1 = lang('Generation of ledger report requires lengthy processing time.') ;
	$msg2.= lang('You should initiate report generation only during off-peak hours.') ;
	$t->set_var('lang_search_message',"$msg1  $msg2");

/* ------------- Read and Write Journal Detail --------------------------- */

$t->set_var('lang_criteria',lang('Reporting Parameters'));
$t->set_var('lang_value',lang('Value'));
$t->set_var('lang_note',lang('Note'));

$phpgw->db->query('Select * from defaults');
$phpgw->db->next_record();
$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');
$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');
$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');
$a1sdf = $phpgw->db->f('attrib1sdesc');	$a1cnv = $phpgw->db->f('attrib1cnval');
$a2sdf = $phpgw->db->f('attrib2sdesc');	$a2cnv = $phpgw->db->f('attrib2cnval');
$a3sdf = $phpgw->db->f('attrib3sdesc');	$a3cnv = $phpgw->db->f('attrib3cnval');

$trialbalance = lang('Trial Balance') ;
$incomestatement = lang('Income Statement') ;
$balancesheet = lang('Balance Sheet') ;
$ledgerlisting = lang('Ledger Listing') ;
$controlreport = lang('Ledger Audit Control Report') ;
$anomalies = lang('List of Journals with Anomalies') ;
$replist = array (	1=>"<OPTION value='1'>1 -- $trialbalance</OPTION>",
			2=>"<OPTION value='2'>2 -- $incomestatement</OPTION>",
			3=>"<OPTION value='3'>3 -- $balancesheet</OPTION>",
			4=>"<OPTION value='4'>4 -- $ledgerlisting</OPTION>",
			5=>"<OPTION value='5'>5 -- $controlreport</OPTION>",
			6=>"<OPTION value='6'>6 -- $anomalies</OPTION>" ) ;
$ac_sl = "<OPTION value='0'>all -- All Accounts (will fail under heavy load)</OPTION>" ;
$ac_sl .= account_selectlist(" WHERE charttype='A' ") ;

$dateformat = lang('Format: YYYY-MM-DD') ;
$note1 = lang("If wrong action chosen, click (Report) to restart.") ;
$note1a = lang("Press (Start Report Generattion) one more time to start.") ;

	$filter = array (
			ftr1		=>	lang('Which Report') ,
			ftrtype1	=>	'select' ,
			ftrsl1		=>	'' ,
			ftrvar1		=>	'repnum' ,
			ftrdefault1	=>	'' ,
			ftrnote1	=>	$note1,

			ftr2		=>	lang('Which Account') ,
			ftrtype2	=>	'select' ,
			ftrsl2		=>	$ac_sl ,
			ftrvar2		=>	'account' ,
			ftrdefault2	=>	'' ,
			ftrnote2	=>	lang('Select the target account') ,

			ftr3		=>	$a1cap ,
			ftrtype3	=>	'select' ,
			ftrsl3		=>	attrib_selectlist($a1tbl,$a1sdf,'','') ,
			ftrvar3		=>	'attrib1' ,
			ftrdefault3	=>	'' ,
			ftrnote3	=>	lang("Choose to produce the report of which")." $a1cap",

			ftr4		=>	$a2cap ,
			ftrtype4	=>	'select' ,
			ftrsl4		=>	attrib_selectlist($a2tbl,$a2sdf,'','') ,
			ftrvar4		=>	'attrib2' ,
			ftrdefault4	=>	'' ,
			ftrnote4	=>	lang("Choose to produce the report of which")." $a2cap",

			ftr5		=>	$a3cap ,
			ftrtype5	=>	'select' ,
			ftrsl5		=>	attrib_selectlist($a3tbl,$a3sdf,'','') ,
			ftrvar5		=>	'attrib3' ,
			ftrdefault5	=>	'' ,
			ftrnote5	=>	lang("Choose to produce the report of which")." $a3cap",

			ftr6		=>	lang('Report Status as of (Current Period)') ,
			ftrtype6	=>	'input' ,
			ftrsl6		=>	'' ,
			ftrvar6		=>	'rdate_curr' ,
			ftrdefault6	=>	'' ,
			ftrnote6	=>	$dateformat ,

			ftr7		=>	lang('Date from (Current Period)') ,
			ftrtype7	=>	'input' ,
			ftrsl7		=>	'' ,
			ftrvar7		=>	'datefrom_curr' ,
			ftrdefault7	=>	'' ,
			ftrnote7	=>	$dateformat ,

			ftr8		=>	lang('Date to (Current Period)') ,
			ftrtype8	=>	'input' ,
			ftrsl8		=>	'' ,
			ftrvar8		=>	'dateto_curr' ,
			ftrdefault8	=>	'' ,
			ftrnote8	=>	$dateformat ,

			ftr9		=>	lang('Report Status as of (Comparison Period)') ,
			ftrtype9	=>	'input' ,
			ftrsl9		=>	'' ,
			ftrvar9		=>	'rdate_comp' ,
			ftrdefault9	=>	'' ,
			ftrnote9	=>	$dateformat ,

			ftr10		=>	lang('Date from (Comparison Period)') ,
			ftrtype10	=>	'input' ,
			ftrsl10		=>	'' ,
			ftrvar10	=>	'datefrom_comp' ,
			ftrdefault10	=>	'' ,
			ftrnote10	=>	$dateformat ,

			ftr11		=>	lang('Date to (Comparison Period)') ,
			ftrtype11	=>	'input' ,
			ftrsl11		=>	'' ,
			ftrvar11	=>	'dateto_comp' ,
			ftrdefault11	=>	'' ,
			ftrnote11	=>	$dateformat ,

									) ;

	if ($repnum=="")	Foreach ($replist as $key=>$choice)	$filter[ftrsl1] .= $choice ;
		else		$filter[ftrsl1] = $replist[$repnum];

	switch ($repnum) :
		case "" :	$filterstr = "(1)" ; break;
		case "1" :	$filterstr = "(1).(6)" ; break;
		case "2" :	$filterstr = "(1).(7).(8).(10).(11)" ; break;
		case "3" :	$filterstr = "(1).(6).(9)" ; break;
		case "4" :	$filterstr = "(1).(7).(8)" ; break;
		case "5" :	$filterstr = "(1).(6)" ; break;
		case "6" :	$filterstr = "(1)" ; $filter[ftrnote1]="<b>$note1a</b>" ; break;
		endswitch ;

	if ($repnum==1 or $repnum==3) {
		For ($i=3;$i<=5;$i++)	{
			$x = $i-2 ;
			$constantvar = "a$x"."cnv" ;
			if ($$constantvar == "yes")	$filterstr .= ".($i)" ;
			}
		}

	if ($repnum==2 or $repnum==4)
		For ($i=3;$i<=5;$i++)	$filterstr .= ".($i)" ;

if ($err) {
	$t->set_var('lang_search_message',$err) ;
	$filter["ftrdefault1"] = $repnum ;
	$filter["ftrdefault2"] = $account ;
	$filter["ftrdefault3"] = $attrib1 ;
	$filter["ftrdefault4"] = $attrib2 ;
	$filter["ftrdefault5"] = $attrib3 ;
	$filter["ftrdefault6"] = $rdate_curr ;
	$filter["ftrdefault7"] = $datefrom_curr ;
	$filter["ftrdefault8"] = $dateto_curr ;
	$filter["ftrdefault9"] = $rdate_comp ;
	$filter["ftrdefault10"] = $datefrom_comp ;
	$filter["ftrdefault11"] = $dateto_comp ;
	}

	$t->set_var('detail_section','');
	$t->set_var('select_section','');
	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		if (substr_count($filterstr,"($i)")==0)	continue ;
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if ($repnum=="") {
		$t->set_var('search_action',$phpgw->link('/ck-ledger/reportfilter.php')) ;
		$t->set_var('lang_search',lang('Input Report Generation Parameters'));
		}
	   else {
		$t->set_var('search_action',$phpgw->link('/ck-ledger/reportfilter_validate.php')) ;
		$t->set_var('lang_search',lang('Start Report Generation'));
		}
	$t->set_var('add_action',$phpgw->link('/ck-ledger/index.php')) ;
	$t->set_var('lang_add',lang('Done'));

	$t->pparse('out','report',True);


?>

