<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: genpayrollfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$period = ($_GET["period"]) ? $_GET["period"] : $_POST["period"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;
	$genpj = ($_GET["genpj"]) ? $_GET["genpj"] : $_POST["genpj"] ;
	$cdate = ($_GET["cdate"]) ? $_GET["cdate"] : $_POST["cdate"] ;
	$bankac = ($_GET["bankac"]) ? $_GET["bankac"] : $_POST["bankac"] ;
	$cheqno = ($_GET["cheqno"]) ? $_GET["cheqno"] : $_POST["cheqno"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Choose Action to perform and to set Action Parameters :'));
	$msg1 = lang("Payroll Generation normally requires lengthy processing time.") ;
	$msg2 = lang("You should initiate Payroll Generation only during off-peak hours.");
	$msg3 = lang("Salary advice for previous period may be regenerated.") ;
	$t->set_var('lang_search_message',"$msg1  $msg2  $msg3");

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Action Parameters'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));

	$warning1 = lang("Since Payroll Generation is irreversible, please perform database backup first then follow the strict sequence of Step 1-2-3.");
	$warning2 = lang("Inaccurate Date will affect subsequent period's payroll.") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$note1 = lang("Step 4 and 5 are optional.") ;
	$note2 = lang('Operate on all staff or staff with the choosen pay period') ;
	$note1a = lang("If wrong action chosen, click (Generate Payroll) to restart.") ;
	$note4 = lang("For cheque generation, this step needs to be repeated for all staff that require a payroll check.") ;
	$note4a = lang("Cheques for past payroll period may be regenerated.") ;
	$note5 = lang("For any one employee's cheque, payment journal should only be generated once.") ;
	$note7 = lang("Choose which ledger (bank) account to put through Cr (cheque amount).") ;
	$note7a = lang("Please ignore if payment journal is not to be generated.") ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$step1 = lang('Step 1 - Test Run on Current Period Payroll Generation') ;
	$step2 = lang('Step 2 - Generate Current Period Payroll, Journal and History Data') ;
	$step3 = lang('Step 3 - Email Salary Advice to Staff') ;
	$step4 = lang('Step 4 - Print (Single) Payroll Cheque and Generate Payment Journal') ;
	$step5 = lang('Step 5 - Delete Payment Journal') ;
	$actlist = array (	1=>	"<OPTION value='1'>$step1</OPTION>",
				2=>	"<OPTION value='2'>$step2</OPTION>",
				3=>	"<OPTION value='3'>$step3</OPTION>",
				4=>	"<OPTION value='4'>$step4</OPTION>",
				5=>	"<OPTION value='5'>$step5</OPTION>",
											) ;
	$filter = array (
				ftr1		=>	lang('Which Action') ,
				ftrtype1	=>	'select' ,
				ftrsl1		=>	'' ,
				ftrvar1		=>	'actnum' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	"<b>$warning1</b>  $note1  $note1a" ,

				ftr2		=>	lang('Pay Period') ,
				ftrtype2	=>	'select' ,
				ftrsl2		=>	$nullopt.pperiod_selectlist('','') ,
				ftrvar2		=>	'period' ,
				ftrdefault2	=>	'' ,
				ftrnote2	=>	$note2 ,

				ftr3		=>	lang('Period From') ,
				ftrtype3	=>	'input' ,
				ftrsl3		=>	'' ,
				ftrvar3		=>	'datefrom' ,
				ftrdefault3	=>	'' ,
				ftrnote3	=>	"<b>$warning2</b>  $dateformat" ,

				ftr4		=>	lang('Period To') ,
				ftrtype4	=>	'input' ,
				ftrsl4		=>	'' ,
				ftrvar4		=>	'dateto' ,
				ftrdefault4	=>	'' ,
				ftrnote4	=>	"<b>$warning2</b>  $dateformat" ,

				ftr5		=>	lang('Which Staff') ,
				ftrtype5	=>	'select' ,
				ftrsl5		=>	$nullopt.employee_selectlist("","") ,
				ftrvar5		=>	'empid' ,
				ftrdefault5	=>	'' ,
				ftrnote5	=>	"$note4  $note4a" ,
				) ;

	if ($actnum=="")	Foreach ($actlist as $key=>$choice)	$filter[ftrsl1] .= $choice ;
		else		$filter[ftrsl1] = $actlist[$actnum];

	switch ($actnum) :
		case "" :	$filterstr = "1" ; break;
		case "1" :	$filterstr = "1234" ; break;
		case "2" :	$filterstr = "1234" ; break;
		case "3" :	$filterstr = "134" ; break;
		case "4" :	$filterstr = "1345" ; break;
		case "5" :	$filterstr = "1345" ; break;
		endswitch ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $actnum ;
		$filter["ftrdefault2"] = $period ;
		$filter["ftrdefault3"] = $datefrom ;
		$filter["ftrdefault4"] = $dateto ;
		$filter["ftrdefault5"] = $empid ;
		}

	$t->set_var('detail_section','');
	$t->set_var('select_section','');
	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		if (substr_count($filterstr,$i)==0)	continue ;
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$noselect = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$next = ($actnum=="") ? "genpayrollfilter.php" : "genpayrollfilter_validate.php" ;
	$t->set_var('search_action',$phpgw->link("/ck-payroll/$next")) ;
	$t->set_var('lang_search',lang('Start Action'));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/index.php')) ;
	$t->set_var('lang_add',lang('Return to Index Page'));
	$t->pparse('out','report',True);

?>


