<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: genpayrollfilter_validate.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array(	'currentapp'		=> 'ck-payroll',
					'noheader'		=> True,
					'nonavbar'		=> True );
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$period = ($_GET["period"]) ? $_GET["period"] : $_POST["period"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$error = lang("Error") ;
	$lang_payperiod = lang('Payroll for period') ;
	$lang_from = lang('from') ;
	$lang_to = lang('to') ;
	$lang_scheque = lang('SalaryCheque') ;
	$lang_empid = lang('empid') ;
	$lang_period = lang('period') ;

	if ($err)	$err=lang("Error flagged before validation") ;
	if ($period<>'' and ($actnum==1 or $actnum==2)) {
		$phpgw->db->query("SELECT * FROM payroll WHERE period='$period'");
		if ($phpgw->db->num_rows()==0)	$err=lang("No staff (with the selected pay period) found");
		}
	if ($datefrom<>"") {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=lang("Invalid Period From Date");
			else	$datefrom = $date ;
		}
	if ($dateto<>"") {
		$date=input2date($dateto) ;
		if ($date=="")	$err=lang("Invalid Period To Date");
			else	$dateto = $date ;
		}
	if ($datefrom<>"" and $dateto<>"" and strtotime($datefrom)>strtotime($dateto))
				$err=lang("Period From later than Period To");
	if ($actnum==1 or $actnum==2) {
	
		$lang_from = lang('from') ;
		$lang_to = lang('to') ;
		$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
		$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
		$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
		$topos = "position('$tomarker' in description)+$tomarkerlen" ;
		$descdatefrom = "substring(description,$frompos,10)" ;
		$descdateto = "substring(description,$topos,10)" ;

		$sql =	"SELECT * FROM gl " ;
		$sql.=	"WHERE source='PYRO' and " ;
		$sql.=	"(($descdatefrom>='$datefrom' and $descdatefrom<='$dateto') " ;
		$sql.=	"or ($descdateto>='$datefrom' and $descdateto<='$dateto'))" ;
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)	$err=lang("Period From/To overlaps with previous payroll periods") ;
		if ($datefrom=="")		$err=lang("Payroll Generation From Date must not be blank") ;
		if ($dateto=="")		$err=lang("Payroll Generation To Date must not be blank") ;
		}
	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/
 
if (!$err)
	{
	switch ($actnum) {
		case 1:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.$phpgw->link("/ck-payroll/gentest.php",$getstr));
			exit();
		case 2:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.$phpgw->link("/ck-payroll/genpayroll.php",$getstr));
			exit();
		case 3:
			$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
			$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
			$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
			$topos = "position('$tomarker' in description)+$tomarkerlen" ;
			$descdatefrom = "substring(description,$frompos,10)" ;
			$descdateto = "substring(description,$topos,10)" ;
			$where = " WHERE 1=1 " ;
			if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
			if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";
			$where = urlencode($where) ;
			Header('Location: '.$phpgw->link("/ck-payroll/sadvicelist.php","filter=$where"));
			exit();
		case 4:
			$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
			$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
			$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
			$topos = "position('$tomarker' in description)+$tomarkerlen" ;
			$descdatefrom = "substring(description,$frompos,10)" ;
			$descdateto = "substring(description,$topos,10)" ;
			$where = " WHERE 1=1 " ;
			if ($empid)	$where .= " AND b.empid='$empid' " ;
			if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
			if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";
			$where = urlencode($where) ;
			Header('Location: '.$phpgw->link("/ck-payroll/schequelist.php","empid=$empid&filter=$where"));
			exit();
		case 5:
			$frommarker = $lang_from.'/' ;  $frmarkerlen=strlen($frommarker);
			$tomarker = $lang_to.'/' ;  $tomarkerlen = strlen($tomarker) ;
			$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
			$topos = "position('$tomarker' in description)+$tomarkerlen" ;
			$descdatefrom = "substring(description,$frompos,10)" ;
			$descdateto = "substring(description,$topos,10)" ;
			$empidmarker = "$lang_empid-$empid" ;
			$where = " WHERE 1=1 " ;
			if ($empid)	$where .= " AND description like '%$empidmarker%' " ;
			if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
			if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";
			$where = urlencode($where) ;
			Header('Location: '.$phpgw->link("/ck-payroll/pjlist.php","empid=$empid&filter=$where"));
			exit();
		default:
			echo lang("Should not be here.  Weird Action Number") ;
		}
	}
else
	{
	$err = urlencode($err) ;
	$getstr = "actnum=$actnum&period=$period&datefrom=$datefrom&dateto=$dateto&empid=$empid&err=$err" ;
//	$getstr.= "genpj=$genpj&cdate=$cdate&bankac=$bankac&cheqno=$cheqno&err=$err";
	Header('Location: '.$phpgw->link("/ck-payroll/genpayrollfilter.php",$getstr));
	exit();
	}

?>
