<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: nrtransedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$oldeaid = ($_GET["oldeaid"]) ? $_GET["oldeaid"] : $_POST["oldeaid"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$refresh = ($_GET["refresh"]) ? $_GET["refresh"] : $_POST["refresh"] ;
	$filter=urlencode(stripslashes($filter));

	$nrt = CreateObject('ck-payroll.nrtrans') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file(array('edit'=>'nrtransscreen.tpl', 'report'=>'nrtransscreen.tpl'));
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang("Edit Non-recurring Payroll Item"));
	$msg1 = lang('Pay Period');
	$msg2 = lang('mn - Month, sm - Semi-monthly, wk - Week, dy - Day, hr - Hour');
	$msg3 = lang('Basis of Calculation');
	$msg4 = lang('bs - basic salary, pc - allowance/deduction unit amount,') ;
	$msg5 = lang('dp - imputed daily pay, hp - imputed hourly pay, qty - inputted qty, amt - inputted amount');
	$msg6 = lang('Remember to select the appropriate payroll expense account.') ;
	$t->set_var('message',"$msg1:  $msg2<br>$msg3:  $msg4 $msg5<br>$msg6");

/* ------------------- Print Non-recurring Payroll Item -------------------------------- */

if (!isset($post) and !isset($refresh)) {
	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.chart_id,a.id " ;
	$sql.=	"FROM pynr_trans a, payroll b, pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$nr = $phpgw->db->Record ;
	$oldeaid = $nr[eaid] ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($nr[period]) :
		case "mn" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('mndfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('smdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('wkdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$nr[daypay] = $nr[salary] ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$nr[daypay] = $nr[salary] * $phpgw->db->f('dyhfactor') ;
				$nr[hourpay] = $nr[salary] ;				break ;
		endswitch ;
	$nr[daypay] = sprintf("%01.2f",$nr[daypay]) ;
	$nr[hourpay] = sprintf("%01.2f",$nr[hourpay]) ;
	$nr[approved_by] = lang("payroll staff") ;
	}
   else $nr = $_POST ;

$nrt->nrtrans_write($t, $nr) ;

$t->parse('out','report',True) ;

/*-------------- Post Non-recurring Payroll Item ----------------------------------------------*/

	if (isset($post)) {
		$err = $nrt->nrtrans_validate($nr,$oldeaid) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$nrt->nrtrans_post($nr,$t,'edit','nrtransedit');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter&oldeaid=$oldeaid" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-payroll/nrtranslist.php",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_refresh',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-payroll/nrtransedit.php",$getstr)) ;
		$t->set_var('lang_post',lang('Post Non-recurring Payroll Item'));
		$t->set_var('lang_refresh',lang('Refresh Screen'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-payroll/nrtranslist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
