<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrolladd.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$refresh = ($_GET["refresh"]) ? $_GET["refresh"] : $_POST["refresh"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$py = CreateObject('ck-payroll.payroll') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('report','payrollscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');
	$t->set_var('lang_title',lang('Add Individual Staff Payroll'));
	$msg0 = lang('If basic salary > 0, a single recurring (basesalary) must be present.');
	$msg1 = lang('Basis of Calculation');
	$msg2 = lang('bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,') ;
	$msg3 = lang('hp - imputed hourly pay, qty - qty input, amt - amount input');
	$msg4 = lang('Reduction/Contribution');
	$msg5 = lang('If Company Contribution is to match Reduction(Employee Contribution),') ;
	$msg6 = lang('then the specific contribution type should have exactly the same setup as its reduction counterpart.');
	$t->set_var('message',"<b>$msg0</b><br><b>$msg1:</b><br>$msg2  $msg3<br><b>$msg4:</b><br>$msg5 $msg6") ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	$py->payroll_header_write($t, $_POST) ;
	$py->payroll_detail_write($t, $_POST,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $py->payroll_validate($_POST,'') ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$py->payroll_post($_POST,$t,'new','payrolladd');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr="filter=$filter";
	$return = ($filter=="") ? "payrollfilter.php" : "payrolllist.php" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-payroll/$return",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_rdnewrow',lang('Done'));
		$t->set_var('lang_ctnewrow',lang('Done'));
		$t->set_var('lang_refresh',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-payroll/payrolladd.php",$getstr)) ;
		$t->set_var('lang_post',lang('Post Individual Staff Payroll'));
		$t->set_var('lang_newrow',lang('Add New Recurring Allowance/Deduction Row'));
		$t->set_var('lang_rdnewrow',lang('Add New Reduction Row'));
		$t->set_var('lang_ctnewrow',lang('Add New Contribution Row'));
		$t->set_var('lang_refresh',lang('Refresh Screen'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-payroll/$return",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
