<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pjlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'pjlist.tpl', 'pj'=>'pjlist.tpl'));
	$t->set_block('pj','pj_row','pj_section');
	$t->set_var('message','');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Salary Payment Journal List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/genpayrollfilter.php'));

$t->set_var('sort_empid',$nm->show_sort_order($sort,'empid',$order,'/ck-payroll/pjlist.php',lang('Employee ID')));
$t->set_var('sort_empname',$nm->show_sort_order($sort,'empname',$order,'/ck-payroll/pjlist.php',lang('Employee Name')));
$t->set_var('sort_datefrom',$nm->show_sort_order($sort,'datefrom',$order,'/ck-payroll/pjlist.php',lang('Date From')));
$t->set_var('sort_dateto',$nm->show_sort_order($sort,'dateto',$order,'/ck-payroll/pjlist.php',lang('Date To')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-payroll/pjlist.php',lang('Description')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-payroll/pjlist.php',lang('Audit Id')));
$t->set_var('lang_delete',lang('Delete'));

$lang_from = lang('from') ;
$lang_to = lang('to') ;
$lang_empid = lang('empid') ;
$lang_period = lang('period') ;
$frmarker = $lang_from.'/' ;  $frmarkerlen=strlen($frmarker);
$tomarker = $lang_to.'/' ;  $tomarkerlen = strlen($tomarker) ;
$empidmarker = $lang_empid.'-' ; $empidmarkerlen = strlen($empidmarker) ;
$frompos = "position('$frmarker' in description)+$frmarkerlen" ;
$topos = "position('$tomarker' in description)+$tomarkerlen" ;
$empidpos = "position('$empidmarker' in description)+$empidmarkerlen" ;
$empidlen = "position('$lang_period' in description)-($empidpos)-1" ;
$descdatefrom = "substring(description,$frompos,10)" ;
$descdateto = "substring(description,$topos,10)" ;
$descempid =  "substring(description,$empidpos,$empidlen)" ;

if (!$order)	$order = "datefrom,dateto" ;
if (!$sort)	$sort = "ASC" ;
$sql =	"SELECT $descempid as empid, name, $descdatefrom as datefrom,$descdateto as dateto,description,a.id " ;
$sql.=	"FROM gl a, employee b $where and source='PYPY' and $descempid=b.id order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'empid'		=> lang("No Matching Item Found"),
				'empname'	=> "",
				'datefrom'	=> "",
				'dateto'	=> "",
				'description'	=> "",
				'id'		=> "",
				'delete'	=> "",
									));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('pj_section','pj_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$empid	= $phpgw->db->f('empid') ;
	$getstr	= "id=$id&empid=$empid&filter=$filter" ;
	$t->set_var(array(	'empid'		=> $empid,
				'empname'	=> $phpgw->db->f('name'),
				'datefrom'	=> $phpgw->db->f('datefrom'),
				'dateto'	=> $phpgw->db->f('dateto'),
				'description'	=> $phpgw->db->f('description'),
				'id'		=> $id,
				'delete'	=> $phpgw->link('/ck-payroll/pjdelete.php',$getstr)
										));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('pj_section','pj_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','pj','report');

?>
