<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pyrcodelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array(	'report'=>'pyrcodelist.tpl', 'pyrcode'=>'pyrcodelist.tpl'));
	$t->set_block('pyrcode','pyrcode_row','pyrcode_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang("List of Allowance/Deduction Codes"));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_note1',lang('Basis of Calculation'));
$t->set_var('lang_note2',lang('bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay, hp - imputed hourly pay, qty - inputted qty, amt - inputted amount'));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-payroll/pyrcodelist.php',lang('Code Name (10 char max)')));
$t->set_var('sort_description',$nm->show_sort_order($sort,"description",$order,'/ck-payroll/pyrcodelist.php',lang('Description (50 char max)')));
$t->set_var('sort_basis',$nm->show_sort_order($sort,"basis",$order,'/ck-payroll/pyrcodelist.php',lang('Basis of Calculation')));
$t->set_var('sort_minqty',$nm->show_sort_order($sort,"minqty",$order,'/ck-payroll/pyrcodelist.php',lang('Min Qty')));
$t->set_var('sort_maxqty',$nm->show_sort_order($sort,"maxqty",$order,'/ck-payroll/pyrcodelist.php',lang('Max Qty')));
$t->set_var('sort_minamt',$nm->show_sort_order($sort,"minamt",$order,'/ck-payroll/pyrcodelist.php',lang('Min Amount')));
$t->set_var('sort_maxamt',$nm->show_sort_order($sort,"maxamt",$order,'/ck-payroll/pyrcodelist.php',lang('Max Amount')));
$t->set_var('sort_unitamt',$nm->show_sort_order($sort,"unitamt",$order,'/ck-payroll/pyrcodelist.php',lang('Unit Amount')));
$t->set_var('sort_unit',$nm->show_sort_order($sort,"unit",$order,'/ck-payroll/pyrcodelist.php',lang('Qty Unit')));
$t->set_var('sort_rate',$nm->show_sort_order($sort,"rate",$order,'/ck-payroll/pyrcodelist.php',lang('Pay Rate')));
$t->set_var('sort_allowdelete',$nm->show_sort_order($sort,"allowdelete",$order,'/ck-payroll/pyrcodelist.php',lang('Allow<br>Delete')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-payroll/pyrcodelist.php',lang('Audit Id')));

if (!$order) $order = "name" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * from pyrcode $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'description'	=> "",
				'basis'		=> "",
				'minqty'	=> "",
				'maxqty'	=> "",
				'minamt'	=> "",
				'maxamt'	=> "",
				'unitamt'	=> "",
				'unit'		=> "",
				'rate'		=> "",
				'allowdelete'	=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('pyrcode_section','pyrcode_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$name = $phpgw->db->f("name") ;
	$allowdelete = $phpgw->db->f("allowdelete") ;
	$allowdelete = ($allowdelete=="y" or $allowdelete=="Y") ? lang("Yes") : lang("No") ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $name,
				'description'	=> $phpgw->db->f("description"),
				'basis'		=> $phpgw->db->f("basis"),
				'minqty'	=> $phpgw->db->f("minqty"),
				'maxqty'	=> $phpgw->db->f("maxqty"),
				'minamt'	=> $phpgw->db->f("minamt"),
				'maxamt'	=> $phpgw->db->f("maxamt"),
				'unitamt'	=> $phpgw->db->f("unitamt"),
				'unit'		=> $phpgw->db->f("unit"),
				'rate'		=> $phpgw->db->f("rate"),
				'allowdelete'	=> $allowdelete,
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-payroll/pyrcodeview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-payroll/pyrcodeedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-payroll/pyrcodecopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-payroll/pyrcodedelete.php',$getstr)  ));
	if ($name=="basesalary")	$t->set_var(array('lang_delete'=>'','delete'=>"")) ;
		else			$t->set_var('lang_delete',lang('Delete')) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('pyrcode_section','pyrcode_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add New Allowance/Deduction Code"));
	$t->set_var('add_action',$phpgw->link('/ck-payroll/pyrcodeadd.php',$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));

	$t->pparse('out','pyrcode','report');

?>
