<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reductnview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-payroll', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$rdtn = CreateObject('ck-payroll.reductn') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('report','reductnscreen.tpl') ;
	$t->set_block('report','exem','exem_section');
	$t->set_block('report','ratetbl','rate_section');
	$t->set_var('lang_title',lang('View Summary Level Reduction'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$msg1 = lang("Reduction Amount = (PayrollTotal-ExemptItem-Floor) * Rate(Row i) - Subtract") ;
	$msg2 = lang("Rate(Row i) requires Step(Row i) < (PayrollTotal-ExemptItem-Floor) <= Step(Row i+1)") ;
	$msg3 = lang("It follows that Step values have to be arranged in strictly ascending order") ;
	$t->set_var('message',"$msg1<br>$msg2<br>$msg3");

/*------------- Write Summary Level Reduction to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM reductn WHERE id='$id'");
	$phpgw->db->next_record();
	$rd = $phpgw->db->Record ;
	$rd[desc] = $phpgw->db->f('description') ;
	$rdtn->reductn_header_write($t, $rd) ;

	$phpgw->db->query("SELECT * FROM rdtnexem WHERE rdtnid='$id' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$rd['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$rd['exemmin'.$i]	=	$phpgw->db->f('min') ;
		$rd['exemactmin'.$i]	=	$phpgw->db->f('actmin') ;
		$rd['exemmax'.$i]	=	$phpgw->db->f('max') ;
		$rd['exemactmax'.$i]	=	$phpgw->db->f('actmax') ;
		$i++ ;
		}
	$phpgw->db->query("SELECT * FROM rdtnrate WHERE rdtnid='$id' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$rd['step'.$i]		=	$phpgw->db->f('step') ;
		$rd['rate'.$i]		=	$phpgw->db->f('rate') ;
		$rd['subtract'.$i]	=	$phpgw->db->f('subtract') ;
		$i++ ;
		}
	$rdtn->reductn_detail_write($t,$rd,True,$insert,$delete,$newrow);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	$t->set_var('action',$phpgw->link('/ck-payroll/reductnlist.php',$getstr)) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_exnewrow',lang('Done'));
	$t->set_var('lang_rtnewrow',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-payroll/reductnlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>

