<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pobillhist.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-po', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$po = CreateObject('ck-po.po') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','pobillhist.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View PO Billing History'));
	$t->set_var('message','') ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

/*------------- Write PO Billing History to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM po WHERE id='$id'");
	$phpgw->db->next_record();
	$duedate = $phpgw->db->f('duedate') ;
	$poamount = $phpgw->db->f('amount') ;
	$netamount = $phpgw->db->f('netamount') ;
	$po->po_header_write($t, $phpgw->db->Record, "e") ;

	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_invoiceid',lang('Invoice ID'));
	$t->set_var('lang_invamount',lang('Invoice Amount'));
	$t->set_var('lang_bamount',lang('Amount billed<br>against this PO'));
	$t->set_var('lang_osamount',lang('Outstanding PO<br>Unbilled Amount'));
	$t->set_var('lang_dayselapsed',lang('Days Elapsed since PO<br>due and not fully billed'));

	$t->set_var('date',$duedate);
	$t->set_var('description','<- '.lang('Due Date').' / '.lang('PO Amount').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount',$poamount);
	$t->set_var('dayselapsed','');
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,invnumber,amount,b_amount FROM ap, ipmatch " ;
	$sql.= "WHERE poid='$id' and id=invoiceid ORDER BY transdate" ;
	$phpgw->db->query($sql);
	$osamount = $poamount ;
	while ($phpgw->db->next_record()) {
		$t->set_var('date',$phpgw->db->f('transdate'));
		$lang_invno = lang('Invoice#') ;
		$t->set_var('description',"$lang_invno:    ".$phpgw->db->f('invnumber'));
		$t->set_var('invoiceid',$phpgw->db->f('id'));
		$t->set_var('invamount',$phpgw->db->f('amount'));
		$bamount = $phpgw->db->f('b_amount') ;
		$t->set_var('bamount',$bamount);
		$osamount -= $bamount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description','<- '.lang('System Date').' / '.lang('Days Overdue').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount','');
	$overdue = (time()-strtotime($duedate))/86400 ;
	
	$overdue = ($overdue<0 or $osamount<=0) ? lang("N/A") : floor($overdue) ;
	$t->set_var('dayselapsed',$overdue);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	if ($poamount==$netamount)
		$t->set_var('action',$phpgw->link('/ck-po/pontlist.php',"filter=$filter")) ;
	    else $t->set_var('action',$phpgw->link('/ck-po/powtlist.php',"filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	if ($poamount==$netamount)
		$t->set_var('done_action',$phpgw->link('/ck-po/pontlist.php',"filter=$filter")) ;
	    else $t->set_var('done_action',$phpgw->link('/ck-po/powtlist.php',"filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
