<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: taxlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-po',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-po'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'taxlist.tpl',	'tax'=>'taxlist.tpl'));
	$t->set_block('tax','tax_row','tax_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Taxes'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Tax'));
$t->set_var('add_action',$phpgw->link('/ck-po/taxadd.php',"filter=$filter"));
$t->set_var('sort_taxnumber',$nm->show_sort_order($sort,'taxnumber',$order,'/ck-po/taxlist.php',lang('Tax Number/Name'),$filter));
$t->set_var('sort_rate',$nm->show_sort_order($sort,'rate',$order,'/ck-po/taxlist.php',lang('Tax Rate'),$filter));
$t->set_var('sort_notes',$nm->show_sort_order($sort,'notes',$order,'/ck-po/taxlist.php',lang('Notes'),$filter));
$t->set_var('sort_chart_id',$nm->show_sort_order($sort,'chart_id',$order,'/ck-po/taxlist.php',lang('Chart Id'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-po/taxlist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "taxnumber" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from tax $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'taxnumber'	=> lang("No Matching Item Found"),
				'rate'		=> "",
				'notes'		=> "",
				'chart_id'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('tax_section','tax_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'taxnumber'	=> $phpgw->db->f('taxnumber'),
				'rate'		=> $phpgw->db->f('rate'),
				'notes'		=> $phpgw->db->f('notes'),
				'chart_id'	=> $phpgw->db->f('chart_id'),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-po/taxview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-po/taxedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-po/taxcopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-po/taxdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('tax_section','tax_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','tax','report');

?>
