<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cswtdelete.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-c',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$cswt = CreateObject('ck-pos-c.cswt') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-c'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','cswtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','addon','addon_section');
	$t->set_block('report','qcash','qcash_section');
	$t->set_var('lang_title',lang('Delete Cash Sale [With Tax]'));
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");
	$t->set_var('csmessage',"");
	$t->set_var('aomessage',"");
	$t->set_var('qcmessage',"");
	$t->set_var('message',"");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to delete ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-pos-c/cswtdelete.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$cs[id] = $id ;
		$cswt->cswt_post($cs, $t, $id, 'delete','cswtdelete');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		exit;
		}

/*------------- Write Cash Sale Detail to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM pos WHERE id='$id'");
	$phpgw->db->next_record();
	$cs = $phpgw->db->Record ;
	$cs[taxstatus] = $phpgw->db->f('taxincluded') ;
	$cswt->cswt_header_write($t, $cs) ;

	$sql = "SELECT * FROM positem WHERE trans_id='$id' and (itemtype='i' or itemtype='s') ORDER BY id" ;
	$phpgw->db->query($sql);
	$i=1;
	while ($phpgw->db->next_record()) {
		$cs['csitemid'.$i]	=	$phpgw->db->f('itemid') ;
		$cs['csitemtype'.$i]	=	$phpgw->db->f('itemtype') ;
		$cs['csqty'.$i]		=	$phpgw->db->f('qty') ;
		$cs['csunit'.$i]	=	$phpgw->db->f('unit') ;
		$cs['csprice'.$i]	=	$phpgw->db->f('price') ;
		$cs['csdiscount'.$i]	=	$phpgw->db->f('discount') ;
		$cs['cstax1'.$i]	=	$phpgw->db->f('tax1') ;
		$cs['cstax2'.$i]	=	$phpgw->db->f('tax2') ;
		$cs['cstax1accid'.$i]	=	$phpgw->db->f('tax1acc_id') ;
		$cs['cstax2accid'.$i]	=	$phpgw->db->f('tax2acc_id') ;
		$i++ ;
		}
	$phpgw->db->query("SELECT * FROM positem WHERE trans_id='$id' and itemtype='a' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$cs['aoitemid'.$i]	=	$phpgw->db->f('itemid') ;
		$i++ ;
		}
	$phpgw->db->query("SELECT * FROM positem WHERE trans_id='$id' and itemtype='q' ORDER BY id");
	$i=1;
	while ($phpgw->db->next_record()) {
		$cs['qcitemid'.$i]	=	$phpgw->db->f('itemid') ;
		$cs['qcqty'.$i]		=	$phpgw->db->f('qty') ;
		$cs['qcvalue'.$i]	=	$phpgw->db->f('value') ;
		$i++ ;
		}
	$cswt->cswt_detail_write($t,$cs,True,True);
	$cswt->cswt_addon_write($t,$cs,True,$delete,False,True);
	$cswt->cswt_qcash_write($t,$cs,True,$delete,False);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
