<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cswtedit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-c',	'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$update = ($_GET["update"]) ? $_GET["update"] : $_POST["update"] ;
	$filter=urlencode(stripslashes($filter));

	$cswt = CreateObject('ck-pos-c.cswt') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-c'));
	$t->set_file('report','cswtscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','addon','addon_section');
	$t->set_block('report','qcash','qcash_section');
	$t->set_var('lang_title',lang('Edit Cash Sale [With Tax]'));
	$t->set_var('csmessage',"");
	$t->set_var('aomessage',"");
	$t->set_var('qcmessage',"");
	$message = lang("Creation of new Cash Sale requires Start-of-shift transaction for the current cash box, transaction date and shift to be completed")." " ;
	$message.= lang("and matching End-of-shift transaction not to have been put through.") ;
	$message.= "    ".lang("If Unit Price includes tax, discount is ignored.") ;
	$message.= "    ".lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$t->set_var('message',$message);

/*------------- Write Cash Sale to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$phpgw->db->query("SELECT * FROM pos WHERE id='$id'");
		$phpgw->db->next_record();
		$cs = $phpgw->db->Record ;
		$cs[taxstatus] = $phpgw->db->f('taxincluded') ;
		}
	    else $cs = $_POST ;
	$cswt->cswt_header_write($t, $cs) ;

	if (!isset($newrow) and !isset($post) and !isset($delete) and !isset($update)) {
		$firstime = True ;
		$sql = "SELECT * FROM positem " ;
		$sql.= "WHERE trans_id='$id' and (itemtype='i' or itemtype='s') ORDER BY id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$cs['csitemid'.$i]	=	$phpgw->db->f('itemid') ;
			$cs['csitemtype'.$i]	=	$phpgw->db->f('itemtype') ;
			$cs['csqty'.$i]		=	$phpgw->db->f('qty') ;
			$cs['csunit'.$i]	=	$phpgw->db->f('unit') ;
			$cs['csprice'.$i]	=	$phpgw->db->f('price') ;
			$cs['csdiscount'.$i]	=	$phpgw->db->f('discount') ;
			$cs['cstax1'.$i]	=	$phpgw->db->f('tax1') ;
			$cs['cstax2'.$i]	=	$phpgw->db->f('tax2') ;
			$cs['cstax1accid'.$i]	=	$phpgw->db->f('tax1acc_id') ;
			$cs['cstax2accid'.$i]	=	$phpgw->db->f('tax2acc_id') ;
			$i++ ;
			}
		$sql = "SELECT * FROM positem " ;
		$sql.= "WHERE trans_id='$id' and itemtype='a' ORDER BY id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$cs['aoitemid'.$i]	=	$phpgw->db->f('itemid') ;
			$i++ ;
			}
		$sql = "SELECT * FROM positem " ;
		$sql.= "WHERE trans_id='$id' and itemtype='q' ORDER BY id" ;
		$phpgw->db->query($sql);
		$i=1;
		while ($phpgw->db->next_record()) {
			$cs['qcitemid'.$i]	=	$phpgw->db->f('itemid') ;
			$cs['qcqty'.$i]		=	$phpgw->db->f('qty') ;
			$cs['qcvalue'.$i]	=	$phpgw->db->f('value') ;
			$i++ ;
			}
		}
	    else $cs = $_POST ;
	    
	$cswt->cswt_transform($cs,$newrow,$delete) ;
	$cswt->cswt_detail_write($t,$cs,$posted,$firstime) ;

	if (isset($newrow))	{
		$cswt->cswt_addon_write($t,$cs,$posted,$delete,$newrow,$firstime);
		$cswt->cswt_qcash_write($t,$cs,$posted,$delete,$newrow);
		}
	    else {
		$cswt->cswt_addon_write($t,$cs,$posted,$delete,False,$firstime);
		$cswt->cswt_qcash_write($t,$cs,$posted,$delete,False);
		}

/*-------------- Post Cash Sale ----------------------------------------------*/

	if (isset($post)) {
		$err = $cswt->cswt_validate($cs) ;
		if (substr_count($err,lang("csError:"))>0)	$t->set_var('csmessage',$err);
		if (substr_count($err,lang("Warning:"))>0)	{$t->set_var('csmessage',$err); $err="" ;}
		if (substr_count($err,lang("aoError:"))>0)	$t->set_var('aomessage',$err);
		if (substr_count($err,lang("qcError:"))>0)	$t->set_var('qcmessage',$err);
		if ($err=='') { $posted = $cswt->cswt_post($cs, $t, $id, 'edit', 'cswtedit') ; }
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_csnewrow',lang('Done'));
		$t->set_var('lang_aonewrow',lang('Done'));
		$t->set_var('lang_qcnewrow',lang('Done'));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('readonly',"readonly");
		$t->set_var('disabled',"disabled");
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-pos-c/cswtedit.php',$getstr)) ;
		$t->set_var('lang_post',lang('Post Cash Sale [with Tax]'));
		$t->set_var('lang_update',lang('Refresh Page'));
		$t->set_var('readonly',"");
		$t->set_var('disabled',"");
		}
	$t->set_var('done_action',$phpgw->link('/ck-pos-c/cswtlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
