<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cswtlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-c', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-c'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'cswtlist.tpl',	'csale'=>'cswtlist.tpl'));
	$t->set_block('csale','cs_row','cs_section');

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
$t->set_var('lang_title',lang('List of Cash Sales [with Tax]'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_note1',lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
$t->set_var('lang_add',lang('Add New Cash Sales'));
$t->set_var('add_action',$phpgw->link('/ck-pos-c/cswtadd.php',"filter=$filter"));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_memo',lang('Sales Memo'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));
if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-pos-c/cswtlist.php',lang('Sale Date')));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,'/ck-pos-c/cswtlist.php',lang('Shift')));
$t->set_var('sort_cashbox',$nm->show_sort_order($sort,'cashbox',$order,'/ck-pos-c/cswtlist.php',lang('Cash Box')));
$t->set_var('sort_posnumber',$nm->show_sort_order($sort,'posnumber',$order,'/ck-pos-c/cswtlist.php',lang('Cash Sale#')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-pos-c/cswtlist.php',lang('Amount')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-pos-c/cswtlist.php',lang('Audit Id')));

$sql =  "SELECT transdate,a.shift as shift,posnumber,b.name as cashbox,amount,a.id as id " ;
$sql.=  "FROM pos a, cashbox b $where AND a.cboxid=b.id ORDER BY $order $sort" ;

$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'cashbox'	=> "",
				'posnumber'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'view'		=> "",
				'memo'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cs_section','cs_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'cashbox'	=> $phpgw->db->f('cashbox'),
				'posnumber'	=> $phpgw->db->f('posnumber'),
				'amount'	=> $phpgw->db->f('amount'),
				'id'		=> $phpgw->db->f('id'),
		'view'		=> $phpgw->link('/ck-pos-c/cswtview.php',$getstr),
		'memo'		=> $phpgw->link('/ck-pos-c/cswtmemo.php',$getstr),
		'edit'		=> $phpgw->link('/ck-pos-c/cswtedit.php',$getstr),
		'copy'		=> $phpgw->link('/ck-pos-c/cswtcopy.php',$getstr),
		'delete'	=> $phpgw->link('/ck-pos-c/cswtdelete.php',$getstr) ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cs_section','cs_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','csale','report');

?>
