<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cswt.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class cswt {

//---- Cash Sale Detail Validation Checks

    function cswt_validate($cs) {
	global $phpgw ;

	$err = "";
	$csrow = lang("csRow") ;
	$cserr = lang("csError:") ;
	if (input2date($cs[transdate])=="")		$err="$cserr ".lang("Invalid Cash Sale Date");
	For ($i=1;isset($cs['csitemid'.$i]);$i++) {
		$csrowi = "[$csrow $i]" ;
		if ($cs['csitemid'.$i]=='')		$err="$csrowi$cserr ".lang("Item Code Missing");
		if ($cs['csqty'.$i] and !is_numeric($cs['csqty'.$i]))
							$err="$csrowi$cserr ".lang("Invalid Qty, must be numeric");
		if ($cs['csdiscount'.$i] and !is_numeric($cs['csdiscount'.$i]))
							$err="$csrowi$cserr ".lang("Invalid Discount, must be numeric");
		}
	$cstotal = $cs[cstotal] ;
	$cserrstatus = $err ;
	$aorow = lang("aoRow") ;
	$aoerr = lang("aoError:") ;
	For ($i=1;isset($cs['aoitemid'.$i]);$i++) {
		$aorowi = "[$aorow $i]" ;
		if ($cs['aoitemid'.$i]=='')		$err="$aorowi$aoerr ".lang("Item Code Missing");
		  else	{
			$aoitemid = $cs['aoitemid'.$i] ;
			$phpgw->db->query("SELECT * FROM addon WHERE id='$aoitemid'");
			if ($phpgw->db->next_record()) {
				$mincount = $phpgw->db->f("mincount") ;
				$maxcount = $phpgw->db->f("maxcount") ;
				$minsale = $phpgw->db->f("minsale") ;
				$maxsale = $phpgw->db->f("maxsale") ;
				}
			$count = 0 ;
			For ($j=1;isset($cs['aoitemid'.$j]);$j++) {
				if ($cs['aoitemid'.$j]==$aoitemid)	$count++ ;
				}
			if ($count<$mincount)	$err="$aoerr ".lang("Item count < Min count for").$aorowi ;
			if ($count>$maxcount)	$err="$aoerr ".lang("Item count > Max count for").$aorowi ;
			if ($cstotal<$minsale)		$err="$aoerr ".lang("Total Gross Sale < Min sale for").$aorowi ;
			if ($cstotal>$maxsale)	$err="$aoerr ".lang("Total Gross Sale > Max sale for").$aorowi ;
			}
		}
	if ($i==2 and $cs[aoitemid1]=='')		$err = $cserrstatus ;
	$qcrow = lang("qcRow") ;
	$qcerr = lang("qcError:") ;
	For ($i=1;isset($cs['qcitemid'.$i]);$i++) {
		$qcrowi = "[$qcrow $i]" ;
		if ($cs['qcitemid'.$i]=='')		$err="$qcrowi$qcerr ".lang("Item Code Missing");
		  else	{
			if ($cs['qcqty'.$i] and !is_numeric($cs['qcqty'.$i]))
						$err="$qcrowi$qcerr ".lang("Invalid Qty, must be numeric");
			if ($cs['qcvalue'.$i] and !is_numeric($cs['qcvalue'.$i]))
						$err="$qcrowi$qcerr ".lang("Invalid Value, must be numeric");
			$qcitemid = $cs['qcitemid'.$i] ;
			$phpgw->db->query("SELECT * FROM qcash WHERE id='$qcitemid'");
			if ($phpgw->db->next_record()) {
				$minsale = $phpgw->db->f("minsale") ;
				$maxsale = $phpgw->db->f("maxsale") ;
				$minqty = $phpgw->db->f("minqty") ;
				$maxqty = $phpgw->db->f("maxqty") ;
				$minvalue = $phpgw->db->f("minvalue") ;
				$maxvalue = $phpgw->db->f("maxvalue") ;
				}
			$qty = $value = 0 ;
			For ($j=1;isset($cs['qcitemid'.$j]);$j++) {
				if ($cs['qcitemid'.$j]==$qcitemid) {
					$qty += $cs['qcqty'.$j] ;
					$value += $cs['qcvalue'.$j] ;
					}
				}
			if ($qty<$minqty)		$err="$qcerr ".lang("Total item qty < Min qty for").$qcrowi ;
			if ($qty>$maxqty)		$err="$qcerr ".lang("Total item qty > Max qty for").$qcrowi ;
			if ($value<$minvalue)	$err="$qcerr ".lang("Total item value < Min value for").$qcrowi ;
			if ($value>$maxvalue)	$err="$qcerr ".lang("Total item value > Max value for").$qcrowi ;
			if ($cstotal<$minsale)		$err="$qcerr ".lang("Total Gross Sale < Min sale for").$qcrowi ;
			if ($cstotal>$maxsale)	$err="$qcerr ".lang("Total Gross Sale > Max sale for").$qcrowi ;
			}
		}
	if ($cs[totqc]<$cs[totpay])			$err="$qcerr ".lang("Total Tendered < Total Payable") ;
	if ($cs[cboxid]=="")				$err="$cserr ".lang("Cashier with no Cash Box assigned");
	  else	{
		$sql = "SELECT * FROM cbtran WHERE cboxid='$cs[cboxid]' and transdate='$cs[transdate]' and " ;
		$sql.=				"shift='$cs[shift]' and trantype='s'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()<=0)	$err="$cserr ".lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM cbtran WHERE cboxid='$cs[cboxid]' and transdate='$cs[transdate]' and " ;
		$sql.=				"shift='$cs[shift]' and trantype='e'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()>0)	$err="$cserr ".lang("Cashbox closed (end-of-shift completed)") ;
		}
	if (!$err and $cs[cboxid]<>"")	{
		$sql = "SELECT * FROM cbtran WHERE cboxid='$cs[cboxid]' and transdate='$cs[transdate]' and " ;
		$sql.=				"shift='$cs[shift]' and trantype='s'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()<=0)	$err="$cserr ".lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM cbtran WHERE cboxid='$cs[cboxid]' and transdate='$cs[transdate]' and " ;
		$sql.=				"shift='$cs[shift]' and trantype='e'" ;
		$phpgw->db->query($sql) ;
		if ($phpgw->db->num_rows()>0)	$err="$cserr ".lang("Cashbox closed (end-of-shift completed)") ;
		  else	{
			$phpgw->db->query("SELECT * FROM cashbox where id='$cs[cboxid]'") ;
			$phpgw->db->next_record() ;
			$maxcash = $phpgw->db->f('maxcash') ;
			$cashbal = cashbalance($cs[cboxid],$cs[transdate],$cs[shift]) ;
			$warning = lang("Warning:") ;
			if ($cashbal>=$maxcash)	$err="$warning ".lang("Cash Full Level reached") ;
			}
		}
	if ($err)	$err = "<b><font size='+2'>$err</font></b>" ;
	return $err ;
	}

//---- Post Cash Sale to Database

    function cswt_post($cs, &$t, &$id, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $cs[id] ;
	$source	= "CSWT" ;
	$transdate = $cs['transdate'] ;
	$netamount = $cs[cstotnet] + $cs[aonet] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$posnumber = ($op=='edit') ? $cs[posnumber] : "$user:".date("Ymd:His") ;
	$desc = "CS: Cash Sale# $posnumber" ;
	$ildesc = "CS: GD against CS# $posnumber" ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO pos(id,cboxid,cashier,posnumber,transdate,shift,customer,taxincluded,amount,netamount) ";
			$sql.="VALUES ('$id','$cs[cboxid]','$cs[cashier]','$posnumber','$transdate',$cs[shift]," ;
			$sql.="'$cs[customer]','$cs[taxstatus]','$cs[totpay]','$netamount')" ;
			$phpgw->db->query($sql);
			$sql = "INSERT INTO gl (id,source,description,transdate) VALUES ('$id','$source','$desc','$transdate')" ;
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "UPDATE pos SET cboxid='$cs[cboxid]',cashier='$cs[cashier]',posnumber='$posnumber'," ;
			$sql.= "transdate='$transdate',shift='$cs[shift]',customer='$cs[customer]',taxincluded='$cs[taxstatus]',";
			$sql.= "amount='$cs[totpay]',netamount='$netamount' " ;
			$sql.= "WHERE id=$id";
			$phpgw->db->query($sql);
			$sql = "UPDATE gl SET source='$source',description='$desc',transdate='$transdate' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE from pos where id = $id");
			$phpgw->db->query("DELETE from gl where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	if ($op<>'new')	{
		$phpgw->db->query("DELETE from positem where trans_id=$id");
		$phpgw->db->query("DELETE from acc_trans where trans_id=$id");
		$phpgw->db->query("DELETE from il where id=$id");
		$phpgw->db->query("DELETE from inv_trans where trans_id=$id");
		}

	if ($op<>'delete') {
		$invitem = False ;
		For ($i=1;isset($cs['csitemid'.$i]);$i++) {
			$csitemid	= $cs['csitemid'.$i];
			$csitemtype	= $cs['csitemtype'.$i];
			$csunit		= $cs['csunit'.$i];
			$csqty		= $cs['csqty'.$i];
			$csprice	= $cs['csprice'.$i];
			$csdiscount	= $cs['csdiscount'.$i];
			$netamount	= $cs['csnetamount'.$i] ;
			$cost		= $cs['cscost'.$i] ;
			$invaccid	= $cs['csinvaccid'.$i] ;
			$incaccid	= $cs['csincaccid'.$i] ;
			$expaccid	= $cs['csexpaccid'.$i] ;
			$tax1		= $cs['cstax1'.$i] ;
			$tax2		= $cs['cstax2'.$i] ;
			$tax1accid	= $cs['cstax1accid'.$i] ;
			$tax2accid	= $cs['cstax2accid'.$i] ;
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$incaccid','$netamount','$transdate')";
			$phpgw->db->query($sql);
			if ($tax1<>0) {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$tax1accid','$tax1','$transdate')";
				$phpgw->db->query($sql);
				}
			if ($tax2<>0) {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$tax2accid','$tax2','$transdate')";
				$phpgw->db->query($sql);
				}
			if ($csitemtype=="i" and $cost<>0 and $cost<>'') {
				$cogs = number_format($csqty*$cost,2,".",'') ;
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$expaccid','-$cogs','$transdate')";
				$phpgw->db->query($sql);
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$invaccid','$cogs','$transdate')";
				$phpgw->db->query($sql);
				$sql = "INSERT INTO inv_trans (trans_id,order_id,parts_id,qty,transdate) " ;
				$sql.= "VALUES ('$id','$id','$csitemid','-$csqty','$transdate')" ;
				$phpgw->db->query($sql);
				$invitem = True ;
				}
			$invaccid = ($invaccid=="") ? 0 : $invaccid ;
			$incaccid = ($incaccid=="") ? 0 : $incaccid ;
			$expaccid = ($expaccid=="") ? 0 : $expaccid ;
			$tax1accid = ($tax1accid=="") ? 0 : $tax1accid ;
			$tax2accid = ($tax2accid=="") ? 0 : $tax2accid ;
			$sql = "INSERT INTO positem (trans_id,invacc_id,incacc_id,expacc_id," ;
			$sql.=			"itemid,itemtype,qty,price,cost,discount,unit," ;
			$sql.=			"tax1,tax2,tax1acc_id,tax2acc_id) " ;
			$sql.= "VALUES ('$id','$invaccid','$incaccid','$expaccid','$csitemid','$csitemtype'," ;
			$sql.=			"'$csqty','$csprice','$cost','$csdiscount','$csunit',";
			$sql.=			"'$tax1','$tax2','$tax1accid','$tax2accid')";
			$phpgw->db->query($sql);
			}
		if ($invitem == True) {
			$sql = "INSERT INTO il (id,source,description,to_from,transdate) " ;
			$sql.= "VALUES ('$id','$source','$ildesc','$cs[customer]','$transdate') " ;
			$phpgw->db->query($sql) ;
			}
		For ($i=1;isset($cs['aoitemid'.$i]);$i++) {
			$aoitemid = $cs['aoitemid'.$i] ;
			if ($aoitemid=="")	continue ;
			$aovalue	= $cs['aovalue'.$i] ;
			$aofactor	= $cs['aofactor'.$i] ;
			$aoamount	= $cs['aoamount'.$i] ;
			$aoincaccid	= $cs['aoincaccid'.$i] ;
			$aoexpaccid	= $cs['aoexpaccid'.$i] ;
			$tax1		= $cs['aotax1'.$i] ;
			$tax2		= $cs['aotax2'.$i] ;
			$tax1accid	= $cs['aotax1accid'.$i] ;
			$tax2accid	= $cs['aotax2accid'.$i] ;
			$chartid = ($aoamount>0) ? $aoincaccid : $aoexpaccid ;
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chartid','$aoamount','$transdate')";
			$phpgw->db->query($sql);
			if ($tax1<>0) {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$tax1accid','$tax1','$transdate')";
				$phpgw->db->query($sql);
				}
			if ($tax2<>0) {
				$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
				$sql.= "VALUES ('$id','$tax2accid','$tax2','$transdate')";
				$phpgw->db->query($sql);
				}
			$sql = "INSERT INTO positem (trans_id,incacc_id,expacc_id,itemid,itemtype,value,factor," ;
			$sql.=					"tax1,tax2,tax1acc_id,tax2acc_id) " ;
			$sql.= "VALUES ('$id','$aoincaccid','$aoexpaccid','$aoitemid','a','$aovalue','$aofactor'," ;
			$sql.=				"'$tax1','$tax2','$tax1accid','$tax2accid')";
			$phpgw->db->query($sql);
			}

		For ($i=1;isset($cs['qcitemid'.$i]);$i++) {
			$qcitemid = $cs['qcitemid'.$i] ;
			$qcqty = $cs['qcqty'.$i] ;
			$qcvalue = $cs['qcvalue'.$i] ;
			$qcamount = $cs['qcamount'.$i] ;
			$qcposaccid = $cs['qcposaccid'.$i] ;
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$qcposaccid','-$qcamount','$transdate')";
			$phpgw->db->query($sql);
			$sql = "INSERT INTO positem (trans_id,posacc_id,itemid,itemtype,qty,value) " ;
			$sql.= "VALUES ('$id','$qcposaccid','$qcitemid','q','$qcqty','$qcvalue')" ;
			$phpgw->db->query($sql);
			}
		if ($cs[qcchange]<>0) {
			$sql = "INSERT INTO acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$cs[cashaccid]','$cs[qcchange]','$transdate')" ;
			$phpgw->db->query($sql);
			$sql = "INSERT INTO positem (trans_id,posacc_id,itemid,itemtype,qty,value) " ;
			$sql.= "VALUES ('$id','$cs[cashaccid]',0,'c','1','-$cs[qcchange]')" ;
			$phpgw->db->query($sql);
			}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Cash Sale") ;
	$t->set_var("message","<b>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$type $tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Cash Sale Header

    function cswt_header_write(&$t, $cs) {
	global $phpgw, $phpgw_info ;

	$taxstatus = $cs[taxstatus] ;
	$t->set_var('lang_posnumber',lang('Cash Sale#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_cashier',lang('Cashier:')." ");
	$t->set_var('lang_cashbox',lang('Cash Box:')." ");
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_shift',lang('Shift'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('posnumber',$cs[posnumber]) ;
	$cashier = $cs[cashier] ;
	$transdate = $cs[transdate] ;
	$shift = $cs[shift] ;
	$cboxid = $cs[cboxid] ;
	$sql = ($cboxid) ? "SELECT * FROM cashbox WHERE id='$cboxid'" :
			"SELECT * FROM cashbox WHERE cashier='$cashier'" ;
	$phpgw->db->query($sql) ;
	$phpgw->db->next_record() ;
	$t->set_var('cashbox',$phpgw->db->f('name')) ;
	if (!$cboxid)	$cboxid = $phpgw->db->f('id') ;
	if (!$shift)	$shift = $phpgw->db->f('shift') ;
	if ($shift=="1")		$shift_desc = "1 - Morning" ;
	if ($shift=="2")		$shift_desc = "2 - Afternoon" ;
	if ($shift=="3")		$shift_desc = "3 - Overnight" ;
	$t->set_var('id',$cs[id]) ;
	$t->set_var('cashier',$cashier) ;
	$t->set_var('transdate',$transdate) ;
	$t->set_var('shift',$shift) ;
	$t->set_var('shift_desc',$shift_desc) ;
	$t->set_var('cboxid',$cboxid) ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$customer)) ;
	$tax_sl = "<OPTION value='t'>".lang('Tax Included')."</OPTION>" ;
	$tax_sl.= "<OPTION value='f'>".lang('Tax Not Included')."</OPTION>" ;
	$tax_sl.= "<OPTION value='e'>".lang('Tax Exempted')."</OPTION>" ;
	$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$cs[id]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Cash Sales Array

    function cswt_transform(&$cs,$newrow,$delete) {
	global $phpgw ;

	$csrow_ = lang('csRow')." " ;
	$csnewrow = lang('Add New Cash Sale Item Row') ;
//	$cashsale = lang('Cash Sale') ;
	$temp[id] = $cs[id] ;
	$temp[cashier] = $cs[cashier] ;
	$temp[posnumber] = $cs[posnumber] ;
	$temp[transdate] = $cs[transdate] ;
	$temp[shift] = $cs[shift] ;
	$temp[cboxid] = $cs[cboxid] ;
	$temp[customer] = $cs[customer] ;
	$temp[taxstatus] = $cs[taxstatus] ;

	if (isset($delete)) {$delrowno = intval(str_replace($csrow_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($cs['csitemid'.$i]);$i++) {
		$csitemid = $cs['csitemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($csitemid<0)	{
			$csitemid = -$csitemid ;
			$csqty = $cs['csqty'.$i]==0 ? 1 : $cs['csqty'.$i] ;
			$phpgw->db->query("SELECT * FROM assembly WHERE assembly_id='$csitemid'");
			while ($phpgw->db->next_record()) {
				$temp['csitemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['csqty'.$j] = $phpgw->db->f('qty') * $csqty ;
				$j++ ;
				}
			continue ;
			}
		$temp['csitemid'.$j]		=	$cs['csitemid'.$i] ;
		$temp['csitemtype'.$j]		=	$cs['csitemtype'.$i] ;
		$temp['csunit'.$j]		=	$cs['csunit'.$i] ;
		$temp['csqty'.$j]		=	$cs['csqty'.$i] ;
		$temp['csprice'.$j]		=	$cs['csprice'.$i] ;
		$temp['csdiscount'.$j]		=	$cs['csdiscount'.$i] ;
		$temp['cstax1'.$j]		=	$cs['cstax1'.$i] ;
		$temp['cstax2'.$j]		=	$cs['cstax2'.$i] ;
		$temp['cstax1accid'.$j]		=	$cs['cstax1accid'.$i] ;
		$temp['cstax2accid'.$j]		=	$cs['cstax2accid'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$csnewrow ;
	if ($newrow==$csnewrow)				$temp['csitemid'.$j] = "" ;
			
	For ($i=1;isset($cs['aoitemid'.$i]);$i++) {
		$temp['aoitemid'.$i]		=	$cs['aoitemid'.$i] ;
		$temp['aotax1'.$i]		=	$cs['aotax1'.$i] ;
		$temp['aotax2'.$i]		=	$cs['aotax2'.$i] ;
		$temp['aotax1accid'.$i]		=	$cs['aotax1accid'.$i] ;
		$temp['aotax2accid'.$i]		=	$cs['aotax2accid'.$i] ;
		}

	For ($i=1;isset($cs['qcitemid'.$i]);$i++) {
		$temp['qcitemid'.$i]		=	$cs['qcitemid'.$i] ;
		$temp['qcqty'.$i]		=	$cs['qcqty'.$i] ;
		$temp['qcvalue'.$i]		=	$cs['qcvalue'.$i] ;
		}
	
	$cs = $temp ;
	unset($temp) ;
	}

//---- Write Cash Sale Detail

    function cswt_detail_write(&$t,&$cs,$posted,$firstime) {
	global $phpgw,$phpgw_info ;

	$csrow_ = lang('csRow')." " ;
	$csnewrow = lang('Add New Cash Sale Item Row') ;
//	$cashsale = lang('Cash Sale') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$taxstatus = $cs[taxstatus] ;
	$phpgw->db->query("SELECT postax1cap,postax2cap,postax1pref,postax2pref FROM defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(postax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(postax2cap));
	$tax1pref = $phpgw->db->f(postax1pref) ;
	$tax2pref = $phpgw->db->f(postax2pref) ;
	if ($tax1pref=='s') {
		$sql = "SELECT customer_id,chart_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1chartid = $phpgw->db->f(chart_id) ;
		$stax1rate = $phpgw->db->f(rate) ;
		}
	if ($tax2pref=='s') {
		$sql = "SELECT customer_id,chart_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2chartid = $phpgw->db->f(chart_id) ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_csale',lang('Cash Sale Items :'));
	$t->set_var('lang_number',lang('Item Code - Id'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_price',lang('Unit Price'));
	$t->set_var('lang_netamount',lang('Net Sale (w/o tax) [ns]'));
	$t->set_var('lang_grosssale',lang('Gross Sale (with tax) [gs]'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_csnewrow',$csnewrow);
	$item_sl = item_selectlist("",'') ;

	For ($i=1;isset($cs['csitemid'.$i]);$i++) {
		$t->set_var('itemid_fld','csitemid'.$i) ;
		$t->set_var('qty_fld','csqty'.$i);
		$t->set_var('discount_fld','csdiscount'.$i);
		$csitemid = $cs['csitemid'.$i] ;
		$t->set_var('csitemid',$csitemid) ;
		$t->set_var('item_selectlist',str_replace("'$csitemid'","'$csitemid'"." selected",$item_sl));
		$csitemtype = $cs['csitemtype'.$i] ;
		$csunit = $cs['csunit'.$i] ;
		$csqty = ($csitemid<>'' and $cs['csqty'.$i]=='') ? 1 : $cs['csqty'.$i] ;
		$csdiscount = $cs['csdiscount'.$i] ;
		$csprice = $cs['csprice'.$i] ;
		unset($itemid) ;
		$csitemid = ($csitemid=="") ? 0 : $csitemid ;
		$phpgw->db->query("SELECT * FROM sprice WHERE id='$csitemid'") ;
		if ($phpgw->db->next_record()) {
			$itemid = $cs['itemid'.$i] = $phpgw->db->f('itemid') ;
			$name = $phpgw->db->f('name') ;
			$price = $phpgw->db->f('price') ;
			}
		$item_id = ($itemid) ? $itemid : $csitemid ;
		$phpgw->db->query("SELECT * FROM service WHERE id='$item_id'") ;
		if ($phpgw->db->next_record()) {
			$type = "s" ;
			$desc = $phpgw->db->f('description') ;
			$unit = $phpgw->db->f('unit') ;
			$cs['csincaccid'.$i] =  $phpgw->db->f('income_accno_id') ;
			if (!$itemid)	$price = $phpgw->db->f('sellprice') ;
			}
		     else {
			$phpgw->db->query("SELECT * FROM parts WHERE id='$item_id'");
			$phpgw->db->next_record() ;
			$type = "i" ;
			$desc = $phpgw->db->f('description') ;
			$unit = $phpgw->db->f('unit') ;
			$cs['cscost'.$i] = $phpgw->db->f('cost') ;
			$cs['csinvaccid'.$i] =  $phpgw->db->f('inventory_accno_id') ;
			$cs['csincaccid'.$i] =  $phpgw->db->f('income_accno_id') ;
			$cs['csexpaccid'.$i] =  $phpgw->db->f('expense_accno_id') ;
			if (!$itemid)	$price = $phpgw->db->f('sellprice') ;
			}
		$description = ($itemid) ? $name." -- Special -- ".$desc : $desc ;
		$csitemtype = $cs['csitemtype'.$i] = $type;
		$csunit = $cs['csunit'.$i] = $unit ;
		$csprice = $cs['csprice'.$i] = $price ;

		$tax1 = $tax1accid = $tax2 = $tax2accid = 0 ;
		switch ($tax1pref) :
			case "s" :	$tax1rate=$stax1rate; $tax1accid=$stax1chartid; break;
			case "i" :
				$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
				$sql.= "WHERE item_id='$item_id' and tax_id=id and " ;
				$sql.=		"taxtype='1' and taxgroup='cs'" ;
				$phpgw->db->query($sql) ;
				$tax1rate = ($phpgw->db->next_record()) ? $phpgw->db->f(rate) : 0 ;
				$tax1accid = ($tax1rate==0) ? 0 : $phpgw->db->f(chart_id) ;
				break;
			endswitch ;
		switch ($tax2pref) :
			case "s" :	$tax2rate=$stax2rate; $tax2accid=$stax2chartid; break;
			case "i" :
				$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
				$sql.= "WHERE item_id='$item_id' and tax_id=id and " ;
				$sql.=		"taxtype='2' and taxgroup='cs'" ;
				$phpgw->db->query($sql) ;
				$tax2rate = ($phpgw->db->next_record()) ? $phpgw->db->f(rate) : 0 ;
				$tax2accid = ($tax2rate==0) ? 0 : $phpgw->db->f(chart_id) ;
				break;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$netamount = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
				$tax1 = number_format($netamount*$tax1rate,2,".",'') ;
				$tax2 = number_format($netamount*$tax2rate,2,".",'') ;
				$cs['csnetamount'.$i] = $netamount ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$csdiscount = '' ;
				$itemtotal = $cs['csitemtotal'.$i] = number_format($csqty*$csprice,2,".",'') ;
				$tax1 = number_format($itemtotal*$tax1rate/(1+$tax1rate+$tax2rate),2,".",'') ;
				$tax2 = number_format($itemtotal*$tax2rate/(1+$tax1rate+$tax2rate),2,".",'') ;
				$cs['csnetamount'.$i] = $netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$netamount = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
				$cs['csnetamount'.$i] = $itemtotal = $netamount ;
			endswitch ;
		if ($firstime) {
			$tax1 = $cs['cstax1'.$i] ;
			$tax2 = $cs['cstax2'.$i] ;
			$tax1accid = $cs['cstax1accid'.$i] ;
			$tax2accid = $cs['cstax2accid'.$i] ;
			}
		$cs['cstax1'.$i] = $tax1 ;
		$cs['cstax2'.$i] = $tax2 ;
		$cs['cstax1accid'.$i] = $tax1accid ;
		$cs['cstax2accid'.$i] = $tax2accid ;
		$t->set_var('itemtype',$csitemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$csunit);
		$t->set_var('qty',$csqty);
		$t->set_var('discount',$csdiscount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$t->set_var('price',$csprice);
		$t->set_var('netamount',$netamount);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$cstotnet += $netamount ;
		$cstotal += $itemtotal ;
		$t->set_var('rowno',$csrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);

		$cs['csitemid'.$i] = $csitemid ;
		$cs['csitemtype'.$i] = $csitemtype ;
		$cs['csqty'.$i] = $csqty ;
		$cs['csprice'.$i] = $csprice ;
		$cs['csdiscount'.$i] = $csdiscount ;
		$cs['csunit'.$i] = $csunit ;
		}

	$cs[cstotnet] = number_format($cstotnet,2,".",'') ;
	$cs[cstotal] = number_format($cstotal,2,".",'') ;
	$t->set_var('lang_cstotal',lang('Total Cash Sale'));
	$t->set_var('cstotnet',$cs[cstotnet]) ;
	$t->set_var('cstotal',$cs[cstotal]) ;
	}

//---- Write Cash Sale AddOn Items

    function cswt_addon_write(&$t,&$cs,$posted,$delete,$newrow,$firstime) {
	global $phpgw,$phpgw_info ;

	$aorow_ = lang('aoRow')." " ;
	$aonewrow = lang('Add New AddOn Row') ;	
//	$addon = lang('AddOn') ;
	$phpgw->db->query("SELECT postax1cap,postax2cap,postax1pref,postax2pref FROM defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(postax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(postax2cap));
	$tax1pref = $phpgw->db->f(postax1pref) ;
	$tax2pref = $phpgw->db->f(postax2pref) ;
	if ($tax1pref=='s') {
		$sql = "SELECT customer_id,chart_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1chartid = $phpgw->db->f(chart_id) ;
		$stax1rate = $phpgw->db->f(rate) ;
		}
	if ($tax2pref=='s') {
		$sql = "SELECT customer_id,chart_id,rate from customertax a, tax b, customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2chartid = $phpgw->db->f(chart_id) ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_addon',lang('Add On Charge/Reduction Items :'));
	$t->set_var('lang_addonnumber',lang('AddOn Name - Id'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_factorbasis',lang('% [Basis]'));
	$t->set_var('lang_aoamount',lang('Amount'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_aonewrow',$aonewrow);
	if (isset($delete))	$delrowno = intval(str_replace($aorow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$addon_sl = addon_selectlist("",'') ;
	$aonet = 0 ;
	$totpay = $cs[cstotal] ;
	For ($i=1;isset($cs['aoitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','aoitemid'.$j) ;
		$itemid = $cs['aoitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('addon_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$addon_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$phpgw->db->query("SELECT * FROM addon WHERE id='$itemid'") ;
		$phpgw->db->next_record() ;
		$notes = $phpgw->db->f('notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$factor = $cs['aofactor'.$i] = $phpgw->db->f('factor') ;
		$basis = $phpgw->db->f('basis') ;
		$incacc = $cs['aoincaccid'.$i] = $phpgw->db->f('incacc_id') ;
		$cs['aoexpaccid'.$i] = $phpgw->db->f('expacc_id') ;
		$salebasis = ($basis=='g') ? "gs" : "ns" ;
		$value = $cs['aovalue'.$i] = ($basis=='g') ? $cs[cstotal] : $cs[cstotnet] ;
		$aoamount = $cs['aoamount'.$i] = number_format($value*$factor,2,".",'') ;

		$tax1 = $tax1accid = $tax2 = $tax2accid = 0 ;
		if ($firstime) {
			$tax1 = $cs['aotax1'.$i] ;
			$tax2 = $cs['aotax2'.$i] ;
			$tax1accid = $cs['aotax1accid'.$i] ;
			$tax2accid = $cs['aotax2accid'.$i] ;
			}
		   else {
			switch ($tax1pref) :
				case "s" :	$tax1rate=$stax1rate; 
						$tax1accid=$cs['aotax1accid'.$i]=$stax1chartid;
						break;
				case "i" :
					$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
					$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
					$sql.=		"taxtype='1' and taxgroup='cs'" ;
					$phpgw->db->query($sql) ;
					$tax1rate = ($phpgw->db->next_record()) ? $phpgw->db->f(rate) : 0 ;
					$tax1accid = $cs['aotax1accid'.$i] = ($tax1rate==0) ? 0 : $phpgw->db->f(chart_id) ;
					break;
				endswitch ;
			switch ($tax2pref) :
				case "s" :	$tax2rate=$stax2rate;
						$tax2accid=$cs['aotax2accid'.$i]=$stax2chartid;
						break;
				case "i" :
					$sql = "SELECT chart_id,rate from itemtax a, tax b " ;
					$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
					$sql.=		"taxtype='2' and taxgroup='cs'" ;
					$phpgw->db->query($sql) ;
					$tax2rate = ($phpgw->db->next_record()) ? $phpgw->db->f(rate) : 0 ;
					$tax2accid = $cs['aotax2accid'.$i] = ($tax2rate==0) ? 0 : $phpgw->db->f(chart_id) ;
					break;
				endswitch ;
			$tax1 = $cs['aotax1'.$i] = number_format($aoamount*$tax1rate,2,".",'') ;
			$tax2 = $cs['aotax2'.$i] = number_format($aoamount*$tax2rate,2,".",'') ;
			}
		$itemtotal = $aoamount + $tax1 + $tax2 ;
		$t->set_var('notes',$notes) ;
		$t->set_var('factor',$factor*100) ;
		$t->set_var('salebasis',$salebasis) ;
		$t->set_var('aoamount',$aoamount) ;
		$t->set_var('tax1',$tax1) ;
		$t->set_var('tax2',$tax2) ;
		$t->set_var('itemtotal',$itemtotal) ;
		$totpay += $itemtotal ;
		$incacc = ($incacc=="") ? 0 : $incacc ;
		$phpgw->db->query("SELECT * FROM tax WHERE chart_id='$incacc' and taxgroup='cs'") ;
		if (!$phpgw->db->next_record())		$aonet += $aoamount ;
		$t->set_var('rowno',$aorow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('addon_section','addon', True);
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$aonewrow ;
	if ($newrow==$aonewrow) {
		$t->set_var('itemid_fld','aoitemid'.$i) ;
		$t->set_var('addon_selectlist',$addon_sl);
		$t->set_var('notes',"");
		$t->set_var('factor',"");
		$t->set_var('salebasis',"") ;
		$t->set_var('aoamount',"");
		$t->set_var('tax1',"");
		$t->set_var('tax2',"");
		$t->set_var('itemtotal',"");
		$t->set_var('rowno',$aorow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('addon_section','addon', True);
		}
	$t->set_var('lang_totpay',lang('Total Payable'));
	$t->set_var('totpay',number_format($totpay,2,".",'')) ;
	$cs[totpay] = $totpay ;
	$cs[aonet] = $aonet ;
	}

//---- Write Cash Sale Payment / Quasi Cash Items

    function cswt_qcash_write(&$t,&$cs,$posted,$delete,$newrow) {
	global $phpgw,$phpgw_info ;

	$qcrow_ = lang('qcRow')." " ;
	$qcnewrow = lang('Add New QCash Row') ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_qcash',lang('Payment / Quasi-Cash Tendered :'));
	$t->set_var('lang_qcashnumber',lang('QCash Name - Id'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_qcamount',lang('Amount'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_qcnewrow',$qcnewrow);
	if (isset($delete))	$delrowno = intval(str_replace($qcrow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$qcash_sl = qcash_selectlist("",'') ;
	$totpay = $cs[totpay] ;
	$totqc = 0 ;
	For ($i=1;isset($cs['qcitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','qcitemid'.$j) ;
		$t->set_var('qty_fld','qcqty'.$j);
		$t->set_var('value_fld','qcvalue'.$j);
		$itemid = $cs['qcitemid'.$i] ;
		$t->set_var('itemid',$qcitemid) ;
		$t->set_var('qcash_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$qcash_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$phpgw->db->query("SELECT * FROM qcash WHERE id='$itemid'") ;
		$phpgw->db->next_record() ;
		$notes = $phpgw->db->f('notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$cs['qcposaccid'.$i] = $phpgw->db->f('posacc_id') ;
		$qcqty = $cs['qcqty'.$i]<>'' ? $cs['qcqty'.$i]: 1;
		$faceval = $phpgw->db->f('value') ;
		$value = $cs['qcvalue'.$i] = ($faceval<>'' and $faceval<>0) ? $faceval : $cs['qcvalue'.$i] ;
		$qcamount = $cs['qcamount'.$i] = number_format($qcqty*$value,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('qty',$qcqty);
		$t->set_var('value',$value);
		$t->set_var('qcamount',$qcamount);
		$totqc += $qcamount ;
		$t->set_var('rowno',$qcrow_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('qcash_section','qcash', True);
		}

	$lasti = $i-1 ;
	$cs['qcqty'.$lasti] = $qcqty ;

	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$qcnewrow ;
	if ($newrow==$qcnewrow) {
		$t->set_var('itemid_fld','qcitemid'.$i) ;
		$t->set_var('qcash_selectlist',$qcash_sl);
		$t->set_var('qty_fld','qcqty'.$i);
		$t->set_var('value_fld','qcvalue'.$i);
		$t->set_var('notes',"");
		$t->set_var('qty',"");
		$t->set_var('value',"");
		$t->set_var('qcamount',"");
		$t->set_var('rowno',$qcrow_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('qcash_section','qcash', True);
		}
	$t->set_var('lang_totqc',lang('Total'));
	$t->set_var('totqc',number_format($totqc,2,".",'')) ;
	$t->set_var('lang_change',lang('Change'));
	$cs[totqc] = $totqc ;
	$qcchange = $cs[qcchange] = number_format($totqc-$totpay,2,".",'') ;
	$t->set_var('change',$qcchange) ;
	$lang_cash = lang('Cash') ;
	$phpgw->db->query("SELECT * FROM qcash WHERE name='$lang_cash'") ;
	$phpgw->db->next_record() ;
	$cs[cashaccid] = $phpgw->db->f('posacc_id') ;
	}

    }

?>
