<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashballist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','cashballist.tpl') ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Quasi-Cash Balances'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_cashbox',lang('Cash Box Name'));
$t->set_var('lang_done',lang('Done'));
$t->set_var('done_action',$phpgw->link('/ck-pos-m/cashbalfilter.php'));
$t->set_var('sort_transdate',$phpgw->nextmatchs->show_sort_order($sort,'transdate',$order,'/ck-pos-m/cashballist.php',lang('Cash Sale Date'),$filter));
$t->set_var('sort_shift',$phpgw->nextmatchs->show_sort_order($sort,'shift',$order,'/ck-pos-m/cashballist.php',lang('Shift'),$filter));
$t->set_var('sort_name',$phpgw->nextmatchs->show_sort_order($sort,'name',$order,'/ck-pos-m/cashballist.php',lang('Quasi-Cash Name'),$filter));
$t->set_var('sort_itemtype',$phpgw->nextmatchs->show_sort_order($sort,'itemtype',$order,'/ck-pos-m/cashballist.php',lang('Item Type'),$filter));
$t->set_var('sort_amount',$phpgw->nextmatchs->show_sort_order($sort,'amount',$order,'/ck-pos-m/cashballist.php',lang('Amount'),$filter));
$t->set_var('lang_view',lang('View Detail'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

$rpos = strrpos($where,"'") ;
$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
$cboxid = substr($where,$lpos) ;
$phpgw->db->query("SELECT name FROM cashbox WHERE id=$cboxid");
$phpgw->db->next_record() ;
$t->set_var('cashbox',$phpgw->db->f('name')) ;

// -------------------------------- Write Quasi-Cash Balances Section -----------------------------------------

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,itemtype,sum(qty*a.value) as amount " ;
$sql.=	"FROM positem a, pos b, qcash c " ;
$sql.=	"$where and itemtype='q' and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"GROUP BY itemid,transdate,b.shift,c.name,itemtype ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'itemtype'	=> "",
				'amount'	=> "",
				'view'		=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbal_section','cashbal',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('itemid') ;
	$name = $phpgw->db->f('name') ;
	$amount = $phpgw->db->f('amount') ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name ,
				'itemtype'	=> $phpgw->db->f('itemtype'),
				'amount'	=> $amount ,
				'view'	=> $phpgw->link('/ck-pos-m/cashbalview.php',"id=$id&filter=$filter")  ));
	if ($name==lang("Cash"))	$cashamount = number_format($amount,2,".",'') ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbal_section','cashbal',true);
	}

$sql =	"SELECT itemid,transdate,shift,sum(qty*value) as amount FROM positem a, pos b " ;
$sql.=	"$where and itemtype='c' and a.trans_id=b.id GROUP BY itemid,transdate,shift" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$id = $phpgw->db->f('itemid') ;
$changeamount = number_format($phpgw->db->f('amount'),2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Cash Change') ,
			'itemtype'	=> "c",
			'amount'	=> $changeamount,
			'view'		=> $phpgw->link('/ck-pos-m/cashbalview.php',"id=$id&filter=$filter")  ));
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashbal_section','cashbal',true);

$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashbal','cashbal_section',true);

// -------------------------------- Write Cash Balance Analysis Section -----------------------------------------

$t->set_var('lang_analysis',lang('Cash Balance Analysis')) ;
$t->set_var('lang_note1',lang('[Shift]:  1-Morning, 2-Afternoon, 3-Overnight'));
$t->set_var('lang_note2',lang('[TranType]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift'));
$t->set_var('lang_transdate',lang('Cash Sale Date')) ;
$t->set_var('lang_shift',lang('Shift')) ;
$t->set_var('lang_name',lang('Item Detail')) ;
$t->set_var('lang_trantype',lang('Transaction Type')) ;
$t->set_var('lang_amount',lang('Amount')) ;

$netbal = 0 ;
$sql =	"SELECT * from cbtran $where and trantype='s'" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$amount = number_format($phpgw->db->f('amount'),2,".",'') ; $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Start-of-shift Cash-in'),
			'trantype'	=> $phpgw->db->f('trantype'),
			'amount'	=> $amount			)) ;
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashanal_section','cashanal',true);
$netbal+= number_format($cashamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Total Cash tendered by Customer'),
			'trantype'	=> '',
			'amount'	=> $cashamount			)) ;
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashanal_section','cashanal',true);

$netbal+= number_format($changeamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Total Cash Change returned to Customer'),
			'trantype'	=> '',
			'amount'	=> $changeamount		)) ;
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashanal_section','cashanal',true);

$sql =	"SELECT * from cbtran $where and trantype<>'s' and trantype<>'e'" ;
$phpgw->db->query($sql);
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$trantype = $phpgw->db->f('trantype') ;
	$amount = number_format($phpgw->db->f('amount'),2,".",''); $netbal+= $amount ;
	if ($trantype=='+')	$name = lang("Additional Cash transferred in during Shift") ;
	if ($trantype=='-')	$name = lang("Additional Cash transferred out during Shift") ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name,
				'trantype'	=> $trantype,
				'amount'	=> $amount	));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashanal_section','cashanal',true);
	}

$sql =	"SELECT * from cbtran $where and trantype='e'" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$amount = number_format($phpgw->db->f('amount'),2,".",''); $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('End-of-shift Cash-out'),
			'trantype'	=> $phpgw->db->f('trantype'),
			'amount'	=> $amount			)) ;
$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashanal_section','cashanal',true);

$t->set_var('tr_color',$nm->alternate_row_color()) ;
$t->parse('cashanal','cashanal_section',true);

$t->set_var('lang_netbal',lang('Net Cash Balance or Cash ShortFall/Surplus(-ve) after End-of-Shift')) ;
$t->set_var('netbal',$netbal) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);

?>
