<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashboxlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'cashboxlist.tpl',	'cashbox'=>'cashboxlist.tpl'));
	$t->set_block('cashbox','cashbox_row','cashbox_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Cash Boxes'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Cash Box'));
$t->set_var('lang_note1',lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/cashboxadd.php',"filter=$filter"));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-pos-m/cashboxlist.php',lang('Cashbox Name'),$filter));
$t->set_var('sort_cashier',$nm->show_sort_order($sort,'cashier',$order,'/ck-pos-m/cashboxlist.php',lang('Cashier for<br>Current Shift'),$filter));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,'/ck-pos-m/cashboxlist.php',lang('Current Shift'),$filter));
$t->set_var('sort_location',$nm->show_sort_order($sort,'location',$order,'/ck-pos-m/cashboxlist.php',lang('Location'),$filter));
$t->set_var('sort_maxcash',$nm->show_sort_order($sort,'maxcash',$order,'/ck-pos-m/cashboxlist.php',lang('Cash Full<br>Warning Level'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-pos-m/cashboxlist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from cashbox $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'cashier'	=> "",
				'shift'		=> "",
				'location'	=> "",
				'maxcash'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbox_section','cashbox_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'cashier'	=> $phpgw->db->f('cashier'),
				'shift'		=> $phpgw->db->f('shift'),
				'location'	=> $phpgw->db->f('location'),
				'maxcash'	=> $phpgw->db->f('maxcash'),
				'id'		=> $id,
		'view'	=> $phpgw->link('/ck-pos-m/cashboxview.php',$getstr),
		'edit'	=> $phpgw->link('/ck-pos-m/cashboxedit.php',$getstr),
		'copy'	=> $phpgw->link('/ck-pos-m/cashboxcopy.php',$getstr),
		'delete'=> $phpgw->link('/ck-pos-m/cashboxdelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cashbox_section','cashbox_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','cashbox','report');

?>
