<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cbtranlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'cbtranlist.tpl',	'cbtran'=>'cbtranlist.tpl'));
	$t->set_block('cbtran','cbtran_row','cbtran_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Cash Box Transactions'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Cash Box Transaction'));
$t->set_var('lang_note1',lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
$t->set_var('lang_note2',lang('[Tran Type]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/cbtranadd.php',"filter=$filter"));

$t->set_var('sort_cbtnumber',$nm->show_sort_order($sort,'cbtnumber',$order,'/ck-pos-m/cbtranlist.php',lang('Cashbox Tran#'),$filter));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-pos-m/cbtranlist.php',lang('Cashbox Name'),$filter));
$t->set_var('sort_manager',$nm->show_sort_order($sort,'manager',$order,'/ck-pos-m/cbtranlist.php',lang('Manager'),$filter));
$t->set_var('sort_cashier',$nm->show_sort_order($sort,'cashier',$order,'/ck-pos-m/cbtranlist.php',lang('Cashier'),$filter));
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-pos-m/cbtranlist.php',lang('Cash Sale Date'),$filter));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,'/ck-pos-m/cbtranlist.php',lang('Shift'),$filter));
$t->set_var('sort_trantype',$nm->show_sort_order($sort,'trantype',$order,'/ck-pos-m/cbtranlist.php',lang('Tran Type'),$filter));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-pos-m/cbtranlist.php',lang('Amount'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-pos-m/cbtranlist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT cbtnumber,name,manager,a.cashier as cashier,transdate,a.shift as shift,trantype,amount,a.id as id from cbtran a, cashbox b $where and a.cboxid=b.id order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'cbtnumber'	=> lang("No Matching Item Found"),
				'name'		=> "",
				'manager'	=> "",
				'cashier'	=> "",
				'transdate'	=> "",
				'shift'		=> "",
				'trantype'	=> "",
				'amount'	=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cbtran_section','cbtran_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'cbtnumber'	=> $phpgw->db->f('cbtnumber'),
				'name'		=> $phpgw->db->f('name'),
				'manager'	=> $phpgw->db->f('manager'),
				'cashier'	=> $phpgw->db->f('cashier'),
				'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'trantype'	=> $phpgw->db->f('trantype'),
				'amount'	=> $phpgw->db->f('amount'),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-pos-m/cbtranview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-pos-m/cbtranedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-pos-m/cbtrancopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-pos-m/cbtrandelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('cbtran_section','cbtran_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','cbtran','report');

?>
