<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: repballist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=> 'ck-pos-m', 'enable_nextmatchs_class'=> True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'repballist.tpl', 'repbal'=>'repballist.tpl'));
	$t->set_block('repbal','repbal_row','repbal_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$db_type = $phpgw_info["server"]["db_type"] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Shift End (Completed) Cash Balances'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Done'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/reportfilter.php'));
$t->set_var('lang_note1',lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
$t->set_var('lang_view', lang('View Detail'));
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,'/ck-pos-m/repballist.php',lang('Date'),$filter));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,'/ck-pos-m/repballist.php',lang('Shift'),$filter));
$t->set_var('sort_cashbox',$nm->show_sort_order($sort,'cashbox',$order,'/ck-pos-m/repballist.php',lang('Cashbox'),$filter));
$t->set_var('sort_cashier',$nm->show_sort_order($sort,'cashier',$order,'/ck-pos-m/repballist.php',lang('Cashier'),$filter));
$t->set_var('sort_cashamt',$nm->show_sort_order($sort,'cashamt',$order,'/ck-pos-m/repballist.php',lang('Cash Tendered<br>by Customer'),$filter));
$t->set_var('sort_changeamt',$nm->show_sort_order($sort,'changeamt',$order,'/ck-pos-m/repballist.php',lang('Cash Returned<br>to Customer'),$filter));
$t->set_var('sort_cbtamt',$nm->show_sort_order($sort,'cbtamt',$order,'/ck-pos-m/repballist.php',lang('Bulk Cash<br>Transferred in/out'),$filter));
$t->set_var('sort_balance',$nm->show_sort_order($sort,'balance',$order,'/ck-pos-m/repballist.php',lang('Cash Shortfall (+ve)<br>Cash Surplus (-ve)'),$filter));

$user = trim($phpgw_info["user"]["userid"]);
$temp1 = "repbal1".$user.time() ;
$temp2 = "repbal2".$user.time() ;
$temp3 = "repbal3".$user.time() ;
$temp4 = "repbal4".$user.time() ;
$lang_cash = lang('Cash') ;

$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=  "SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift from cbtran a,cashbox b " ;
$sql.=	"$where and a.cboxid=b.id and trantype='e'" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT d.cboxid as cboxid,d.transdate as transdate,d.shift as shift,sum(qty*a.value) as cashamt " ;
$sql.=		"FROM positem a,pos b,qcash c,$temp1 d " ;
$sql.=	"WHERE b.cboxid=d.cboxid and b.transdate=d.transdate and b.shift=d.shift and " ;
$sql.=		"name='$lang_cash' and a.trans_id=b.id and a.itemid=c.id " ;
$sql.=	"GROUP BY d.transdate,d.shift,d.cboxid,itemid" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT c.cboxid as cboxid,c.transdate as transdate,c.shift as shift,cashamt, " ;
$sql.=		"sum(qty*value) as changeamt FROM positem a,pos b,$temp2 c " ;
$sql.=	"WHERE b.cboxid=c.cboxid and b.transdate=c.transdate and b.shift=c.shift and " ;
$sql.=		"itemtype='c' and a.trans_id=b.id " ;
$sql.=	"GROUP BY c.transdate,c.shift,c.cboxid,itemid,cashamt" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp4 AS " ;
$sql.=	"SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift,name,b.cashier as cashier," ;
$sql.=		"cashamt,changeamt,sum(amount) as cbtamt, 0.00 as balance FROM $temp3 a, cbtran b,cashbox c " ;
$sql.=	"WHERE a.cboxid=b.cboxid and a.transdate=b.transdate and a.shift=b.shift and a.cboxid=c.id " ;
$sql.=	"GROUP BY a.transdate,a.shift,a.cboxid,name,b.cashier,cashamt,changeamt " ;
$phpgw->db->query($sql) ;
$phpgw->db->query("UPDATE $temp4 SET balance=cashamt+changeamt+cbtamt") ;

if (!$order) {$order = "transdate" ; }
if (!$sort)  {$sort = "ASC" ; }
$phpgw->db->query("SELECT * FROM $temp4 order by $order $sort") ;

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'cashbox'	=> "",
				'cashier'	=> "",
				'cashamt'	=> "",
				'changeamt'	=> "",
				'cbtamt'	=> "",
				'balance'	=> "",
				'lang_item'	=> ""	)) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('repbal_section','repbal_row',True);
	}
while ($phpgw->db->next_record()) {
	$transdate = $phpgw->db->f('transdate') ;
	$shift = $phpgw->db->f('shift') ;
	$cboxid = $phpgw->db->f('cboxid') ;
	$t->set_var(array(	'transdate'	=> $transdate,
				'shift'		=> $shift,
				'cashbox'	=> $phpgw->db->f('name'),
				'cashier'	=> $phpgw->db->f('cashier'),
				'cashamt'	=> number_format($phpgw->db->f('cashamt'),2,".",''),
				'changeamt'	=> number_format($phpgw->db->f('changeamt'),2,".",''),
				'cbtamt'	=> number_format($phpgw->db->f('cbtamt'),2,".",''),
				'balance'	=> $phpgw->db->f('balance') ,
				'lang_item'	=> lang('View Detail')	)) ;
	$ifilter = urlencode(" WHERE shift='$shift' AND transdate='$transdate' AND cboxid = '$cboxid'") ;
	$item = $phpgw->link('/ck-pos-m/cashballist.php',"filter=$ifilter");
	$t->set_var('item',$item);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('repbal_section','repbal_row',true);
	}

$phpgw->db->query("DROP TABLE $temp1") ;
$phpgw->db->query("DROP TABLE $temp2") ;
$phpgw->db->query("DROP TABLE $temp3") ;
$phpgw->db->query("DROP TABLE $temp4") ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','repbal','report');

?>
