<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: spricelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-pos-m', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-pos-m'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'spricelist.tpl',	'sprice'=>'spricelist.tpl'));
	$t->set_block('sprice','sprice_row','sprice_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Special Prices'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Add New Special Price'));
$t->set_var('add_action',$phpgw->link('/ck-pos-m/spriceadd.php',"filter=$filter"));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-pos-m/spricelist.php',lang('Special Price<br>Name'),$filter));
$t->set_var('sort_price',$nm->show_sort_order($sort,'price',$order,'/ck-pos-m/spricelist.php',lang('Special<br>Price'),$filter));
$t->set_var('sort_itemid',$nm->show_sort_order($sort,'itemid',$order,'/ck-pos-m/spricelist.php',lang('ID of Normally<br>Priced Item'),$filter));
$t->set_var('sort_splanid',$nm->show_sort_order($sort,'splanid',$order,'/ck-pos-m/spricelist.php',lang('Sales Promo<br>Plan ID'),$filter));
$t->set_var('sort_start',$nm->show_sort_order($sort,'start',$order,'/ck-pos-m/spricelist.php',lang('Valid from'),$filter));
$t->set_var('sort_endd',$nm->show_sort_order($sort,'endd',$order,'/ck-pos-m/spricelist.php',lang('Valid to'),$filter));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-pos-m/spricelist.php',lang('Audit Id'),$filter));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from sprice $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'name'		=> lang("No Matching Item Found"),
				'price'		=> "",
				'itemid'	=> "",
				'splanid'	=> "",
				'start'		=> "",
				'endd'		=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('sprice_section','sprice_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'name'		=> $phpgw->db->f('name'),
				'price'		=> $phpgw->db->f('price'),
				'itemid'	=> $phpgw->db->f('itemid'),
				'splanid'	=> $phpgw->db->f('splanid'),
				'start'		=> $phpgw->db->f('start'),
				'endd'		=> $phpgw->db->f('endd'),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-pos-m/spriceview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-pos-m/spriceedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-pos-m/spricecopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-pos-m/spricedelete.php',$getstr)  ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('sprice_section','sprice_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','sprice','report');

?>
