<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;
	$phpgw_info["flags"]["currentapp"] = 'ck-quote';
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-quote'));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Quotation Audit Control Report'));
	$t->set_var('lang_detail', lang('Detail'));
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_customer', lang('Customer'));
	$t->set_var('lang_tax', lang('Tax Type'));
	$t->set_var('lang_quote', lang('Quotation'));
	$t->set_var('lang_oitem', lang('Order Item'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_status_note'," ".lang('(note the effect of postdated Quotations)'));
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_netamount', lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', lang('Total Tax'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/


$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_amount = $phpgw->db->f('amount') ;
$quote_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum(qty*sellprice-discount-tax1-tax2) as oitem_amount from oitem a,quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount = $phpgw->db->f('oitem_amount') ;
$sql =	"SELECT sum(qty*sellprice-discount) as oitem_amount from oitem a,quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount += $phpgw->db->f('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from oitem a,quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT count(id) as count from quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count from oitem a,quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id from quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id from oitem a,quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_id = $phpgw->db->f('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('quote_count',$quote_count) ;
$t->set_var('oitem_count',$oitem_count) ;
$t->set_var('payment_count',$payment_count) ;
$t->set_var('quote_id',$quote_id) ;
$t->set_var('oitem_id',$oitem_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/


$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from quote " ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_amount = $phpgw->db->f('amount') ;
$quote_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum(qty*sellprice-discount-tax1-tax2) as oitem_amount from oitem a,quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount = $phpgw->db->f('oitem_amount') ;
$sql =	"SELECT sum(qty*sellprice-discount) as oitem_amount from oitem a,quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount += $phpgw->db->f('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from oitem a,quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT count(id) as count FROM customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM quote" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count FROM oitem a,quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM payment" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id FROM customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM quote" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id FROM oitem a,quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_id = $phpgw->db->f('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('sys_quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('sys_oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('sys_oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('sys_customer_count',$customer_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_quote_count',$quote_count) ;
$t->set_var('sys_oitem_count',$oitem_count) ;
$t->set_var('sys_payment_count',$payment_count) ;
$t->set_var('sys_customer_id',$customer_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_quote_id',$quote_id) ;
$t->set_var('sys_oitem_id',$oitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-quote/reportfilter.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	$phpgw->common->phpgw_footer();
?>
