<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: servicelist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-service', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-service'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'servicelist.tpl',  'service'=>'servicelist.tpl'));
	$t->set_block('service','service_row','service_section');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('List of Services'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Add New Service'));
	$t->set_var('add_action',$phpgw->link('/ck-service/serviceadd.php',"filter=$filter"));

$t->set_var('sort_servicenumber',$nm->show_sort_order($sort,'servicenumber',$order,'/ck-service/servicelist.php',lang('Service Name/Number')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-service/servicelist.php',lang('Description')));
$t->set_var('sort_notes',$nm->show_sort_order($sort,'notes',$order,'/ck-service/servicelist.php',lang('Notes')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-service/servicelist.php',lang('Audit Id')));
$t->set_var('lang_edit',lang('Edit'));
$t->set_var('lang_view',lang('View'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

if (!$order) {$order = "servicenumber" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =  "SELECT * from service $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'servicenumber'	=> lang("No Matching Item Found"),
				'description'	=> "",
				'notes'		=> "",
				'id'		=> "",
				'view'		=> "",
				'edit'		=> "",
				'copy'		=> "",
				'delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('service_section','service_row',True);
	}
while ($phpgw->db->next_record()) {
	$servicenumber		= $phpgw->db->f('servicenumber') ;
	$description		= $phpgw->db->f('description') ;
	$notes			= $phpgw->db->f('notes') ;
	$id			= $phpgw->db->f('id') ;
	$getstr			= "id=$id&filter=$filter" ;
	$t->set_var(array(	'servicenumber'	=> $servicenumber,
            	    		'description'	=> $description,
                    		'notes'		=> $notes,
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-service/serviceview.php',$getstr),
				'edit'		=> $phpgw->link('/ck-service/serviceedit.php',$getstr),
				'copy'		=> $phpgw->link('/ck-service/servicecopy.php',$getstr),
				'delete'	=> $phpgw->link('/ck-service/servicedelete.php',$getstr)));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('service_section','service_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','service','report');

?>
