<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.sqmatch.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class sqmatch {

//---- sqmatch Detail Validation Checks

    function sqmatch_validate($sq) {
	global $phpgw ;
	$err=""; $error=lang("Error");
	$row = lang("Row") ;
	$sum_anewaamt = 0 ;
	For ($i=1;isset($sq['aquoteid'.$i]);$i++) {
		$anewaamt = $sq['anewaamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($anewaamt<0)		$err=$rowi.lang("New Amount Accepted must be +ve");
		if ($anewaamt>$sq[amount])	$err=$rowi.lang("New Amount Accepted > SO Amt");
		if (!is_numeric($anewaamt) and strlen($anewaamt)>0)
						$err=$rowi.lang("New Amt Accepted must be numeric");
		$sum_anewaamt += ($anewaamt=="") ? $sq['aa_amount'.$i] : $anewaamt ;
		}
	if ($sum_anewaamt>$sq[amount])		$err=lang('Total Amount Accepted > SO Amount');
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Post Sqmatch to Database

    function sqmatch_post($sq, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $sq[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	switch ($op) :
		case "edit" :	$actioned = lang("updated") ;	break ;
		case "clear" :	$actioned = lang("cleared") ;	break ;
		endswitch ;
	$phpgw->db->query("DELETE from sqmatch where soid=$id");
	if ($op<>'clear') {
		For ($i=1;isset($sq['aquoteid'.$i]);$i++) {
			$a_amt = $sq['anewaamount'.$i]=="" ? $sq['aa_amount'.$i] : $sq['anewaamount'.$i] ;
			if ($a_amt<>0) {
				$quoteid	= $sq['aquoteid'.$i] ;
				$sql="INSERT INTO sqmatch (quoteid,soid,a_amount) VALUES ('$quoteid','$id','$a_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("SO") ;  $matching = lang("matching to Quotation") ;
	$t->set_var("message2","<b>$tran [id#$id] $matching $actioned.</b>") ;
	$t->set_var("lang_confirm","<b>$tran [id#$id] $matching $actioned.</b>") ;
	return True ;
	}

//---- Write sqmatch (Sales Order) Header

    function sqmatch_header_write(&$t, $sq) {
	global $phpgw ;

	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_sonumber',lang('Sales Order #:')."  ");
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_amount',lang('SO Amount:')." ");
	$t->set_var('lang_transdate',lang('SO Date:')."  ");
	$t->set_var('lang_duedate',lang('Due Date:')."  ");
	$t->set_var('customer',$sq[customer]) ;
	$t->set_var('customer_selectlist',customer_selectlist("WHERE id=$sq[customer]",'')) ;
	$t->set_var('sonumber',$sq[sonumber]) ;
	$t->set_var('id',$sq[id]) ;
	$t->set_var('amount',$sq[amount]) ;
	$t->set_var('transdate',$sq[transdate]) ;
	$t->set_var('duedate',$sq[duedate]) ;
	$t->parse('out','report',True);
	}


//---- Write Sqmatch Detail

    function sqmatch_detail_write(&$t,&$sq,$posted) {
	global $phpgw,$phpgw_info ;

	$moverow_ = lang('Move Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_altitle',lang('List of Fully/Partially ACCEPTED Quotation confirmed by this SO'));
	$t->set_var('lang_aquotenumber',lang('Quotation#'));
	$t->set_var('lang_aquoteid',lang('Quotation ID'));
	$t->set_var('lang_aduedate',lang('Due Date'));
	$t->set_var('lang_afullamount',lang('Full Quotation Amount'));
	$t->set_var('lang_aacepted',lang('Amount Accepted<br>via this SO'));
	$t->set_var('lang_anewaamount',lang('Amount Accepted via this<br>SO to be Updated to'));
	$sum_aquoteamount = $sum_aa_amount = $sum_anewaamount = 0 ;
	For ($i=1;isset($sq['aquoteid'.$i]);$i++) {
		$t->set_var('aquotenumber_fld','aquotenumber'.$i);
		$t->set_var('aquoteid_fld','aquoteid'.$i);
		$t->set_var('aduedate_fld','aduedate'.$i);
		$t->set_var('aquoteamount_fld','aquoteamount'.$i);
		$t->set_var('aa_amount_fld','aa_amount'.$i) ;
		$t->set_var('anewaamount_fld','anewaamount'.$i);
		$t->set_var('aquotenumber',$sq['aquotenumber'.$i]) ;
		$aquoteid = $sq['aquoteid'.$i] ;
		$t->set_var('aquoteid',$aquoteid) ;
		$t->set_var('aduedate',$sq['aduedate'.$i]) ;
		$t->set_var('aquoteamount',$sq['aquoteamount'.$i]) ;
		$t->set_var('aa_amount',$sq['aa_amount'.$i]) ;
		$anewaamount = $sq['anewaamount'.$i] ;
		if (is_numeric($anewaamount))		$t->set_var('anewaamount',"") ;
			else				$t->set_var('anewaamount',$anewaamount) ;
		if (strlen($anewaamount)>0 and is_numeric($anewaamount)) {
			For ($j=1;isset($sq['pdquoteid'.$j]);$j++) {
				if ($aquoteid==$sq['pdquoteid'.$j]) {
					$sq['pda_amount'.$j] = $anewaamount ;
					$sq['pdacceptedamt'.$j]= $sq['pda_amount'.$j] + $sq['pda_othamt'.$j];
					$sq['pdosamount'.$j] = $sq['pdquoteamount'.$j] - $sq['pdacceptedamt'.$j] ;
					break ;
					}
				}
			if (!isset($sq['pdquoteid'.$j])) {
				$user = trim($phpgw_info["user"]["userid"]);
				$tmp = "ism".$user.time() ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=		"SELECT quotenumber,id,duedate,amount,0.0 as a_amount,sum(a_amount) as acceptedamt " ;
				$sql.=			"FROM quote,sqmatch WHERE id='$aquoteid' and quoteid='$aquoteid' " ;
				$sql.=			"GROUP BY quotenumber,id,duedate,amount" ;
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=		"SELECT quotenumber,id,duedate,amount,a_amount,0.0 as acceptedamt FROM quote,sqmatch ";
				$sql.=			"WHERE id='$aquoteid' and quoteid='$aquoteid' and soid='$sq[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT quotenumber,id,duedate,amount,sum(a_amount) as a_amount,sum(acceptedamt) as acceptedamt " ;
				$sql.= "FROM $tmp GROUP BY quotenumber,id,duedate,amount " ;
				$phpgw->db->query($sql) ;

				while ($phpgw->db->next_record()) {
					$sq['pdquotenumber'.$j]	=	$phpgw->db->f('quotenumber') ;
					$sq['pdquoteid'.$j]	=	$phpgw->db->f('id') ;
					$sq['pdduedate'.$j]	=	$phpgw->db->f('duedate') ;
					$sq['pdquoteamount'.$j]	=	$phpgw->db->f('amount') ;
					$sq['pda_amount'.$j]	=	$anewaamount ;
					$sq['pda_othamt'.$j]	=	$phpgw->db->f('acceptedamt')-$phpgw->db->f('a_amount');
					$sq['pdacceptedamt'.$j]	=	$sq['pda_amount'.$j] + $sq['pda_othamt'.$j];
					$sq['pdosamount'.$j]	=	$sq['pdquoteamount'.$j] - $sq['pdacceptedamt'.$j] ;
					$j++ ;
					}
				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);
				}
			$t->set_var('aa_amount',$anewaamount) ;
			$sq['aa_amount'.$i] = $anewaamount ;
			}
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('acceptedlist_section','acceptedlist', True);
		$sum_aquoteamount	+= $sq['aquoteamount'.$i] ;
		$sum_aa_amount		+= $sq['aa_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('acceptedlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$sq[move])) ;
	if ($movrowno<>0) {
		$t->set_var('aquotenumber_fld','aquotenumber'.$i);
		$t->set_var('aquoteid_fld','aquoteid'.$i);
		$t->set_var('aduedate_fld','aduedate'.$i);
		$t->set_var('aquoteamount_fld','aquoteamount'.$i);
		$t->set_var('aa_amount_fld','aa_amount'.$i) ;
		$t->set_var('anewaamount_fld','anewaamount'.$i);
		$t->set_var('aquotenumber',$sq['pdquotenumber'.$movrowno]) ;
		$t->set_var('aquoteid',$sq['pdquoteid'.$movrowno]) ;
		$t->set_var('aduedate',$sq['pdduedate'.$movrowno]) ;
		$t->set_var('aquoteamount',$sq['pdquoteamount'.$movrowno]) ;
		$t->set_var('aa_amount',0) ;
		$t->set_var('anewaamount',"") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('acceptedlist_section','acceptedlist', True);
		$sum_aquoteamount	+= $sq['pdquoteamount'.$movrowno] ;
		}
	$msg = ($sq[amount]>$sum_aa_amount) ? lang("[SO underallocated to Quotation]") : "" ;
	$t->set_var('lang_total',lang('Total Amount')." <b>".$msg."</b>");
	$t->set_var('sum_aquoteamount',$sum_aquoteamount);
	$t->set_var('sum_aa_amount',$sum_aa_amount);
	$t->set_var('sum_anewaamount',$sum_anewaamount);
	$t->set_var('lang_pdltitle',lang('List of Quotations accrued on this customer'));
	$t->set_var('lang_pdquotenumber',lang('Quotation#'));
	$t->set_var('lang_pdquoteid',lang('Quotation ID'));
	$t->set_var('lang_pdduedate',lang('Due Date'));
	$t->set_var('lang_pdfullamount',lang('Full Quotation Amount'));
	$t->set_var('lang_pda_amount',lang('Amount Accepted via this SO'));
	$t->set_var('lang_pda_othamt',lang('Amount Accepted via other SOs'));
	$t->set_var('lang_pdacceptedamt',lang('Total Amount Accepted'));
	$t->set_var('lang_pdosamount',lang('Outstanding Pending Amount'));
	$t->set_var('lang_pdmove2accepted',lang('Move to Accepted List'));
	For ($i=1;isset($sq['pdquoteid'.$i]);$i++) {
		$t->set_var('pdquotenumber_fld','pdquotenumber'.$i);
		$t->set_var('pdquoteid_fld','pdquoteid'.$i);
		$t->set_var('pdduedate_fld','pdduedate'.$i);
		$t->set_var('pdquoteamount_fld','pdquoteamount'.$i);
		$t->set_var('pda_amount_fld','pda_amount'.$i);
		$t->set_var('pda_othamt_fld','pda_othamt'.$i);
		$t->set_var('pdacceptedamt_fld','pdacceptedamt'.$i) ;
		$t->set_var('pdosamount_fld','pdosamount'.$i);
		$t->set_var('pdquotenumber',$sq['pdquotenumber'.$i]) ;
		$t->set_var('pdquoteid',$sq['pdquoteid'.$i]) ;
		$t->set_var('pdduedate',$sq['pdduedate'.$i]) ;
		$t->set_var('pdquoteamount',$sq['pdquoteamount'.$i]) ;
		$t->set_var('pda_amount',$sq['pda_amount'.$i]) ;
		$t->set_var('pda_othamt',$sq['pda_othamt'.$i]) ;
		$t->set_var('pdacceptedamt',$sq['pdacceptedamt'.$i]) ;
		$t->set_var('pdosamount',$sq['pdosamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($sq['aquoteid'.$j]);$j++) {
			if ($sq['pdquoteid'.$i]==$sq['aquoteid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)		$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)			$t->set_var('rowno',"done") ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('pendinglist_section','pendinglist', True);
		}
	if ($i==1)	$t->set_var('pendinglist_section',"");
	}

//---- Perform SO/Quotation Matching on Balance Amount by Matching Equal Amount

    function match_equal(&$sq) {
	global $phpgw ;

	/* no empty quotation pending list handling */
	$temp = $sq ;
	For ($j=1;isset($sq['pdquoteid'.$j]);$j++)	$duedate[$j] = $temp['pdduedate'.$j] ;
	asort($duedate) ;
	reset($duedate) ;
	$j = 1 ;
	while (list($key,$val)=each($duedate)) {
		$sq['pdquotenumber'.$j]	=	$temp['pdquotenumber'.$key] ;
		$sq['pdquoteid'.$j]	=	$temp['pdquoteid'.$key] ;
		$sq['pdduedate'.$j]	=	$val ;
		$sq['pdquoteamount'.$j]	=	$temp['pdquoteamount'.$key] ;
		$sq['pda_amount'.$j]	=	$temp['pda_amount'.$key] ;
		$sq['pda_othamt'.$j]	=	$temp['pda_othamt'.$key] ;
		$sq['pdacceptedamt'.$j]	=	$temp['pdacceptedamt'.$key] ;
		$sq['pdosamount'.$j]	=	$temp['pdosamount'.$key] ;
		$j++ ;
		}
	$bal = $sq[amount] ;
	For ($i=1;isset($sq['aquoteid'.$i]);$i++)	{
		$bal -= $sq['aa_amount'.$i] ;
		$sq['anewaamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("SO is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($sq['pdquoteid'.$j]);$j++) {
			if ($sq['pdosamount'.$j]==$bal) {
				$sq['pda_amount'.$j] += $bal ;
				$sq['pdacceptedamt'.$j] += $bal ;
				$sq['pdosamount'.$j]  = 0 ;
				$quoteid = $sq['pdquoteid'.$j] ;
				For ($i=1;isset($sq['aquoteid'.$i]);$i++) {
					if ($sq['aquoteid'.$i]==$quoteid) {
						$sq['aa_amount'.$i] += $bal ;
						$sq['anewaamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($sq['aquoteid'.$i])) {
					$sq['aquotenumber'.$i]	= $sq['pdquotenumber'.$j] ;
					$sq['aquoteid'.$i]	= $sq['pdquoteid'.$j] ;
					$sq['aduedate'.$i]	= $sq['pdduedate'.$j] ;
					$sq['aquoteamount'.$i]	= $sq['pdquoteamount'.$j];
					$sq['aa_amount'.$i]	= $bal ;
					$sq['anewaamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($sq['pdquoteid'.$j]))	$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform SO/Quotation Matching on Balance Amount by FIFO Scheme

    function match_fifo(&$sq) {
	global $phpgw ;

	/* no empty quotation pending list handling */
	$temp = $sq ;
	For ($j=1;isset($sq['pdquoteid'.$j]);$j++)	$duedate[$j] = $temp['pdduedate'.$j] ;
	asort($duedate) ;
	reset($duedate) ;
	$j = 1 ;
	while (list($key,$val)=each($duedate)) {
		$sq['pdquotenumber'.$j]	=	$temp['pdquotenumber'.$key] ;
		$sq['pdquoteid'.$j]	=	$temp['pdquoteid'.$key] ;
		$sq['pdduedate'.$j]	=	$val ;
		$sq['pdquoteamount'.$j]	=	$temp['pdquoteamount'.$key] ;
		$sq['pda_amount'.$j]	=	$temp['pda_amount'.$key] ;
		$sq['pda_othamt'.$j]	=	$temp['pda_othamt'.$key] ;
		$sq['pdacceptedamt'.$j]	=	$temp['pdacceptedamt'.$key] ;
		$sq['pdosamount'.$j]	=	$temp['pdosamount'.$key] ;
		$j++ ;
		}

	$bal = $sq[amount] ;
	For ($i=1;isset($sq['aquoteid'.$i]);$i++)	{
		$bal -= $sq['aa_amount'.$i] ;
		$sq['anewaamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("SO is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($sq['pdquoteid'.$j]);$j++) {
			$pdosamt = $sq['pdosamount'.$j] ;
			if ($pdosamt>0) {
				if ($bal>=$pdosamt) {
					$sq['pda_amount'.$j] += $pdosamt ;
					$sq['pdacceptedamt'.$j] += $pdosamt ;
					$sq['pdosamount'.$j]  = 0 ;
					$quoteid = $sq['pdquoteid'.$j] ;
					For ($i=1;isset($sq['aquoteid'.$i]);$i++) {
						if ($sq['aquoteid'.$i]==$quoteid) {
							$sq['aa_amount'.$i] += $pdosamt ;
							$sq['anewaamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($sq['aquoteid'.$i])) {
						$sq['aquotenumber'.$i]	= $sq['pdquotenumber'.$j] ;
						$sq['aquoteid'.$i]	= $quoteid ;
						$sq['aduedate'.$i]	= $sq['pdduedate'.$j] ;
						$sq['aquoteamount'.$i]	= $sq['pdquoteamount'.$j];
						$sq['aa_amount'.$i]	+= $pdosamt ;
						$sq['anewaamount'.$i]	= "" ;
						}
					$bal -= $pdosamt ;
					}
				   else {
					$sq['pda_amount'.$j] += $bal ;
					$sq['pdacceptedamt'.$j] += $bal ;
					$sq['pdosamount'.$j]  -= $bal ;
					$quoteid = $sq['pdquoteid'.$j] ;
					For ($i=1;(isset($sq['aquoteid'.$i]) and $bal>0);$i++) {
						if ($sq['aquoteid'.$i]==$quoteid) {
							$sq['aa_amount'.$i] += $bal ;
							$sq['anewaamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($sq['aquoteid'.$i])) {
						$sq['aquotenumber'.$i]	= $sq['pdquotenumber'.$j] ;
						$sq['aquoteid'.$i]	= $quoteid ;
						$sq['aduedate'.$i]	= $sq['pdduedate'.$j] ;
						$sq['aquoteamount'.$i]	= $sq['pdquoteamount'.$j];
						$sq['aa_amount'.$i]	= $bal ;
						$sq['anewaamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen SO/Quotation Matching

    function match_clear(&$sq) {
	global $phpgw ;

	For ($i=1;isset($sq['aquoteid'.$i]);$i++)	{
		$quoteid = $sq['aquoteid'.$i] ;
		$aaamt = $sq['aa_amount'.$i] ;
		For ($j=1;isset($sq['pdquoteid'.$j]);$j++) {
			if ($sq['pdquoteid'.$j]==$quoteid) {
				$sq['pda_amount'.$j] = 0 ;
				$sq['pdacceptedamt'.$j] -= $aaamt ;
				$sq['pdosamount'.$j]  += $aaamt ;
				break ;
				}
			}
		if (!isset($sq['pdquoteid'.$j])) {
			$sq['pdquotenumber'.$j]	=	$sq['aquotenumber'.$i] ;
			$sq['pdquoteid'.$j]	=	$quoteid ;
			$sq['pdduedate'.$j]	=	$sq['aduedate'.$i] ;
			$sq['pdquoteamount'.$j]	=	$sq['aquoteamount'.$i] ;
			$sq['pda_amount'.$j]	=	0 ;
			$sq['pda_othamt'.$j]	=	$sq['aquoteamount'.$i] - $aaamt ;
			$sq['pdacceptedamt'.$j]	=	$sq['pda_othamt'.$j] ;
			$sq['pdosamount'.$j]	=	$aaamt ;
			}
		unset($sq['aquoteid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current SO cleared") ;
	return "<b>$message</b>" ;
	}

    }

?>

