<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: approveeclist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'approveeclist.tpl', 'approveec'=>'approveeclist.tpl'));
	$t->set_block('approveec','approveec_row','approveec_section');
	$t->set_var('message','');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Staff Expense/Allowance (E/A) Claim Approval List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/approvefilter.php'));

$t->set_var('sort_staff',$nm->show_sort_order($sort,'staff',$order,'/ck-sss/approveeclist.php',lang('Employee Name/#')));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,'/ck-sss/approveeclist.php',lang('E/A Name')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-sss/approveeclist.php',lang('E/A Description')));
$t->set_var('sort_qty',$nm->show_sort_order($sort,'qty',$order,'/ck-sss/approveeclist.php',lang('Quantity')));
$t->set_var('sort_unit',$nm->show_sort_order($sort,'unit',$order,'/ck-sss/approveeclist.php',lang('Unit')));
$t->set_var('sort_unitamt',$nm->show_sort_order($sort,'unitamt',$order,'/ck-sss/approveeclist.php',lang('Unit Amount')));
$t->set_var('sort_rate',$nm->show_sort_order($sort,'rate',$order,'/ck-sss/approveeclist.php',lang('Pay Rate')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,'/ck-sss/approveeclist.php',lang('Amount')));
$t->set_var('sort_comment',$nm->show_sort_order($sort,'comment',$order,'/ck-sss/approveeclist.php',lang('Comment')));
$t->set_var('sort_approved_by',$nm->show_sort_order($sort,'approved_by',$order,'/ck-sss/approveeclist.php',lang('Approved By')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-sss/approveeclist.php',lang('Audit Id')));
$t->set_var('lang_approve',lang('Approve/Reject'));

if (!$order) $order = "staff,name" ;
if (!$sort)  $sort = "ASC" ;
$sql =	"SELECT b.name as staff,c.name as name,description," ;
$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
$sql.=	"FROM pynr_trans a, employee b, pyrcode c " ;
$sql.=	"$where and empid=b.id and pyrcodeid=c.id order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'staff'		=> lang("No Matching Item Found"),
				'name'		=> "",
				'description'	=> "",
				'qty'		=> "",
				'unit'		=> "",
				'unitamt'	=> "",
				'rate'		=> "",
				'amount'	=> "",
				'comment'	=> "",
				'approved_by'	=> "",
				'id'		=> "",
				'approve'	=> "",
									));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('approveec_section','approveec_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$approved_by	= $phpgw->db->f('approved_by') ;
	$getstr		= "id=$id&filter=$filter" ;
	$t->set_var(array(	'staff'		=> $phpgw->db->f('staff'),
				'name'		=> $phpgw->db->f('name'),
				'description'	=> $phpgw->db->f('description'),
				'qty'		=> $phpgw->db->f('qty'),
				'unit'		=> $phpgw->db->f('unit'),
				'unitamt'	=> $phpgw->db->f('unitamt'),
				'rate'		=> $phpgw->db->f('rate'),
				'amount'	=> $phpgw->db->f('amount'),
				'comment'	=> $phpgw->db->f('comment'),
				'approved_by'	=> $approved_by,
				'id'		=> $id,
				'approve'	=> $phpgw->link('/ck-sss/expenseappapprove.php',$getstr)
										));
	if ($approved_by<>'')	$t->set_var('lang_approve','') ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('approveec_section','approveec_row',true);
	$t->set_var('lang_approve',lang('Approve/Reject'));
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','approveec','report');

?>
