<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expenseappapprove.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$reject = ($_GET["reject"]) ? $_GET["reject"] : $_POST["reject"] ;
	$filter=urlencode(stripslashes($filter));

	$expapp = CreateObject('ck-sss.expenseapp') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file('report','expenseappapprove.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Approve Staff Expense/Allowance (E/A) Claim'));
	$msg1 = lang('Pay Period');
	$msg2 = lang('mn - Month, sm - Semi-monthly, wk - Week, dy - Day, hr - Hour');
	$msg3 = lang('Basis of Calculation');
	$msg4 = lang('bs - basic salary, pc - allowance/deduction unit amount,') ;
	$msg5 = lang('dp - imputed daily pay, hp - imputed hourly pay, qty - inputted qty, amt - inputted amount');
	$t->set_var('message',"$msg1:  $msg2<br>$msg3:  $msg4 $msg5");
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');

/*------------- Write Expense/Allowance Claim to Screen Display ----------------------------*/

if (!isset($post) and !isset($reject)) {
	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM pynr_trans a, payroll b, pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$nr = $phpgw->db->Record ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($nr[period]) :
		case "mn" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('mndfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('smdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$nr[daypay] = $nr[salary]/$phpgw->db->f('wkdfactor') ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$nr[daypay] = $nr[salary] ;
				$nr[hourpay] = $nr[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$nr[daypay] = $nr[salary] * $phpgw->db->f('dyhfactor') ;
				$nr[hourpay] = $nr[salary] ;				break ;
		endswitch ;
	$nr[daypay] = sprintf("%01.2f",$nr[daypay]) ;
	$nr[hourpay] = sprintf("%01.2f",$nr[hourpay]) ;
	}
  else  $nr = $_POST ;

	$expapp->expenseapp_write($t, $nr) ;

	$t->parse('out','report',True);

/*-------------- Post Expense/Allowance Claim----------------------------------------------*/

	if (isset($post))	$posted=$expapp->expenseapp_post($nr,$t,'approve','expenseappapprove');
	if (isset($reject)) {
		$error = lang("Error") ;
		$errmsg = lang("Please provide a reject reason") ;
		if ($nr[reason]=='')	$t->set_var('message',"<b>$error: $errmsg</b>");
		   else			$rejected = $expapp->expenseapp_reject($nr,$t);
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted or $rejected) {
		$t->set_var('action',$phpgw->link('/ck-sss/approveeclist.php',$getstr));
		$t->set_var('lang_approve',lang('Done'));
		$t->set_var('lang_reject',lang('Done'));
		$t->set_var('lang_reason',lang('Reject Reason'));
		$t->set_var('reason',$nr[reason]);
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-sss/expenseappapprove.php',$getstr)) ;
		$t->set_var('lang_approve',lang('Approve E/A Claim'));
		$t->set_var('lang_reject',lang('Reject E/A Claim'));
		$t->set_var('lang_reason',lang('Reject Reason'));
		$t->set_var('reason',$nr[reason]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link('/ck-sss/approveeclist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
