<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expenseappfilter.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$eaid = ($_GET["eaid"]) ? $_GET["eaid"] : $_POST["eaid"] ;
	$period = ($_GET["period"]) ? $_GET["period"] : $_POST["period"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Search among existing Expense/Allowance Claims :'));
	$t->set_var('lang_search_message',lang('To search for all items, leave fields blank'));

/* ------------- Read and Write Searching Criteria --------------------------- */

	$t->set_var('lang_criteria',lang('Searching Criteria'));
	$t->set_var('lang_value',lang('Value'));
	$t->set_var('lang_note',lang('Note'));
	$nullopt = "<OPTION value=''></OPTION>" ;

	$filter = array (
				ftr1		=>	lang('Expense/Allowance Type') ,
				ftrtype1	=>	'select' ,
				ftrsl1		=>	$nullopt.eaid_selectlist("WHERE allowssc='y'",'','long') ,
				ftrvar1		=>	'eaid' ,
				ftrdefault1	=>	'' ,
				ftrnote1	=>	lang('Search for the target expense/allowance claim type')
											 ) ;

	if ($err) {
		$t->set_var('lang_search_message',$err) ;
		$filter["ftrdefault1"] = $eaid ;
		}

	$nodetail = $noselect = True ;

	For ($i=1;isset($filter['ftr'.$i]);$i++)	{
		switch ($filter['ftrtype'.$i])	:
			case "input" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "checkbox" :
				$nodetail = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$t->set_var('default',$filter['ftrdefault'.$i]);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('checkbox',"type='checkbox'");
				$yes = ($filter['ftrdefault'.$i]=='yes') ? "yes" : "" ;
				$t->set_var('checked',$yes);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('detail_section','detail', True);
				break ;
			case "select" :
				$noselect = False ;
				$t->set_var('condition',$filter['ftr'.$i]);
				$t->set_var('var',$filter['ftrvar'.$i]);
				$default = $filter['ftrdefault'.$i] ;
				$sl = str_replace("'$default'","'$default' selected",$filter['ftrsl'.$i]) ;
				$t->set_var('selectlist',$sl);
				$t->set_var('note',$filter['ftrnote'.$i]);
				$t->set_var('tr_color',$nm->alternate_row_color()) ;
				$t->parse('select_section','select', True);
				break ;
			endswitch ;
		}
	if ($nodetail)		$t->set_var('detail_section','');
	if ($noselect)		$t->set_var('select_section','');

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('search_action',$phpgw->link('/ck-sss/expenseappfilter_validate.php')) ;
	$t->set_var('lang_search',lang('Start Search'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/expenseappadd.php')) ;
	$t->set_var('lang_add',lang('Add New Expense/Allowance Claim'));
	$t->pparse('out','report',True);

?>
