<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expenseapplist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array(	'report'=>'expenseapplist.tpl', 'expenseapp'=>'expenseapplist.tpl'));
	$t->set_block('expenseapp','expenseapp_row','expenseapp_section');
	$msg1 = lang('Approved Expense/Allowance Claims cannot be edited nor deleted.') ;
	$msg2 = lang('To allow auto email requesting various approvals, email/dns environment must be correctly setup.') ;
	$msg3 = lang('Even if Expense/Allowance Claim is approved, you still need to forward all original supporting documents to Accounts Department.') ;
	$t->set_var('message',"$msg1  $msg2<br>$msg3");
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang("List of Expense/Allowance Claims"));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_empname',$nm->show_sort_order($sort,'empname',$order,'/ck-sss/expenseapplist.php',lang('Employee Name')));
$t->set_var('sort_pyrname',$nm->show_sort_order($sort,"pyrname",$order,'/ck-sss/expenseapplist.php',lang('E/A Name')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-sss/expenseapplist.php',lang('Expense/Allowance Description')));
$t->set_var('sort_qty',$nm->show_sort_order($sort,"qty",$order,'/ck-sss/expenseapplist.php',lang('Quantity')));
$t->set_var('sort_unit',$nm->show_sort_order($sort,'unit',$order,'/ck-sss/expenseapplist.php',lang('Unit')));
$t->set_var('sort_unitamt',$nm->show_sort_order($sort,"unitamt",$order,'/ck-sss/expenseapplist.php',lang('Unit Amount')));
$t->set_var('sort_rate',$nm->show_sort_order($sort,'rate',$order,'/ck-sss/expenseapplist.php',lang('Pay Rate')));
$t->set_var('sort_amount',$nm->show_sort_order($sort,"amount",$order,'/ck-sss/expenseapplist.php',lang('Amount')));
$t->set_var('sort_comment',$nm->show_sort_order($sort,'comment',$order,'/ck-sss/expenseapplist.php',lang('Comment')));
$t->set_var('sort_approved_by',$nm->show_sort_order($sort,'approved_by',$order,'/ck-sss/expenseapplist.php',lang('Approved By')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-sss/expenseapplist.php',lang('Audit Id')));

if (!$order) $order = "empname" ;
if (!$sort)  $sort = "ASC" ;
$sql =	"SELECT b.name as empname,c.name as pyrname,description," ;
$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
$sql.=	"FROM pynr_trans a, employee b, pyrcode c " ;
$sql.=	"$where and empid=b.id and pyrcodeid=c.id order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'empname'	=> lang("No Matching Item Found"),
				'pyrname'	=> "",
				'description'	=> "",
				'qty'		=> "",
				'unit'		=> "",
				'unitamt'	=> "",
				'rate'		=> "",
				'amount'	=> "",
				'comment'	=> "",
				'approved_by'	=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "" ));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('expenseapp_section','expenseapp_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$approved_by	= $phpgw->db->f('approved_by') ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var(array(	'empname'	=> $phpgw->db->f("empname"),
				'pyrname'	=> $phpgw->db->f("pyrname"),
				'description'	=> $phpgw->db->f("description"),
				'qty'		=> $phpgw->db->f("qty"),
				'unit'		=> $phpgw->db->f("unit"),
				'unitamt'	=> $phpgw->db->f("unitamt"),
				'rate'		=> $phpgw->db->f("rate"),
				'amount'	=> $phpgw->db->f("amount"),
				'comment'	=> $phpgw->db->f("comment"),
				'approved_by'	=> $phpgw->db->f("approved_by"),
				'id'		=> $id,
				'view'	=> $phpgw->link('/ck-sss/expenseappview.php',$getstr),
				'edit'	=> $phpgw->link('/ck-sss/expenseappedit.php',$getstr),
				'copy'	=> $phpgw->link('/ck-sss/expenseappcopy.php',$getstr),
				'delete'=> $phpgw->link('/ck-sss/expenseappdelete.php',$getstr)  ));
	if ($approved_by<>'')	$t->set_var(array(	'lang_edit'	=> '',
							'lang_delete'	=> '',
							'edit'		=> '',
							'delete'	=> ''	)) ;
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('expenseapp_section','expenseapp_row',true);
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_delete',lang('Delete'));
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add New Expense/Allowance Claims"));
	$t->set_var('add_action',$phpgw->link('/ck-sss/expenseappadd.php',$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));

	$t->pparse('out','expenseapp','report');

?>
