<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attend.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class attend {

//---- Attendance Detail Validation Checks

    function attend_validate($a) {
	global $phpgw ;

	$err="";  $error = lang("Error:") ;
	if ($a[type]==lang('sign-in') and $a[signin]=='')	$err=lang("Sign in Reason Missing") ;
	if ($a[type]==lang('sign-out') and $a[signout]=='')	$err=lang("Sign out Reason Missing") ;
	if ($a[signin]<>'' and $a[signout]<>'')		$err=lang("Both Sign In & Out Reasons are active") ;
	if ($err)					$err = "<b>$error $err</b>" ;
	return $err ;
	}

//---- Post Attendance Detail to Database

    function attend_post($a, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$reason = ($a[type]==$lang_si) ? $a[signin] : $a[signout] ;
	$type = $a[type] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$transdate = date("Y-m-d") ;
	$date = str_replace("-","",$transdate) ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :
			$sql = "SELECT id from log WHERE script='$script' and userid='$user' and date='$date' and time='$time'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$id=$phpgw->db->f('id');
			$phpgw->db->query("UPDATE log SET trans_id=id WHERE id='$id'");
			$sql="INSERT INTO attendance (id,empid,type,reason,transdate,time) ";
			$sql.="VALUES ('$id','$a[empid]','$type','$reason','$transdate','$time')";
			$phpgw->db->query($sql);
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
/*
		case "edit" :
			$sql ="UPDATE attend SET name='$a[name]',addr1='$a[addr1]',addr2='$a[addr2]'," ;
			$sql.="addr3='$a[addr3]',addr4='$a[addr4]',terms='$a[terms]',taxincluded='$tax',";
			$sql.="contact='$a[contact]',phone='$a[phone]',fax='$a[fax]',email='$a[email]',";
			$sql.="notes='$a[notes]' WHERE id=$id";
			$phpgw->db->query($sql);
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$phpgw->db->query("DELETE FROM attend WHERE id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
*/
		endswitch ;
/*
	if ($op<>'new')		$phpgw->db->query("DELETE FROM attendtax WHERE attend_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		if ($t1<>"")	$phpgw->db->query("INSERT INTO attendtax(attend_id,tax_id,taxtype) VALUES('$id','$t1','1')");
		if ($t2<>"")	$phpgw->db->query("INSERT INTO attendtax(attend_id,tax_id,taxtype) VALUES('$id','$t2','2')");
		}
*/
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Attendance Record") ;
	$msg = "$a[name] $a[type] - $transdate/$time" ;
	$t->set_var("message","<b>$msg<br>$type $tran [id#$id] $actioned.</b>") ;
	$t->set_var('lang_confirm',"<b>$type $tran [id#$id] $actioned.</b>");
	$posted = True ;
	return $posted ;
	}

//---- Write Attendance Detail

    function attend_write(&$t, &$a) {
	global $phpgw ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>";
	$t->set_var('lang_type',lang('Action'));
	$t->set_var('lang_name',lang('Employee Name/#'));
	$t->set_var('lang_signin',lang('Sign In Reason'));
	$t->set_var('lang_signout',lang('Sign Out Reason'));
	$lang_signin = lang('sign-in') ;
	$lang_signout = lang('sign-out') ;

	$type_sl = str_replace("'$a[type]'","'$a[type]' selected",$type_sl) ;
	$t->set_var('type_selectlist',$type_sl);
	$t->set_var('name',$a[name]);
	$t->set_var('empid',$a[empid]);
	$signin_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_signin'",'','long') ;
	$signin_sl = str_replace("'$a[signin]'","'$a[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
	$signout_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_signout'",'','long') ;
	$signout_sl = str_replace("'$a[signout]'","'$a[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

    }

?>
