<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.photo.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class photo {

//---- Photo Detail Validation Checks

    function photo_validate($p) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$maxfile = 10240 ;
	$newimg = "/tmp/$p[id].ck-ledger.img" ;
	if (!$p[post] and !is_file($newimg))	$err = lang("Photo must be previewed before update") ;
	if (is_file($newimg) and filesize($newimg)>$maxfile)
		$err = lang("Error: File size too large (max-10K)") ;
	if ($p['phototype']<>"image")
		$err = lang("Photo must be of type (image), check if photo had been previewed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post photo Detail to Database

    function photo_post($p, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id	= $p[id] ;
	$app	= $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);
	
	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'delete') {
		$imgdir = $phpgw_info["server"]["files_dir"]."/images" ;
		umask(000) ;
		if (!is_dir($imgdir))	mkdir($imgdir,0700) ;
		$newimg = "/tmp/$id.ck-ledger.img" ;
		$fd = fopen($newimg,"r");
		$contents = fread($fd,filesize($newimg)) ;
		fclose($fd) ;
		$photo = "$imgdir/$id.png" ;
		umask(000) ;
		if ($fp = fopen($photo, "w")) {fputs($fp, $contents); fclose($fp);}
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Photo for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	$posted = True ;
	return $posted ;
	}

//---- Write Photo Detail

    function photo_write(&$t, &$p) {
	global $phpgw,$phpgw_info;

	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->set_var('lang_name',lang("Employee Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_oldphoto',lang('Existing Photo'));
	$t->set_var('lang_browse',lang('Click [Browse] to choose new photo'));
	$t->set_var('lang_newphoto',lang('New Photo'));

	$id = $p[id] ;
	$t->set_var('name',$p[name]);
	$t->set_var('id',$id);
	$t->set_var('phototype',$p['phototype']);
	$imgdir = $phpgw_info["server"]["files_dir"]."/images" ;
	$oldimg = "$imgdir/$id.png" ;
	$t->set_var('oldimage',$phpgw->link("/ck-hr/employeeview_image.php","imgfile=$oldimg"));
	if (!isset($p[post]) and isset($_FILES['photofile'])) {
		$tempimg = $_FILES['photofile']['tmp_name'] ;
		$types = explode("/",$_FILES['photofile']['type']) ;
		$p['phototype'] = $types[0] ;
		$t->set_var('phototype',$p['phototype']);
		exec("rm -f /tmp/*.ck-ledger.img") ;
		$newimg = "/tmp/$id.ck-ledger.img" ;
		move_uploaded_file($tempimg, $newimg) ;
		}
	$t->set_var('newimage',$phpgw->link("/ck-hr/employeeview_image.php","imgfile=$newimg"));
	$t->parse('out','report',True);
	}

    }

?>
