<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.role.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class role {

//---- Role Validation Checks

    function role_validate($r) {
	global $phpgw ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	$AccAdm=$AccMgr=$APAdm=$APMgr=$ARAdm=$ARMgr=$CSAdm=$CSMgr=$HRAdm=$HRMgr= "" ;
	$InvAdm=$InvMgr=$PurAdm=$PurMgr=$SalAdm=$SalMgr=$SvcAdm=$SvcMgr=$SysAdm= "" ;
	For ($i=1;isset($r['rolecode'.$i]);$i++) {
		switch ($r['rolecode'.$i]) :
			case "AccAdm" :	if ($AccAdm<>"") $err="[$row $i]".lang("Duplicate AccAdm role"); $AccAdm=True; break;
			case "AccMgr" :	if ($AccMgr<>"") $err="[$row $i]".lang("Duplicate AccMgr role"); $AccMgr=True; break;
			case "APAdm" :	if ($APAdm<>"") $err="[$row $i]".lang("Duplicate APAdm role"); $APAdm=True; break;
			case "APMgr" :	if ($APMgr<>"") $err="[$row $i]".lang("Duplicate APMgr role"); $APMgr=True; break;
			case "ARAdm" :	if ($ARAdm<>"") $err="[$row $i]".lang("Duplicate ARAdm role"); $ARAdm=True; break;
			case "ARMgr" :	if ($ARMgr<>"") $err="[$row $i]".lang("Duplicate ARMgr role"); $ARMgr=True; break;
			case "CSAdm" :	if ($CSAdm<>"") $err="[$row $i]".lang("Duplicate CSAdm role"); $CSAdm=True; break;
			case "CSMgr" :	if ($CSMgr<>"") $err="[$row $i]".lang("Duplicate CSMgr role"); $CSMgr=True; break;
			case "HRAdm" :	if ($HRAdm<>"") $err="[$row $i]".lang("Duplicate HRAdm role"); $HRAdm=True; break;
			case "HRMgr" :	if ($HRMgr<>"") $err="[$row $i]".lang("Duplicate HRMgr role"); $HRMgr=True; break;
			case "InvAdm" :	if ($InvAdm<>"") $err="[$row $i]".lang("Duplicate InvAdm role"); $InvAdm=True; break;
			case "InvMgr" :	if ($InvMgr<>"") $err="[$row $i]".lang("Duplicate InvMgr role"); $InvMgr=True; break;
			case "PurAdm" :	if ($PurAdm<>"") $err="[$row $i]".lang("Duplicate PurAdm role"); $PurAdm=True; break;
			case "PurMgr" :	if ($PurMgr<>"") $err="[$row $i]".lang("Duplicate PurMgr role"); $PurMgr=True; break;
			case "SalAdm" :	if ($SalAdm<>"") $err="[$row $i]".lang("Duplicate SalAdm role"); $SalAdm=True; break;
			case "SalMgr" :	if ($SalMgr<>"") $err="[$row $i]".lang("Duplicate SalMgr role"); $SalMgr=True; break;
			case "SvcAdm" :	if ($SvcAdm<>"") $err="[$row $i]".lang("Duplicate SvcAdm role"); $SvcAdm=True; break;
			case "SvcMgr" :	if ($SvcMgr<>"") $err="[$row $i]".lang("Duplicate SvcMgr role"); $SvcMgr=True; break;
			case "SysAdm" :	if ($SysAdm<>"") $err="[$row $i]".lang("Duplicate SysAdm role"); $SysAdm=True; break;
			endswitch ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Post Role to Database

    function role_post($r, &$t, $op, $script) {
	global $phpgw, $phpgw_info ;

	$db_type = $phpgw_info["server"]["db_type"] ;
	$id = $r[id] ;

	$app  = $phpgw_info[flags][currentapp] ;
	$user = trim($phpgw_info["user"]["userid"]);
	$date = date("Ymd") ;
	$time = date("H:i:s") ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO log (trans_id,app,script,userid,date,time,op) VALUES ('$id','$app','$script','$user','$date','$time','$op')" ;
	$phpgw->db->query($sql);

	switch ($op) :
		case "new" :						break ;
		case "edit" :	$actioned = lang("updated") ;		break ;
		case "delete" :						break ;
		endswitch ;

	if ($op<>'new')		$phpgw->db->query("DELETE from role where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($r['rolecode'.$i]);$i++) {
			$rolecode = $r['rolecode'.$i] ;
			$sql = "INSERT INTO role(empid,rolecode) VALUES ('$id','$rolecode')" ;
			$phpgw->db->query($sql);
			}
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$tran = lang("Role for Employee") ;
	$t->set_var("message","<b>$tran [id#$id] $actioned.</b>") ;
	return True ;
	}

//---- Write Role Header

    function role_header_write(&$t, $r) {
	global $phpgw ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$r[name]) ;
	$t->set_var('id',$r[id]) ;
	$t->parse('out','report',True);
	}

//---- Write Role Detail

    function role_detail_write(&$t, $r, $posted, $insert, $delete, $newrow) {
	global $phpgw,$phpgw_info ;

	$row_ = lang('Row')." " ;
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$id = $r[id] ;
	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_rolecode',lang("Role Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$lang_role = lang('role') ;
	$rolecode_sl = hrcodename_selectlist("WHERE type='$lang_role'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($r['rolecode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('rolecode_fld','rolecode'.$i) ;
			$t->set_var('rolecode_selectlist',$rolecode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tr_color',$nm->alternate_row_color()) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$rolecode	=	$r['rolecode'.$i] ;
		$t->set_var('rolecode_fld','rolecode'.$j) ;
		$t->set_var('rolecode_selectlist',str_replace("'$rolecode'","'$rolecode' selected",$rolecode_sl)) ;

		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('rolecode_fld','rolecode'.$i) ;
		$t->set_var('rolecode_selectlist',$rolecode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tr_color',$nm->alternate_row_color()) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>
