<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrolllist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = stripslashes($filter) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>'payrolllist.tpl', 'payroll'=>'payrolllist.tpl'));
	$t->set_block('payroll','payroll_row','payroll_section');
	$t->set_var('message','');

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('th_bg',$phpgw_info['theme']['th_bg']);
	$t->set_var('lang_title',lang('Past Period Payroll Info List'));
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',lang('Done'));
	$t->set_var('add_action',$phpgw->link('/ck-sss/payrollfilter.php'));

$t->set_var('sort_staff',$nm->show_sort_order($sort,'staff',$order,'/ck-sss/payrolllist.php',lang('Employee Name/#')));
$t->set_var('sort_datefrom',$nm->show_sort_order($sort,'datefrom',$order,'/ck-sss/payrolllist.php',lang('Date From')));
$t->set_var('sort_dateto',$nm->show_sort_order($sort,'dateto',$order,'/ck-sss/payrolllist.php',lang('Date To')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,'/ck-sss/payrolllist.php',lang('Period Description')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,'/ck-sss/payrolllist.php',lang('Audit Id')));
$t->set_var('lang_view',lang('View'));

$lang_from = lang('from') ;
$lang_to = lang('to') ;
$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
$topos = "position('$tomarker' in description)+$tomarkerlen" ;
$descdatefrom = "substring(description,$frompos,10)" ;
$descdateto = "substring(description,$topos,10)" ;

if (!$order)	$order = "staff,datefrom,dateto" ;
if (!$sort)	$sort = "ASC" ;
$sql =	"SELECT name as staff,$descdatefrom as datefrom,$descdateto as dateto,description,b.id,empid " ;
$sql.=	"FROM pyrohist a, gl b, employee c " ;
$sql.=	"$where and source='PYRO' and trans_id=b.id and type='NETP' and empid=c.id " ;
$sql.=	"order by $order $sort" ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'staff'		=> lang("No Matching Item Found"),
				'datefrom'	=> "",
				'dateto'	=> "",
				'description'	=> "",
				'id'		=> "",
				'view'		=> "",
									));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('payroll_section','payroll_row',True);
	}
while ($phpgw->db->next_record()) {
	$id		= $phpgw->db->f('id') ;
	$empid		= $phpgw->db->f('empid') ;
	$desc		= $phpgw->db->f('description') ;
	$getstr		= "id=$id&empid=$empid&desc=$desc&filter=$filter" ;
	$t->set_var(array(	'staff'		=> $phpgw->db->f('staff'),
				'datefrom'	=> $phpgw->db->f('datefrom'),
				'dateto'	=> $phpgw->db->f('dateto'),
				'description'	=> $desc,
				'id'		=> $id,
				'view'		=> $phpgw->link('/ck-sss/payrollview.php',$getstr)
										));
	$t->set_var('tr_color',$nm->alternate_row_color()) ;
	$t->parse('payroll_section','payroll_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','payroll','report');

?>
