<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrollview.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;
	$desc = ($_GET["desc"]) ? $_GET["desc"] : $_POST["desc"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=urlencode(stripslashes($filter));

	$py = CreateObject('ck-sss.payroll') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file('report','payrollview.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','nrdetail','nrdetail_section');
	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');

	$title = lang('View Past Payroll Period Info') ;
	$t->set_var('lang_title',"$title:  $desc");
	$msg1 = lang('Basis of Calculation');
	$msg2 = lang('bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,') ;
	$msg3 = lang('hp - imputed hourly pay, qty - qty input, amt - amount input');
	$msg4 = lang('Reduction/Contribution');
	$msg5 = lang('Base = TotalRecurring + TotalNonRecurring - ExemptItem(Subject to Min/Max Action)') ;
	$msg6 = lang('Amount = (Base - Floor) * Rate - Subtract') ;
	$t->set_var('message',"<b>$msg1:</b><br>$msg2<br>$msg3<br><b>$msg4:</b><br>$msg5<br>$msg6") ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM payroll WHERE empid='$empid'");
	$phpgw->db->next_record();
	$p = $phpgw->db->Record ;
	$py->payroll_header_write($t, $p) ;

	$phpgw->db->query("SELECT * FROM pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYRC'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['eaid'.$i]		=	$phpgw->db->f('codeid') ;
		$p['basis'.$i]		=	$phpgw->db->f('basis') ;
		$p['qty'.$i]		=	$phpgw->db->f('qty') ;
		$p['unit'.$i]		=	$phpgw->db->f('unit') ;
		$p['unitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$p['rate'.$i]		=	$phpgw->db->f('rate') ;
		$p['amount'.$i]		=	-$phpgw->db->f('amount') ;
		$p['comment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYNR'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['nreaid'.$i]		=	$phpgw->db->f('codeid') ;
		$p['nrapproved_by'.$i]	=	$phpgw->db->f('approved_by') ;
		$p['nrbasis'.$i]	=	$phpgw->db->f('basis') ;
		$p['nrqty'.$i]		=	$phpgw->db->f('qty') ;
		$p['nrunit'.$i]		=	$phpgw->db->f('unit') ;
		$p['nrunitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$p['nrrate'.$i]		=	$phpgw->db->f('rate') ;
		$p['nramount'.$i]	=	-$phpgw->db->f('amount') ;
		$p['nrcomment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM pyrohist WHERE trans_id='$id' and empid='$empid' and type='RDTN'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['rdtnid'.$i] = $phpgw->db->f('codeid') ;
		$p['rdbase'.$i] = $phpgw->db->f('base') ;
		$p['rdfloor'.$i] = $phpgw->db->f('floor') ;
		$p['rdrate'.$i] = $phpgw->db->f('rate') ;
		$p['rdsubtract'.$i] = $phpgw->db->f('subtract') ;
		$p['rdamount'.$i] = $phpgw->db->f('amount') ;
		$p['rdcomment'.$i] = $phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM pyrohist WHERE trans_id='$id' and empid='$empid' and type='CTCR'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['cntrid'.$i] = $phpgw->db->f('codeid') ;
		$p['ctbase'.$i] = $phpgw->db->f('base') ;
		$p['ctfloor'.$i] = $phpgw->db->f('floor') ;
		$p['ctrate'.$i] = $phpgw->db->f('rate') ;
		$p['ctsubtract'.$i] = $phpgw->db->f('subtract') ;
		$p['ctamount'.$i] = $phpgw->db->f('amount') ;
		$p['ctcomment'.$i] = $phpgw->db->f('comment') ;
		}
	$py->payroll_detail_write($t, $p, "PAST");

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&empid=$empid&filter=$filter" ;
	$t->set_var('action',$phpgw->link("/ck-sss/payrolllist.php",$getstr));
	$t->set_var('done_action',$phpgw->link("/ck-sss/payrolllist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
