<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: predit.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-hr', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$newrow = ($_GET["newrow"]) ? $_GET["newrow"] : $_POST["newrow"] ;
	$reload = ($_GET["reload"]) ? $_GET["reload"] : $_POST["reload"] ;
	$insert = ($_GET["insert"]) ? $_GET["insert"] : $_POST["insert"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;
	$filter=urlencode(stripslashes($filter));

	$pr = CreateObject('ck-hr.pr') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
	$t->set_file('report','prscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Edit Performance Review'));
	$message = lang("If the screen display gets too complicated, click [Reload from Employee Record] to start afresh.") ;
	$t->set_var('message',$message) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

/*------------- Write Performance Review to Screen Display ----------------------------*/

	if (!isset($newrow) and !isset($post) and !isset($reload) and !isset($insert) and !isset($delete)) {
		$phpgw->db->query("SELECT * FROM employee WHERE id='$id'");
		$phpgw->db->next_record();
		$p = $phpgw->db->Record ;
		}
	    else $p = $_POST ;
	$pr->pr_header_write($t, $p) ;

	if ((!isset($newrow) and !isset($post) and !isset($insert) and !isset($delete)) or isset($reload)) {
		$p = "" ;
		$p[name] = $_POST[name] ;
		$p[id] = $_POST[id] ;
		$phpgw->db->query("SELECT * from pr where empid='$id' order by prfrom");
		For ($i=1;$phpgw->db->next_record();$i++) {
			$prfrom			=	$phpgw->db->f('prfrom') ;
			$p['fromyear'.$i]	=	substr($prfrom,0,4) ;
			$p['frommonth'.$i]	=	substr($prfrom,5,2) ;
			$p['fromday'.$i]	=	substr($prfrom,8,2) ;
			$prto			=	$phpgw->db->f('prto') ;
			$p['toyear'.$i]		=	substr($prto,0,4) ;
			$p['tomonth'.$i]	=	substr($prto,5,2) ;
			$p['today'.$i]		=	substr($prto,8,2) ;
			$p['prcode'.$i]		=	$phpgw->db->f('prcode') ;
			$p['comment'.$i]	=	$phpgw->db->f('comment') ;
			$p['reviewer'.$i]	=	$phpgw->db->f('reviewer') ;
			$pddate			=	$phpgw->db->f('pddate') ;
			$p['pdyear'.$i]		=	substr($pddate,0,4) ;
			$p['pdmonth'.$i]	=	substr($pddate,5,2) ;
			$p['pdday'.$i]		=	substr($pddate,8,2) ;
			}
		}

	$pr->pr_detail_write($t, $p,$posted,$insert,$delete,$newrow);

	$t->parse('out','report',True);

/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/

	if (isset($post)) {
		$err = $pr->pr_validate($p) ;
		$t->set_var('message',$err);
		if ($err=='')	$posted=$pr->pr_post($p,$t,'edit','predit');
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
		$t->set_var('lang_update',lang('Done'));
		$t->set_var('lang_newrow',lang('Done'));
		$t->set_var('lang_reload',lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link("/ck-hr/predit.php",$getstr)) ;
		$t->set_var('lang_update',lang('Post Performance Review'));
		$t->set_var('lang_newrow',lang('Add New Row'));
		$t->set_var('lang_reload',lang('Reload from Employee Record'));
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link("/ck-hr/employeelist.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
