<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: timesheetapprove.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$reject = ($_GET["reject"]) ? $_GET["reject"] : $_POST["reject"] ;
	$filter=urlencode(stripslashes($filter));

	$tsh = CreateObject('ck-sss.timesheet') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file('report','timesheetapprove.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('Approve Staff Timesheet'));
	$t->set_var('message',"") ;
	$t->set_var('readonly',"readonly") ;
	$t->set_var('disabled',"disabled") ;

/*------------- Write Timesheet to Screen Display ----------------------------*/

	if (!isset($post) and !isset($reject)) {
		$sql = "SELECT a.id,empid,name,year,week,hour_ttl,day_ttl FROM timesheet a,employee b " ;
		$sql.= "WHERE a.id=$id and empid=b.id";
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$ts = $phpgw->db->Record ;
		}
    	else $ts = $_POST ;
	$tsh->timesheet_header_write($t, $ts) ;

	if (!isset($post) and !isset($reject)) {
		$sql = "SELECT a.*,b.* from ts_trans a, timesheet b " ;
		$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
		$phpgw->db->query($sql);
		$ts[tsyear0] = date("Y") ;
		$ts[tsmonth0] = date("m") ;
		$ts[tsday0] = date("d") ;
		$i=1;
		while ($phpgw->db->next_record()) {
			$transdate		=	$phpgw->db->f('transdate') ;
			$ts['tsyear'.$i]	=	substr($transdate,0,4) ;
			$ts['tsmonth'.$i]	=	substr($transdate,5,2) ;
			$ts['tsday'.$i]		=	substr($transdate,8,2) ;
			$ts['project'.$i]	=	$phpgw->db->f('project') ;
			$ts['activity'.$i]	=	$phpgw->db->f('activity') ;
			$ts['hour'.$i]		=	$phpgw->db->f('hour') ;
			$ts['day'.$i]		=	$phpgw->db->f('day') ;
			$ts['achieve'.$i]	=	$phpgw->db->f('achieve') ;
			$ts['achival'.$i]	=	$phpgw->db->f('achival') ;
			$ts['achiunit'.$i]	=	$phpgw->db->f('achiunit') ;
			$i++ ;
			}
		}
	    else $ts = $_POST ;

	$tsh->timesheet_detail_write($t, $ts, $posted, $insert, $delete, $newrow);

	$t->parse('out','report',True);

/*-------------- Post timesheet----------------------------------------------*/

	if (isset($post))	$posted=$tsh->timesheet_post($ts,$t,'approve','timesheetapprove');
	if (isset($reject)) {
		$error = lang("Error") ;
		$errmsg = lang("Please provide a reject reason") ;
		if ($ts[reason]=='')	$t->set_var('message',"<b>$error: $errmsg</b>");
		   else			$rejected = $tsh->timesheet_reject($ts,$t);
		}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if ($posted or $rejected) {
		$t->set_var('action',$phpgw->link('/ck-sss/approvetslist.php',$getstr));
		$t->set_var('lang_replicate',lang('Done'));
		$t->set_var('lang_approve',lang('Done'));
		$t->set_var('lang_reject',lang('Done'));
		$t->set_var('lang_reason',lang('Reject Reason'));
		$t->set_var('reason',$ts[reason]);
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$t->set_var('action',$phpgw->link('/ck-sss/timesheetapprove.php',$getstr)) ;
		$t->set_var('lang_replicate',lang('Done'));
		$t->set_var('lang_approve',lang('Approve Timesheet'));
		$t->set_var('lang_reject',lang('Reject Timesheet'));
		$t->set_var('lang_reason',lang('Reject Reason'));
		$t->set_var('reason',$ts[reason]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link('/ck-sss/approvetslist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
