<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: timesheetdelete.php,v 0.0.5 2002/02/11 C K Wu $ */

	global $phpgw;

	$phpgw_info["flags"] = array('currentapp'=>'ck-sss', 'enable_nextmatchs_class'=>True);
	include('../header.inc.php');
	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=urlencode(stripslashes($filter));

	$tsh = CreateObject('ck-sss.timesheet') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-sss'));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report','timesheetscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang("Delete Timesheet"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

	$getstr="filter=$filter";
	if (!isset($yes)) {
		$t->set_var('lang_confirm',lang('Are you sure you want to delete ?'));
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$t->set_var('yes_action',$phpgw->link('/ck-sss/timesheetdelete.php',"id=$id&".$getstr));
		$t->set_var('no_action',$phpgw->link('/ck-sss/timesheetlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$ts[id] = $id ;
		$tsh->timesheet_post($ts, $t,'delete','timesheetdelete');
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link('/ck-sss/timesheetlist.php',$getstr)) ;
		$t->set_var('no_action',$phpgw->link('/ck-sss/timesheetlist.php',$getstr)) ;
		$t->pparse('out','question',True);
		$phpgw->common->phpgw_footer();
		exit;
		}

/*------------- Write timesheet to Screen Display ----------------------------*/

	$sql = "SELECT a.id,empid,name,year,week FROM timesheet a,employee b " ;
	$sql.= "WHERE a.id=$id and empid=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$tsh->timesheet_header_write($t, $phpgw->db->Record) ;

	$sql = "SELECT a.*,b.* from ts_trans a, timesheet b " ;
	$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
	$phpgw->db->query($sql);
	$ts[tsyear0] = date("Y") ;
	$ts[tsmonth0] = date("m") ;
	$ts[tsday0] = date("d") ;
	$i=1;
	while ($phpgw->db->next_record()) {
		$transdate		=	$phpgw->db->f('transdate') ;
		$ts['tsyear'.$i]	=	substr($transdate,0,4) ;
		$ts['tsmonth'.$i]	=	substr($transdate,5,2) ;
		$ts['tsday'.$i]		=	substr($transdate,8,2) ;
		$ts['project'.$i]	=	$phpgw->db->f('project') ;
		$ts['activity'.$i]	=	$phpgw->db->f('activity') ;
		$ts['hour'.$i]		=	$phpgw->db->f('hour') ;
		$ts['day'.$i]		=	$phpgw->db->f('day') ;
		$ts['achieve'.$i]	=	$phpgw->db->f('achieve') ;
		$ts['achival'.$i]	=	$phpgw->db->f('achival') ;
		$ts['achiunit'.$i]	=	$phpgw->db->f('achiunit') ;
		$i++ ;
		}
	$tsh->timesheet_detail_write($t, $ts, True, False, False, False);

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link('/ck-sss/timesheetlist.php',$getstr));
	$t->set_var('lang_replicate',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('done_action',$phpgw->link('/ck-sss/timesheetlist.php',$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
